*! version 1.1.0  20feb2008
program _r2e, eclass
	version 9
	syntax [,			///
		XMACros(namelist)	///
		XSCAlars(namelist)	///
		XMATrices(namelist)	///
	]

	// exclude special cases
	local xmacros	`xmacros' properties
	local xmatrices	`xmatrices' b V

	// This routine assumed that e() is ready to have things added to it,
	// meaning that -ereturn post- has already been called.

	// merge the contents of r(properties) with e(properties)
	local props `e(properties)' `r(properties)'
	local props : list uniq props
	ereturn local properties `props'

	// save the macros
	local macros : r(macros)
	local macros : list macros - xmacros
	foreach name of local macros {
		ereturn local `name' `"`r(`name')'"'
	}

	// save the scalars
	local scalars : r(scalars)
	local scalars : list scalars - xscalars
	foreach name of local scalars {
		ereturn scalar `name' = r(`name')
	}

	// save the matrices
	local matrices : r(matrices)
	local matrices : list matrices - xmatrices
	tempname mat
	foreach name of local matrices {
		matrix `mat' = r(`name')
		ereturn matrix `name' `mat'
	}

	ClearR
end

program ClearR, rclass
	return clear
end
exit
