{smcl}
{* *! version 1.0.5  12may2008}{...}
{cmd:help addedlinestyle}
{hline}
{* index addedlinestyle it}{...}

{title:Title}

{p2colset 5 27 29 2}{...}
{p2col :{hi:[G] {it:addedlinestyle}} {hline 2}}Choices for overall look of added lines{p_end}
{p2colreset}{...}


{title:Syntax}

{p2colset 9 34 40 2}{...}
{p2col : {it:addedlinestyle}}
	description{p_end}
{p2line}
{p2col : {cmd:default}}
	determined by scheme{p_end}
{p2col : {cmd:extended}}
	extends through plot region margins{p_end}
{p2col : {cmd:unextended}}
	does not extend through margins{p_end}
{p2line}
{p2colreset}{...}

{pin}
Other {it:addedlinestyles} may be available; type

	    {cmd:.} {bf:{stata graph query addedlinestyle}}

{pin}
to obtain the full list installed on your computer.


{title:Description}

{pstd}
Added lines are those added by the {it:added_line_options}.
{it:addedlinestyle} specifies the overall look of those lines.
See {manhelpi added_line_options G}.


{title:Remarks}

{pstd}
Remarks are presented under the following headings:

	{help addedlinestyle##remarks1:What is an added line?}
	{help addedlinestyle##remarks2:What is an addedlinestyle?}
	{help addedlinestyle##remarks3:You do not need to specify an addedlinestyle}


{marker remarks1}{...}
{title:What is an added line?}

{pstd}
Added lines are lines added by the {it:added_line_options} that extend
across the plot region and perhaps across the plot region's margins, too.


{marker remarks2}{...}
{title:What is an addedlinestyle?}

{pstd}
Added lines are defined by

{phang2}
    1.  whether the lines extend into the plot region's margin;

{phang2}
    2.  the style of the lines, which includes the lines'
	thickness, color, and whether solid, dashed, etc.;
	see {manhelpi linestyle G}.

{pstd}
The {it:addedlinestyle} specifies both these attributes.


{marker remarks3}{...}
{title:You do not need to specify an addedlinestyle}

{pstd}
The {it:addedlinestyle} is specified in the options

	{cmd:yline(}...{cmd:, style(}{it:addedlinestyle}{cmd:)} ...{cmd:)}
	{cmd:xline(}...{cmd:, style(}{it:addedlinestyle}{cmd:)} ...{cmd:)}

{pstd}
Correspondingly, other {cmd:yline()} and {cmd:xline()} suboptions
allow you to specify the individual attributes; see
{manhelpi added_line_options G}.

{pstd}
You specify the {it:addedlinestyle} when a style exists that is exactly what
you desire or when another style would allow you to specify fewer changes to
obtain what you want.


{title:Also see}

{psee}
Manual:  {bf:[G] {it:addedlinestyle}}

{psee}
Online:  {manhelpi added_line_options G}
{p_end}
