{smcl}
{* *! version 1.0.4  12may2008}{...}
{cmd:help alignmentstyle}
{hline}
{* index alignmentstyle it}{...}
{* index baseline tt}{...}
{* index bottom tt}{...}
{* index middle tt}{...}
{* index top tt}{...}

{title:Title}

{p2colset 5 27 29 2}{...}
{p2col :{hi:[G] {it:alignmentstyle}} {hline 2}}Choices for vertical alignment of text{p_end}
{p2colreset}{...}


{title:Syntax}

{p2colset 9 30 32 2}{...}
{p2col : {it:alignmentstyle}}
	description{p_end}
{p2line}
{p2col : {cmd:baseline}}
	bottom of textbox = baseline of letters{p_end}
{p2col : {cmd:bottom}}
	bottom of textbox = bottom of letters{p_end}
{p2col : {cmd:middle}} 
	middle of textbox = middle of letters{p_end}
{p2col : {cmd:top}}
	top of textbox = top of letters{p_end}
{p2line}
{p2colreset}{...}

{pin}
Other {it:alignmentstyles} may be available; type

	    {cmd:.} {bf:{stata graph query alignmentstyle}}

{pin}
to obtain the full list installed on your computer.


{title:Description}

{pstd}
See {manhelpi textbox_options G} for a description of textboxes.
{it:alignmentstyle} specifies how the text is vertically aligned in a
textbox.  Think of the textbox as being horizontal, even if it is vertical when
specifying this option.

{pstd}
{it:alignmentstyle} is specified inside options such as the
{cmd:alignment()} suboption of {cmd:title()}
(see {manhelpi title_options G}):

{pin}
	{cmd:. graph} ...{cmd:, title("My title", alignment(}{it:alignmentstyle}{cmd:))} ...

{pstd}
Sometimes an {it:alignmentstylelist} is allowed.  An
{it:alignmentstylelist} is a sequence of {it:alignmentstyles} separated by
spaces.  Shorthands are allowed to make specifying the list easier; see 
{manhelpi stylelists G}.


{title:Remarks}

{pstd}
Think of the text as being horizontal, even if it is not, and think of
the textbox as containing one line, such as

	{cmd:Hpqgxyz}

{pstd}
{cmd:alignment()} specifies how the bottom of the textbox aligns with the
bottom of the text.

{pstd}
{cmd:alignment(baseline)} specifies that the bottom of the textbox
be the baseline of the letters in the box.  That would result in something
like

	{cmd:....Hpqgxyz....}

{pstd}
where dots represent the bottom of the textbox.  Periods in most fonts are
located on the baseline of letters.  Note how the letters {cmd:p}, {cmd:q},
{cmd:g}, and {cmd:y} extend below the baseline.

{pstd}
{cmd:alignment(bottom)} specifies that the bottom of the textbox be
the bottom of the letters, which would be below the dots in the above example,
lining up with the lowest part of the {cmd:p}, {cmd:q}, {cmd:g} and {cmd:y}.

{pstd}
{cmd:alignment(middle)} specifies that the middle of the textbox line
up with the middle of a capital {cmd:H}.  This is useful when you want to
align text with a line.

{pstd}
{cmd:alignment(top)} specifies that the top of the textbox line up
with the top of a capital {cmd:H}.


{title:Also see}

{psee}
Manual:  {bf:[G] {it:alignmentstyle}}

{psee}
Online:  {manhelpi textbox_options G};
{manhelpi justificationstyle G}
{p_end}
