{smcl}
{* *! version 1.0.6  06jan2009}{...}
{cmd:help capture}
{hline}

{title:Title}

{p2colset 5 20 22 2}{...}
{p2col :{hi:[P] capture} {hline 2}}Capture return code{p_end}
{p2colreset}{...}


{title:Syntax}

	{cmdab:cap:ture} [{cmd::}] {it:command}


{title:Description}

{pstd}
{cmd:capture} executes {it:command}, suppressing all its output
(including error messages, if any) and issues a return code of zero.  The
actual return code generated by {it:command} is stored in the built-in
scalar {cmd:_rc}.

{pstd}
{cmd:capture} can be combined with {cmd:{c -(}}{cmd:{c )-}} to produce capture
blocks, which suppress output for the block of commands.


{title:Remarks}

{pstd}
{cmd:capture} is useful in do-files and programs since their execution
terminates when a command issues a nonzero return code.  Preceding sensitive
commands with the word {cmd:capture} allows the do-file or program to
continue despite of errors.  Also do-files and programs can be made
to respond appropriately to any situation by conditioning their remaining
actions on the content of the scalar {cmd:_rc}.

{pstd} 
{cmd:capture} can be combined with {cmd:noisily} to display the output and
any error messages regardless of the return code.  For example, 

{phang2}{cmd:. capture noisily regress y x} {p_end}

{pstd}
will either display an error message and store the return code in {cmd:_rc} or 
display the output and store a return code of zero in {cmd:_rc}.


{title:Also see}

{psee}
Manual:  {bf:[P] capture}

{psee}
Online:  {manhelp break P}, {manhelp confirm P}, {manhelp noisily P}
{p_end}
