{smcl}
{* *! version 1.0.6  14may2008}{...}
{cmd:help cat_axis_label_options}
{hline}
{* index axis line, look of}{...}

{title:Title}

{p2colset 5 35 37 2}{...}
{p2col :{hi:[G] {it:cat_axis_label_options}} {hline 2}}Options for specifying look of categorical axis labels{p_end}
{p2colreset}{...}


{title:Syntax}

{p2colset 9 40 42 2}{...}
{p2col:{it:cat_axis_label_options}}
	description{p_end}
{p2line}
{p2col:{cmdab:nolab:els}}
	suppress axis labels{p_end}
{p2col:{cmdab:tick:s}}
	display axis ticks{p_end}
{p2col:{cmd:angle(}{it:{help anglestyle}}{cmd:)}}
	angle of axis labels{p_end}
{p2col:{cmdab:alt:ernate}}
	offset adjacent labels{p_end}

{p2col:{cmdab:tsty:le:(}{it:{help tickstyle}}{cmd:)}}
	labels & ticks: overall style{p_end}

{p2col:{cmd:labgap(}{it:{help relativesize}}{cmd:)}}
	labels: margin between tick and label{p_end}
{p2col:{cmd:labstyle(}{it:{help textstyle}}{cmd:)}}
	labels: overall style{p_end}
{p2col:{cmdab:labs:ize:(}{it:{help textsizestyle}}{cmd:)}}
	labels: size of text{p_end}
{p2col:{cmdab:labc:olor:(}{it:{help colorstyle}}{cmd:)}}
	labels: color of text{p_end}

{p2col:{cmdab:tl:ength:(}{it:{help relativesize}}{cmd:)}}
	ticks: length{p_end}
{p2col:{cmdab:tp:osition:(}{cmdab:o:utside}|{cmdab:c:rossing}|}{p_end}
{p2col 32 40 42 2:{cmdab:i:nside:)}}
	ticks: position/direction{p_end}
{p2col:{cmdab:tlsty:le:(}{it:{help linestyle}}{cmd:)}}
	ticks: linestyle of{p_end}
{p2col:{cmdab:tlw:idth:(}{it:{help linewidthstyle}}{cmd:)}}
	ticks: thickness of line{p_end}
{p2col:{cmdab:tlc:olor:(}{it:{help colorstyle}}{cmd:)}}
	ticks: color of line{p_end}
{p2line}
{p2colreset}{...}


{title:Description}

{pstd}
The {it:cat_axis_label_options} determine the look of the labels that appear
on a categorical {it:x} axis produced by {cmd:graph} {cmd:bar}, {cmd:graph}
{cmd:hbar}, {cmd:graph} {cmd:dot}, and {cmd:graph} {cmd:box}.  These options
are specified inside {cmd:label()} of {cmd:over()}:

{phang2}
	. {cmd:graph} ...{cmd:, over(}{it:varname}{cmd:,} ... {cmd:label(}{it:cat_axis_label_options}{cmd:)} ...{cmd:)}

{pstd}
The most useful
{it:cat_axis_label_options} are
{cmd:angle()}, {cmd:alternate}, {cmd:labcolor()}, and {cmd:labsize()}.


{title:Options}

{phang}
{cmd:nolabels}
    suppresses display of category labels on the axis.  For 
    {cmd:graph} {cmd:bar} and {cmd:graph} {cmd:hbar}, the {cmd:nolabels}
    option is useful when combined with the {cmd:blabel()} option used to
    place the labels on the bars themselves; see {manhelpi blabel_option G}.

{phang}
{cmd:ticks}
    specifies that ticks appear on the categorical {it:x} axis.
    By default, ticks are not presented on categorical axes, and it is unlikely
    that you would want them to be.

{phang}
{cmd:angle(}{it:anglestyle}{cmd:)}
    specifies the angle at which the labels on the axis
    appear.  The default is {cmd:angle(0)}, meaning horizontal.  With
    vertical bar charts and other vertically oriented charts,
    it is sometimes useful to specify
    {cmd:angle(90)} (vertical text reading bottom to top),
    {cmd:angle(-90)} (vertical text reading top to bottom), or
    {cmd:angle(-45)} (angled text reading top-left to bottom-right);
    see {manhelpi anglestyle G}.

{pmore}
    Unix users:  if you specify {cmd:angle(-45)}, results will appear on your
    screen as if you specified {cmd:angle(-90)}; results will appear correctly
    when you print.

{phang}
{cmd:alternate}
    causes adjacent labels to be offset from one another and is useful when
    there are many labels or when labels are long.  For instance, rather than
    obtaining an axis labeled,

	    {hline 4}{c TT}{hline 9}{c TT}{hline 9}{c TT}{hline 9}{c TT}{hline 4}
	     ResearchDevelopmentMarketing   Sales

{pmore}
    with {cmd:alternate}, you obtain

	    {hline 4}{c TT}{hline 9}{c TT}{hline 9}{c TT}{hline 9}{c TT}{hline 4}
	     Research           Marketing
		     Development            Sales

{phang}
{cmd:tstyle(}{it:tickstyle}{cmd:)}
    specifies the overall look of labels and ticks.  Here the
    emphasis is on labels since ticks are usually suppressed on a categorical
    axis.  The options documented below will allow you to change each
    attribute of the label and tick, but the {it:tickstyle} specifies the
    starting point.

{pmore}
    You need not specify {cmd:tstyle()} just because there is something
    you want to change about the look of labels and ticks.  You specify
    {cmd:tstyle()} when another style exists that is exactly what you desire
    or when another style would allow you to specify fewer changes to obtain
    what you want.

{phang}
{cmd:labgap()},
{cmd:labstyle()},
{cmd:labsize()}, and
{cmd:labcolor()}
    specify details about how the labels are presented.  Of particular
    interest are {cmd:labsize(}{it:textsizestyle}{cmd:)}, which specifies the
    size of the labels, and {cmd:labcolor(}{it:colorstyle}{cmd:)}, which
    specifies the color of the labels; see {manhelpi textsizestyle G} and
    {manhelpi colorstyle G} for a list of color choices.

{phang}
{cmd:tlength(}{it:relativesize}{cmd:)}
    specifies the overall length of the ticks.

{phang}
{cmd:tposition(outside}|{cmd:crossing}|{cmd:inside)}
    specifies whether the ticks are to extend {cmd:outside} (from the axis
    out, the usual default), {cmd:crossing} (crossing the axis
    line, extending in and out), or {cmd:inside} (from the axis
    into the plot region).

{phang}
{cmd:tlstyle()},
{cmd:tlwidth()}, and
{cmd:tlcolor()}
    specify other details about the look of the ticks.
    Ticks are just lines.
    See {help lines} for more information.


{title:Remarks}

{pstd}
You draw a bar, dot, or box plot of {cmd:empcost} by {cmd:division}:

{phang2}
	{cmd:. graph} ... {cmd:empcost, over(division)}

{pstd}
Seeing the result, you wish to make the text labeling the divisions 20%
larger.  You type:

{phang2}
	. {cmd:graph} ... {cmd:empcost, over(division, label(labsize(*1.2)))}


{title:Also see}

{psee}
Manual:  {bf:[G] {it:cat_axis_label_options}}

{psee}
Online:  {manhelp graph_bar G:graph bar},
{manhelp graph_box G:graph box},
{manhelp graph_dot G:graph dot}
{p_end}
