{smcl}
{* *! version 1.0.4  14may2008}{...}
{cmd:help cat_axis_line_options}
{hline}
{* index axis line, look of}{...}

{title:Title}

{p2colset 5 34 36 2}{...}
{p2col :{hi:[G] {it:cat_axis_line_options}} {hline 2}}Options for specifying look of categorical axis line{p_end}
{p2colreset}{...}


{title:Syntax}

{p2colset 9 40 42 2}{...}
{p2col:{it:cat_axis_line_options}}
	description{p_end}
{p2line}
{p2col:{cmd:off} and {cmd:on}}
	suppress/force display of axis{p_end}
{p2col:{cmd:fill}}
	allocate space for axis even if {cmd:off}{p_end}
{p2col:{cmdab:fex:tend}}
	extend axis line through plot region and plot region's margin{p_end}
{p2col:{cmdab:ex:tend}}
	extend axis line through plot region{p_end}
{p2col:{cmdab:noex:tend}}
	do not extend axis line at all{p_end}
{p2col:{cmdab:noli:ne}}
	do not even draw axis line{p_end}
{p2col:{cmdab:li:ne}}
	force drawing of axis line{p_end}

{p2col:{cmdab:titleg:ap:(}{it:{help relativesize}}{cmd:)}}
	margin between axis title and tick labels{p_end}
{p2col:{cmdab:outerg:ap:(}{it:{help relativesize}}{cmd:)}}
	margin outside of axis title{p_end}

{p2col:{cmdab:lsty:le:(}{it:{help linestyle}}{cmd:)}}
	overall style of axis line{p_end}
{p2col:{cmdab:lc:olor:(}{it:{help colorstyle}}{cmd:)}}
	color of axis line{p_end}
{p2col:{cmdab:lw:idth:(}{it:{help linewidthstyle}}{cmd:)}}
	thickness of axis line{p_end}
{p2col:{cmdab:lp:attern:(}{it:{help linepatternstyle}}{cmd:)}}
	whether axis solid, dashed, etc.{p_end}
{p2line}
{p2colreset}{...}


{title:Description}

{pstd}
The {it:cat_axis_line_options} determine the look of the categorical {it:x}
axis in {cmd:graph} {cmd:bar}, {cmd:graph} {cmd:hbar}, {cmd:graph} {cmd:dot},
and {cmd:graph} {cmd:box}.  These options are rarely specified but when
specified, they are specified inside {cmd:axis()} of {cmd:over()}:

{phang2}
	{cmd:. graph} ...{cmd:, over(}{it:varname}{cmd:,} ... {cmd:axis(}{it:cat_axis_line_options}{cmd:)} ...{cmd:)}


{title:Options}

{phang}
{cmd:off} and {cmd:on}
    suppress or force the display of the axis.

{phang}
{cmd:fill} goes with {cmd:off} and is seldom
    specified.  If you turned an axis off but still wanted the space to be
    allocated for the axis, you could specify {cmd:fill}.

{phang}
{cmd:fextend}, {cmd:extend}, {cmd:noextend}, {cmd:line}, and {cmd:noline}
    determine how much of the line representing the axis is to be drawn.  They
    are alternatives.

{pmore}
    {cmd:noline} specifies that the line not be drawn at all.  The axis
    is there, ticks and labels will appear, but the axis line itself will not
    be drawn.

{pmore}
    {cmd:line} is the opposite of {cmd:noline}, for use if the axis line
    somehow got turned off.

{pmore}
    {cmd:noextend} specifies that the axis line not extend beyond the
    range of the axis, defined by the first and last categories.

{pmore}
    {cmd:extend} specifies that the line be longer than that and extend
    all the way across the plot region.

{pmore}
    {cmd:fextend} specifies that the line be longer than that and
    extend across the plot region and across the plot region's margins.  For a
    definition of the plot region's margins, see 
    {manhelpi region_options G}.  If the plot region has no margins (which
    would be rare), then {cmd:fextend} means the same as {cmd:extend}.  If the
    plot region does have margins, {cmd:extend} would result in the {it:y} and
    {it:x} axes not meeting.  With {cmd:fextend}, they touch.

{pmore}
    {cmd:fextend} is the default with most schemes.

{phang}
{cmd:titlegap(}{it:relativesize}{cmd:)} specifies the margin to be inserted
     between the axis title and the axis' tick labels.

{phang}
{cmd:outergap(}{it:relativesize}{cmd:)} specifies the margin to be inserted
     outside the axis title.

{phang}
{cmd:lstyle(}{it:linestyle}{cmd:)},
{cmd:lcolor(}{it:colorstyle}{cmd:)},
{cmd:lwidth(}{it:linewidthstyle}{cmd:)}, and
{cmd:lpattern(}{it:linepatternstyle}{cmd:)}
determine the overall look of the line that is the axis;
see {help lines}.


{title:Remarks}

{pstd}
The {it:cat_axis_line_options} are rarely specified.


{title:Also see}

{psee}
Manual:  {bf:[G] {it:cat_axis_line_options}}

{psee}
Online:  
{manhelp graph_bar G:graph bar},
{manhelp graph_box G:graph box},
{manhelp graph_dot G:graph dot}
{p_end}
