{smcl}
{* *! version 1.0.5  14may2008}{...}
{cmd:help cline_options}
{hline}
{* index connect() tt option}{...}

{title:Title}

{p2colset 5 26 28 2}{...}
{p2col :{hi:[G] {it:cline_options}} {hline 2}}Options for connecting points with lines (subset of connect options){p_end}
{p2colreset}{...}


{title:Syntax}

{p2colset 9 40 42 2}{...}
{p2col:{it:cline_options}}
	description{p_end}
{p2line}
{p2col:{cmdab:c:onnect:(}{it:{help connectstyle}}{cmd:)}}
	how to connect points{p_end}

{p2col:{cmdab:lp:attern:(}{it:{help linepatternstyle}}{cmd:)}}
	line pattern (solid, dashed, etc.){p_end}
{p2col:{cmdab:lw:idth:(}{it:{help linewidthstyle}}{cmd:)}}
	thickness of line{p_end}
{p2col:{cmdab:lc:olor:(}{it:{help colorstyle}}{cmd:)}}
	color of line{p_end}
{p2col:{cmdab:lsty:le:(}{it:{help linestyle}}{cmd:)}}
	overall style of line{p_end}

{p2col:{cmdab:psty:le:(}{it:{help pstyle}}{cmd:)}}
	overall plot style, including linestyle{p_end}

{p2col:{help advanced_options:{bf:recast(}{it:newplottype}{bf:)}}}
	advanced; treat plot as {it:newplottype}{p_end}
{p2line}
{p2colreset}{...}
{pin}All options are {it:rightmost}; see {help repeated options}.{p_end}
{pin}Some plots do not allow {cmd:recast()}.{p_end}


{title:Description}

{pstd}
The {it:cline_options} specify how points on a graph are
to be connected.

{pstd}
In certain contexts (e.g., {manhelp scatter G}), the {cmd:lpattern()},
{cmd:lwidth()}, {cmd:lcolor()}, and {cmd:lstyle()} options may be specified
with a list of elements, with the first element applying to the first
variable, the second element to the second variable, and so on.  For
information on specifying lists, see {manhelpi stylelists G}.


{title:Options}

{phang}
{opt connect(connectstyle)} specifies whether points are to be connected and,
if so, how the line connecting them is to be shaped.  The line between each
pair of points can connect them directly or in stairstep fashion.

{phang}
{cmd:lpattern(}{it:linepatternstyle}{cmd:)},
{cmd:lwidth(}{it:linewidthstyle}{cmd:)},
{cmd:lcolor(}{it:colorstyle}{cmd:)}, and
{cmd:lstyle(}{it:linestyle}{cmd:)}
    determine the look of the line used to connect the points; see 
    {help lines}.  Note the {cmd:lpattern()} option, which
    allows you to specify whether the line is solid, dashed, etc.;
    see {manhelpi linepatternstyle G} for a list of line-pattern choices.

{phang}
{cmd:pstyle(}{it:pstyle}{cmd:)}
    specifies the overall style of the plot, including not only the linestyle
    but also all other settings for the look of the plot.  Only the 
    {it:{help linestyle}} affects the look of {cmd:line} plots.  See 
    {manhelpi pstyle G} for a list of available plot styles.

{phang}
{cmd:recast(}{it:newplottype}{cmd:)}
        is an advanced option allowing the plot to be recast from one type to
        another, for example, from a {help twoway line:line plot} to a
        {help twoway scatter:scatterplot}; see
        {manhelpi advanced_options G}.  Most, but not all, plots allow
        {cmd:recast()}.


{title:Remarks}

{pstd}
An important option among all the above is {cmd:connect()}, which  determines
whether and how the points are connected.  The points need not be connected at
all ({cmd:connect(i)}), which is {cmd:scatter}'s default.  Or the points might
be connected by straight lines ({cmd:connect(l)}), which is {cmd:line}'s
default (and is available in {cmd:scatter}).  {cmd:connect(i)} and
{cmd:connect(l)} are commonly specified, but there are other possibilities
such as {cmd:connect(J)}, which connects in stairstep fashion and is
appropriate for empirical distributions.  See {manhelpi connectstyle G}
for a full list of your choices.

{pstd}
The remaining connect options specify how the line is to look:  Is it solid or
dashed?  Is it red or green?  How thick is it?  Option
{cmd:lpattern()} can be of great importance, especially when printing to a
monochrome printer.  For a general discussion of lines (which occur in
many contexts other than connecting points), see {help lines}.


{title:Also see}

{psee}
Manual:  {bf:[G] {it:cline_options}}

{psee}
Online:  
{manhelp lines G:concept: lines};
{manhelpi colorstyle G},
{manhelpi connectstyle G},
{manhelpi linestyle G},
{manhelpi linepatternstyle G},
{manhelpi linewidthstyle G}
{p_end}
