{smcl}
{* *! version 1.1.9  20nov2008}{...}
{cmd:help clogit postestimation}{right:dialog:  {bf:{dialog clogit_p:predict}}}
{right:also see:  {helpb clogit} }
{hline}

{title:Title}

{p2colset 5 34 36 2}{...}
{p2col :{hi:[R] clogit postestimation} {hline 2}}Postestimation tools for 
clogit{p_end}
{p2colreset}{...}


{title:Description}

{pstd}
The following postestimation commands are available for {cmd:clogit}:

{synoptset 13 notes}{...}
{p2coldent :command}description{p_end}
{synoptline}
INCLUDE help post_adjust3
INCLUDE help post_estat
INCLUDE help post_svy_estat
INCLUDE help post_estimates
INCLUDE help post_hausman
INCLUDE help post_lincom
{p2coldent:(1) {helpb linktest}}link test for model specification{p_end}
{p2coldent:(2) {helpb lrtest}}likelihood-ratio test{p_end}
INCLUDE help post_mfx
INCLUDE help post_nlcom
{synopt :{helpb clogit postestimation##predict:predict}}predictions, residuals, influence statistics, and other diagnostic measures{p_end}
INCLUDE help post_predictnl
INCLUDE help post_suest
INCLUDE help post_test
INCLUDE help post_testnl
{synoptline}
{p2colreset}{...}
{p 4 6 2}
(1) {cmd:linktest} is not available with {cmd:svy} estimation results.
{p_end}
{p 4 6 2}
(2) {cmd:lrtest} is not appropriate with {cmd:svy} estimation results.
{p_end}


{marker predict}{...}
{title:Syntax for predict}

{p 8 16 2}
{cmd:predict} 
{dtype}
{newvar}
{ifin}
[{cmd:,} {it:statistic} {opt nooff:set}]

{synoptset 11 tabbed}{...}
{synopthdr:statistic}
{synoptline}
{syntab :Main}
{synopt :{opt pc1}}probability of a positive outcome; the default
{p_end}
{synopt :{opt pu0}}probability of a positive outcome, assuming
fixed effect is zero{p_end}
{synopt :{opt xb}}linear prediction{p_end}
{synopt :{opt stdp}}standard error of the linear prediction{p_end}
{p2coldent :* {opt db:eta}}Delta-b influence statistic{p_end}
{p2coldent :* {opt dx:2}}Delta chi-squared lack-of-fit statistic{p_end}
{p2coldent :* {opt gdb:eta}}Delta-b influence statistic for each group{p_end}
{p2coldent :* {opt gdx:2}}Delta chi-squared lack-of-fit statistic for each group{p_end}
{p2coldent :* {opt h:at}}Hosmer and Lemeshow leverage{p_end}
{p2coldent :* {opt r:esiduals}}Pearson residuals{p_end}
{p2coldent :* {opt rsta:ndard}}standardized Pearson residuals{p_end}
{synopt :{opt sc:ore}}first derivative of the log likelihood with respect to xb{p_end}
{synoptline}
{p2colreset}{...}
INCLUDE help unstarred

{p 4 6 2}Starred statistics are available for multiple controls per
case-matching design only. They are not available if {cmd:vce(robust)},
{cmd:vce(cluster} {it:clustvar}{cmd:)}, or {cmd:pweight}s were specified with
{cmd:clogit}.

{p 4 6 2}{opt dbeta}, {opt dx2}, {opt gdbeta}, {opt gdx2}, {opt hat} and 
{opt rstandard} are not available if {opt constraints()} were specified with
{cmd:clogit}.


{title:Options for predict}

{dlgtab:Main}

{phang}
{opt pc1}, the default, calculates the probability of a
positive outcome conditional on one positive outcome within group.

{phang}
{opt pu0} calculates the probability of a positive outcome, assuming that
the fixed effect is zero.

{phang}
{opt xb} calculates the linear prediction.

{phang}
{opt stdp} calculates the standard error of the linear prediction.

{phang}
{opt dbeta} calculates the Delta-b influence statistic, a standardized measure
of the difference in the coefficient vector that is due to deletion of the
observation.

{phang}
{opt dx2} calculates the Delta chi-squared influence statistic, reflecting the
decrease in the Pearson chi-squared that is due to deletion of the observation.

{phang}
{opt gdbeta} calculates the approximation to the Pregibon stratum-specific
Delta-b influence statistic, a standardized measure of the difference in the
coefficient vector that is due to deletion of the entire stratum.

{phang}
{opt gdx2} calculates the approximation to the Pregibon stratum-specific Delta
chi-squared influence statistic, reflecting the decrease in the Pearson
chi-squared that is due to deletion of the entire stratum.

{phang}
{opt hat} calculates the Hosmer and Lemeshow leverage or the diagonal element
of the hat matrix.

{phang}
{opt residuals} calculates the Pearson residuals.

{phang}
{opt rstandard} calculates the standardized Pearson residuals.

{phang}
{opt score} calculates the equation-level score, the derivative of the log
likelihood with respect to the linear prediction.

{phang}
{opt nooffset} is relevant only if you specified {cmd:offset({varname})} for
{cmd:clogit}. It modifies the calculations made by {cmd:predict} so that they
ignore the offset variable; the linear prediction is treated as xb rather than
as xb + offset.  This option cannot be specified with {opt dbeta},
{opt dx2}, {opt gdbeta}, {opt gdx2}, {opt hat} and {opt rstandard}.


{title:Examples}

{pstd}Setup{p_end}
{phang2}{cmd:. webuse lowbirth}{p_end}

{pstd}Fit conditional logistic regression{p_end}
{phang2}{cmd:. clogit low lwt smoke ptd ht ui race2 race3, strata(pairid)}

{pstd}Test that the coefficient on {cmd:race2} equals the coefficient on
{cmd:race3}{p_end}
{phang2}{cmd:. test race2 = race3}{p_end}

{pstd}Predict the probability of a positive outcome conditional on one
positive outcome within group{p_end}
{phang2}{cmd:. predict pc}{p_end}

{pstd}Predict Hosmer and Lemeshow leverage{p_end}
{phang2}{cmd:. predict hat, hat}


{title:Also see}

{psee}
Manual:  {bf:[R] clogit postestimation}

{psee}
Online:  {manhelp clogit R}
{p_end}
