{smcl}
{* *! version 1.0.12  20nov2008}{...}
{cmd:help cloglog postestimation} {right:dialog:  {bf:{dialog clog_p:predict}}}
{right:also see:  {bf:{help cloglog}}}
{hline}

{title:Title}

{p2colset 5 35 37 2}{...}
{p2col :{hi:[R] cloglog postestimation} {hline 2}}Postestimation tools for cloglog{p_end}
{p2colreset}{...}


{title:Description}

{pstd}
The following postestimation commands are available for {cmd:cloglog}:

{synoptset 13 notes}{...}
{p2coldent :command}description{p_end}
{synoptline}
INCLUDE help post_adjust2par
INCLUDE help post_estat
INCLUDE help post_svy_estat
INCLUDE help post_estimates
INCLUDE help post_lincom
{p2coldent:(2) {helpb linktest}}link test for model specification{p_end}
{p2coldent:(3) {helpb lrtest}}likelihood-ratio test{p_end}
INCLUDE help post_mfx
INCLUDE help post_nlcom
{synopt :{helpb cloglog postestimation##predict:predict}}predictions, residuals, influence statistics, and other diagnostic measures{p_end}
INCLUDE help post_predictnl
INCLUDE help post_suest
INCLUDE help post_test
INCLUDE help post_testnl
{synoptline}
{p2colreset}{...}
{p 4 6 2}(1) {cmd:adjust} is not appropriate with time-series operators.{p_end}
{p 4 6 2}
(2) {cmd:linktest} is not available with {cmd:svy} estimation results.
{p_end}
{p 4 6 2}
(3) {cmd:lrtest} is not appropriate with {cmd:svy} estimation results.
{p_end}


{marker predict}{...}
{title:Syntax for predict}

{phang2}{cmd:predict}
{dtype}
{newvar}
{ifin}
[{cmd:,} {it:statistic} {cmdab:nooff:set}]

{synoptset 11 tabbed}{...}
{synopthdr:statistic}
{synoptline}
{syntab :Main}
{synopt :{opt p:r}}probability of a positive outcome; the default{p_end}
{synopt :{opt xb}}linear prediction{p_end}
{synopt :{opt stdp}}standard error of the linear prediction{p_end}
{synopt :{opt sc:ore}}first derivative of the log likelihood with respect to xb{p_end}
{synoptline}
{p2colreset}{...}
INCLUDE help esample


{title:Options for predict}

{dlgtab:Main}

{phang}
{opt pr}, the default, calculates the probability of a positive outcome.

{phang}
{opt xb} calculates the linear prediction.

{phang}
{opt stdp} calculates the standard error of the linear prediction.

{phang}
{opt score} calculates the equation-level score, the derivative of the log
likelihood with respect to the linear prediction.

{phang}
{opt nooffset} is relevant only if you specified {opth offset(varname)} for
{cmd:cloglog}.  It modifies the calculations made by {opt predict} so that they
ignore the offset variable; the linear prediction is treated as xb rather than
xb + offset.


{title:Examples}

{pstd}Setup{p_end}
{phang2}{cmd:. sysuse auto}{p_end}
{phang2}{cmd:. cloglog foreign weight mpg}{p_end}
{phang2}{cmd:. estimates store cloglog}{p_end}
{phang2}{cmd:. logit foreign weight mpg}{p_end}
{phang2}{cmd:. estimates store logit}{p_end}

{pstd}Perform seemingly unrelated estimation so that we can compare the
estimates from the two fitted models{p_end}
{phang2}{cmd:. suest cloglog logit}

{pstd}Display the coefficient matrix to learn how the equations are
named{p_end}
{phang2}{cmd:. matrix list e(b)}

{pstd}Test that the estimates from the two fitted models are the same{p_end}
{phang2}{cmd:. test [cloglog_foreign = logit]}


{title:Also see}

{psee}
Manual:  {bf:[R] cloglog postestimation}

{psee}
Online:  {manhelp cloglog R}
{p_end}
