{smcl}
{* *! version 1.2.2  13may2008}{...}
{cmd:help dates and times}
{hline}
{* index dates and times}{...}
{* index time variables and values}{...}
{* index %t values and formats}{...}
{* index pseudofunctions}{...}
{* index tc() pseudofunction}{...}
{* index tC() pseudofunction}{...}
{* index td() pseudofunction}{...}
{* index tw() pseudofunction}{...}
{* index tm() pseudofunction}{...}
{* index tq() pseudofunction}{...}
{* index th() pseudofunction}{...}
{* index mdyhms() function}{...}
{* index dhms() function}{...}
{* index hms() function}{...}
{* index Cmdyhms() function}{...}
{* index Cdhms() function}{...}
{* index Chms() function}{...}
{* index mdy() function}{...}
{* index Cofc() function}{...}
{* index dofc() function}{...}
{* index cofC() function}{...}
{* index dofC() function}{...}
{* index cofd() function}{...}
{* index Cofd() function}{...}
{* index wofd() function}{...}
{* index mofd() function}{...}
{* index qofd() function}{...}
{* index hofd() function}{...}
{* index yofd() function}{...}
{* index dofw() function}{...}
{* index dofm() function}{...}
{* index dofq() function}{...}
{* index dofh() function}{...}
{* index dofy() function}{...}
{* index year() function}{...}
{* index month() function}{...}
{* index day() function}{...}
{* index doy() function}{...}
{* index halfyear() function}{...}
{* index quarter() function}{...}
{* index week() function}{...}
{* index dow() function}{...}
{* index hh() function}{...}
{* index mm() function}{...}
{* index ss() function}{...}
{* index hhC() function}{...}
{* index mmC() function}{...}
{* index ssC() function}{...}
{* index hours() function}{...}
{* index minutes() function}{...}
{* index seconds() function}{...}
{* index msofhours() function}{...}
{* index msofminutes() function}{...}
{* index msofseconds() function}{...}
{* index clock() function}{...}
{* index Clock() function}{...}
{* index date() function}{...}
{* index weekly() function}{...}
{* index monthly() function}{...}
{* index quarterly() function}{...}
{* index halfyearly() function}{...}
{* index yearly() function}{...}
{* index yw() function}{...}
{* index ym() function}{...}
{* index yq() function}{...}
{* index yh() function}{...}


{title:Title}

{p2colset 5 28 30 2}{...}
{p2col :{hi:[D] dates and times} {hline 2}}Date and time (%t) values and
variables{p_end}
{p2colreset}{...}


{title:Syntax}

{p 4 4 2}
Syntax is presented under the following headings:

	{help dates_and_times##how:How Stata records dates and times}
	{help dates_and_times##inputting:Inputting date and time data}
        {help dates_and_times##sttypes:Recommended storage types for %t variables}
	{help dates_and_times##typing:Typing dates and times}
	{help dates_and_times##constructing:Constructing date and time values from numerical components}
	{help dates_and_times##converting:Converting date and time values}
	{help dates_and_times##extracting:Extracting date and time components}
	{help dates_and_times##durations:Obtaining and working with durations}
	{help dates_and_times##formatting:Formatting date and time values}

{p 4 4 2}
Click {help dates_and_times##description:here} to skip to the Description and Remarks.


{marker how}{...}
    {title:How Stata records dates and times}

{p 8 8 2}
Dates and times are called {cmd:%t} values.  
{cmd:%t} values are numerical and integral.  The integral value records 
the number of time units that have passed from an agreed-upon base,
which for Stata is 1960.

{p 8 8 2}
Coding and interpretation of date and time ({cmd:%t}) values are as follows:

        {c TLC}{hline 8}{c TT}{hline 12}{c TT}{hline 47}{c TRC}
        {c |}        {c |}            {c |} ----- Numerical value & interpretation ------ {c |}
        {c |} Format {c |} Meaning    {c |}   Value = -1  {c |}   {bf:Value = 0}   {c |}   Value = 1   {c |}
        {c LT}{hline 8}{c +}{hline 12}{c +}{hline 15}{c +}{hline 15}{c +}{hline 15}{c RT}
        {c |}  {cmd:%tc}   {c |} clock      {c |}   31dec1959   {c |}   {bf:01jan1960}   {c |}   01jan1960   {c |}
        {c |}        {c |}            {c |}  23:59:59.999 {c |}  {bf:00:00:00.000} {c |}  00:00:00.001 {c |}
        {c |}        {c |}            {c |}               {c |}               {c |}               {c |}
        {c |}  {cmd:%td}   {c |} days       {c |}   31dec1959   {c |}   {bf:01jan1960}   {c |}   02jan1960   {c |}
        {c |}        {c |}            {c |}               {c |}               {c |}               {c |}
        {c |}  {cmd:%tw}   {c |} weeks      {c |}    1959w52    {c |}    {bf:1960w1}     {c |}     1960w2    {c |}
        {c |}        {c |}            {c |}               {c |}               {c |}               {c |}
        {c |}  {cmd:%tm}   {c |} months     {c |}    1959m12    {c |}    {bf:1960m1}     {c |}     1960m2    {c |}
        {c |}        {c |}            {c |}               {c |}               {c |}               {c |}
        {c |}  {cmd:%tq}   {c |} quarters   {c |}    1959q4     {c |}    {bf:1960q1}     {c |}     1960q2    {c |}
        {c |}        {c |}            {c |}               {c |}               {c |}               {c |}
        {c |}  {cmd:%th}   {c |} half years {c |}    1959h2     {c |}    {bf:1960h1}     {c |}     1960h2    {c |}
        {c |}        {c |}            {c |}               {c |}               {c |}               {c |}
        {c |}  {cmd:%tg}   {c |} generic    {c |}      -1       {c |}      {bf:0}        {c |}       1       {c |}
        {c BLC}{hline 8}{c BT}{hline 12}{c BT}{hline 15}{c BT}{hline 15}{c BT}{hline 15}{c BRC}
{p 8 8 2}
        {it:Explanation:} the middle, bolded column shows the {bf:base}
        {bf:value}.  For a {cmd:%td} value, 0 means 01jan1960.  The
        table also shows that -1 means 31dec1959 and 1 means 02jan1960.  A
        {cmd:%td} value records the number of days from 01jan1960.
        A {cmd:%tc} value records the number of milliseconds from 
        the start of 01jan1960, a {cmd:%tw} value records the number of 
        weeks from the first week of 1960, and so on.

{p 8 8 2}
That is,

{p 12 12 2}
     For a {cmd:%tc} value, a 1-unit change represents 1 ms.

{p 16 16 2}
         Integer 394,839,482,000 represents 05jul1972 21:38:02.000 because
         that date occurred 394,839,482,000 ms after 01jan1960
         00:00:00.000.

{p 16 16 2}
         Integer -394,839,482,000 represents 28jun1947 02:21:58.000 because
         that date occurred 394,839,482,000 ms before 01jan1960
         00:00:00.000.

{p 12 12 2}
     For a {cmd:%td} value, a 1-unit change represents 1 day.

{p 16 16 2}
         Integer 4,569 represents 05jul1972 because that date occurred 4,569
         days after 01jan1960.

{p 16 16 2}
         Integer -4,569 represents 29jun1947 because that date occurred 4,569
         days before 01jan1960.

{p 12 12 2}
     For a {cmd:%tw} value, a 1-unit change represents 1 week.

{p 16 16 2}
         Integer 650 represents 1972w27 because that date occurred 650 weeks
         after 1960w1.

{p 16 16 2}
         Integer -650 represents 1947w27 because that date occurred 650 weeks
         before 1960w1.

{p 12 12 2}
     For a {cmd:%tm} value, a 1-unit change represents 1 month.

{p 16 16 2}
         Integer 150 represents 1972m7 because that date occurred 150 calendar
         months after 1960m1.

{p 16 16 2}
         Integer -150 represents 1947m7 because that date occurred 150 calendar
         months before 1960m1.

{p 12 12 2}
For a {cmd:%tq} value, a 1-unit change represents one quarter (3 calendar months).

{p 16 16 2}
	Integer 50 represents 1972q3 because that date occurred 50 quarters 
        after 1960q1.

{p 16 16 2}
	Integer -50 represents 1947q3 because that date occurred 50 quarters
	before 1960q1.

{p 12 12 2}
     For a {cmd:%th} value, a 1-unit change represents one half-year, or
     6 months.

{p 16 16 2}
        Integer 25 represents 1972h2 because that date occurred 25 half years
        after 1960h1.

{p 16 16 2}
        Integer -25 represents 1947h2 because that date occurred 25 half years
        before 1960h1.

{p 12 12 2}
     For a {cmd:%tg} value, a 1-unit change represents whatever you wish.

{p 16 16 2}
         Integer 100 might represent 100 workdays, or 100 lunar months, or
         anything else, after some agreed-upon event, such as 01jan1960, or
         the date you were born, or anything else.

{p 16 16 2}
         Negative values would represent times before the event.

{p 8 8 2}
In addition to the above, there is {cmd:%ty}:

        {c TLC}{hline 8}{c TT}{hline 11}{c TT}{hline 48}{c TRC}
        {c |}        {c |}           {c |} ------ Numerical value & interpretation ------ {c |}
        {c |} Format {c |} Meaning   {c |}     1959      {c |}     1960      {c |}      1961      {c |}
        {c LT}{hline 8}{c +}{hline 11}{c +}{hline 15}{c +}{hline 15}{c +}{hline 16}{c RT}
        {c |}  {cmd:%ty}   {c |} year      {c |}     1959      {c |}     1960      {c |}      1961      {c |}
        {c BLC}{hline 8}{c BT}{hline 11}{c BT}{hline 15}{c BT}{hline 15}{c BT}{hline 16}{c BRC}

{p 8 8 2}  
A {cmd:%ty} value is like the other {cmd:%t} values except that, rather
than the base being 1960, the base is 0 AD.  (Years 0100 through 9999 are
valid.)

{p 8 8 2}
In addition to the above, there is {cmd:%tC}:

        {c TLC}{hline 8}{c TT}{hline 11}{c TT}{hline 48}{c TRC}
        {c |}        {c |}           {c |} ------ Numerical value & interpretation ------ {c |}
        {c |} Format {c |} Meaning   {c |}      -1       {c |}       0       {c |}        1       {c |}
        {c LT}{hline 8}{c +}{hline 11}{c +}{hline 15}{c +}{hline 15}{c +}{hline 16}{c RT}
        {c |}  {cmd:%tC}   {c |} clock     {c |}   31dec1959   {c |}   01jan1960   {c |}    01jan1960   {c |}
        {c |}        {c |}           {c |}  23:59:59.999 {c |}  00:00:00.000 {c |}   00:00:00.001 {c |}
        {c |}        {c |}           {c |}               {c |}               {c |}                {c |}
        {c BLC}{hline 8}{c BT}{hline 11}{c BT}{hline 15}{c BT}{hline 15}{c BT}{hline 16}{c BRC}

{p 8 8 2}
{cmd:%tC} is similar to {cmd:%tc}, except that {cmd:%tC} accounts for leap
seconds:

{p 12 12 2}
Remember that {cmd:%tc} integer 394,839,482,000 represents 05jul1972
21:38:02.000.

{p 12 12 2}
That integer in {cmd:%tC} represents 05jul1972 21:38:01.000.  For those
who wish their clock based on astronomical observation, 1 leap second was
inserted.  (The first leap second was on 30jun1972, the 
second on 31dec1972, and others have been inserted since then.)
See {it:{help dates_and_times##tcvstC:Advice on using %tc and %tC}} under {bf:Remarks}
below.

{p 8 8 2}
{it:Jargon:} a {cmd:%td} value is sometimes called an elapsed date.

{p 8 8 2}
{it:Historical note:}  a {cmd:%td} value is sometimes referred to as 
a {cmd:%d} value.  The {cmd:t} is omitted because, 
in Stata's history, {cmd:%d} values predated the other {cmd:%t} values.
Dropping the {cmd:t} is still allowed but is now considered an anachronism.


{marker inputting}{...}
    {title:Inputting date and time data}

{p 8 8 2}
Date and time variables are best read as strings.  Then use one of the 
string-to-numeric conversion functions to convert the string representation 
to the appropriate {cmd:%t} value:

	    Format {c |} String-to-numeric conversion function
            {hline 7}{c +}{hline 41}
              {cmd:%tc}  {c |}   {cmd:clock(}{it:string}{cmd:,} {it:mask}{cmd:)}
	      {cmd:%tC}  {c |}   {cmd:Clock(}{it:string}{cmd:,} {it:mask}{cmd:)}
                   {c |}
              {cmd:%td}  {c |}   {cmd:date(}{it:string}{cmd:,} {it:mask}{cmd:)}
                   {c |}
              {cmd:%tw}  {c |}   {cmd:weekly(}{it:string}{cmd:,} {it:mask}{cmd:)}
              {cmd:%tm}  {c |}   {cmd:monthly(}{it:string}{cmd:,} {it:mask}{cmd:)}
              {cmd:%tq}  {c |}   {cmd:quarterly(}{it:string}{cmd:,} {it:mask}{cmd:)}
              {cmd:%th}  {c |}   {cmd:halfyearly(}{it:string}{cmd:,} {it:mask}{cmd:)}
              {cmd:%ty}  {c |}   {cmd:yearly(}{it:string}{cmd:,} {it:mask}{cmd:)}
                   {c |}
              {cmd:%tg}  {c |}   no function necessary; read as numeric
            {hline 7}{c BT}{hline 41}

{p 8 8 2}
In the above functions, {it:string} is the variable or value containing 
the string representation to be converted and {it:mask} specifies the order 
in which the components occur:

{p 12 14 2}
o For {cmd:%td} function {cmd:date()}, {it:string} might be "August 21, 2005"
or "8-21-2005" and {it:mask} might be {cmd:"MDY"}, meaning that the elements
occur in the order month, day, and year.

{p 12 14 2}
o For {cmd:%tc} function {cmd:clock()}, {it:string} might be
"21aug2005 15:21:22" and {it:mask} be {cmd:"DMYhms"}, meaning that the
elements occur in the order day, month, year, hours, minutes, and seconds.

{p 8 8 2}
Thus one might code

{p 12 12 2}
. {cmd:generate datehired = date(datehiredstr, "MDY")}

{p 12 12 2}
. {cmd:generate double timeadmitted = clock(timeadmitstr, "DMYhms")}

{p 8 8 2}
See {it:{help dates_and_times##str2num:String-to-numeric translation functions}}
under {bf:Remarks} for details.


{marker sttypes}{...}
    {title:Recommended storage types for %t variables}

{p 8 8 2}
In the example above, we stored {cmd:%tc} variable {cmd:timeadmitted} as a
{cmd:double}.  Doing so is important if precision is to be maintained.

{p 8 8 2}
The recommended storage types for {cmd:%t} variables are

	    Format {c |} Recommended storage type
	    {hline 7}{c +}{hline 26}
	      {cmd:%tc}  {c |} {cmd:double}
	      {cmd:%tC}  {c |} {cmd:double}
	           {c |}
	      {cmd:%td}  {c |} {cmd:float} or {cmd:long}
	           {c |}
	      {cmd:%tw}  {c |} {cmd:float} or {cmd:int}
	      {cmd:%tm}  {c |} {cmd:float} or {cmd:int}
	      {cmd:%tq}  {c |} {cmd:float} or {cmd:int}
	      {cmd:%th}  {c |} {cmd:float} or {cmd:int}
	      {cmd:%ty}  {c |} {cmd:float} or {cmd:int}
	      {cmd:%tg}  {c |} {cmd:float} or {cmd:int}
	    {hline 7}{c BT}{hline 26}

{p 8 8 2}
Storing a {cmd:%tc} ({cmd:%tC}) variable as a {cmd:double} is important if
precision is to be maintained.  {cmd:%tc} variables are integers, but being
the number of milliseconds from the start of 1960, they are large integers.

{p 8 12 2}
What happens if you store a {cmd:%tc} value as a {cmd:float}:{break} 
    The largest integer that can be stored precisely in a {cmd:float} is
    16,777,216, corresponding to 01jan1960 04:39:37.216.  Times after that
    will be subject to rounding; the rounding as of recent times can be as
    much as 2 minutes, 11 seconds.

{p 8 12 2}
What happens if you store a {cmd:%tc} value as a {cmd:long}:{break}
    The largest integer that can be stored in a {cmd:long} is 2,147,483,620,
    corresponding to 25jan1960 20:31:23.620.  Times after that cannot be
    stored in a {cmd:long}.

{p 8 12 2}
What happens if you store a {cmd:%tc} value as a {cmd:double}:{break}
    The largest integer that can be stored precisely in a {cmd:double} is 
    9,007,199,254,740,992, corresponding to a date in year 285,422,880.
    Stata cuts off dates at year 9999, but for other reasons.

{p 4 4 2}
(In the above, we use an idiosyncratic definition of "precisely":  positive
value {it:x} is stored precisely if {it:x} MINUS 1 is not equal to {it:x},
where MINUS is the computer's operation of subtraction.  For {cmd:float} and
{cmd:double}, there are larger values that are stored exactly, but not
precisely.  For example, both {cmd:float} and {cmd:double} can exactly store
the integer 2^100, a value approximately equal to 1.3e+30, but 2^100 MINUS 1
is still 2^100 because of loss of precision.)

                 {c TLC}{hline 47}{c TRC}
                 {c |} {bf:DO NOT FORGET}                                 {c |}
                 {c |}                                               {c |}
                 {c |} {cmd:%tc} and {cmd:%tC} values {bf:MUST BE} stored as {cmd:double}s. {c |}
                 {c |} Doing so is your responsibility, not Stata's. {c |}
                 {c BLC}{hline 47}{c BRC}


{marker typing}{...}
    {title:Typing dates and times}

{p 8 8 2}
Remember, date and time values are just integers, so in an expression, 
you could type the appropriate integer:

{p 12 12 2}
. {cmd:gen before = cond(hiredon < 16237, 1, 0) if hiredon < .}

{p 12 12 2}
. {cmd:drop if admittedon < 1402920000000}

{p 8 8 2} 
Easier to type is

{p 12 12 2}
. {cmd:gen before = cond(hiredon < td(15jun2004), 1, 0) if hiredon < .}

{p 12 12 2}
. {cmd:drop if admittedon < tc(15jun2004 12:00:00)}

{p 8 8 2}
{cmd:td()} and {cmd:tc()} are called pseudofunctions because they 
translate what you type into their integer equivalents.
Pseudofunctions require only that you specify the date/time components 
in the expected order, so rather than 15jun2004 above, we could have 
specified 15 June 2004, 15-6-2004, or 15/6/2004.

{p 8 8 2}
The date and time pseudofunctions and their expected component order are 

	    Format {c |} Pseudofunction
	    {hline 7}{c +}{hline 50}
	    {cmd:%tc}    {c |} {cmd:tc(}[{it:day-month-year}] {it:hh}{cmd::}{it:mm}[{cmd::}{it:ss}[{cmd:.}{it:sss}]]{cmd:)}
	    {cmd:%tC}    {c |} {cmd:tC(}[{it:day-month-year}] {it:hh}{cmd::}{it:mm}[{cmd::}{it:ss}[{cmd:.}{it:sss}]]{cmd:)}
                   {c |}
	    {cmd:%td}    {c |} {cmd:td(}{it:day-month-year}{cmd:)}
                   {c |}
	    {cmd:%tw}    {c |} {cmd:tw(}{it:year-week}{cmd:)}
	    {cmd:%tm}    {c |} {cmd:tm(}{it:year-month}{cmd:)}
	    {cmd:%tq}    {c |} {cmd:tq(}{it:year-quarter}{cmd:)}
	    {cmd:%th}    {c |} {cmd:th(}{it:year-half}{cmd:)}
	    {cmd:%ty}    {c |} none necessary; just type year
	    {cmd:%tg}    {c |} none necessary
	    {hline 7}{c BT}{hline 50}

{p 8 8 2}
The {it:day-month-year} in {cmd:tc()} and {cmd:tC()} are optional.
If you omit them, 01jan1960 is assumed.  Doing so produces time as an offset, 
which can be useful in, for example, 

{p 12 12 2}
. {cmd:gen six_hrs_later = eventtime + tc(6:00)}

{p 8 8 2}
Also see {it:{help dates_and_times##extracting:Extracting date and time components}}
below.

{p 8 8 2}
{it:Historical note:}  pseudofunctions 
{cmd:td()}, 
{cmd:tw()}, 
{cmd:tm()}, 
{cmd:tq()}, and
{cmd:th()}
used to be called 
{cmd:d()}, 
{cmd:w()}, 
{cmd:m()}, 
{cmd:q()}, and
{cmd:h()}.  Those names still work but are considered 
anachronisms.


{marker constructing}{...}
    {title:Constructing date and time values from numerical components}

{p 8 8 2}
If you had numeric variables {cmd:M}, {cmd:D}, and {cmd:Y} containing 
month number, day of month, and year (in the first observation, 
the variables might contain 12, 15, and 2006), you could code 

	    . {cmd:generate mydate = mdy(M, D, Y)}

{p 8 8 2}
to obtain new {cmd:%td} variable containing the date (which would 
be 15dec2006 in the first observation).

{p 8 8 2}
The date-from-numerical-components functions are

	    Format {c |} Function
	    {hline 7}{c +}{hline 42}
	     {cmd:%tc}   {c |} {cmd:mdyhms(}{it:M}, {it:D}, {it:Y}, {it:h}, {it:m}, {it:s}{cmd:)}
	     {cmd:%tc}   {c |} {cmd:dhms(}{it:td}, {it:h}, {it:m}, {it:s}{cmd:)}
	     {cmd:%tc}   {c |} {cmd:hms(}{it:h}, {it:m}, {it:s}{cmd:)}
	           {c |}
	     {cmd:%tC}   {c |} {cmd:Cmdyhms(}{it:M}, {it:D}, {it:Y}, {it:h}, {it:m}, {it:s}{cmd:)}  
	     {cmd:%tC}   {c |} {cmd:Cdhms(}{it:td}, {it:h}, {it:m}, {it:s}{cmd:)}
	     {cmd:%tC}   {c |} {cmd:Chms(}{it:h}, {it:m}, {it:s}{cmd:)}
	           {c |}
	     {cmd:%td}   {c |} {cmd:mdy(}{it:M}, {it:D}, {it:Y}{cmd:)}
		   {c |}
	     {cmd:%tw}   {c |} {cmd:yw(}{it:Y}, {it:W}{cmd:)}
	     {cmd:%tm}   {c |} {cmd:ym(}{it:Y}, {it:M}{cmd:)}
	     {cmd:%tq}   {c |} {cmd:yq(}{it:Y}, {it:Q}{cmd:)}
	     {cmd:%th}   {c |} {cmd:yh(}{it:Y}, {it:H}{cmd:)}
	     {cmd:%ty}   {c |} {it:Y}
	    {hline 7}{c BT}{hline 42}

{p 8 8 2}
where

	    {it:td} is a {cmd:%td} value,

            {it:M}, {it:D}, and {it:Y} are month, day, and year values, 
		    1 <= {it:M} <= 12
		    1 <= {it:D} <= 31
		 0100 <= {it:Y} <= 9999

	    {it:h}, {it:m}, and {it:s} are hour, minute, and second values,
		    0 <= {it:h} <= 23
                    0 <= {it:m} <= 59 
                0.000 <= {it:s} <= 59.999   (see note below)

            {it:W} is a week number, 1 <= {it:W} <= 52

	    {it:Q} is a quarter number, 1 <= {it:Q} <= 4

	    {it:H} is a half number, 1 <= {it:H} <= 2

{p 8 8 2}
Note concerning {it:s}:
Functions {cmd:Cmdyhms()} and {cmd:Cdhms()} allow 
0.000 <= {it:s} <= 60.999 when the 60th second is a leap second.
For instance, according to the authorities, 
31dec1972 23:59:60 is an official leap second 
but 
31dec1971 23:59:60 is not.  
{cmd:Cmdyhms(12,31,1971,23,59,60)} therefore evaluates to missing ({cmd:.})
whereas {cmd:Cmdyhms(12,31,1972,23,59,60)} evaluates to 410,313,601,000, a
nonmissing value.  (The expanded range of {it:s} does not apply to
{cmd:Chms()} because it is a pure time based on 01jan1960 and there were no
leap seconds on that date.  Functions {cmd:hms()} and {cmd:Chms()} are in fact
identical.)


{p 8 8 2}
Functions {cmd:mdyhms()} and {cmd:dhms()} are related by

{col 17}{...}
{cmd:mdyhms(}{it:M}, {it:D}, {it:Y}, {it:h}, {it:m}, {it:s}{cmd:)} = {...}
{cmd:dhms(mdy(}{it:M},{it:D},{it:Y}{cmd:)}, {it:h}, {it:m}, {it:s}{cmd:)}

{p 8 8 2}
and similarly, 

{col 16}{...}
{cmd:Cmdyhms(}{it:M}, {it:D}, {it:Y}, {it:h}, {it:m}, {it:s}{cmd:)} = {...}
{cmd:Cdhms(mdy(}{it:M},{it:D},{it:Y}{cmd:)}, {it:h}, {it:m}, {it:s}{cmd:)}

{p 8 8 2}
With {cmd:mdyhms()}, you have six variables, such as 
{it:M}=7, {it:D}=5, {it:Y}=1972, 
{it:h}=21, {it:m}=38, and {it:s}=2, and 
{cmd:mdyhms()} returns 05jul1972 21:38:02.
With {cmd:dhms()} you have four variables, 
the first specifying the {cmd:%td} value of 05jul1972, 
and {it:h}, {it:m}, and {it:s} being the same, and 
{cmd:dhms()} returns the date + time, 05jul1972 21:38:02.


{marker converting}{...}
    {title:Converting date and time values}

{p 8 8 2}
One type of {cmd:%t} value can be converted into another.  The functions
are

                    To...
            From {c |}  {cmd:%tc      %tC      %td      %tw     %tm       %tq}
            {hline 5}{c +}{hline 52}
            {cmd:%tc}  {c |} {cmd:         Cofc()   dofc()}
            {cmd:%tC}  {c |} {cmd:cofC()}   {cmd:         dofC()}
                 {c |}
            {cmd:%td}  {c |} {cmd:cofd()   Cofd()            wofd()   mofd()   qofd()}
                 {c |}
            {cmd:%tw}  {c |}                   {cmd:dofw()}
            {cmd:%tm}  {c |}                   {cmd:dofm()}
            {cmd:%tq}  {c |}                   {cmd:dofq()}
            {cmd:%th}  {c |}                   {cmd:dofh()}
            {cmd:%ty}  {c |}                   {cmd:dofy()}
            {hline 5}{c BT}{hline 52}

                    To...
            From {c |}  {cmd:%th        %ty}
            {hline 5}{c +}{hline 17}
            {cmd:%tc}  {c |}  
            {cmd:%tC}  {c |}
	         {c |}
            {cmd:%td}  {c |} {cmd:hofd()   yofd()}
	         {c |}
            {cmd:%tw}  {c |} 
            {cmd:%tm}  {c |} 
            {cmd:%tq}  {c |} 
            {cmd:%th}  {c |} 
            {cmd:%ty}  {c |} 
            {hline 5}{c BT}{hline 17}

{p 8 8 2}
For instance, to convert {cmd:%td} to a {cmd:%tc} value, 

	    . {cmd:generate double datetimevalue = cofd(datevalue)}

{p 8 8 2}
{cmd:%td} is the mother of all date and time values, and 
to convert a {cmd:%tq} value to a {cmd:%tc} value, you must first 
convert to a {cmd:%td} value:

	    . {cmd:generate double datetimevalue = cofd(dofq(quartervalue))}


{marker extracting}{...}
    {title:Extracting date and time components}

{p 8 8 2}
Let {it:d} be a {cmd:%td} variable or value.  The following functions
will extract components of {it:d}:

	    {hline 61}
                                            Result if {it:d} = td(05jul1972)
	    Function         Returns            (i.e., {it:d} = 4,569)        
	    {hline 61}
	    {cmd:year(}{it:d}{cmd:)}          calendar year            1972
            {cmd:month(}{it:d}{cmd:)}         calendar month           7
            {cmd:day(}{it:d}{cmd:)}           day within month         5

	    {cmd:doy(}{it:d}{cmd:)}           day of year              187

	    {cmd:halfyear(}{it:d}{cmd:)}      half of year             2
	    {cmd:quarter(}{it:d}{cmd:)}       quarter                  3
            {cmd:week(}{it:d}{cmd:)}          week within year         27

            {cmd:dow(}{it:d}{cmd:)}           day of week (0 = Sunday) 3 (means Wednesday)
	    {hline 61}

{p 8 8 2}
Remember, any {cmd:%t} value can be converted to a {cmd:%td} value by using
the appropriate conversion function; see
{it:{help dates_and_times##converting:Converting date and time values}} above.
If variable {cmd:date_time_admitted} is {cmd:%tc} and you want to obtain the
day of week,

{p 12 12 2}
. {cmd:gen day = dow(dofc(date_time_admitted))}

{p 8 8 2}
Let {it:t} be a {cmd:%tc} variable.  The following functions will extract 
components of {it:t}:

	    {hline 64}
                                        Result if {it:t} = tc(05jul1972-21:38:02)
	    Function         Returns         (i.e., {it:t} = 394,839,482,000)
	    {hline 64}
	    {cmd:hh(}{it:t}{cmd:)}            time of day, hours       21
            {cmd:mm(}{it:t}{cmd:)}            time of day, minutes     38
            {cmd:ss(}{it:t}{cmd:)}            time of day, seconds     2.000
	    {hline 64}
{p 12 12 2}
Other components can be extracted by calculating 
{cmd:dofc(}{it:t}{cmd:)} and then extracting components
from the {cmd:%td} value.

{p 8 8 2}
Let {it:T} be a {cmd:%tC} variable.  The following functions will extract 
components of {it:T}:

	    {hline 64}
                                        Result if {it:T} = tC(05jul1972-21:38:01)
	    Function         Returns         (i.e., {it:T} = 394,839,482,000)
	    {hline 64}
	    {cmd:hhC(}{it:T}{cmd:)}           time of day, hours       21
            {cmd:mmC(}{it:T}{cmd:)}           time of day, minutes     38
            {cmd:ssC(}{it:T}{cmd:)}           time of day, seconds     1.000
	    {hline 64}
{p 12 12 2}
By convention, leap seconds came after 23:59:59 and are labeled 
23:59:60.  Thus {cmd:ssC(}{it:T}{cmd:)} can return 60.{break}
Other components can be extracted by calculating 
{cmd:dofC(}{it:T}{cmd:)} and then extracting components
from the {cmd:%td} value.


{marker durations}{...}
    {title:Obtaining and working with durations}

{p 8 8 2}
Remember that {cmd:%t} variables are simply durations from 1960:
	
	    Format {c |}    Units 
	    {hline 7}{c +}{hline 13}
            {cmd:%tC}    {c |} milliseconds
            {cmd:%tc}    {c |} milliseconds
                   {c |}
            {cmd:%td}    {c |} days
                   {c |}
            {cmd:%tw}    {c |} weeks
            {cmd:%tm}    {c |} months
            {cmd:%tq}    {c |} quarters
            {cmd:%th}    {c |} half years
	    {hline 7}{c BT}{hline 13}

{p 8 8 2}
Thus, to obtain the duration between {cmd:%t} variables, subtract them:

{p 12 12 2}
. {cmd:gen days_employed = curdate - hiredate}

{p 12 12 2}
. {cmd:gen qtrs_to_15jan = curqtr - qofd(td(15jan2005))}

{p 8 8 2}
To add a duration to a date, add the two values:

{p 12 12 2}
. {cmd:gen lastdate = hiredate + days_employed}
{p_end}
{p 12 12 2}
. {cmd:format lastdate %td}

{p 12 12 2}
. {cmd:gen qtr_of_merger = curqtr + quarters_to_merger}
{p_end}
{p 12 12 2}
. {cmd:format qtr_of_merger %tq}

{p 8 8 2}
When creating new date and time variables, remember to format them 
so that they will be readable should you print them.

{p 8 8 2}
The above applies equally to {cmd:%tc} and {cmd:%tC} variables:

{p 12 12 2}
. {cmd:gen double millisecs_employed = lasttime - hiretime}

{p 8 8 2}
and 

{p 12 12 2}
. {cmd:gen double lasttime = hiretime + millisecs_employed}
{p_end}
{p 12 12 2}
. {cmd:format lasttime %tc}

{p 8 8 2}
Note our use of {cmd:double}.  Times are recorded in milliseconds and must be
stored as {cmd:double}s if precision is to be maintained.

{p 8 8 2}
There are 1,000 ms in a second, 60*1,000 in a minute, 
and 60*60*1,000 in an hour.  It is easy to mistype these constants when
converting to more readable units, and therefore the following functions are
provided:

	    Function       {c |}  Purpose
	    {hline 15}{c +}{hline 34}
	    {cmd:hours(}{it:ms}{cmd:)}      {c |}  convert milliseconds to hours
                           {c |}  returns {it:ms}/(60*60*1000)
                           {c |}
            {cmd:minutes(}{it:ms}{cmd:)}    {c |}  convert milliseconds to minutes
                           {c |}  returns {it:ms}/(60*1000)
                           {c |}
	    {cmd:seconds(}{it:ms}{cmd:)}    {c |}  convert milliseconds to seconds
                           {c |}  returns {it:ms}/1000 
                           {c |}
	    {cmd:msofhours(}{it:h}{cmd:)}   {c |}  convert hours to milliseconds
                           {c |}  returns {it:h}*60*60*1000
                           {c |}
	    {cmd:msofminutes(}{it:m}{cmd:)} {c |}  convert minutes to milliseconds
                           {c |}  returns {it:m}*60*1000
                           {c |}
	    {cmd:msofseconds(}{it:s}{cmd:)} {c |}  convert seconds to milliseconds
                           {c |}  returns {it:s}*1000
	    {hline 15}{c BT}{hline 34}

{p 8 8 2}
Thus you can code 

{p 12 12 2}
. {cmd:gen double days_employed = 24*hours(lasttime-hiretime)}

{p 8 8 2}
and

{p 12 12 2}
. {cmd:gen double lasttime = hiretime + msofhours(24*days_employed)}

{p 8 8 2}
If precision is to be preserved, the use of these functions does not 
alleviate the necessity of using {cmd:double}s.

{p 8 8 2}
Also {cmd:days_employed} in the above will include fraction
of a day.  If a rounded integer result is desired, then round
explicitly:

{p 12 12 2}
. {cmd:gen approx_days_employed = round(24*hours(lasttime-hiretime))}
 

{marker formatting}{...}
    {title:Formatting date and time values}

{p 8 8 2}
    A variable's values are formatted to indicate (1) the units used and (2)
    how the variable is to be displayed:

            . {cmd:generate mydate = date(datestr, "DMY")}

            . {cmd:list mydate in 1}
            {txt}
                 {c TLC}{hline 8}{c TRC}
                 {c |} {res}mydate {txt}{c |}
                 {c LT}{hline 8}{c RT}
              1. {c |} {res} 17096 {txt}{c |}
                 {c BLC}{hline 8}{c BRC}

	    . {cmd:format mydate %td}

            . {cmd:list mydate in 1}
            {txt}
                 {c TLC}{hline 11}{c TRC}
                 {c |} {res}   mydate {txt}{c |}
                 {c LT}{hline 11}{c RT}
              1. {c |} {res}22oct2006 {txt}{c |}
                 {c BLC}{hline 11}{c BRC}


            . {cmd:generate double mytime = clock(timestr, "DMY hm")}

            . {cmd:list mytime in 1}
            {txt}
                 {c TLC}{hline 11}{c TRC}
                 {c |} {res}   mytime {txt}{c |}
                 {c LT}{hline 11}{c RT}
              1. {c |} {res}1.477e+12 {txt}{c |}
                 {c BLC}{hline 11}{c BRC}

	    . {cmd:format mytime %tc}

            . {cmd:list mytime in 1}
            {txt}
                 {c TLC}{hline 20}{c TRC}
                 {c |} {res}            mytime {txt}{c |}
                 {c LT}{hline 20}{c RT}
              1. {c |} {res}22oct2006 13:02:00 {txt}{c |}
                 {c BLC}{hline 20}{c BRC}


{p 8 8 2}
The {cmd:%t} formats result in the following output:

	    Format {c |} Example of output
	    {hline 7}{c +}{hline 28}
	    {cmd:%tC}    {c |} 05jul1972 21:38:01
	    {cmd:%tc}    {c |} 05jul1972 21:38:02
	           {c |}
	    {cmd:%td}    {c |} 05jul1972
	           {c |}
            {cmd:%tw}    {c |} 1972w27
	    {cmd:%tm}    {c |} 1972m7
	    {cmd:%tq}    {c |} 1972q3
            {cmd:%th}    {c |} 1972h2
            {cmd:%ty}    {c |} 1972
            {cmd:%tg}    {c |} (actual integer shown)
	    {hline 7}{c BT}{hline 28}
            Formats {cmd:%tC} and {cmd:%tc} do not
            show the milliseconds by default.
 
{p 8 8 2}
You can specify how date and times are to be formatted.
Rather than 05jul1972, you could have July 5, 1972, or rather 
than 05jul1972 21:38:02, you could have 7-5-72 9:38 p.m.
This reformatting is done by adding codes to the end of {cmd:%tC}, {cmd:%tc},
{cmd:%td}, etc.  In fact, the default {cmd:%tC}, {cmd:%tc}, {cmd:%td}, ...,
formats actually mean

	    Format {c |} Implied (fully specified) format
	    {hline 7}{c +}{hline 33}
	    {cmd:%tC}    {c |} {cmd:%tCDDmonCCYY_HH:MM:SS}
	    {cmd:%tc}    {c |} {cmd:%tcDDmonCCYY_HH:MM:SS}
                   {c |}
	    {cmd:%td}    {c |} {cmd:%tdDDmonCCYY}
                   {c |}
	    {cmd:%tw}    {c |} {cmd:%twCCYY!www}
	    {cmd:%tm}    {c |} {cmd:%tmCCYY!mnn}
	    {cmd:%th}    {c |} {cmd:%thCCYY!hh}
            {cmd:%ty}    {c |} {cmd:%tyCCYY}
	    {hline 7}{c BT}{hline 33}

{p 8 8 2}
Typing 

{p 12 12 2}
. {cmd:format mytimevar %tc}

{p 8 8 2}
has the same effect as typing

{p 12 12 2}
. {cmd:format mytimevar %tcDDmonCCYY_HH:MM:SS}


{p 8 8 2}
Format {cmd:%tcDDmonCCYY_HH:MM:SS} is interpreted as

{col 11}{c TLC}{hline 66}{c TRC}
          {c |}       {cmd:%}          {cmd:t}             {cmd:c}             {cmd:DDmonCCYY_HH:MM:SS}  {c |}
          {c |}       |          |             |                      |          {c |}
          {c |} all formats    it's a        variable           formatting codes {c |}
          {c |} start with {cmd:%}   time format   coded in           specify how to   {c |}
          {c |}                              milliseconds       display value    {c |}
{col 11}{c BLC}{hline 66}{c BRC}

{p 8 8 2}
The formatting codes are 

	    Code      Meaning            Output
	    {hline 65}
	    {cmd:CC}        century-1          01 - 99
	    {cmd:cc}        century-1          1 - 99
	    {cmd:YY}        2-digit year       00 - 99
	    {cmd:yy}        2-digit year       0 - 99

            {cmd:JJJ}       day within year    001 - 366
	    {cmd:jjj}       day within year    1 - 366

	    {cmd:Mon}       month              Jan, Feb, ..., Dec
	    {cmd:Month}     month              January, February, ..., December
            {cmd:mon}       month              jan, feb, ..., dec
            {cmd:month}     month              january, february, ..., december
            {cmd:NN}        month              01 - 12
	    {cmd:nn}        month              1 - 12

            {cmd:DD}        day within month   01 - 31
            {cmd:dd}        day within month   1 - 31

            {cmd:DAYNAME}   day of week        Sunday, Monday, ... (aligned)
            {cmd:Dayname}   day of week        Sunday, Monday, ... (unaligned)
	    {cmd:Day}       day of week        Sun, Mon, ...
            {cmd:Da}        day of week        Su, Mo, ...
            {cmd:day}       day of week        sun, mon, ...
            {cmd:da}        day of week        su, mo, ...

            {cmd:h}         half               1 - 2
            {cmd:q}         quarter            1 - 4
            {cmd:WW}        week               01 - 52
            {cmd:ww}        week               1 - 52

	    {cmd:HH}        hour               00 - 23
	    {cmd:Hh}        hour               00 - 12
	    {cmd:hH}        hour               0 - 23
            {cmd:hh}        hour               0 - 12

            {cmd:MM}        minute             00 - 59
	    {cmd:mm}        minute             0 - 59

            {cmd:SS}        second             00 - 60 (sic, due to leap seconds)
            {cmd:ss}        second             0 - 60 (sic, due to leap seconds)
	    {cmd:.s}        tenths             .0 - .9
	    {cmd:.ss}       hundredths         .00 - .99
	    {cmd:.sss}      thousandths        .000 - .999

	    {cmd:am}        show am or pm      {cmd:am}   or  {cmd:pm}
	    {cmd:a.m.}      show a.m. or p.m.  {cmd:a.m.} or  {cmd:p.m.}
	    {cmd:AM}        show AM or PM      {cmd:AM}   or  {cmd:PM}
	    {cmd:A.M.}      show A.M. or P.M.  {cmd:A.M.} or  {cmd:P.M.}

	    {cmd:.}         display period     .
	    {cmd:,}         display comma      ,
	    {cmd::}         display colon      :
	    {cmd:-}         display hyphen     -
	    {cmd:_}         display space
            {cmd:/}         display slash      /
            {cmd:\}         display backslash  \
            {cmd:!}{it:c}        display character  {it:c}

	    {cmd:+}         separator (see note)
	    {hline 65}
            {it:Note:}  {cmd:+} displays nothing; it may be used to separate one code 
	    from the next to make the format more readable.  {cmd:+} is never
	    necessary.  For instance, {cmd:%tchh:MM+am} and {cmd:%tchh:MMam} have the
	    same meaning, as does {cmd:%tc+hh+:+MM+am}.

{p 8 8 2}
Thus, if you had a {cmd:%td} variable and wanted to display the dates 
as, for example, January 9, 2002, you could specify the format 
{cmd:%tdMonth_dd,_CCYY}.

{p 8 8 2}
If you had a {cmd:%tc} variable and wanted to display the time as

{p 12 12 2}
Fri Aug 18 12:01:35 CDT 2006

{p 8 8 2}
you could specify {cmd:%tcDay_Mon_DD_HH:MM:SS_!C!D!T_CCYY}.

{p 8 8 2}
The maximum length of a format specifier is 48 characters; the 
example shown above is 34 characters.


{marker description}{...}
{title:Description}

{p 4 4 2}
Complete documentation of Stata's treatment of date and time values is
provided.  Every feature and function is documented here, either 
in {it:Syntax} above or in {it:Remarks} below.


{title:Remarks}

{p 4 4 2}
Remarks are presented under the following headings:

	{help dates_and_times##experiment:Experimenting with the date and time functions}
	{help dates_and_times##str2num:String-to-numeric translation functions}
	    {help dates_and_times##fcnclock:The clock() function}
	        {help dates_and_times##mask:How clock() interprets the mask}
	        {help dates_and_times##twodigit:Working with two-digit years}
	        {help dates_and_times##incomplete:Working with incomplete dates and times}
	    {help dates_and_times##fcnClock:The Clock() function}
	    {help dates_and_times##fcndate:The date() function}
{* runtogether in next line is supposed to be one word}{...}
	    {help dates_and_times##runtogether:Translating run-together dates such as 20060125}
	    {help dates_and_times##fcnother:The other translation functions}
	{help dates_and_times##validtimes:Valid times}
	{help dates_and_times##leapsecs:When leap seconds occurred}
	{help dates_and_times##truncatedtimes:Truncated times}
	{help dates_and_times##tcvstC:Advice on using %tc and %tC}
	    {help dates_and_times##tcvstCsum:Summary}
	    {help dates_and_times##tcvstCdtl:Explanation}


{marker experiment}{...}
{title:Experimenting with the date and time functions}

{p 4 4 2}
The best way to become familiar with Stata's date and time functions 
is to experiment with the {cmd:display} command.

	. {cmd:display date("5-12-1998", "MDY")}
        14011

	. {cmd:display %td date("5-12-1998", "MDY")}
	12may1998

        . {cmd:display clock("5-12-1998 11:15", "MDY hm")}
        1.211e+12

        . {cmd:display %20.0gc clock("5-12-1998 11:15", "MDY hm")}
	  1,210,590,900,000

        . {cmd:display %tc clock("5-12-1998 11:15", "MDY hm")}
	12may1998 11:15:00

{p 4 4 2}
Remember, when you work with {cmd:display}, you can specify a format in front
of the expression to specify how the result is to be formatted.


{marker str2num}{...}
{title:String-to-numeric translation functions}

{p 4 4 2}
The string-to-numeric date and time translation functions are

	    Format {c |} String-to-numeric conversion function
            {hline 7}{c +}{hline 41}
              {cmd:%tc}  {c |}   {cmd:clock(}{it:string}{cmd:,} {it:mask} [{cmd:,} {it:topyear}]{cmd:)}
	      {cmd:%tC}  {c |}   {cmd:Clock(}{it:string}{cmd:,} {it:mask} [{cmd:,} {it:topyear}]{cmd:)}
                   {c |}
              {cmd:%td}  {c |}   {cmd:date(}{it:string}{cmd:,} {it:mask} [{cmd:,} {it:topyear}]{cmd:)}
                   {c |}
              {cmd:%tw}  {c |}   {cmd:weekly(}{it:string}{cmd:,} {it:mask} [{cmd:,} {it:topyear}]{cmd:)}
              {cmd:%tm}  {c |}   {cmd:monthly(}{it:string}{cmd:,} {it:mask} [{cmd:,} {it:topyear}]{cmd:)}
              {cmd:%tq}  {c |}   {cmd:quarterly(}{it:string}{cmd:,} {it:mask} [{cmd:,} {it:topyear}]{cmd:)}
              {cmd:%th}  {c |}   {cmd:halfyearly(}{it:string}{cmd:,} {it:mask} [{cmd:,} {it:topyear}]{cmd:)}
              {cmd:%ty}  {c |}   {cmd:yearly(}{it:string}{cmd:,} {it:mask} [{cmd:,} {it:topyear}]{cmd:)}
            {hline 7}{c BT}{hline 41}
            {it:string} is the value to be translated. 
            {it:mask} specifies the order of the components.
            {it:topyear} is described in {it:{help dates_and_times##twodigit:Working with two-digit years}} below.

{p 4 4 2}
These functions are typically used after reading date and/or time data.
The data contain values such as "08/12/06", "12-8-2006", "12 Aug 06",
"12aug2006 14:23", and "12 aug06 2:23 pm".  You read 
the data into a string variable and then use one of the 
translation functions to translate the string into a {cmd:%t} variable.

{p 4 4 2}
The translation functions are used in expressions, such as 

{p 8 8 2}
. {cmd:generate double timeadmitted = clock(timeadmitstr, "DMYhms")}{break}
. {cmd:format timeadmitted %tc}

{p 8 8 2}
. {cmd:generate datehired = date(datehiredstr, "MDY")}{break}
. {cmd:format datehired %td}

{p 4 4 2}
All functions require two arguments, the string to be translated and 
a second string specifying the order in which the date and time 
components occur.

{p 4 4 2}
The most useful of these functions are {cmd:clock()}, {cmd:Clock()}, and
{cmd:date()}.  The other functions are rarely used.


{marker fcnclock}{...}
    {title:The clock() function}

{p 4 4 2}
{cmd:clock()} returns a {cmd:%tc} value.
The syntax of {cmd:clock()} is

{p 12 12 2}
{cmd:clock(}{it:string}{cmd:,} {it:mask} [{cmd:,} {it:topyear}]{cmd:)}

{p 4 4 2}
Ignore optional argument {it:topyear}; we will discuss that below.
Second argument {it:mask} is a string specifying the order of the components
in {it:string} and consists of the following codes: 

	    Code  {c |} Meaning
	    {hline 6}{c +}{hline 39}
             {cmd:M}    {c |} month
             {cmd:D}    {c |} day within month
             {cmd:Y}    {c |} 4-digit year
	     {cmd:19Y}  {c |} 2-digit year to be interpreted as 19{it:xx}
             {cmd:20Y}  {c |} 2-digit year to be interpreted as 20{it:xx}
                  {c |}
             {cmd:h}    {c |} hour of day
             {cmd:m}    {c |} minutes within hour 
             {cmd:s}    {c |} seconds within minute
                  {c |}
             {cmd:#}    {c |} ignore one element
	    {hline 6}{c BT}{hline 39}

{p 4 4 2}
Examples of date strings and the mask required to translate them include

          String to translate               Corresponding mask
	  {hline 52}
          01dec2006 14:22                   {cmd:"DMYhm"}
          01-12-2006 14.22                  {cmd:"DMYhm"}

	  1dec2006 14:22                    {cmd:"DMYhm"}
	  1-12-2006 14:22                   {cmd:"DMYhm"}

          01dec06 14:22                     {cmd:"DM20Yhm"}
          01-12-06 14.22                    {cmd:"DM20Yhm"}

          December 1, 2006 14:22            {cmd:"MDYhm"}

          2006 Dec 01 14:22                 {cmd:"YMDhm"}
          2006-01-12 14:22                  {cmd:"YMDhm"}

          2006-01-12 14:22:43               {cmd:"YMDhms"}
          2006-01-12 14:22:43.2             {cmd:"YMDhms"}
          2006-01-12 14:22:43.21            {cmd:"YMDhms"}
          2006-01-12 14:22:43.213           {cmd:"YMDhms"}

          2006-01-12  2:22:43.213 pm        {cmd:"YMDhms"}
          2006-01-12  2:22:43.213 pm.       {cmd:"YMDhms"}
          2006-01-12  2:22:43.213 p.m.      {cmd:"YMDhms"}
          2006-01-12  2:22:43.213 P.M.      {cmd:"YMDhms"}

	  20060112 1422                     {cmd:"YMDhm"}

	  14:22                             {cmd:"hm"}    (see note)
          2006-12-01                        {cmd:"YMD"}   (see note)

	  Wed Dec 01 14:22:43 CST 2006      {cmd:"#MDhms#Y"}
	  {hline 52}
{p 10 10 2}
Note:   a subset of components may be specified.{break}
        {cmd:clock("14:22", "hm")} produces 01jan1960 14:22:00.{break}
        {cmd:clock("2006-12-01", "YMD")} produces 01dec2006 00:00:00.

          Also there is nothing special included in {it:mask}
          to process a.m. and p.m. markers.  When you include 
          code {cmd:h}, {cmd:clock()} automatically watches for the
          meridian markers.


{p 4 4 2}
{it:mask} may include spaces so that it is more readable; they have no 
meaning.  Thus we can code 

{p 8 8 2}
. {cmd:generate double admit = clock(admitstr, "#MDhms#Y")}

{p 4 4 2}
or code

{p 8 8 2}
. {cmd:generate double admit = clock(admitstr, "# MD hms # Y")}

{p 4 4 2}
and which we code makes no difference.


{marker mask}{...}
    {title:How clock() interprets the mask}

{p 4 4 2}
To specify the appropriate mask, it helps to understand the rules that
{cmd:clock()} applies.  They are

{p 8 12 2}
1.  For each string to be translated, remove all punctuation except 
    for the period separating seconds from tenths, hundredths, and 
    thousandths of seconds.  Replace the punctuation with a space.

{p 8 12 2}
2.  Insert a space in the string everywhere that a letter is next to
    a number or vice versa.

{p 8 12 2}
3.  Interpret the resulting elements according to {it:mask}.

{p 4 4 2}
For instance, consider the string 

{p 12 12 2}
01dec2006 14:22

{p 4 4 2}
Under rule (1), the string becomes 

{p 12 12 2}
01dec2006 14 22

{p 4 4 2}
Under rule (2), the string becomes 

{p 12 12 2}
01 dec 2006 14 22

{p 4 4 2}
Now {cmd:clock()} applies rule (3).  If the mask is {cmd:"DMYhm"}, then
{cmd:clock()} interprets "01" as the day, "dec" as the month, and so on.

{p 4 4 2}
Or consider the string

{p 12 12 2}
Wed Dec 01 14:22:43 CST 2006

{p 4 4 2}
Under rule (1), the string becomes 

{p 12 12 2}
Wed Dec 01 14 22 43 CST 2006

{p 4 4 2}
Applying rule (2) does not change the string.  Now {cmd:clock()} applies rule
(3).  If the mask is {cmd:"#MDhms#Y"}, {cmd:clock()} skips "Wed", interprets
"Dec" as the month, and so on.

{p 4 4 2}
The {cmd:#} code serves a second purpose.  If it appears at the end 
of the mask, it specifies that the rest of {it:string} is to 
be ignored.  Consider translating 

{p 12 12 2}
Wed Dec 01 14 22 43 CST 2006 patient 42

{p 4 4 2}
The mask code that previously worked when "patient 42" was not part of the
string, {cmd:"#MDhms#Y"}, will result in missing value.  {cmd:clock()} is
careful in the translation and, if all the string is not used, returns
missing.  If you end mask in {cmd:#}, however, {cmd:clock()} ignores the rest
of the string.  Changing mask from {cmd:"#MDhms#Y"} to {cmd:"#MDhms#Y#"}
will produce the desired result.


{marker twodigit}{...}
    {title:Working with two-digit years}

{p 4 4 2}
Consider translating the string 01-12-06 14:22, which is to be 
interpreted as 01dec2006 14:22:00.  
{cmd:clock()} provides two ways of doing this.  

{p 4 4 2}
The first is to specify the assumed prefix in the mask.  
01-12-06 14:22 can be read by specifying mask 
{cmd:"DM20Yhm"}.  If we instead wanted to interpret the year 
as 1906, we would specify mask {cmd:"DM19Yhm"}.  We could even 
interpret the year as 1806 by specifying {cmd:"DM18Yhm"}.

{p 4 4 2}
But what if our data include 01-12-06 14:22 and include
06-15-98 11:01?  We want to interpret the first as being in 2006 and 
the second as being in 1998.  That is the purpose of optional 
argument {it:topyear}:

{p 12 12 2}
{cmd:clock(}{it:string}{cmd:,} {it:mask} [{cmd:,} {it:topyear}]{cmd:)}

{p 4 4 2}
When you specify {it:topyear}, you are stating that when years in 
{it:string} are two digits, the full year is to be obtained 
by finding the largest year not exceeding {it:topyear}.
Thus you could code, 

{p 8 8 2}
. {cmd:generate double timestamp = clock(timestr, "DMYhm", 2020)}

{p 4 4 2}
Two-digit year 06 would be interpreted as 2006 because 2006 does not
exceed 2020.  Two-digit 98 would be 
interpreted as 1998 because 2098 does exceed 2020; 1998 does not.


{marker incomplete}{...}
    {title:Working with incomplete dates and times}

{p 4 4 2}
Function {cmd:clock()} does not require every component of the date and 
time be specified.

{p 4 4 2}
Translating 2006-12-01 with mask {cmd:"YMD"} results in 01dec2006 00:00:00.

{p 4 4 2}
Translating 14:22 with mask {cmd:"hm"} results in 01jan1960 14:22:00.

{p 4 4 2}
Translating 11-2006 with mask {cmd:"MY"} results in 01nov2006 00:00:00.

{p 4 4 2}
The default for a component, if not specified in the mask, is


             Code {c |} Default if not specified
	    {hline 6}{c +}{hline 25}
             {cmd:M}    {c |} 01
             {cmd:D}    {c |} 01
             {cmd:Y}    {c |} 1960
                  {c |}
             {cmd:h}    {c |} 00
             {cmd:m}    {c |} 00
             {cmd:s}    {c |} 00
	    {hline 6}{c BT}{hline 25}

{p 4 4 2}
This feature is useful.  You may have data recording "14:22", meaning a
duration of 14 hours and 22 minutes, or the time 14:22 each day.  See
{it:{help dates_and_times##durations:Obtaining and working with durations}}
under {bf:Syntax} above.


{marker fcnClock}{...}
    {title:The Clock() function}

{p 4 4 2}
The syntax of function {cmd:Clock()} is 

{p 12 12 2}
{cmd:Clock(}{it:string}{cmd:,} {it:mask} [{cmd:,} {it:topyear}]{cmd:)}

{p 4 4 2}
Function {cmd:Clock()} is identical to {cmd:clock()} except that, rather than
returning a {cmd:%tc} value, it returns {cmd:%tC}.  

{p 4 4 2}
Note:  {cmd:Clock()} is almost identical to
{cmd:Cofc(clock())}.  The difference is that {cmd:Clock()} understands leap
seconds, such as 30jun1997 23:59:60.


{marker fcndate}{...}
    {title:The date() function}

{p 4 4 2}
The syntax of function {cmd:date()} is 

{p 12 12 2}
{cmd:date(}{it:string}{cmd:,} {it:mask} [{cmd:,} {it:topyear}]{cmd:)}

{p 4 4 2}
Function {cmd:date()} is identical to {cmd:clock()} except that it returns a
{cmd:%td} value rather than a {cmd:%tc} value.  Function {cmd:date()}
is the same as {cmd:dofc(clock())}.

{p 4 8 2}
{it:Historical note:}
Stata 10's {cmd:date()} function is much improved over that of previous 
versions, and the mask is specified a little differently.  In previous 
versions, the codes for year, month, and date were {cmd:y}, {cmd:m}, and 
{cmd:d} rather than {cmd:Y}, {cmd:M}, and {cmd:D}.  Under version control, 
the old codes are allowed and, in fact, the original {cmd:date()} function
is used.

{p 8 8 2}
The big advantage of Stata 10's {cmd:date()} is that it will translate 
run-together dates such as 20061201 (no special action by you required)
and translate more complicated date strings such as 
Wed Dec 01 14:22:43 CST 2006 (special action required in how {it:mask} is
specified, something that the old {cmd:date()} would not have understood).


{marker runtogether}{...}
    {title:Translating run-together dates such as 20060125}

{p 4 4 2}
Functions {cmd:clock()}, {cmd:Clock()}, and {cmd:date()} will translate dates
and times that are run together such as 20060125, 060125, and 20060125110215
(which is 25jan2006 11:02:15).  There is nothing special that you have to do:

	. {cmd:display %d date("20060125", "YMD")}
	25jan2006

	. {cmd:display %td date("060125", "20YMD")}
	25jan2006

	. {cmd:display %tc clock("20060125110215", "YMDhms")}
	25jan2006 11:02:15

{p 4 4 2}
In a data context, you could type

	. {cmd:gen startdate = date(startdatestr, "YMD")}

	. {cmd:gen double starttime = clock(starttimestr, "YMDhms")}

{p 4 4 2}
Remember to read the original data into a string.  If you read the data as
numeric, the best advice is to read the data again.  Numbers such as 
20060125 and 20060125110215 will be rounded unless they are stored as 
{cmd:double}s.

{p 4 4 2}
If you did read them into a {cmd:double}, or you have verified that rounding
did not occur, you can convert the variable from numeric to string.  The
numeric-to-string conversion function is {cmd:string()}, which comes in
one- and two-argument forms.  You will need the two-argument
form:

	. {cmd:gen str startdatestr = string(startdatedouble, "%10.0g")}

	. {cmd:gen str starttimestr = string(starttimedouble, "%16.0g")}

{p 4 4 2}
If you omitted the format, {cmd:string()} would produce 2.01e+07 for 20060125
and 2.01e+13 for 20060125110215.  The format we used had a width 2
larger than the length of the integer number, although using a too-wide format
would not hurt.


{marker fcnother}{...}
    {title:The other translation functions}

{p 4 4 2}
The other translation functions are

	    Format {c |} String-to-numeric conversion function
            {hline 7}{c +}{hline 41}
              {cmd:%tw}  {c |}   {cmd:weekly(}{it:string}{cmd:,} {it:mask} [{cmd:,} {it:topyear}]{cmd:)}
              {cmd:%tm}  {c |}   {cmd:monthly(}{it:string}{cmd:,} {it:mask} [{cmd:,} {it:topyear}]{cmd:)}
              {cmd:%tq}  {c |}   {cmd:quarterly(}{it:string}{cmd:,} {it:mask} [{cmd:,} {it:topyear}]{cmd:)}
              {cmd:%th}  {c |}   {cmd:halfyearly(}{it:string}{cmd:,} {it:mask} [{cmd:,} {it:topyear}]{cmd:)}
            {hline 7}{c BT}{hline 41}
            {it:string} is the value to be translated. 
            {it:mask} specifies the order of the components.
            {it:topyear} is described in {it:{help dates_and_times##twodigit:Working with two-digit years}} above.

{p 4 4 2}
These functions are rarely used because data seldom arrive in these 
formats.

{p 4 4 2}
All the functions translate a pair of numbers: {cmd:weekly()} translates a
year and a week number (1-52), {cmd:monthly()} translates a year and a month
number (1-12), {cmd:quarterly()} translates a year and a quarter number (1-4),
and {cmd:halfyearly()} translates a year and a half number (1-2).

{p 4 4 2}
The masks allowed are far more limited than for {cmd:clock()}, {cmd:Clock()}, 
and {cmd:date()}:

	    Code  {c |} Meaning
	    {hline 6}{c +}{hline 39}
             {cmd:Y}    {c |} 4-digit year
	     {cmd:19Y}  {c |} 2-digit year to be interpreted as 19{it:xx}
             {cmd:20Y}  {c |} 2-digit year to be interpreted as 20{it:xx}
                  {c |}
             {cmd:W}    {c |} week number     ({cmd:weekly()} only)
             {cmd:M}    {c |} month number    ({cmd:monthly()} only)
             {cmd:Q}    {c |} quarter number  ({cmd:quarterly()} only)
             {cmd:H}    {c |} half number     ({cmd:halfyearly()} only)
	    {hline 6}{c BT}{hline 39}
            The pair of numbers to be translated must be
            separated by space or punctuation.  No extra
            characters are allowed.

{p 4 4 2}
{it:Historical note:}
Before Stata 10, the mask codes were lowercase letters.  Under 
version control, lowercase letters are still allowed.


{marker validtimes}{...}
{title:Valid times}

{p 4 4 2}
27:62:90 is an invalid time.  If you try to convert 27:62:90 to a {cmd:%tc} 
or {cmd:%tC} value, you will get missing value or an error message.

{p 4 4 2}
24:00:00 is also invalid.  Correct is 00:00:00 of the next day.

{p 4 4 2}
In {it:hh}:{it:mm}:{it:ss}, the requirements are 
0 <= {it:hh} < 24, 
0 <= {it:mm} < 60, 
and 
0 <= {it:ss} < 60, although sometimes 60 is allowed.

{p 4 4 2}
31dec2005 23:59:60 is an invalid {cmd:%tc} time but a valid {cmd:%tC} one.
31dec2005 23:59:60 was an inserted leap second.

{p 4 4 2}
30dec2005 23:59:60 is an invalid time in both {cmd:%tc} and {cmd:%tC} formats.
30dec2005 23:59:60 was not an inserted leap second.  Correct is 
31dec2005 00:00:00.


{marker leapsecs}{...}
{title:When leap seconds occurred}

{p 4 4 2}
Stata system file {cmd:leapseconds.maint} lists the dates on which leap
seconds occurred.  The file is updated periodically (see 
{manhelp update R}; the file is updated when you 
update ado-files) and Stata's {cmd:%tC} functions access the 
file to know when leap seconds occurred.

{p 4 4 2}
You can access it, too.  To view the file, type 

	. {bf:{view leapseconds.maint, adopath asis:viewsource leapseconds.maint}}


{marker truncatedtimes}{...}
{title:Truncated times}

{p 4 4 2}
Consider the time 11:32:59.999.  Other, less precise ways of writing that time
are

	11:32:59.99
	11:32:59.9
	11:32:59
	11:32

{p 4 4 2}
That is, when you suppress the display of more detailed components of the time,
the parts that are displayed are not rounded.  Stata displays time like
a digital watch; the time is 11:32 right up until the instant that
it is 11:33.


{marker tcvstC}{...}
{title:Advice on using %tc and %tC}

{marker tcvstCsum}{...}
    {title:Summary}
    
{p 4 4 2}
Stata provides two time formats, 

{p 8 8 2}
{cmd:%tC}, also known as UTC, which accounts for leap seconds, and 

{p 8 8 2}
{cmd:%tc}, which ignores them (it assumes 86,400 seconds/day).

{p 4 4 2}
Systems vary in how they treat time variables.  SAS ignores leap seconds.
Oracle includes them.  Stata handles either.
Our advice:

{p 8 12 2}
    1.  If you obtain data from a system that accounts for 
        leap seconds, import using Stata's {cmd:%tC}.  

{p 12 16 2}
           a.  If you later need to export data to a system that does not
               account for leap seconds, use Stata's {cmd:cofC()} function to
               translate time values before exporting.

{p 12 16 2}
           b.  If you intend to {cmd:tsset} the time variable and 
               the analysis will be at the 
               second level or finer, just {cmd:tsset} the {cmd:%tC}
               variable, specifying the appropriate {cmd:delta()}
               if necessary, e.g., {cmd:delta(1000)} for 
               seconds.

{p 12 16 2}
           c.  If you intend to {cmd:tsset} the time variable and 
               the analysis will be at coarser than the second level 
               (minute, hour, etc.), 
               create a {cmd:%tc} variable from the {cmd:%tC} variable
               ({cmd:generate} {cmd:double} {it:tctime} = 
               {cmd:cofC(}{it:tCtime}{cmd:)}) and {cmd:tsset} that, 
               specifying the appropriate {cmd:delta()} if necessary.
               You must do that because, in a {cmd:%tC} variable, 
               there are not necessarily 60 seconds in a minute; 
               some minutes have 61 seconds.

{p 8 12 2}
    2.  If you obtain data from a system that ignores leap seconds, 
        use Stata's {cmd:%tc}.  

{p 12 16 2}
            a.  If you later need to export data to a system that does account
                for leap seconds, use Stata's {cmd:Cofc()} function to
                translate time values.

{p 12 16 2}
            b.  If you intend to {cmd:tsset} the time variable, just 
                {cmd:tsset} it, specifying the appropriate {cmd:delta()}.

{p 4 4 2}
Some users prefer to always use Stata's {cmd:%tc} because {cmd:%tc}
values are a little easier to work with.  You can do that if 
    
{p 8 12 2}
1.  you do not mind having up to 1 second of error and

{p 8 12 2}
2.  you do not import or export numerical values (clock ticks) from other
    systems that are using leap seconds, because then there could be
    nearly 30 seconds of error.

{p 4 4 2}
There are two things to remember if you use {cmd:%tC} variables:

{p 8 12 2}
1.  The number of seconds between two dates is a function of when the 
    dates occurred.  Five days from one date is not simply a matter of 
    adding 5*24*60*60*1,000 ms.  You might need to add another 
    1,000 ms.  Three hundred and sixty-five days from now might
    require adding 1,000 or 2,000 ms.  The longer the span, the more
    you might have to add.  (The best way to add durations to {cmd:%tC}
    variables is to extract the components, add to them, and then reconstruct
    from the numerical components.)

{p 8 12 2}
2.  You cannot accurately predict date/times into the future.
    We do not know what the {cmd:%tC} value will be of 25dec2026 00:00:00
    because, along the way, the authorities may (and probably will) announce
    leap seconds.
    

{marker tcvstCdtl}{...}
    {title:Explanation}

{p 4 4 2}
Stata's {cmd:%tc} encoding assumes that there are 24*60*60*1,000 ms 
per day, just as an atomic clock, counting oscillations between the 
nucleus of an atom and its electrons, would define
it.

{p 4 4 2}
Since 1972, leap seconds have been added once or twice a year to keep time
measured that way in synchronization with the earth's rotation.
Unlike leap years, however, there is no formula to
predict when leap seconds will occur.  The earth is on average slowing down,
but there is a relatively large random component, and so leap seconds are
determined by fiat and announced 6 months before they are inserted.  Leap
seconds are added, if necessary, on the end of the day on June 30 and December
31 and are designated 23:59:60.

{p 4 4 2}
You may have heard various terms such as GMT and UTC.  

{p 4 4 2}
GMT is the old Greenwich Mean Time and is based on astronomical observation.

{p 4 4 2}
UTC stands for coordinated universal time and is measured by atomic clocks, 
occasionally corrected for leap seconds.

{p 4 4 2}
UT1 is the mean solar time, with which UTC is kept in sync by the 
occasional addition of a leap second.

{p 4 4 2}
TAI is atomic time on which UTC is based.  TAI was set to GMT plus 10 
seconds in 1958 and has been running since then.

{p 4 4 2}
UNK is our term for the time standard most people use.  UNK stands for
unknown, or unknowing.  UNK is based on a recent time observation, probably
UTC, and then most people just assume that there are 86,400 seconds per day
after that.

{p 4 4 2}
The UNK standard is usually adequate, and you will want to use {cmd:%tc}
rather than the leap second-adjusted {cmd:%tC} encoding.  If you are using
computer-timestamped data, however, you may need to find out whether the
timestamping system used leap second adjustment.  Problems can arise even if
you do not care about losing or gaining a second here and there.

{p 4 4 2}
For instance, you may import timestamp values from other systems as integers,
recorded in the number of milliseconds, or export them.  You may
do this, but as of 18aug2006, if you choose the wrong encoding scheme
(choose {cmd:%tc} when you should choose {cmd:%tC}, or vice versa), your
recent times will be off by 23 seconds.

{p 4 4 2}
To avoid such problems, you may decide to import and export data by using
printable forms, such as "Fri Aug 18 14:05:36 CDT 2006".  This method has
advantages, but for {cmd:%tC} encoding, times such as 23:59:60 are
possible.  Some systems will refuse to decode such times.

{p 4 4 2}
Stata refuses to decode 23:59:60 in the {cmd:%tc} encoding (function
{cmd:clock()}) and accepts it with {cmd:%tC} (function {cmd:Clock()}).
(When the {cmd:%tC} function {cmd:Clock()} sees a time with a 60th second, the
function verifies that the time is one of the official leap seconds.)  Thus,
when translating from printable forms, you can assume {cmd:%tc} and check for
missing values.  If there are none, then you can use {cmd:%tc}.  You will
never be off by more than 1 second.  If there are leap seconds in your data,
use  {cmd:Clock()} to translate them and then, if you still want to work in
{cmd:%tc} units, use function {cmd:cofC()} to translate {cmd:%tC} values into
{cmd:%tc}.  Again, you will have no more than 1 second of inaccuracy.

{p 4 4 2}
If precision matters, the best way to process {cmd:%tC} data is simply to
treat them that way.  The inconvenience is that you cannot assume that there
are 86,400 seconds per day.  To obtain the duration between dates, you must
subtract the two time values involved.  The other difficulty has to do with
dealing with dates in the future.  Under the {cmd:%tC} encoding, there is no
set value for any date more than 6 months in the future.


{title:Also see}

{psee}
Manual:  {bf:[D] dates and times}

{psee}
Online:  {manhelp format D}
{p_end}

