{smcl}
{* *! version 1.0.6  14may2008}{...}
{cmd:help eps_options}
{hline}
{* index exporting graphs}{...}
{* index PostScript}{...}
{* index Encapsulated PostScript}{...}

{title:Title}

{p2colset 5 24 26 2}{...}
{p2col :{hi:[G] {it:eps_options}} {hline 2}}Options for exporting to Encapsulated PostScript{p_end}
{p2colreset}{...}


{title:Syntax}

{p2colset 9 34 37 2}{...}
{p2col:{it:eps_options}}
	description{p_end}
{p2line}
{p2col:{cmd:logo(on}|{cmd:off)}}
	whether to include Stata logo{p_end}
{p2col:{cmd:cmyk(on}|{cmd:off)}}
	whether to use CMYK rather than RGB colors{p_end}
{p2col:{cmdab:pre:view:(on}|{cmd:off)}}
	whether to include TIFF preview{p_end}
{p2col:{cmd:mag(}{it:#}{cmd:)}}
	magnification/shrinkage factor; default is 100{p_end}
{p2col:{cmdab:font:face:(}{it:fontname}{cmd:)}}
	font to use{p_end}
{p2col:{cmdab:or:ientation:(portrait}|}{p_end}
{p2col 21 34 37 2:{cmd:landscape)}}
	whether vertical or horizontal{p_end}
{p2line}
{p2colreset}{...}

{pstd}
Current default values may be listed by typing

	{bf:. {stata graph set eps}}

{pstd}
and default values may be set by typing

{p 8 16 2}
{cmd:.} {helpb graph set}
{cmd:eps}
{it:name}
{it:value}

{pstd}
where {it:name} is the name of an {it:eps_option}, omitting the
parentheses.


{title:Description}

{pstd}
These {it:eps_options} are used with {cmd:graph} {cmd:export}
when creating an Encapsulated PostScript file; see
{manhelp graph_export G:graph export}.


{title:Options}

{phang}
{cmd:logo(on)} and {cmd:logo(off)}
    specify whether the Stata logo should be included at the bottom of the
    graph.

{phang}
{cmd:cmyk(on)} and {cmd:cmyk(off)}
    specify whether colors in the output file should be specified as CMYK
    values rather than RGB values.

{phang}
{cmd:preview(on)} and {cmd:preview(off)}
    specify whether a TIFF preview of the graph should be included in the 
    Encapsulated PostScript file.  This option allows word processors that
    cannot interpret PostScript to display a preview of the file.  The preview
    is often substituted for the Encapsulated PostScript file when printing
    to a non-PostScript printer.  This option is not available in Stata 
    console and requires the Graph window to be visible.

{phang}
{cmd:mag(}{it:#}{cmd:)}
    specifies that the graph be drawn smaller or larger than ordinarily.
    {cmd:mag(100)} is the default, meaning ordinary size.
    {cmd:mag(110)} would make the graph 10% larger than usual, and
    {cmd:mag(90)} would make the graph 10% smaller than usual.
    {it:#} must be an integer.

{phang}
{cmd:fontface(}{it:fontname}{cmd:)}
    specifies the name of the PostScript font to be used to render text.
    If {it:fontname} includes blanks, {it:fontname} must be enclosed in
    double quotes.

{phang}
{cmd:orientation(portrait)}
and
{cmd:orientation(landscape)}
    specify whether  the graph is to be presented vertically or horizontally.


{title:Remarks}

{pstd}
Remarks are presented under the following headings:

	{help eps_options##remarks1:Using the eps_options}
	{help eps_options##remarks2:Setting defaults}


{marker remarks1}{...}
{title:Using the eps_options}

{pstd}
You have drawn a graph and wish to create an Encapsulated PostScript file
for including the file in a document.
You wish,
however, to change the text from Helvetica to Roman, which is "Times" in
PostScript jargon:

	{cmd:. graph} ...{col 50}(draw a graph)

	{cmd:. graph export myfile.eps, fontface(Times)}


{marker remarks2}{...}
{title:Setting defaults}

{pstd}
If you always wanted {cmd:graph} {cmd:export} to use Times
when exporting to Encapsulated PostScript files, you could type

	{cmd:. graph set eps fontface Times}

{pstd}
Later you could type

	{cmd:. graph set eps fontface Helvetica}

{pstd}
to change it back.  You can list the current {it:eps_option} settings
for Encapsulated PostScript by typing

	{cmd:. graph set eps}


{title:Also see}

{psee}
Manual:  {bf:[G] {it:eps_options}}

{psee}
Online:  {manhelp graph_export G:graph export},
{manhelp graph_set G:graph set}
{p_end}
