{smcl}
{* *! version 1.0.1  13feb2008}{...}
{cmd:help file extensions}
{hline}

{title:Title}

    {bf:[U] 11.6 File-naming conventions}


{title:Remarks}

{pstd}
In most cases, Stata automatically provides a file extension if you do not
supply one.  For instance, if you type {cmd:use mydata}, Stata assumes that
you mean {cmd:use mydata.dta} because {cmd:.dta} is the file extension
Stata normally uses for data files.

{pstd}
Stata provides eighteen default file extensions that are used by various
commands:

{p2colset 9 20 22 2}{...}
{p2col :{cmd:.ado}}automatically loaded do-files{p_end}
{p2col :{cmd:.dct}}ASCII data dictionary{p_end}
{p2col :{cmd:.do}}do-file{p_end}
{p2col :{cmd:.dta}}Stata-format dataset{p_end}
{p2col :{cmd:.dtasig}}{cmd:datasignature} file{p_end}
{p2col :{cmd:.gph}}{cmd:graph}{p_end}
{p2col :{cmd:.grec}}Graph Editor recording (ASCII format){p_end}
{p2col :{cmd:.irf}}impulse-response function datasets{p_end}
{p2col :{cmd:.log}}log file in text format{p_end}
{p2col :{cmd:.mata}}Mata source code{p_end}
{p2col :{cmd:.mlib}}Mata library{p_end}
{p2col :{cmd:.mmat}}Mata matrix{p_end}
{p2col :{cmd:.mo}}Mata object file{p_end}
{p2col :{cmd:.out}}file saved by {cmd:outsheet}{p_end}
{p2col :{cmd:.raw}}ASCII-format dataset{p_end}
{p2col :{cmd:.smcl}}log file in SMCL format{p_end}
{p2col :{cmd:.sthlp}}help files{p_end}
{p2col :{cmd:.sum}}checksum files to verify network transfers{p_end}
{p2col :{cmd:.ster}}saved estimates{p_end}

{pstd}
You do not have to name your data files with the {cmd:.dta} extension.  If
you type an explicit file extension, it will override the default, so
if your dataset was stored as {cmd:myfile.dat}, you could type
{cmd:use myfile.dat}.  If your dataset was stored as simply {cmd:myfile}
with no file extension, you could type the period at the end of the
filename to indicate that you are explicitly specifying the null
extension.

{pstd}
Stata also makes use of twelve other file extensions.  These files are of
interest only to advanced programmers or are for Stata's internal use.
They are

{p2col :{cmd:.class}}class file for object-oriented programming; see
            {manhelp class P}{p_end}
{p2col :{cmd:.dlg}}dialog resource file{p_end}
{p2col :{cmd:.idlg}}dialog resource include file{p_end}
{p2col :{cmd:.ihlp}}help include file{p_end}
{p2col :{cmd:.key}}{cmd:search}'s keyword database file{p_end}
{p2col :{cmd:.maint}}maintenance file (for Stata's internal use only){p_end}
{p2col :{cmd:.mnu}}menu file (for Stata's internal use only){p_end}
{p2col :{cmd:.pkg}}user-site package file{p_end}
{p2col :{cmd:.plugin}}compiled addition (DLL){p_end}
{p2col :{cmd:.scheme}}control file for a graph scheme{p_end}
{p2col :{cmd:.style}}graph style file{p_end}
{p2col :{cmd:.toc}}user-site description file{p_end}


{title:Also see}

{psee}
Manual:  {hi:[U] 11.6 File-naming conventions}
{p_end}
