{smcl}
{* *! version 1.0.4  14may2008}{...}
{cmd:help fcline_options}
{hline}

{title:Title}

{p2colset 5 27 29 2}{...}
{p2col :{hi:[G] {it:fcline_options}} {hline 2}}Options for determining the look of fitted connecting lines{p_end}
{p2colreset}{...}


{title:Syntax}

{p2colset 9 40 42 2}{...}
{p2col:{it:fcline_options}}
	description{p_end}
{p2line}
{p2col:{cmdab:clp:attern:(}{it:{help linepatternstyle}}{cmd:)}}
	whether line solid, dashed, etc.{p_end}
{p2col:{cmdab:clw:idth:(}{it:{help linewidthstyle}}{cmd:)}}
	thickness of line{p_end}
{p2col:{cmdab:clc:olor:(}{it:{help colorstyle}}{cmd:)}}
	color of line{p_end}

{p2col:{cmdab:clsty:le:(}{it:{help linestyle}}{cmd:)}}
	overall style of line{p_end}
{p2col:{cmdab:psty:le:(}{it:{help pstyle}}{cmd:)}}
	overall plot style, including linestyle{p_end}
{p2line}
{p2colreset}{...}
{pin}
All options are {it:rightmost}; see {help repeated options}.


{title:Description}

{pstd}
The {it:fcline_options} determine the look of a fitted connecting line in most
contexts.


{title:Options}

{phang}
{cmd:clpattern(}{it:linepatternstyle}{cmd:)}
    specifies whether the line is solid, dashed, etc.
    See {manhelpi linepatternstyle G} for a list of available patterns.

{phang}
{cmd:clwidth(}{it:linewidthstyle}{cmd:)}
    specifies the thickness of the line.
    See {manhelpi linewidthstyle G} for a list of available thicknesses.

{phang}
{cmd:clcolor(}{it:colorstyle}{cmd:)}
    specifies the color of the line.  See {manhelpi colorstyle G} for a
    list of available colors.

{phang}
{cmd:clstyle(}{it:linestyle}{cmd:)}
    specifies the overall style of the line:  its pattern, thickness, and
    color.

{pmore}
    You need not specify {cmd:clstyle()} just because there is something
    you want to change about the look of the line.  The other
    {it:fcline_options} will allow you to make changes.  You specify
    {cmd:clstyle()} when another style exists that is exactly what you
    desire or when another style would allow you to specify fewer changes.

{pmore}
    See {manhelpi linestyle G} for a list of available line styles.

{phang}
{cmd:pstyle(}{it:pstyle}{cmd:)}
    specifies the overall style of the plot, including not only the linestyle
    but also all other settings for the look of the plot.  Only the 
    {it:{help linestyle}} affects the look of lines.  See 
    {manhelpi pstyle G} for a list of available plot styles.


{title:Remarks}

{pstd}
Lines occur in many contexts and, in almost all of those contexts, the above
options are used to determine the look of the fitted connecting line.  For
instance, the {cmd:clcolor()} option in

{phang2}
	{cmd:. twoway lfitci y x, clcolor(red)}

{pstd}
causes the line through the ({cmd:y},{cmd:x}) points to be drawn in red.

{pstd}
The same option in

	{cmd:. twoway lfitci y x, title("My line", box clcolor(red))}

{pstd}
causes the outline drawn around the title's box to be drawn in red.  
In the second command, the option {cmd:clcolor(red)} was a suboption to the
{cmd:title()} option.


{title:Also see}

{psee}
Manual:  {bf:[G] {it:fcline_options}}
{p_end}
