{smcl}
{* *! version 1.0.5  14may2008}{...}
{cmd:help fitarea_options}
{hline}

{title:Title}

{p2colset 5 28 30 2}{...}
{p2col :{hi:[G] {it:fitarea_options}} {hline 2}}Options for specifying the look of confidence interval areas{p_end}
{p2colreset}{...}


{title:Syntax}

{p2colset 9 40 42 2}{...}
{p2col:{it:fitarea_options}}
	description{p_end}
{p2line}
{p2col:{cmdab:acol:or:(}{it:{help colorstyle}}{cmd:)}}
	outline and fill color{p_end}
{p2col:{cmdab:fc:olor:(}{it:{help colorstyle}}{cmd:)}}
	fill color{p_end}
{p2col:{cmdab:fi:ntensity:(}{it:{help intensitystyle}}{cmd:)}}
	fill intensity{p_end}

{p2col:{cmdab:alc:olor:(}{it:{help colorstyle}}{cmd:)}}
	outline color{p_end}
{p2col:{cmdab:alw:idth:(}{it:{help linewidthstyle}}{cmd:)}}
	thickness of outline{p_end}
{p2col:{cmdab:alp:attern:(}{it:{help linepatternstyle}}{cmd:)}}
	outline pattern (solid, dashed, etc.){p_end}
{p2col:{cmdab:alsty:le:(}{it:{help linestyle}}{cmd:)}}
	overall look of outline{p_end}

{p2col:{cmdab:asty:le:(}{it:{help areastyle}}{cmd:)}}
	overall look of area, all settings above{p_end}
{p2col:{cmdab:psty:le:(}{it:{help pstyle}}{cmd:)}}
	overall plot style, including areastyle{p_end}
{p2line}
{p2colreset}{...}
{pin}
All options are {it:merged-implicit}; see {help repeated options}.


{title:Description}

{pstd}
The {it:fitarea_options} determine the look of, for instance, the confidence
interval areas created by {cmd:twoway fpfitci}, {cmd:twoway lfitci},
{cmd:twoway lpolyci}, and {cmd:twoway qfitci}.


{title:Options}

{phang}
{cmd:acolor(}{it:colorstyle}{cmd:)}
    specifies one color to be used both to outline the shape of the
    area and to fill its interior.
    See {manhelpi colorstyle G} for a list of color choices.

{phang}
{cmd:fcolor(}{it:colorstyle}{cmd:)}
    specifies the color to be used to fill the interior of the area.
    See {manhelpi colorstyle G} for a list of color choices.

{phang}
{cmd:fintensity(}{it:intensitystyle}{cmd:)}
    specifies the intensity of the color used to fill the interior of the area.
    See {manhelpi intensitystyle G} for a list of intensity choices.

{phang}
{cmd:alcolor(}{it:colorstyle}{cmd:)}
    specifies the color to be used to outline the area.
    See {manhelpi colorstyle G} for a list of color choices.

{phang}
{cmd:alwidth(}{it:linewidthstyle}{cmd:)}
    specifies the thickness of the line to be used to outline the area.
    See {manhelpi linewidthstyle G} for a list of choices.

{phang}
{cmd:alpattern(}{it:linepatternstyle}{cmd:)}
    specifies whether the line used to outline the area is solid, dashed,
    etc.
    See {manhelpi linepatternstyle G} for a list of pattern choices.

{phang}
{cmd:alstyle(}{it:linestyle}{cmd:)}
    specifies the overall style of the line used to outline the area, 
    including its pattern (solid, dashed, etc.), thickness, and color.
    The three options listed above allow you to change the line's attributes,
    but {cmd:lstyle()} is the starting point.
    See {manhelpi linestyle G} for a list of choices.

{phang}
{cmd:astyle(}{it:areastyle}{cmd:)}
    specifies the overall look of the area.  The options listed above allow
    you to change each attribute, but {cmd:style()} provides a starting
    point.

{pmore}
    You need not specify {cmd:style()} just because there is something you
    want to change.  You specify {cmd:style()} when another style exists that
    is exactly what you desire or when another style would allow you to
    specify fewer changes to obtain what you want.

{pmore}
    See {manhelpi areastyle G} for a list of available area styles.

{phang}
{cmd:pstyle(}{it:pstyle}{cmd:)}
    specifies the overall style of the plot, including not only the areastyle
    but also all other settings for the look of the plot.  Only the 
    {it:{help areastyle}} affects the look of areas.  See 
    {manhelpi pstyle G} for a list of available plot styles.


{title:Remarks}

{pstd}
{it:fitarea_options} are allowed as options with any {cmd:graph twoway}
plottype that creates shaded confidence interval areas, for example,
{cmd:graph} {cmd:twoway} {cmd:lfitci}, as in

{phang2}
	{cmd:. graph twoway lfitci} {it:yvar} {it:xvar}{cmd:, acolor(blue)}

{pstd}
The above would set the area enclosed by {it:yvar} and the {it:x} axis to be
blue; see {manhelp twoway_area G:graph twoway area} and
{manhelp twoway_rarea G:graph twoway rarea}.


{title:Also see}

{psee}
Manual:  {bf:[G] {it:fitarea_options}}
{p_end}
