{smcl}
{* *! version 1.1.13  01nov2007}{...}
{cmd: help glm}{right:dialogs:  {bf:{dialog glm}}  {dialog glm, message(-svy-) name(svy_glm):svy: glm}{space 5}}
{right:also see:  {help glm postestimation}}
{hline}

{title:Title}

{p2colset 5 16 18 2}{...}
{p2col :{hi:[R] glm} {hline 2}}Generalized linear models{p_end}
{p2colreset}{...}


{title:Syntax}

{p 8 12 2}
{cmd:glm}
{depvar}
[{indepvars}]
{ifin}
{weight}
[{cmd:,} {it:options}]

{synoptset 26 tabbed}{...}
{synopthdr}
{synoptline}
{syntab :Model}
{synopt :{opth f:amily(glm##familyname:familyname)}}distribution of {depvar};
    default is {cmd:family(gaussian)}{p_end}
{synopt :{opth l:ink(glm##linkname:linkname)}}link function; default is
    canonical link for {opt family()} specified{p_end}

{syntab :Model 2}
{synopt :{opt nocon:stant}}suppress constant term{p_end}
{synopt :{opth exp:osure(varname)}}include ln({it:varname}) in model with
coefficient constrained to 1{p_end}
{synopt :{opth off:set(varname)}}include {it:varname} in model with coefficient
constrained to 1{p_end}
{synopt:{cmdab:const:raints(}{it:{help ts estimation options##constraints():constraints}}{cmd:)}}apply specified linear constraints{p_end}
{synopt :{opth mu(varname)}}use {it:varname} as the initial estimate for the
mean of {depvar}{p_end}
{synopt :{opth ini:t(varname)}}synonym for {opt mu(varname)}{p_end}

{syntab :SE/Robust}
{synopt :{cmd:vce(}{it:{help glm##vcetype:vcetype}}{cmd:)}}{it:vcetype}
may be {opt oim}, {opt r:obust}, {opt cl:uster} {it:clustvar}, {opt eim}, 
{opt opg}, {opt boot:strap}, {opt jack:knife}, {opt hac} {it:kernel},
{opt jackknife1}, or {opt unb:iased}{p_end}
{synopt :{opt vf:actor(#)}}multiply variance matrix by scalar {it:#}{p_end}
{synopt :{opt disp(#)}}quasilikelihood multiplier{p_end}
{synopt :{cmdab:sca:le(x2}|{cmd:dev}|{it:#}{cmd:)}}set the scale parameter{p_end}

{syntab :Reporting}
{synopt :{opt le:vel(#)}}set confidence level; default is
{cmd:level(95)}{p_end}
{synopt :{opt ef:orm}}report exponentiated coefficients{p_end}

{syntab :Max options}
{synopt :{opt ml}}use maximum likelihood optimization; the default{p_end}
{synopt :{opt irls}}use iterated, reweighted least-squares optimization of the
deviance{p_end}
{synopt :{it:{help glm##maximize_options:maximize_options}}}control the maximization process; seldom
used{p_end}
{synopt :{opt fisher(#)}}use the Fisher scoring Hessian or expected
information matrix (EIM){p_end}
{synopt :{opt search}}search for good starting values{p_end}

{p2coldent :+ {opt nohead:er}}suppress header table from above
coefficient table{p_end}
{p2coldent :+ {opt notable}}suppress coefficient table{p_end}
{p2coldent :+ {opt nodisplay}}suppress the output; iteration log is
still displayed{p_end}
{synoptline}
{p2colreset}{...}

{marker familyname}{...}
{synoptset 23}{...}
{synopthdr :familyname}
{synoptline}
{synopt :{opt gau:ssian}}Gaussian (normal){p_end}
{synopt :{opt ig:aussian}}inverse Gaussian{p_end}
{synopt :{opt b:inomial}[{it:{help varname:varnameN}}|{it:#N}]}Bernoulli/binomial{p_end}
{synopt :{opt p:oisson}}Poisson{p_end}
{synopt :{opt nb:inomial}[{it:#k}]}negative binomial{p_end}
{synopt :{opt gam:ma}}gamma{p_end}
{synoptline}
{p2colreset}{...}

{marker linkname}{...}
{synoptset 23}{...}
{synopthdr :linkname}
{synoptline}
{synopt :{opt i:dentity}}identity{p_end}
{synopt :{opt log}}log{p_end}
{synopt :{opt l:ogit}}logit{p_end}
{synopt :{opt p:robit}}probit{p_end}
{synopt :{opt c:loglog}}cloglog{p_end}
{synopt :{opt pow:er} {it:#}}power{p_end}
{synopt :{opt opo:wer} {it:#}}odds power{p_end}
{synopt :{opt nb:inomial}}negative binomial{p_end}
{synopt :{opt logl:og}}log-log{p_end}
{synopt :{opt logc}}log-complement{p_end}
{synoptline}
{p2colreset}{...}

{p 4 6 2}
{it:depvar} and {it:indepvars} may contain time-series operators; see {help tsvarlist}.{p_end}
{p 4 6 2}
{opt bootstrap}, {opt by}, {opt jackknife}, {opt nestreg},
{opt rolling}, {opt statsby}, {opt stepwise}, {opt svy}, and {cmd:xi}
are allowed; see {help prefix}.{p_end}
{p 4 6 2}Weights are not allowed with the {helpb bootstrap} prefix.{p_end}
{p 4 6 2}{cmd:aweight}s are not allowed with the {helpb jackknife} prefix.
{p_end}
{p 4 6 2}
{opt vce()},
{opt vfactor()},
{opt disp()},
{opt scale()},
{opt irls},
{opt fisher()},
{opt noheader},
{opt notable},
{opt nodisplay},
and weights are not allowed with the {helpb svy} prefix.
{p_end}
{p 4 6 2}
+ {opt noheader}, {opt notable}, and {opt nodisplay} do not appear in the
dialog box.
{p_end}
{p 4 6 2}
{opt fweight}s, {opt aweight}s, {opt iweight}s, and {opt pweight}s are
allowed; see {help weight}.{p_end}
{p 4 6 2}
See {manhelp glm_postestimation R:glm postestimation} for features available
after estimation.{p_end}


{title:Description}

{pstd}
{opt glm} fits generalized linear models.  It can fit models by using
either IRLS (maximum quasilikelihood) or Newton-Raphson (maximum likelihood)
optimization, which is the default.  Previous versions of {cmd:glm} used only
IRLS.

{pstd}
See {help logistic estimation commands} for lists of related estimation
commands.


{title:Options}

{dlgtab:Model}

{phang}
{opt family(familyname)} specifies the distribution of
{depvar}; {cmd:family(gaussian)} is the default.

{phang}
{opt link(linkname)} specifies the link function; the
default is the canonical link for the {cmd:family()} specified.

{dlgtab:Model 2}

{phang}
{opt noconstant}, {opth exposure(varname)}, {opt offset(varname)},
{opt constraints(constraints)}; see 
{helpb estimation options:[R] estimation options}.
{opt constraints(constraints)} is not allowed with {opt irls}.

{phang}
{opth mu(varname)} specifies {it:varname} as the initial estimate for the mean
of {depvar}.  This option can be useful with models that experience convergence
difficulties, such as {cmd:family(binomial)} models with power or odds-power
links.  {opt init(varname)} is a synonym.

{marker vcetype}{...}
{dlgtab:SE/Robust}

INCLUDE help vce_asymptall

{pmore}
In addition to the standard {it:vcetype}s, {opt glm} allows the following
alternatives:

{phang2}
{cmd:vce(eim)} specifies that the expected information matrix estimate of
variance be used.

{phang2}
{cmd:vce(jackknife1)} specifies that the one-step jackknife estimate of
variance be used.

{phang2}
{cmd:vce(hac} {it:kernel} [{it:#}]{cmd:)} specifies that a
heteroskedasticity- and autocorrelation-consistent (HAC) variance estimate be
used.  HAC refers to the general form for combining weighted matrices
to form the variance estimate.  There are three kernels built into
{opt glm}. {it:kernel} is a user-written program or one of

{center:{opt nw:est} | {opt ga:llant} | {opt an:derson}}

{pmore2}
{it:#} specifies the number of lags.  If {it:#} is not specified, N - 2 is
assumed.  If you wish to specify {cmd:vce(hac} ... {cmd:)}, you must 
{cmd:tsset} your data before calling {cmd:glm}.

{phang2}
{cmd:vce(unbiased)} specifies that the unbiased sandwich estimate of variance
be used.

{phang}
{opt vfactor(#)} specifies a scalar by which to
multiply the resulting variance matrix.  This option allows you to match
output with other packages, which may apply degrees of freedom or other
small-sample corrections to estimates of variance.

{phang}
{opt disp(#)} multiplies the variance of {depvar}
by {it:#} and divides the deviance by {it:#}.  The resulting distributions are
members of the quasilikelihood family.

{phang}
{cmd:scale(x2}|{cmd:dev}|{it:#}{cmd:)} overrides the
default scale parameter.  This option is allowed only with Hessian
(information matrix) variance estimates.

{pmore}
By default, {cmd:scale(1)} is assumed for the 
discrete distributions (binomial, Poisson, and negative binomial),
and {cmd:scale(x2)} is assumed for the continuous distributions
(Gaussian, gamma, and inverse Gaussian).

{pmore}
{cmd:scale(x2)} specifies that the scale parameter be set to the Pearson
chi-squared (or generalized chi-squared) statistic divided by the residual
degrees of freedom, which is recommended by McCullagh and Nelder (1989) as a
good general choice for continuous distributions.

{pmore}
{cmd:scale(dev)} sets the scale parameter to the deviance divided by the
residual degrees of freedom.  This option provides an alternative to
{cmd:scale(x2)} for continuous distributions and overdispersed or
underdispersed discrete distributions.

{pmore}
{opt scale(#)} sets the scale parameter to {it:#}.
For example, using {cmd:scale(1)} in {cmd:family(gamma)} models results in
exponential-errors regression.  Additional use of {cmd:link(log)} rather than
the default {cmd:link(power -1)} for {cmd:family(gamma)} essentially
reproduces Stata's {opt streg}, {cmd:dist(exp) nohr} command (see
{manhelp streg ST}) if all the observations are uncensored.

{dlgtab:Reporting}

{phang}
{opt level(#)}; see
{helpb estimation options##level():[R] estimation options}.

{phang}
{opt eform} displays the exponentiated coefficients and corresponding
standard errors and confidence intervals.  For 
{cmd:family(binomial) link(logit)} (i.e., logistic regression),
 exponentiation results in odds ratios; for 
{cmd:family(poisson) link(log)} (i.e., Poisson regression),
 exponentiated coefficients are rate ratios.

{marker maximize_options}{...}
{dlgtab:Max options}

{phang}
{opt ml} requests that optimization be carried out using Stata's {opt ml}
commands and is the default.

{phang}
{opt irls} requests iterated, reweighted least-squares (IRLS) optimization of
the deviance instead of Newton-Raphson optimization of the
log likelihood.  If the {opt irls} option is not specified, the optimization
is carried out using Stata's {opt ml} commands, in which case all options of
{opt ml maximize} are also available.

{phang}
{it:maximize_options}:
{opt dif:ficult},
{opt tech:nique(algorithm_spec)},
{opt iter:ate(#)},
[{cmdab:no:}]{opt lo:g},
{opt tr:ace},
{opt grad:ient},
{opt showstep},
{opt hess:ian},
{opt shownr:tolerance},
{opt tol:erance(#)},
{opt ltol:erance(#)},
{opt gtol:erance(#)},
{opt nrtol:erance(#)},
{opt nonrtol:erance},
{opt from(init_specs)}; see {manhelp maximize R}. These options are seldom used.

{pmore}
Setting the optimization type to {cmd:technique(bhhh)} resets the default
{it:vcetype} to {cmd:vce(opg)}.

{phang}
{opt fisher(#)} specifies the number of Newton-Raphson steps that
should use the Fisher scoring Hessian or expected information matrix (EIM)
before switching to the observed information matrix (OIM).  This option is
useful only for Newton-Raphson optimization (and not when using {cmd:irls}).

{phang}
{opt search} specifies that the command should search for good starting
values.  This option is useful only for Newton-Raphson optimization (and
not when using {opt irls}).

{pstd}
The following options are available with {opt glm} but are not shown in the
dialog box:

{phang}
{opt noheader} suppresses the header information from the output.  The
coefficient table is still displayed.

{phang}
{opt notable} suppresses the table of coefficients from the output.  The
header information is still displayed.

{phang}
{opt nodisplay} suppresses the output.  The iteration log is still
displayed.


{title:Remarks}

{pstd}
Although {opt glm} can be used to fit linear regression
(and, in fact, does so by default), this should be viewed as an instructional
feature; {cmd:regress} produces such estimates more quickly, 
and many postestimation commands are available to explore the adequacy of
the fit; see {manhelp regress R} and
{manhelp regress_postestimation R:regress postestimation}.

{pstd}
In any case, you should specify the link function by using the {opt link()}
option and the distributional family by using {opt family()}.
The available link functions are

{center:Link function            {cmd:glm} option     }
{center:{hline 40}}
{center:identity                 {cmd:link(identity)} }
{center:log                      {cmd:link(log)}      }
{center:logit                    {cmd:link(logit)}    }
{center:probit                   {cmd:link(probit)}   }
{center:complementary log-log    {cmd:link(cloglog)}  }
{center:odds power               {cmd:link(opower} {it:#}{cmd:)} }
{center:power                    {cmd:link(power} {it:#}{cmd:)}  }
{center:negative binomial        {cmd:link(nbinomial)}}
{center:log-log                  {cmd:link(loglog)}   }
{center:log-complement           {cmd:link(logc)}     }

{pstd}
The available distributional families are

{center:Family                 {cmd:glm} option       }
{center:{hline 40}}
{center:Gaussian(normal)       {cmd:family(gaussian)} }
{center:inverse Gaussian       {cmd:family(igaussian)}}
{center:Bernoulli/binomial     {cmd:family(binomial)} }
{center:Poisson                {cmd:family(poisson)}  }
{center:negative binomial      {cmd:family(nbinomial)}}
{center:gamma                  {cmd:family(gamma)}    }

{pstd}
You do not have to specify both {opt family()} and {opt link()}; the default
{opt link()} is the canonical link for the specified {opt family()}
(except for {opt nbinomial}):

{center:Family                  Default link{space 2}}
{center:{hline 38}}
{center:{cmd:family(gaussian)}        {cmd:link(identity)}}
{center:{cmd:family(igaussian)}       {cmd:link(power -2)}}
{center:{cmd:family(binomial)}        {cmd:link(logit)}   }
{center:{cmd:family(poisson)}         {cmd:link(log)}     }
{center:{cmd:family(nbinomial)}       {cmd:link(log)}     }
{center:{cmd:family(gamma)}           {cmd:link(power -1)}}

{pstd}
If you specify both {opt family()} and {opt link()}, not all
combinations make sense.  You may choose from the following combinations:

	  {c |} id  log  logit  probit  clog  pow  opower  nbinomial  loglog  logc
{hline 10}{c +}{hline 67}
Gaussian  {c |}  x   x                         x
inv. Gau. {c |}  x   x                         x
binomial  {c |}  x   x     x      x       x    x     x                  x      x
Poisson   {c |}  x   x                         x
neg. bin. {c |}  x   x                         x              x
gamma     {c |}  x   x                         x


{title:Examples}

    {hline}
{pstd}Setup{p_end}
{phang2}{cmd:. webuse lbw2}{p_end}

{pstd}Generalized linear model with Bernoulli family and default logit
link{p_end}
{phang2}{cmd:. glm low age lwt race2 race3 smoke ptl ht ui, family(binomial)}
{p_end}

{pstd}Replay results and report exponentiated coefficients{p_end}
{phang2}{cmd:. glm, eform}

    {hline}
{pstd}Setup{p_end}
{phang2}{cmd:. webuse ldose}{p_end}

{pstd}Generalized linear model with binomial family and default logit
link{p_end}
{phang2}{cmd:. glm r ldose, family(binomial n)}{p_end}

{pstd}Generalized linear model with binomial family and cloglog link{p_end}
{phang2}{cmd:. glm r ldose, family(binomial n) link(cloglog)}{p_end}

    {hline}
{pstd}Setup{p_end}
{phang2}{cmd:. webuse beetle}{p_end}

{pstd}Create indicator variables for {cmd:beetle}, called {cmd:beetle1},
{cmd:beetle2}, ...{p_end}
{phang2}{cmd:. tabulate beetle, gen(beetle)}{p_end}

{pstd}Generalized linear model with binomial family and cloglog link{p_end}
{phang2}{cmd:. glm r beetle2 beetle3 ldose, family(binomial n) link(cloglog)}
{p_end}

{pstd}Replay results with 99% confidence intervals{p_end}
{phang2}{cmd:. glm, level(99)}{p_end}
    {hline}


{title:Saved results}

{pstd}
{cmd:glm} saves the following in {cmd:e()}:

{synoptset 20 tabbed}{...}
{p2col 5 20 24 2: Scalars}{p_end}
{synopt:{cmd:e(N)}}number of observations{p_end}
{synopt:{cmd:e(k)}}number of parameters{p_end}
{synopt:{cmd:e(k_eq)}}number of equations in {cmd:e(b)}{p_end}
{synopt:{cmd:e(k_eq_model)}}number of equations in model Wald test{p_end}
{synopt:{cmd:e(k_dv)}}number of dependent variables{p_end}
{synopt:{cmd:e(df)}}residual degrees of freedom{p_end}
{synopt:{cmd:e(phi)}}scale parameter{p_end}
{synopt:{cmd:e(disp)}}dispersion parameter{p_end}
{synopt:{cmd:e(df_m)}}model degrees of freedom{p_end}
{synopt:{cmd:e(aic)}}model AIC{p_end}
{synopt:{cmd:e(bic)}}model BIC{p_end}
{synopt:{cmd:e(ll)}}log likelihood, if NR{p_end}
{synopt:{cmd:e(N_clust)}}number of clusters{p_end}
{synopt:{cmd:e(chi2)}}chi-squared{p_end}
{synopt:{cmd:e(p)}}significance{p_end}
{synopt:{cmd:e(rank)}}rank of {cmd:e(V)}{p_end}
{synopt:{cmd:e(deviance)}}deviance{p_end}
{synopt:{cmd:e(deviance_p)}}Pearson deviance{p_end}
{synopt:{cmd:e(deviance_ps)}}scaled Pearson deviance{p_end}
{synopt:{cmd:e(deviance_s)}}scaled deviance{p_end}
{synopt:{cmd:e(dispers)}}dispersion{p_end}
{synopt:{cmd:e(dispers_p)}}Pearson dispersion{p_end}
{synopt:{cmd:e(dispers_ps)}}scaled Pearson dispersion{p_end}
{synopt:{cmd:e(dispers_s)}}scaled dispersion{p_end}
{synopt:{cmd:e(vf)}}factor set by {cmd:vfactor()}, {cmd:1} if not set{p_end}
{synopt:{cmd:e(power)}}power set by {cmd:power()}, {cmd:opower()}{p_end}
{synopt:{cmd:e(ic)}}number of iterations{p_end}
{synopt:{cmd:e(rc)}}return code{p_end}
{synopt:{cmd:e(converged)}}{cmd:1} if converged, {cmd:0} otherwise{p_end}

{synoptset 20 tabbed}{...}
{p2col 5 20 24 2: Macros}{p_end}
{synopt:{cmd:e(cmd)}}{cmd:glm}{p_end}
{synopt:{cmd:e(cmdline)}}command as typed{p_end}
{synopt:{cmd:e(depvar)}}name of dependent variable{p_end}
{synopt:{cmd:e(varfunc)}}name of variance function used{p_end}
{synopt:{cmd:e(varfunct)}}{cmd:Gaussian}, {cmd:Inverse Gaussian},
                 {cmd:Binomial}, {cmd:Poisson}, {cmd:Neg. Binomial},
		 {cmd:Bernoulli}, {cmd:Power}, or {cmd:Gamma}{p_end}
{synopt:{cmd:e(varfuncf)}}variance function{p_end}
{synopt:{cmd:e(link)}}name of link function used{p_end}
{synopt:{cmd:e(m)}}number of binomial trials{p_end}
{synopt:{cmd:e(a)}}neg. binomial k{p_end}
{synopt:{cmd:e(wtype)}}weight type{p_end}
{synopt:{cmd:e(wexp)}}weight expression{p_end}
{synopt:{cmd:e(title)}}title in estimation output{p_end}
{synopt:{cmd:e(clustvar)}}name of cluster variable{p_end}
{synopt:{cmd:e(offset)}}offset{p_end}
{synopt:{cmd:e(chi2type)}}{cmd:Wald} or {cmd:LR}; type of model chi-squared
	test{p_end}
{synopt:{cmd:e(cons)}}set if {cmd:noconstant} specified{p_end}
{synopt:{cmd:e(linkt)}}link title{p_end}
{synopt:{cmd:e(linkf)}}link form{p_end}
{synopt:{cmd:e(hac_kernel)}}HAC kernel{p_end}
{synopt:{cmd:e(hac_lag)}}HAC lag{p_end}
{synopt:{cmd:e(vce)}}{it:vcetype} specified in {cmd:vce()}{p_end}
{synopt:{cmd:e(vcetype)}}title used to label Std. Err.{p_end}
{synopt:{cmd:e(opt1)}}optimization title, line 1{p_end}
{synopt:{cmd:e(opt2)}}optimization title, line 2{p_end}
{synopt:{cmd:e(opt)}}{cmd:ml} or {cmd:irls}{p_end}
{synopt:{cmd:e(ml_method)}}type of {cmd:ml} method{p_end}
{synopt:{cmd:e(user)}}name of likelihood-evaluator program{p_end}
{synopt:{cmd:e(technique)}}maximization technique{p_end}
{synopt:{cmd:e(crittype)}}optimization criterion{p_end}
{synopt:{cmd:e(properties)}}{cmd:b V}{p_end}
{synopt:{cmd:e(predict)}}program used to implement {cmd:predict}{p_end}

{synoptset 20 tabbed}{...}
{p2col 5 20 24 2: Matrices}{p_end}
{synopt:{cmd:e(b)}}coefficient vector{p_end}
{synopt:{cmd:e(ilog)}}iteration log (up to 20 iterations){p_end}
{synopt:{cmd:e(gradient)}}gradient vector{p_end}
{synopt:{cmd:e(V)}}variance-covariance matrix of the estimators{p_end}

{synoptset 20 tabbed}{...}
{p2col 5 20 24 2: Functions}{p_end}
{synopt:{cmd:e(sample)}}marks estimation sample{p_end}
{p2colreset}{...}


{title:Reference}

{phang}
McCullagh, P., and J. A. Nelder. 1989.
{it:Generalized Linear Models}. 2nd ed.
London: Chapman & Hall.


{title:Also see}

{psee}
Manual:  {bf:[R] glm}

{psee}
Online:  {manhelp glm_postestimation R:glm postestimation};{break}
{manhelp cloglog R},
{manhelp logistic R},
{manhelp nbreg R},
{manhelp poisson R},
{manhelp regress R},
{manhelp svy_estimation SVY:svy estimation},
{manhelp xtgee XT}
{p_end}
