{smcl}
{* *! version 1.0.11  20nov2008}{...}
{cmd:help glm postestimation}{right:dialogs:  {bf:{dialog glim_p:predict}}}
{right:also see:  {helpb glm}{space 4}}
{hline}

{p2colset 5 31 33 2}{...}
{p2col :{hi:[R] glm postestimation} {hline 2}}Postestimation tools for glm{p_end}
{p2colreset}{...}


{title:Description}

{pstd}
The following postestimation commands are available for {opt glm}:

{synoptset 13 notes}{...}
{p2coldent :command}description{p_end}
{synoptline}
INCLUDE help post_adjust2par
INCLUDE help post_estat
INCLUDE help post_svy_estat
INCLUDE help post_estimates
INCLUDE help post_lincom
{p2coldent:(2) {helpb linktest}}link test for model specification{p_end}
{p2coldent:(3) {helpb lrtest}}likelihood-ratio test{p_end}
INCLUDE help post_mfx
INCLUDE help post_nlcom
{synopt :{helpb glm postestimation##predict:predict}}predictions, residuals, influence statistics, and other diagnostic measures{p_end}
INCLUDE help post_predictnl
INCLUDE help post_suest
INCLUDE help post_test
INCLUDE help post_testnl
{synoptline}
{p2colreset}{...}
{p 4 6 2}(1) {cmd:adjust} is not appropriate with time-series operators.{p_end}
{p 4 6 2}
(2) {cmd:linktest} is not available with {cmd:svy} estimation results.
{p_end}
{p 4 6 2}
(3) {cmd:lrtest} is not appropriate with {cmd:svy} estimation results.
{p_end}


{marker predict}{...}
{title:Syntax for predict}

{p 8 16 2}
{cmd:predict}
{dtype}
{newvar}
{ifin}
[{cmd:,} {it:{help glm postestimation##statistic:statistic}}
{it:{help glm postestimation##options:options}}]

{synoptset 16 tabbed}{...}
{marker statistic}{...}
{synopthdr :statistic}
{synoptline}
{syntab :Main}
{synopt :{opt m:u}}g_inverse(xb); the default{p_end}
{synopt :{opt xb}}the linear prediction{p_end}
{synopt :{opt e:ta}}synonym of {opt xb}{p_end}
{synopt :{opt stdp}}standard error of the linear prediction{p_end}
{synopt :{opt a:nscombe}}Anscombe residuals{p_end}
{synopt :{opt c:ooksd}}Cook's distance{p_end}
{synopt :{opt d:eviance}}deviance residuals{p_end}
{synopt :{opt h:at}}diagonals of the "hat" matrix{p_end}
{synopt :{opt l:ikelihood}}a weighted average of standardized deviance and standardized Pearson residuals{p_end}
{synopt :{opt p:earson}}Pearson residuals{p_end}
{synopt :{opt r:esponse}}differences between the observed and fitted
outcomes{p_end}
{synopt :{opt s:core}}first derivative of the log likelihood with respect to
xb{p_end}
{synopt :{opt w:orking}}working residuals{p_end}
{synoptline}
{p2colreset}{...}

{synoptset 16 tabbed}{...}
{marker options}{...}
{synopthdr}
{synoptline}
{syntab :Options}
{synopt :{opt nooff:set}}modify calculations to ignore offset variable{p_end}
{synopt :{opt adj:usted}}adjust deviance residual to speed up convergence{p_end}
{synopt :{opt sta:ndardized}}multiply residual by the factor (1-h)^[-1/2]{p_end}
{synopt :{opt stu:dentized}}multiply residual by one over the square root of
the estimated scale parameter{p_end}
{synopt :{opt mod:ified}}modify denominator of residual to be a reasonable
estimate of the variance of {depvar}{p_end}
{synoptline}
{p2colreset}{...}
INCLUDE help esample
{p 4 6 2}
{opt mu}, {opt xb}, {opt stdp}, and {opt score} are the only statistics
allowed with {cmd:svy} estimation results.{p_end}


{title:Options for predict}

{dlgtab:Main}

{phang}
{opt mu}, the default, specifies that {opt predict} calculate the inverse link
of the linear prediction.

{phang}
{opt xb} calculates the linear prediction.

{phang}
{opt eta} is a synonym for {opt xb}.

{phang}
{opt stdp} calculates the standard error of the linear predictor.

{phang}
{opt anscombe} calculates the Anscombe residuals to produce residuals that
closely follow a normal distribution.

{phang}
{opt cooksd} calculates Cook's distance, which measures the aggregate change
in the estimated coefficients when each observation is left out of the
estimation.

{phang}
{opt deviance} calculates the deviance residuals.  Deviance residuals are
recommended by McCullagh and Nelder (1989) and by others as having the best
properties for examining the goodness of fit of a GLM.  They are approximately
normally distributed if the model is correct.  They may be plotted against the
fitted values or against a covariate to inspect the model's fit.  Also see the
{opt pearson} option below.

{phang}
{opt hat} calculates the diagonals of the "hat" matrix as an analog to simple
linear regression.

{phang}
{opt likelihood} calculates a weighted average of standardized deviance
and standardized Pearson residuals.

{phang}
{opt pearson} calculates the Pearson residuals.  Pearson
residuals often have markedly skewed distributions for nonnormal family
distributions.  Also see the {opt deviance} option above.

{phang}
{opt response} calculates the differences between the observed and
fitted outcomes.

{phang}
{opt score} calculates the equation-level score, the derivative of the log
likelihood with respect to the linear prediction.

{phang}
{opt working} calculates the working residuals, which are response residuals
weighted according to the derivative of the link function.

{dlgtab:Options}

{phang}
{opt nooffset} is relevant only if you specified 
{opth offset(varname)} for {opt glm}.  It modifies the calculations made by
{opt predict} so that they ignore the offset variable; the linear prediction
is treated as xb rather than xb + offset.

{phang}
{opt adjusted} adjusts the deviance residual to speed up the
convergence to the limiting normal distribution.
The adjustment deals with adding to the deviance residual a higher-order term
that depends on the variance function family.  This option is allowed only 
when {opt deviance} is specified.

{phang}
{opt standardized} requests that the residual be multiplied by the
factor {bind:(1-h)^[-1/2]}, where h is the diagonal of the hat matrix.
This operation is done to account for the correlation between {depvar} and its
predicted value.

{phang}
{opt studentized} requests that the residual be multiplied by one over
the square root of the estimated scale parameter.

{phang}
{opt modified} requests that the denominator of the residual be
modified to be a reasonable estimate of the variance of {depvar}.
The base residual is multiplied by the factor (k/w)^[-1/2], where k is
either one or the user-specified dispersion parameter and w is the
specified weight (or one if left unspecified).


{title:Examples}

{phang}{cmd:. webuse ldose}{p_end}
{phang}{cmd:. glm r ldose, family(binomial n) link(logit)}{p_end}
{phang}{cmd:. predict mu_logit}{p_end}
{phang}{cmd:. predict dr_logit, deviance}{p_end}
{phang}{cmd:. linktest, family(binomial n) link(logit)}{p_end}


{title:Reference}

{phang}
McCullagh, P., and J. A. Nelder. 1989.
{it:Generalized Linear Models}. 2nd ed.
London: Chapman & Hall/CRC.


{title:Also see}

{psee}
Manual:  {bf:[R] glm postestimation}

{psee}
Online:  {manhelp glm R};{break}
         {manhelp regress_postestimation R:regress postestimation}
{p_end}
