{smcl}
{* *! version 1.0.15  20aug2007}{...}
{cmd:help blogit}, {cmd:help bprobit},{right:dialogs:  {bf:{dialog blogit}}  {bf:{dialog bprobit}}{space 6}}
{cmd:help glogit}, {cmd:help gprobit}{right:{bf:{dialog glogit}}  {bf:{dialog gprobit}}{space 6}}
{right:also see:  {help glogit postestimation}}
{hline}

{title:Title}

{p2colset 5 19 21 2}{...}
{p2col :{hi:[R] glogit} {hline 2}}Logit and probit estimation for grouped data{p_end}
{p2colreset}{...}


{title:Syntax}

{phang}
Logistic regression for grouped data

{p 8 16 2}{cmd:blogit}{space 2}{it:pos_var} {it:pop_var} [{it:rhsvars}]
		{ifin} [{cmd:,}
		{it:{help glogit##blogit_options:blogit_options}}]


{phang}
Probit regression for grouped data

{p 8 16 2}{cmd:bprobit} {it:pos_var} {it:pop_var} [{it:rhsvars}]
		{ifin} [{cmd:,}
		{it:{help glogit##bprobit_options:bprobit_options}}]


{phang}
Weighted least-squares logistic regression for grouped data

{p 8 16 2}{cmd:glogit}{space 2}{it:pos_var} {it:pop_var} [{it:rhsvars}]
	{ifin} [{cmd:,}
	{it:{help glogit##glogit_options:glogit_options}}]


{phang}
Weighted least-squares probit regression for grouped data

{p 8 16 2}{cmd:gprobit} {it:pos_var} {it:pop_var} [{it:rhsvars}]
	{ifin} [{cmd:,}
	{it:{help glogit##gprobit_options:gprobit_options}}]
	

{synoptset 20 tabbed}{...}
{marker blogit_options}{...}
{synopthdr :blogit_options}
{synoptline}
{syntab :Model}
{synopt :{opt nocon:stant}}suppress constant term{p_end}
{synopt :{opt asis}}retain perfect predictor variables{p_end}
{synopt :{opth off:set(varname)}}include {it:varname} in model with coefficient
constrained to 1{p_end}

{syntab :SE/Robust}
{synopt :{opth vce(vcetype)}}{it:vcetype} may be {opt oim}, {opt r:obust},
{opt cl:uster} {it:clustvar}, {opt boot:strap}, or {opt jack:knife}{p_end}

{syntab :Reporting}
{synopt :{opt l:evel(#)}}set confidence level; default is
{cmd:level(95)}{p_end}
{synopt :{opt or}}report odds ratios{p_end}

{syntab :Max options}
{synopt :{it:{help glogit##maximize_options:maximize_options}}}control the maximization process; seldom
used{p_end}

{p2coldent :+ {opt nocoe:f}}do not display coefficient table; seldom
used{p_end}
{synoptline}
{p2colreset}{...}

{synoptset 20 tabbed}{...}
{marker bprobit_options}{...}
{synopthdr :bprobit_options}
{synoptline}
{syntab :Model}
{synopt :{opt nocon:stant}}suppress constant term{p_end}
{synopt :{opt asis}}retain perfect predictor variables{p_end}
{synopt :{opth off:set(varname)}}include {it:varname} in model with coefficient
constrained to 1{p_end}

{syntab :SE/Robust}
{synopt :{opth vce(vcetype)}}{it:vcetype} may be {opt oim}, {opt r:obust},
{opt cl:uster} {it:clustvar}, {opt boot:strap}, or {opt jack:knife}{p_end}

{syntab :Reporting}
{synopt :{opt l:evel(#)}}set confidence level; default is {cmd:level(95)}{p_end}

{syntab :Max options}
{synopt :{it:{help glogit##maximize_options:maximize_options}}}control the maximization process; seldom used{p_end}
	
{p2coldent :+ {opt nocoe:f}}do not display coefficient table; seldom
used{p_end}
{synoptline}
{p2colreset}{...}

{synoptset 20 tabbed}{...}
{marker glogit_options}{...}
{synopthdr :glogit_options}
{synoptline}
{syntab :SE}
{synopt :{opth vce(vcetype)}}{it:vcetype} may be {opt ols}, 
{opt boot:strap}, or {opt jack:knife}{p_end}

{syntab :Reporting}
{synopt :{opt l:evel(#)}}set confidence level; default is
{cmd:level(95)}{p_end}
{synopt :{opt or}}report odds ratios{p_end}
{synoptline}
{p2colreset}{...}

{synoptset 20 tabbed}{...}
{marker gprobit_options}{...}
{synopthdr :gprobit_options}
{synoptline}
{syntab :SE}
{synopt :{opth vce(vcetype)}}{it:vcetype} may be {opt ols}, 
{opt boot:strap}, or {opt jack:knife}{p_end}

{syntab :Reporting}
{synopt :{opt l:evel(#)}}set confidence level; default is
{cmd:level(95)}{p_end}
{synoptline}
{p2colreset}{...}

{p 4 6 2}
+{opt nocoef} does not appear in the dialog box.{p_end}
{p 4 6 2}
{opt bootstrap}, {opt by}, {opt jackknife}, {opt rolling}, {opt statsby},
and {cmd:xi} are allowed; see {help prefix}.{p_end}
{p 4 6 2}
See {manhelp glogit_postestimation R:glogit postestimation}
for features available after estimation.{p_end}


{title:Description}

{pstd}
{cmd:blogit} and {cmd:bprobit} produce maximum-likelihood logit and probit
estimates on grouped ("blocked") data; {cmd:glogit} and {cmd:gprobit} produce
weighted least-squares estimates.  In the syntax diagrams, {it:pos_var} and
{it:pop_var} refer to variables containing the total number of positive
responses and the total population.

{pstd}
See {help logistic estimation commands} for a list of related estimation
commands.


{title:Options for blogit and bprobit}

{dlgtab:Model}

{phang}
{opt noconstant}; see
{helpb estimation options##noconstant:[R] estimation options}.

{phang}
{opt asis} forces retention of perfect predictor variables and their
associated perfectly predicted observations and may produce instabilities in
maximization; see {manhelp probit R}.

{phang}
{opth offset(varname)}; see
{helpb estimation options##offset():[R] estimation options}.

{dlgtab:SE/Robust}

INCLUDE help vce_asymptall

{dlgtab:Reporting}

{phang}
{opt level(#)}; see 
{helpb estimation options##level():[R] estimation options}.

{phang}
{opt or} ({opt blogit} only) reports the estimated coefficients transformed to
odds ratios, i.e., exp(b) rather than b.
Standard errors and confidence intervals
are similarly transformed.  This option affects how results are displayed, not
how they are estimated.  {opt or} may be specified at estimation or when
replaying previously estimated results.

{marker maximize_options}{...}
{dlgtab:Max options}

{phang}
{it:maximize_options}: {opt iter:ate(#)}, [{cmdab:no:}]{opt lo:g},
{opt tr:ace}, {opt tol:erance(#)}, {opt ltol:erance(#)}, 
{opt nrtol:erance(#)}, {opt nonrtol:erance}; see
{manhelp maximize R}.  These options are seldom used.

{pstd}
The following option is available with {opt blogit} and {opt bprobit} but is
not shown in the dialog box:

{phang}
{opt nocoef} specifies that the coefficient table not be displayed.  This
option is sometimes used by program writers but is useless interactively.


{title:Options for glogit and gprobit}

{marker glvcetype}{...}
{dlgtab:SE}

INCLUDE help vce_asymptbj

{pmore}
{cmd:vce(ols)}, the default, uses the standard variance estimator for ordinary
least-squares regression.

{dlgtab:Reporting}

{phang}
{opt level(#)}; see
{helpb estimation options##level():[R] estimation options}.

{phang}
{opt or} ({cmd:glogit} only) reports the estimated coefficients transformed to
odds ratios, i.e., e^b rather than b.  Standard errors and confidence
intervals are similarly transformed.  This option affects how results are
displayed, not how they are estimated.  {opt or} may be specified at
estimation or when replaying previously estimated results.


{title:Examples}

{pstd}Setup{p_end}
{phang2}{cmd:. webuse xmpl2}{p_end}

{pstd}Logistic regression for grouped data{p_end}
{phang2}{cmd:. blogit deaths pop agecat exposed}{p_end}

{pstd}Same as above, but report odds ratios rather than coefficients{p_end}
{phang2}{cmd:. blogit deaths pop agecat exposed, or}

{pstd}Weighted least-squares logistic regression for grouped data{p_end}
{phang2}{cmd:. glogit deaths pop agecat exposed}{p_end}

{pstd}Same as above, but report odds ratios rather than coefficients{p_end}
{phang2}{cmd:. glogit deaths pop agecat exposed, or}

{pstd}Probit regression for grouped data{p_end}
{phang2}{cmd:. bprobit deaths pop agecat exposed}

{pstd}Replay with 99% confidence intervals{p_end}
{phang2}{cmd:. bprobit, level(99)}

{pstd}Weighted least-squares probit regression for grouped data{p_end}
{phang2}{cmd:. gprobit deaths pop agecat exposed}


{title:Saved results}

{pstd}
{cmd:blogit} and {cmd:bprobit} save the following in {cmd:e()}:

{synoptset 20 tabbed}{...}
{p2col 5 20 24 2: Scalars}{p_end}
{synopt:{cmd:e(N)}}number of observations{p_end}
{synopt:{cmd:e(N_cdf)}}number of completely determined failures{p_end}
{synopt:{cmd:e(N_cds)}}number of completely determined successes{p_end}
{synopt:{cmd:e(df_m)}}model degrees of freedom{p_end}
{synopt:{cmd:e(r2_p)}}pseudo-R-squared{p_end}
{synopt:{cmd:e(N_clust)}}number of clusters{p_end}
{synopt:{cmd:e(ll)}}log likelihood{p_end}
{synopt:{cmd:e(ll_0)}}log likelihood, constant-only model{p_end}
{synopt:{cmd:e(chi2)}}chi-squared{p_end}

{synoptset 20 tabbed}{...}
{p2col 5 20 24 2: Macros}{p_end}
{synopt:{cmd:e(cmd)}}{cmd:blogit} or {cmd:bprobit}{p_end}
{synopt:{cmd:e(cmdline)}}command as typed{p_end}
{synopt:{cmd:e(depvar)}}name of dependent variable{p_end}
{synopt:{cmd:e(title)}}title in estimation output{p_end}
{synopt:{cmd:e(clustvar)}}name of cluster variable{p_end}
{synopt:{cmd:e(offset)}}offset{p_end}
{synopt:{cmd:e(chi2type)}}{cmd:Wald} or {cmd:LR}; type of model chi-squared
	test{p_end}
{synopt:{cmd:e(vce)}}{it:vcetype} specified in {cmd:vce()}{p_end}
{synopt:{cmd:e(vcetype)}}title used to label Std. Err.{p_end}
{synopt:{cmd:e(crittype)}}optimization criterion{p_end}
{synopt:{cmd:e(properties)}}{cmd:b V}{p_end}
{synopt:{cmd:e(predict)}}program used to implement {cmd:predict}{p_end}

{synoptset 20 tabbed}{...}
{p2col 5 20 24 2: Matrices}{p_end}
{synopt:{cmd:e(b)}}coefficient vector{p_end}
{synopt:{cmd:e(V)}}variance-covariance matrix of the estimators{p_end}

{synoptset 20 tabbed}{...}
{p2col 5 20 24 2: Functions}{p_end}
{synopt:{cmd:e(sample)}}marks estimation sample{p_end}

{pstd}
{cmd:glogit} and {cmd:gprobit} save the following in {cmd:e()}:

{synoptset 20 tabbed}{...}
{p2col 5 20 24 2: Scalars}{p_end}
{synopt:{cmd:e(N)}}number of observations{p_end}
{synopt:{cmd:e(mss)}}model sum of squares{p_end}
{synopt:{cmd:e(df_m)}}model degrees of freedom{p_end}
{synopt:{cmd:e(rss)}}residual sum of squares{p_end}
{synopt:{cmd:e(df_r)}}residual degrees of freedom{p_end}
{synopt:{cmd:e(r2)}}R-squared{p_end}
{synopt:{cmd:e(r2_a)}}adjusted R-squared{p_end}
{synopt:{cmd:e(F)}}F statistic{p_end}
{synopt:{cmd:e(rmse)}}root mean squared error{p_end}

{synoptset 20 tabbed}{...}
{p2col 5 20 24 2: Macros}{p_end}
{synopt:{cmd:e(cmd)}}{cmd:glogit} or {cmd:gprobit}{p_end}
{synopt:{cmd:e(cmdline)}}command as typed{p_end}
{synopt:{cmd:e(depvar)}}name of dependent variable{p_end}
{synopt:{cmd:e(title)}}title in estimation output{p_end}
{synopt:{cmd:e(model)}}{cmd:ols}{p_end}
{synopt:{cmd:e(vce)}}{it:vcetype} specified in {cmd:vce()}{p_end}
{synopt:{cmd:e(vcetype)}}title used to label Std. Err.{p_end}
{synopt:{cmd:e(predict)}}program used to implement {cmd:predict}{p_end}
{synopt:{cmd:e(properties)}}{cmd:b V}{p_end}

{synoptset 20 tabbed}{...}
{p2col 5 20 24 2: Matrices}{p_end}
{synopt:{cmd:e(b)}}coefficient vector{p_end}
{synopt:{cmd:e(V)}}variance-covariance matrix of the estimators{p_end}

{synoptset 20 tabbed}{...}
{p2col 5 20 24 2: Functions}{p_end}
{synopt:{cmd:e(sample)}}marks estimation sample{p_end}
{p2colreset}{...}


{title:Also see}

{psee}
Manual:  {bf:[R] glogit}

{psee}
Online:  {manhelp glogit_postestimation R:glogit postestimation};{break}
{manhelp logistic R},
{manhelp logit R},
{manhelp probit R}
{p_end}
