{smcl}
{* *! version 1.0.6  14may2008}{...}
{cmd:help graph dir}
{hline}

{title:Title}

{p2colset 5 22 24 2}{...}
{p2col :{hi:[G] graph dir} {hline 2}}List names of graphs in memory and on disk{p_end}
{p2colreset}{...}


{title:Syntax}

{p 8 23 2}
{cmdab:gr:aph}
{cmd:dir}
[{it:pattern}]
[{cmd:,}
{it:options}]

{p2colset 9 30 34 2}{...}
{p2col:{it:options}}
	description{p_end}
{p2line}
{p2col:{cmdab:m:emory}}
	list only graphs stored in memory{p_end}
{p2col:{cmdab:g:ph}}
	list only graphs stored on disk{p_end}
{p2col:{cmdab:d:etail}}
	produce detailed listing{p_end}
{p2line}
{p2colreset}{...}

{pstd}
where {it:pattern} is allowed by Stata's {cmd:match()} function:
{cmd:*} means that 0 or more characters go here, and {cmd:?}{space 1}means
that exactly one character goes here; see {help string functions}.


{title:Description}

{pstd}
{cmd:graph} {cmd:dir} lists the names of graphs stored in memory and
stored on disk in the current directory.


{title:Options}

{phang}
{cmd:memory} and {cmd:gph}
    restrict what is listed; {cmd:memory} lists only the names of graphs
    stored in memory and {cmd:gph} lists only the names of graphs stored on
    disk.

{phang}
{cmd:detail}
    specifies that, in addition to the names, the commands that created the
    graphs be listed.


{title:Remarks}

{pstd}
See {manhelp graph_manipulation G:graph manipulation} for an introduction to
the graph manipulation commands.

{pstd}
{cmd:graph} {cmd:dir} without options lists in column format
the names of the graphs stored in memory and those stored on disk in
the current directory.

	{cmd}. graph dir
{res}{col 13}Graph{col 24}figure1.gph{col 41}large.gph{col 55}s7.gph
{col 13}dot.gph{col 24}figure2.gph{col 41}old.gph{col 55}yx_lines.gph{txt}

{pstd}
Graphs in memory are listed first, followed by graphs stored on disk.
In the example above, we have only one graph in memory:  {cmd:Graph}.

{pstd}
You may specify a pattern to restrict the files listed:

	{cmd}. graph dir fig*
{res}{col 13}figure1.gph{col 26}figure2.gph{txt}

{pstd}
The {cmd:detail} option lists the names and the commands that drew the
graphs:

	{cmd}. graph dir fig*, detail

	{txt}  name{col 24}command
	  {hline 60}
	{res}  figure1.gph{...}
{col 24}{...}
{txt}matrix  h-tempjul, msy(p) name(myview)
	{res}  figure2.gph{...}
{col 24}{...}
{txt}twoway scatter mpg weight, saving(figure2)
	  {hline 60}


{title:Saved Results}

{pstd}
{cmd:graph} {cmd:dir} returns in macro {cmd:r(list)} the names of the
graphs.


{title:Also see}

{psee}
Manual:  {bf:[G] graph dir}

{psee}
Online:  
{manhelp graph_manipulation G:graph manipulation};
{manhelp graph_describe G:graph describe}
{p_end}
