{smcl}
{* *! version 1.0.4  19jul2007}{...}
{cmd:help graph save}
{hline}

{title:Title}

{p2colset 5 23 25 2}{...}
{p2col :{hi:[G] graph save} {hline 2}}Save graph to disk{p_end}
{p2colreset}{...}


{title:Syntax}

{p 8 16 2}
{cmdab:gr:aph}
{cmd:save}
[{it:graphname}]
{it:filename}
[{cmd:,}
{cmd:asis}
{cmd:replace}]


{title:Description}

{pstd}
{cmd:graph} {cmd:save} saves the specified graph to disk.  If {it:graphname}
is not specified, the graph currently displayed is saved.

{pstd}
If {it:filename} is specified without an extension, {cmd:.gph} is assumed.


{title:Options}

{phang}
{cmd:asis} specifies that the graph be frozen and saved as is.
    The alternative -- and the default if {cmd:asis} is not
    specified -- is live format.  In live format, the graph can be edited
    in future sessions, and the overall look of the graph
    continues to be controlled by the chosen scheme (see
    {manhelp schemes G:schemes intro}).

{pmore} Say that you type

	    {cmd:. scatter yvar xvar,} ...
	    {cmd:. graph save mygraph}

{pmore}
    which will create file {cmd:mygraph.gph}.  Suppose that you send the
    file to a colleague.  The way the graph will appear on your colleague's
    computer might be different from how it appeared on yours.  Perhaps you
    display titles on the top, and your colleague has set his scheme to display
    titles on the bottom.  Or perhaps your colleague prefers {it:y} axes on
    the right rather than on the left.  It will still be the
    same graph, but it might look different.

{pmore}
    Or perhaps you just file away {cmd:mygraph.gph} for use later.  If the
    file is stored in the default live format, you can come back to it and
    change the way it looks by specifying a different scheme, and you can edit
    it.

{pmore}
    If, on the other hand, you specify {cmd:asis}, the graph will forever look
    just as it looked the instant it was saved.  You cannot edit it, and you
    cannot change the scheme.  If you send the as-is graph to colleagues, they
    will see it exactly in the form that you see it.

{pmore}
    Whether a graph is saved as-is or live makes no difference for
    printing.  As-is graphs usually require fewer bytes to store, and they
    generally display more quickly, but that is all.

{pstd}
{cmd:replace} specifies that the file may be replaced if it already exists.


{title:Remarks}

{pstd}
You may instead specify that the graph be saved at the instant you draw
it by specifying the
{cmd:saving(}{it:filename}[{cmd:,}
{cmd:asis}
{cmd:replace}]{cmd:)}
option; see {manhelpi saving_option G}.


{title:Also see}

{psee}
Manual:  {bf:[G] graph save}

{psee}
Online:  
{manhelpi saving_option G},
{manhelp graph_export G:graph export};
{manhelp gph_files G:concept: gph files},
{manhelp graph_manipulation G:graph manipulation},
{p_end}
