{smcl}
{* *! version 1.1.7  13feb2008}{...}
{cmd:help graph use}
{hline}

{title:Title}

{p2colset 5 22 24 2}{...}
{p2col :{hi:[G] graph use} {hline 2}}Display graph stored on disk{p_end}
{p2colreset}{...}


{title:Syntax}

{p 8 30 2}
{cmdab:gr:aph}
{cmd:use}
{it:filename}
[{cmd:,}
{cmd:nodraw}
{cmd:name(}{it:name}[{cmd:, replace}]{cmd:)}
{cmdab:sch:eme:(}{it:schemename}{cmd:)}]


{synoptset 23 tabbed}{...}
{synopthdr :options}
{synoptline}
{synopt:{opt nodraw}}do not draw the graph{p_end}
{synopt:{cmdab:scheme(}{it:{help schemes:schemename}}{cmd:)}}overall 
	look{p_end}
{synopt:{cmdab:name(}{it:name} [{cmd:, replace}]{cmd:)}}specify new name 
	for graph{p_end}
{synopt:{cmdab:play(}{it:recordingname}{cmd:)}}play edits from 
	{it:recordingname}{p_end}
{synoptline}


{title:Description}

{pstd}
{cmd:graph} {cmd:use} displays (draws) the graph previously saved in a
.gph file and, if the graph was stored in live format, loads it.

{pstd}
If {it:filename} is specified without an extension, {cmd:.gph} is assumed.


{title:Options}

{phang}
{cmd:nodraw}
    specifies that the graph not be displayed.
    If the graph was stored in live format, it is still loaded;
    otherwise, {cmd:graph} {cmd:use} does nothing.
    See {manhelpi nodraw_option G}.

{phang}
{cmd:name(}{it:name}[{cmd:, replace}]{cmd:)}
    specifies the name under which the graph is to be stored in memory,
    assuming that the graph was saved in live format.
    {it:filename} is the default name, where any path component in
    {it:filename} is excluded.  For example, 

           {cmd:. graph use mydir\mygraph.gph}

{pmore}
    will draw a graph with the name {cmd:mygraph}.

{pmore}
    If the default name already exists {cmd:graph}{it:#} is used instead,
    where {it:#} is chosen to create a unique name.

{pmore}
    If the graph is not stored in
    live format, the graph can only be displayed, not loaded, and the
    {cmd:name()} is irrelevant.

{phang}
{cmd:scheme(}{it:schemename}{cmd:)}
    specifies the scheme controlling the overall look of the graph to be
    used; see {manhelp schemes G:schemes intro}.  If {cmd:scheme()} is not
    specified, the default is the {it:schemename} recorded in the graph being
    loaded.

{phang}
INCLUDE help playopt_desc


{title:Remarks}

{pstd}
Graphs can be saved at the time you draw them either by specifying the
{cmd:saving()} option or subsequently using the {cmd:graph} {cmd:save}
command; see {manhelpi saving_option G} and {manhelp graph_save G:graph save}.
Modern graphs are saved in live format or as-is format; see {help gph files}.
Regardless of how the graph was saved or the format in which it was saved,
{cmd:graph} {cmd:use} can redisplay the graph; simply type

	{cmd:. graph use} {it:filename}

{pstd}
In a prior session, you drew a graph by typing

	{cmd}. twoway qfitci  mpg weight, stdf ||
		 scatter mpg weight       ||
	  , by(foreign, total row(1)) saving(cigraph){txt}

{pstd}
The result of this was to create file {cmd:cigraph.gph}.  At a later date,
you can see the contents of the file by typing

	{cmd:. graph use cigraph}

{pstd}
You might now edit the graph (see {manhelp graph_editor G:graph editor}),
or print a copy of the graph.


{title:Also see}

{psee}
Manual:  {bf:[G] graph use}

{psee}
Online:  
{manhelp graph_combine G:graph combine};
{manhelp graph_save G:graph save},
{manhelpi saving_option G};
{manhelp gph_files G:concept: gph files},
{manhelpi name_option G}
{p_end}
