{smcl}
{* *! version 1.0.9  20nov2008}{...}
{cmd:help hetprob postestimation}{right:dialog:  {bf:{dialog hetpr_p:predict}}}
{right:also see:  {helpb hetprob}}
{hline}

{title:Title}

{p2colset 5 35 37 2}{...}
{p2col :{hi:[R] hetprob postestimation} {hline 2}}Postestimation tools for hetprob{p_end}
{p2colreset}{...}


{title:Description}

{pstd}
The following postestimation commands are available for {cmd:hetprob}:

{synoptset 13 notes}{...}
{p2coldent :command}description{p_end}
{synoptline}
INCLUDE help post_adjust1par
INCLUDE help post_estat
INCLUDE help post_svy_estat
INCLUDE help post_estimates
INCLUDE help post_lincom
{p2coldent:(2) {helpb linktest}}link test for model specification{p_end}
{p2coldent:(3) {helpb lrtest}}likelihood-ratio test{p_end}
INCLUDE help post_mfx
INCLUDE help post_nlcom
{synopt :{helpb hetprob postestimation##predict:predict}}predictions, residuals, influence statistics, and other diagnostic measures{p_end}
INCLUDE help post_predictnl
INCLUDE help post_suest
INCLUDE help post_test
INCLUDE help post_testnl
{synoptline}
{p2colreset}{...}
{p 4 6 2}(1) {cmd:adjust} is not appropriate with time-series operators.{p_end}
{p 4 6 2}
(2) {cmd:linktest} is not available with {cmd:svy} estimation results.
{p_end}
{p 4 6 2}
(3) {cmd:lrtest} is not appropriate with {cmd:svy} estimation results.
{p_end}


{marker predict}{...}
{title:Syntax for predict}

{p 8 16 2}
{cmd:predict} {dtype} {newvar} {ifin} [{cmd:,} {it:statistic} 
{opt nooff:set}]

{p 8 16 2}
{cmd:predict} {dtype} {c -(}{it:stub*}{c |}{it:newvar_reg}
{it:newvar_lnsigma2}{c )-} {ifin} {cmd:,} {opt sc:ores}

{synoptset 11 tabbed}{...}
{synopthdr :statistic}
{synoptline}
{syntab :Main}
{synopt :{opt p:r}}probability of a positive outcome; the default{p_end}
{synopt :{opt xb}}linear prediction{p_end}
{synopt :{opt s:igma}}standard deviation of the error term{p_end}
{synoptline}
{p2colreset}{...}
INCLUDE help esample


{title:Options for predict}

{dlgtab:Main}

{phang}
{opt p}, the default, calculates the probability of a positive outcome.

{phang}
{opt xb} calculates the linear prediction.

{phang}
{opt sigma} calculates the standard deviation of the error term.

{phang}
{opt nooffset} is relevant only if you specified {opt offset(varname)} for
{cmd:hetprob}.  It modifies the calculations made by {cmd:predict} so that
they ignore the offset variable; the linear prediction is treated as xb rather
than xb + offset.

{phang}
{opt scores} calculates equation-level score variables.

{pmore}
The first new variable will contain the derivative of the log likelihood with
respect to the regression equation.

{pmore}
The second new variable will contain the derivative of the log likelihood with
respect to the scale equation ({hi:lnsigma2}).


{title:Example}

{phang}{cmd:. webuse hetprobxmpl}{p_end}
{phang}{cmd:. hetprob y x, het(xhet) vce(robust)}{p_end}
{phang}{cmd:. predict phat}{p_end}
{phang}{cmd:. predict sigmahat, sigma}{p_end}


{title:Also see}

{psee}
Manual:  {bf:[R] hetprob postestimation}

{psee}
Online:  {manhelp hetprob R}
{p_end}
