{smcl}
{* *! version 1.0.10  30oct2008}{...}
{cmd:help inspect}{right:dialog:  {bf:{dialog inspect}}}
{hline}

{title:Title}

{p2colset 5 20 22 2}{...}
{p2col :{hi:[D] inspect} {hline 2}}Display simple summary of data's
attributes{p_end}
{p2colreset}{...}


{title:Syntax}

{p 8 16 2}
{opt ins:pect}
[{varlist}]
{ifin}

{p 4 6 2}
{opt by} is allowed; see {manhelp by D}.


{title:Description}

{pstd}
The {opt inspect} command provides a quick summary of a numeric variable that
differs from the summary provided by {helpb summarize} or {helpb tabulate}.  It
reports the number of negative, zero, and positive values; the number of
integers and nonintegers; the number of unique values; and the number of
missing; and it produces a small histogram.  Its purpose is not analytical but
is to allow you to quickly gain familiarity with unknown data.


{title:Examples}

    {hline}
    Setup
{phang2}{cmd:. sysuse auto}

{pstd}Display simple summary of {cmd:mpg}{p_end}
{phang2}{cmd:. inspect mpg}

    {hline}
    Setup
{phang2}{cmd:. sysuse census}

{pstd}Display simple summary of {cmd:region}, a variable with a value
label{p_end}
{phang2}{cmd:. inspect region}

    {hline}
    Setup
{phang2}{cmd:. sysuse citytemp}

{pstd}Display simple summary of {cmd:tempjan}, a variable with missing values
{p_end}
{phang2}{cmd:. inspect tempjan}{p_end}
    {hline}


{title:Saved results}

{pstd}
{cmd:inspect} saves the following in {cmd:r()}:

{synoptset 20 tabbed}{...}
{p2col 5 20 24 2: Scalars}{p_end}
{synopt:{cmd:r(N)}}number of observations{p_end}
{synopt:{cmd:r(N_neg)}}number of negative observations{p_end}
{synopt:{cmd:r(N_0)}}number of observations equal to 0{p_end}
{synopt:{cmd:r(N_pos)}}number of positive observations{p_end}
{synopt:{cmd:r(N_negint)}}number of negative integer observations{p_end}
{synopt:{cmd:r(N_posint)}}number of positive integer observations{p_end}
{synopt:{cmd:r(N_unique)}}number of unique values or . if more than 99{p_end}
{synopt:{cmd:r(N_undoc)}}number of undocumented values or . if not labeled{p_end}
{p2colreset}{...}


{title:Also see}

{psee}
Manual:  {bf:[D] inspect}

{psee}
Online:  {manhelp codebook D},
{manhelp compare D},
{manhelp describe D},
{manhelp isid D},
{manhelp lv R},
{manhelp summarize R},
{manhelp table R},
{manhelp tabulate_oneway R:tabulate oneway},
{manhelp tabulate_twoway R:tabulate twoway},
{manhelp tabulate_summarize R:tabulate, summarize()}
{p_end}
