{smcl}
{* *! version 1.1.3  27may2008}{...}
{cmd:help ivregress postestimation}{...}
{right:dialog:  {bf:{dialog ivregress_estat:estat}  {dialog ivregress_p:predict}}}
{right:also see:  {helpb ivregress}{space 5}}
{hline}

{title:Title}

{p2colset 5 37 37 2}{...}
{p2col :{hi:[R] ivregress postestimation} {hline 2}}Postestimation tools for ivregress{p_end}
{p2colreset}{...}


{title:Description}

{pstd}
The following postestimation commands are of special interest after 
{cmd:ivregress}:

{synoptset 16}{...}
{p2coldent :command}description{p_end}
{synoptline}
{synopt :{helpb ivregress postestimation##estatendog:estat endogenous}}perform tests of endogeneity{p_end}
{synopt :{helpb ivregress postestimation##estatfirst:estat firststage}}report "first-stage" regression statistics{p_end}
{synopt :{helpb ivregress postestimation##estatoverid:estat overid}}perform tests of overidentifying restrictions{p_end}
{synoptline}
{p2colreset}{...}
{p 4 6 2}
These commands are not appropriate after the {cmd:svy} prefix.
{p_end}

{pstd}
The following standard postestimation commands are also available:

{synoptset 14 notes}{...}
{p2coldent :command}description{p_end}
{synoptline}
INCLUDE help post_adjust2star
{synopt :{helpb estat}}VCE and estimation sample summary{p_end}
INCLUDE help post_svy_estat
INCLUDE help post_estimates
INCLUDE help post_hausman
INCLUDE help post_lincom
INCLUDE help post_mfx
INCLUDE help post_nlcom
{synopt :{helpb ivregress postestimation##predict:predict}}predictions, residuals, influence statistics, and other diagnostic measures{p_end}
INCLUDE help post_predictnl
INCLUDE help post_test
INCLUDE help post_testnl
{synoptline}
{p2colreset}{...}
{p 4 6 2}(1) {cmd:adjust} is not appropriate with time-series operators.


{title:Special-interest postestimation commands}

{pstd} 
{cmd:estat endogenous} performs tests to determine whether endogenous 
regressors in the model are in fact exogenous.  After GMM estimation, 
the C (difference-in-Sargan) statistic is reported.  After 2SLS 
estimation with an unadjusted VCE, the Durbin (1954) and Wu-Hausman (Wu 1973;
Hausman 1978) statistics are reported.  After 2SLS with a robust, 
cluster-robust, or HAC VCE, Wooldridge's (1995) robust score test and a 
robust regression-based test are reported.  In all cases, if the test 
statistic is significant, the variables being tested must be 
treated as endogenous.

{pstd}
{cmd:estat firststage} reports various statistics that measure the
relevance of the excluded exogenous variables.  By default, whether the
equation has one or more than one endogenous regressor determines which
diagnostics for weak instruments are reported.

{pstd}
{cmd:estat overid} performs tests of overidentifying restrictions.  If
the 2SLS estimator was used, Sargan's (1958) and Basmann's (1960) chi-squared
tests are reported, as is Wooldridge's (1995) robust score test; if the LIML
estimator was used, Anderson and Rubin's (1950) chi-squared test and
Basmann's F test are reported; and if the GMM estimator was used, Hansen's
(1982) J statistic chi-squared test is reported.  A statistically significant
test statistic always indicates that the instruments may not be valid.


{marker predict}{...}
{title:Syntax for predict}

{p 8 16 2}
{cmd:predict} {dtype} {newvar} {ifin} [{cmd:,} {it:statistic}]

{p 8 16 2}
{cmd:predict} {dtype} 
{c -(}{it:stub*}{c |}{it:newvarlist}{c )-}
{ifin} {cmd:,} {opt sc:ores}

{synoptset 14 tabbed}{...}
{synopthdr :statistic}
{synoptline}
{syntab :Main}
{synopt :{opt xb}}linear prediction; the default{p_end}
{synopt :{opt r:esiduals}}residuals{p_end}
INCLUDE help regstats
{synoptline}
{p2colreset}{...}
INCLUDE help esample
{p 4 6 2}
{opt stdf} is not allowed with {cmd:svy} estimation results.
{p_end}

INCLUDE help whereab


{title:Options for predict}

{dlgtab:Main}

{phang}{opt xb}, the default, calculates the linear prediction.

{phang}{opt residuals} calculates the residuals, that is, y - xb.  These are
based on the estimated equation when the observed values of the endogenous
variables are used -- not the projections of the instruments
onto the endogenous variables.

{phang}
{opt stdp} calculates the standard error of the prediction, which can be
thought of as the standard error of the predicted expected value or mean for
the observation's covariate pattern.  This is also referred to as the standard
error of the fitted value.

{phang}
{opt stdf} calculates the standard error of the forecast, which is the
standard error of the point prediction for 1 observation.  It is
commonly referred to as the standard error of the future or forecast value.
By construction, the standard errors produced by {opt stdf} are always larger
than those produced by {opt stdp}; see {it:Methods and Formulas} in
{hi:[R] regress}. 

INCLUDE help pr_opt

{phang}
{cmd:e(}{it:a}{cmd:,}{it:b}{cmd:)} calculates
{bind:E(xb + u | {it:a} < xb + u < {it:b})}, the expected value of
y|x conditional on y|x being in the interval ({it:a},{it:b}), meaning,
y|x is censored.  {it:a} and {it:b} are specified as they are for
{opt pr()}.

{phang}
{cmd:ystar(}{it:a}{cmd:,}{it:b}{cmd:)} calculates E(y*), where 
{bind:y* = {it:a}} if {bind:xb + u {ul:<} {it:a}}, {bind:y* = {it:b}} if
{bind:xb + u {ul:>} {it:b}}, and {bind:y* = xb + u} otherwise, meaning
that y* is truncated.  {it:a} and {it:b} are specified as they are for
{opt pr()}.

{phang}{opt scores} calculates the score for the model.  A new score
variable is created for each endogenous regressor, as well as an
equation-level score that applies to all exogenous variables 
and constant term (if present).


{marker estatendog}{...}
{title:Syntax for estat endogenous}

{p 8 16 2}
{cmd:estat} {cmdab:endog:enous} [{it:varlist}] [{cmd:,} 
{cmdab:l:ags}{cmd:(}{it:#}{cmd:)} {cmd:forceweights} {cmd:forcenonrobust}]


{title:Options for estat endogenous}

{phang}
{opt lags(#)} specifies the number of lags to use for prewhitening when
computing the heteroskedasticity- and autocorrelation-consistent (HAC)
version of the score test of endogeneity.  Specifying
{cmd:lags(0)} requests no prewhitening.  This option is valid only when
the model was fitted via 2SLS and a HAC covariance matrix was requested
when the model was fitted.  The default is {cmd:lags(1)}.

{phang}
{opt forceweights} requests that the tests of overidentifying
restrictions be computed even though {cmd:aweight}s, {cmd:pweight}s, or
{cmd:iweight}s were used in the previous estimation.  By default, these
tests are conducted only after unweighted or frequency-weighted
estimation.  The reported critical values may be inappropriate for
weighted data, so the user must determine whether the critical values
are appropriate for a given application.

{phang}
{opt forcenonrobust} requests that the Durbin and Wu-Hausman statistics be 
reported even though a robust VCE was used at estimation time.  This 
option is only available if the model was fitted by 2SLS.


{marker estatfirst}{...}
{title:Syntax for estat firststage}

{p 8 16 2}
{cmd:estat} {cmdab:first:stage} [{cmd:,} {cmd:all} {cmd:forcenonrobust}]


{title:Options for estat firststage}

{phang}
{opt all} requests that all first-stage goodness-of-fit statistics be
reported regardless of whether the model contains one or more endogenous
regressors.  By default, if the model contains one endogenous regressor,
then the first-stage R-squared, adjusted R-squared, partial R-squared, 
and F statistics are reported, whereas if the model contains multiple 
endogenous regressors, then Shea's partial R-squared and adjusted 
partial R-squared are reported instead.

{phang}
{opt forcenonrobust} requests that the minimum eigenvalue statistic and 
its critical values be reported even though a robust VCE was used at 
estimation time.  The reported critical values assume that the errors are
independently and identically distributed normal, so the user must
determine whether the critical values are appropriate for a given
application.


{marker estatoverid}{...}
{title:Syntax for estat overid}

{p 8 16 2}
{cmd:estat} {cmdab:over:id} [{cmd:,} {cmdab:l:ags}{cmd:(}{it:#}{cmd:)} 
{cmd:forceweights} {cmd:forcenonrobust}]


{title:Options for estat overid}

{phang} 
{opt lags(#)} specifies the number of lags to use for prewhitening when
computing the heteroskedasticity- and autocorrelation-consistent (HAC)
version of the score test of overidentifying restrictions.  Specifying
{cmd:lags(0)} requests no prewhitening.  This option is valid only when
the model was fitted via 2SLS and a HAC covariance matrix was requested
when the model was fitted.  The default is {cmd:lags(1)}.

{phang}
{opt forceweights} requests that the tests of overidentifying
restrictions be computed even though {cmd:aweight}s, {cmd:pweight}s, or
{cmd:iweight}s were used in the previous estimation.  By default, these
tests are conducted only after unweighted or frequency-weighted
estimation.  The reported critical values may be inappropriate for
weighted data, so the user must determine whether the critical values
are appropriate for a given application.

{phang}
{opt forcenonrobust} requests that the Sargan and Basmann tests of
overidentifying restrictions be performed after 2SLS or LIML estimation
even though a robust VCE was used at estimation time.  These tests
assume that the errors are independently and identically distributed normal,
so the user must determine whether the critical values are appropriate
for a given application.


{title:Remarks on estat endogenous}

{pstd}
{cmd:estat endogenous} performs various tests to determine whether 
regressors treated as endogenous during estimation could in fact be 
treated as exogenous.  {cmd:estat endogenous} works after estimation by 
2SLS and GMM.  It does not work when the previous model was fitted using 
the LIML estimator, though you can construct a Hausman test using the 
{help hausman} command.

{space 2}{title:After 2SLS estimation}

{pstd}
In the context of 2SLS estimation, tests of endogeneity are commonly 
called Durbin-Wu-Hausman tests.  As Davidson and MacKinnon (1993,
239) note, these tests do not actually test the exogeneity of the 
regressors per se, but whether the coefficients of more-efficient 
OLS estimation or 2SLS estimation with fewer endogenous regressors 
differ significantly from the coefficients of consistent but less 
efficient 2SLS estimation treating all the suspected regressors as 
endogenous.

{pstd} 
The following table summarizes the tests performed by 
{cmd:estat endogenous} after 2SLS estimation, after which we explain the 
tests in more detail.  The type of VCE used at estimation time 
determines which of the four tests can be used.  By default, 
{cmd:estat endogenous} tests whether all of the endogenous regressors 
are exogenous; the column marked "Subsets" indicates whether the 
exogeneity of just a subset of the endogenous regressors can be tested.

{pmore}{space 3}VCE{space 6}{c |}{space 2}Durbin{space 2}Wu-Hausman{space 2}Wooldridge{space 2}Regression{space 2}Subsets{p_end}
{pmore}{hline 12}{c +}{hline 53}{p_end}
{pmore}unadjusted{space 2}{c |}{space 4}X{space 9}X{space 34}X{p_end}
{pmore}robust{space 6}{c |}{space 26}X{space 12}X{p_end}
{pmore}cluster{space 5}{c |}{space 39}X{p_end}
{pmore}HAC{space 9}{c |}{space 26}X{space 12}X{p_end}

{pstd} 
When the previous model was fitted via 2SLS and a robust covariance
matrix was not requested, {cmd:estat endogenous} reports Durbin's (1954)
test statistic and Wu's (1973) "T-2" statistic, which Hausman (1978)
showed can be calculated very easily using auxiliary regressions.  Baum,
Schaffer, and Stillman (2003) provide a lucid discussion of these tests. 
Both the Durbin and Wu-Hausman versions of the test assume that the
errors are independently and identically distributed (i.i.d.).  If you 
requested any type of robust VCE with the previously fitted model, then 
the Durbin and Wu-Hausman statistics are not reported unless you use the 
{opt forcenonrobust} option.

{pstd} 
When the error terms for the reduced-form equations for the endogenous
regressors and the structural equation are not i.i.d., then alternative
tests must be used.  In the case of heteroskedasticity or
autocorrelation, Wooldridge's (1995) robust score test of endogeneity
can be applied.  In the case of potential autocorrelation, Wooldridge's
test requires a prewhitening step, and you use the {cmd:lags()} option
to specify the number of lags to use.  Wooldridge's score test is not
supported for clustered data, and his test cannot be used to test the
endogeneity of just a subset of the endogenous regressors of the
original model.  When the errors are homoskedastic, Wooldridge's score
test is identical to Durbin's test.  If you requested a 
heteroskedasticity-robust VCE at estimation time, Wooldridge's 
heteroskedasticity-robust score test is reported.  If you requested a 
HAC VCE at estimation time, the HAC version of the score test is 
reported.

{pstd} 
In addition to Wooldridge's score test, {cmd:estat endogenous} performs 
a regression-based test of endogeneity that can be made robust to 
heteroskedasticity, clustering, or heteroskedasticity and 
autocorrelation.  Like Wooldridge's score test, this test can only test 
the endogeneity of all the endogenous regressors in the model; tests of 
subsets of endogenous regressors are not supported.  This test consists
of two steps.  In the first step, the "first-stage" regressions are 
performed, and the residuals are obtained.  In the second step, the 
user's model is fitted via OLS, and the first-stage residuals are 
included as additional regressors.  If the coefficients on the residual 
terms are jointly significant in this augmented regression, then the 
endogenous regressors of the original model are indeed endogenous.  As 
suggested by Cameron and Trivedi (2005, 273), by using a robust 
covariance matrix with the augmented regression, this test can be made 
robust to heteroskedasticity, clustering, or autocorrelation.  The type 
of robust VCE used with this regression is determined by the type of VCE 
requested when the original model was fitted.  With an unadjusted 
VCE, this regression-based test is identical to the Wu-Hausman test.

{space 2}{title:After GMM estimation}

{pstd}
After fitting a model via GMM, testing whether regressors are endogenous 
is equivalent to testing whether the moment conditions implied by 
treating those variables as exogenous are valid.  Let {it:J} denote the 
value of the GMM criterion function treating the variables under 
consideration as exogenous, and let {it:J'} denote the value of the 
criterion function treating those variables as endogenous.  Then the 
test statistic {it:C} = {it:J}-{it:J'} has a chi-squared distribution 
with {it:m} degrees of freedom, where {it:m} is the number of variables 
being tested.  A significant test statistic indicates that the variables 
are endogenous (i.e., that the additional moment conditions implied by 
treating those variables as exogenous are not valid).

{pstd}
In finite samples, the C statistic calculated by fitting the two
models individually using {cmd:ivregress} can be negative.  To
circumvent that situation, following Hayashi (2000, 220), we fit the
efficient model (the model treating the variables under consideration as
exogenous) and extract the weighting matrix {it:W}.  We then create a
weighting matrix {it:W'} by eliminating from {it:W} the rows and columns
corresponding to the variables being tested.  Finally, we fit the
consistent model via GMM, using the weighting matrix {it:W'}.  The type
of weighting matrix used by {cmd:estat endogenous} is determined by the
specification of the {opt wmat()} option in the model previously fitted
by {cmd:ivregress}.

{space 2}{title:Finite-sample considerations}

{pstd} 
Simulation results show that all these tests for endogeneity have low
power when the sample size is small (less than a few hundred
observations), meaning that the tests fail to reject the null hypothesis
that the tested variables are exogenous when they are in fact
endogenous.  However, for larger sample sizes these tests perform well 
when the error terms are i.i.d.  

{pstd}
When the error terms are not i.i.d., the non-robust tests do not have
correct size: even when the null hypothesis is true, the non-robust
tests reject the null hypothesis at a rate much greater than the nominal
size of the test.  On the other hand, our simulations show that the
heteroskedasticity-robust variants of the test do have approximately the
correct size when the errors are conditionally heteroskedastic.  The 
cluster-robust tests likewise do relatively well when the errors are 
clustered.  In the presence of autocorrelation, having a large sample is 
particularly important, which unfortunately is generally the exception 
rather than the rule with time-series data.  All of these tests for 
endogeneity perform abysmally when instruments are weak.


{title:Examples}

{pstd}Setup{p_end}
{phang2}{cmd:. webuse hsng2}{p_end}

{pstd}Fit a model via 2SLS and obtain first-stage regression diagnostics{p_end}
{phang2}{cmd:. ivregress 2sls rent pcturban (hsngval = faminc reg2-reg4)}{p_end}
{phang2}{cmd:. estat firststage}{p_end}

{pstd}Obtain the Sargan and Basmann tests of overidentifying restrictions{p_end}
{phang2}{cmd:. estat overid}

{pstd}Test whether {cmd:hsngval} can be treated as exogenous{p_end}
{phang2}{cmd:. estat endogenous}

{pstd}Fit a model with two endogenous regressors via GMM and obtain all first-stage regression diagnostics{p_end}
{phang2}{cmd:. ivregress gmm rent (hsngval pcturban = faminc reg2-reg4)}{p_end}
{phang2}{cmd:. estat firststage, all}{p_end}

{pstd}Obtain Hansen's J statistic{p_end}
{phang2}{cmd:. estat overid}

{pstd}Test whether {cmd:hsngval} can be treated as exogenous{p_end}
{phang2}{cmd:. estat endogenous hsngval}


{title:Saved results}

{pstd}
After 2SLS estimation, {cmd:estat endogenous} saves the following in {cmd:r()}:

{synoptset 20 tabbed}{...}
{p2col 5 20 24 2: Scalars}{p_end}
{synopt:{cmd:r(durbin)}}Durbin chi-squared statistic{p_end}
{synopt:{cmd:r(p_durbin)}}p-value for Durbin chi-squared statistic{p_end}
{synopt:{cmd:r(wu)}}Wu-Hausman F statistic{p_end}
{synopt:{cmd:r(p_wu)}}p-value for Wu-Hausman F statistic{p_end}
{synopt:{cmd:r(df)}}degrees of freedom{p_end}
{synopt:{cmd:r(wudf_r)}}denominator degrees of freedom for Wu-Hausman F{p_end}
{synopt:{cmd:r(r_score)}}robust score statistic{p_end}
{synopt:{cmd:r(p_r_score)}}p-value for robust score statistic{p_end}
{synopt:{cmd:r(hac_score)}}HAC score statistic{p_end}
{synopt:{cmd:r(p_hac_score)}}p-value for HAC score statistic{p_end}
{synopt:{cmd:r(lags)}}lags used in prewhitening{p_end}
{synopt:{cmd:r(regF)}}regression-based F statistic{p_end}
{synopt:{cmd:r(p_regF)}}p-value for regression-based F statistic{p_end}
{synopt:{cmd:r(regFdf_n)}}regression-based F numerator degrees of freedom{p_end}
{synopt:{cmd:r(regFdf_r)}}regression-based F denominator degrees of freedom{p_end}

{pstd}
After GMM estimation, {cmd:estat endogenous} saves the following in {cmd:r()}:

{synoptset 20 tabbed}{...}
{p2col 5 20 24 2: Scalars}{p_end}
{synopt:{cmd:r(C)}}C chi-squared statistic{p_end}
{synopt:{cmd:r(p_C)}}p-value for C chi-squared statistic{p_end}
{synopt:{cmd:r(df)}}degrees of freedom{p_end}

{pstd}
{cmd:estat firststage} saves the following in {cmd:r()}:

{synoptset 20 tabbed}{...}
{p2col 5 20 24 2: Scalars}{p_end}
{synopt:{cmd:r(mineig)}}minimum eigenvalue statistic{p_end}

{p2col 5 20 24 2: Matrices}{p_end}
{synopt:{cmd:r(mineigcv)}}critical values for minimum eigenvalue statistic{p_end}
{synopt:{cmd:r(multiresults)}}Shea's partial R-squared statistics{p_end}
{synopt:{cmd:r(singleresults)}}first-stage R-squared and F statistics{p_end}

{pstd}
After 2SLS estimation, {cmd:estat overid} saves the following in {cmd:r()}:

{p2col 5 20 24 2: Scalars}{p_end}
{synopt:{cmd:r(lags)}}lags used in prewhitening{p_end}
{synopt:{cmd:r(df)}}chi-squared degrees of freedom{p_end}
{synopt:{cmd:r(score)}}score chi-squared statistic{p_end}
{synopt:{cmd:r(p_score)}}p-value for score chi-squared statistic{p_end}
{synopt:{cmd:r(basmann)}}Basmann chi-squared statistic{p_end}
{synopt:{cmd:r(p_basmann)}}p-value for Basmann chi-squared statistic{p_end}
{synopt:{cmd:r(sargan)}}Sargan chi-squared statistic{p_end}
{synopt:{cmd:r(p_sargan)}}p-value for Sargan chi-squared statistic{p_end}

{pstd}
After LIML estimation, {cmd:estat overid} saves the following in {cmd:r()}:

{p2col 5 20 24 2: Scalars}{p_end}
{synopt:{cmd:r(ar)}}Anderson-Rubin chi-squared statistic{p_end}
{synopt:{cmd:r(p_ar)}}p-value for Anderson-Rubin chi-squared statistic{p_end}
{synopt:{cmd:r(ar_df)}}chi-squared degrees of freedom{p_end}
{synopt:{cmd:r(basmann)}}Basmann F statistic{p_end}
{synopt:{cmd:r(p_basmann)}}p-value for Basmann F statistic{p_end}
{synopt:{cmd:r(basmann_df_n)}}F numerator degrees of freedom{p_end}
{synopt:{cmd:r(basmann_df_d)}}F denominator degrees of freedom{p_end}

{pstd}
After GMM estimation, {cmd:estat overid} saves the following in {cmd:r()}:

{p2col 5 20 24 2: Scalars}{p_end}
{synopt:{cmd:r(HansenJ)}}Hansen's J chi-squared statistic{p_end}
{synopt:{cmd:r(p_HansenJ)}}p-value for Hansen's J chi-squared statistic{p_end}
{synopt:{cmd:r(J_df)}}chi-squared degrees of freedom{p_end}
{p2colreset}{...}


{title:References}

{phang}
Anderson, T. W., and H. Rubin. 1950.
The asymptotic properties of estimates of the parameters
of a single equation in a complete system of stochastic equations.
{it:Annals of Mathematical Statistics} 21: 570-582.

{phang}
Basmann, R. L. 1960.
On finite sample distributions of generalized classical linear
indentifiability test statistics.
{it:Journal of the American Statistical Association} 55: 650-659.

{phang}
Baum, C. F., M. E. Schaffer, and S. Stillman. 2003.
Instrumental variables and GMM: Estimation and testing.
{browse "http://www.stata-journal.com/article.html?article=st0030":{it:Stata Journal} 3: 1-31}.

{phang}
Cameron, A. C., and Trivedi, P. K. 2005.
{it:Microeconometrics: Methods and Applications}.
New York: Cambridge University Press.

{phang}
Davidson, R., and J. G. MacKinnon. 1993.
{it:Estimation and Inference in Econometrics}.
New York: Oxford University Press.

{phang}
Durbin, J. 1954.
Errors in variables.
{it:Review of the International Statistical Institute} 22: 23-32.

{phang}
Hansen, L. P. 1982.
Large sample properties of generalized method of moments estimators.
{it:Econometrica} 50: 1029-1054.

{phang}
Hausman, J. 1978.
Specification tests in econometrics.
{it:Econometrica} 46: 1251-1271.

{phang}
Hayashi, F. 2000.
{it:Econometrics}.  Princeton, NJ: Princeton University Press.

{phang}
Sargan, J. D. 1958.
The estimation of economic relationships using instrumental variables.
{it:Econometrica} 26: 393-415.

{phang}
Wooldridge, J. M. 1995.
Score diagnostics for linear models estimated by two stage least
squares.
In {it:Advances in Econometrics and Quantitative Economics: Essays in Honor}
{it:of Professor C. R. Rao},
ed. G. S. Maddala, P. C. B. Phillips, and T. N. Srinivasan, 66-87.
Oxford: Blackwell.

{phang}
Wu, D.-M. 1973.
Alternative tests of independence between stochastic regressors and
disturbances.
{it: Econometrica} 42: 529-546.


{title:Also see}

{psee}
Manual:  {bf:[R] ivregress postestimation}

{psee}
Online:  {manhelp ivregress R}
{p_end}
