{smcl}
{* *! version 1.0.6  27mar2008}{...}
{title:What is chibar2?}

{pstd}
The likelihood-ratio (LR) test that is displayed is testing on the boundary
of the parameter space.  You are probably testing whether an estimated
variance component (something that is always greater than zero) is
different from zero by using an LR test.

{pstd}
Suppose for now that the two models being compared differ only with respect
to the variance component in question, in which case the test statistic will
be displayed as "chibar(01)".  In such cases, the limiting distribution of the
maximum-likelihood estimate of the parameter in question is a normal
distribution that is halved, or chopped off at the boundary -- zero here. 
The distribution of the LR test statistic is therefore not the usual
chi-squared with 1 degree of freedom but is instead a 50:50 mixture of a
chi-squared with no degrees of freedom (i.e., a point mass at zero) and a
chi-squared with 1 degree of freedom.

{pstd}
The p-value of the LR test takes this into account and will be set to 1
if it is determined that your estimate is close enough to zero to be, in
effect, zero for purposes of significance.  Otherwise, the p-value displayed
is set to one-half of the probability that a chi-squared with 1 degree of
freedom is greater than the calculated LR test statistic.

{pstd}
Sometimes you are testing whether a variance component is zero {it:in addition} to testing whether {it:k} other parameters (not affected by boundary
conditions) are zero.  Such situations often arise when comparing 
mixed-effects models, such as those fitted by {cmd:xtmixed}.  For such tests,
the distribution of the likelihood-ratio test statistic is a 50:50 mixture of
chi-squared distributions with {it:k} and {it:k}+1 degrees of freedom, shown
on the output as "chibar(4_5)", for example.  As for chibar(01), significance
levels are adjusted accordingly.

{pstd}
Finally, if you are testing more than one boundary-affected parameter, the
theory is much more complex and usually intractable.  When this
occurs, Stata will either display significance levels that are
{help j_xtmixedlr:conservative} and marked as such or will not display an 
LR test at all.


{title:References}

{phang}
Gutierrez, R. G., S. L. Carter, and D. M. Drukker. 2001.
On boundary-value likelihood-ratio tests.  
{browse "http://www.stata.com/products/stb/journals/stb60.pdf":{it:Stata Technical Bulletin} 60}: 15-18. Reprinted in
{it:Stata Technical Bulletin Reprints}, vol. 8, pp. 233-236.{p_end}

{phang}McLachlan, G. J., and K. E. Basford. 1988.  {it:Mixture Models}.
New York: Marcel Dekker.{p_end}

{phang}Self, S. G., and K.-Y. Liang. 1987. Asymptotic properties of 
maximum likelihood estimators and likelihood ratio tests under nonstandard
conditions.  {it:Journal of the American Statistical Association} 
82: 605-610.{p_end}

{phang}Stram, D. O., and J. W. Lee. 1994. Variance components testing
in the longitudinal mixed effects model. {it:Biometrics} 50: 1171-1177.{p_end}


{title:Also see}

{psee}
Manual:  {bf:[XT] xtmixed}, {bf:[XT] xtmelogit}, {bf:[XT] xtmepoisson}
{p_end}
