{smcl}
{* *! version 1.0.5  13may2008}{...}
{cmd:help legendstyle}
{hline}
{* index legendstyle it}{...}

{title:Title}

{p2colset 5 24 26 2}{...}
{p2col :{hi:[G] {it:legendstyle}} {hline 2}}Choices for look of legends{p_end}
{p2colreset}{...}


{title:Syntax}

{p2colset 9 38 40 2}{...}
{p2col:{it:legendstyle}}description{p_end}
{p2line}
{p2col:{cmd:default}}determined by scheme{p_end}
{p2line}
{p2colreset}{...}

{pin}
Other {it:legendstyles} may be available; type

	    {cmd:.} {bf:{stata graph query legendstyle}}

{pin}
to obtain the complete list of {it:legendstyles} installed on your computer.


{title:Description}

{pstd}
{it:legendstyle} specifies the
overall style of legends
and
is specified in the {cmd:legend(style())} option:

{phang2}
	{cmd:. graph} ...{cmd:, legend(} ... {cmd:style(}{it:legendstyle}{cmd:)} ...{cmd:)}


{title:Remarks}

{pstd}
Remarks are presented under the following headings:

	{help legendstyle##remarks1:What is a legend?}
	{help legendstyle##remarks2:What is a legendstyle?}
	{help legendstyle##remarks3:You do not need to specify a legendstyle}


{marker remarks1}{...}
{title:What is a legend?}

{pstd}
A legend is a table that shows the symbols used in a graph along with text
describing their meaning.  Each symbol/text entry in a legend is called a key.
See {manhelpi legend_option G} for more information.


{marker remarks2}{...}
{title:What is a legendstyle?}

{pstd}
The look of a legend is defined by 14 attributes:

{phang2}
    1.  The number of columns or rows of the table

{phang2}
    2.  Whether, in a multicolumn table, the first, second, ..., keys
	appear across the rows or down the columns

{phang2}
    3.  Whether the symbol/text of a key appears horizontally adjacent
	or vertically stacked

{phang2}
    4.  The gap between lines of the legend

{phang2}
    5.  The gap between columns of the legend

{phang2}
    6.  How the symbol of a key is aligned and justified

{phang2}
    7.  The gap between the symbol and text of a key

{phang2}
    8.  The height to be allocated in the table for the symbol of the key

{phang2}
    9.  The width to be allocated in the table for the symbol of the key

{p 7 12 2}
   10.  The width to be allocated in the table for the text of the key

{p 7 12 2}
   11.  Whether the above-specified height and width are to be
	dynamically adjusted according to contents of the keys

{p 7 12 2}
   12.  The margin around the legend

{p 7 12 2}
   13.  The color, size, etc., of the text of a key (17 features)

{p 7 12 2}
   14.  The look of any titles, subtitles, notes, and captions
	placed around the table (23 characteristics each)

{pstd}
The {it:legendstyle} specifies all 14 of these attributes.


{marker remarks3}{...}
{title:You do not need to specify a legendstyle}

{pstd}
The {it:legendstyle} is specified in the option

	{cmd:legend(style(}{it:legendstyle}{cmd:))}

{pstd}
Correspondingly, option {cmd:legend()} has other suboptions that will
allow you to specify the 14 attributes individually; see
{it:{help legend_option}}.

{pstd}
Specify the {it:legendstyle} when a style exists that is exactly what
you desire or when another style would allow you to specify fewer changes
to obtain what you want.


{title:Also see}

{psee}
Manual:  {bf:[G] {it:legendstyle}}

{psee}
Online:  {manhelpi legend_option G}
{p_end}
