{smcl}
{* *! version 1.0.4  13may2008}{...}
{cmd:help linepatternstyle}
{hline}
{* index linepatternstyle it}{...}

{title:Title}

{p2colset 5 29 31 2}{...}
{p2col :{hi:[G] {it:linepatternstyle}} {hline 2}}Choices for whether lines are solid, dashed, etc.{p_end}
{p2colreset}{...}


{title:Syntax}

{p2colset 9 34 36 2}{...}
{p2col:{it:linepatternstyle}}description{p_end}
{p2line}
{p2col:{cmd:solid}}solid line{p_end}
{p2col:{cmd:dash}}dashed line{p_end}
{p2col:{cmd:dot}}dotted line{p_end}
{p2col:{cmd:dash_dot}}{p_end}
{p2col:{cmd:shortdash}}{p_end}
{p2col:{cmd:shortdash_dot}}{p_end}
{p2col:{cmd:longdash}}{p_end}
{p2col:{cmd:longdash_dot}}{p_end}
{p2col:{cmd:blank}}invisible line{p_end}
{p2col:{cmd:"}{it:formula}{cmd:"}}e.g., {cmd:"-."} or {cmd:"--.."} etc.{p_end}
{p2line}
{pin}
A {it:formula} is composed of any combination of{p_end}
{p2col 17 34 36 2: {cmd:l}}solid line{p_end}
{p2col 17 34 36 2: {cmd:_}}(underscore) a long dash{p_end}
{p2col 17 34 36 2: {cmd:-}}(hyphen) a medium dash{p_end}
{p2col 17 34 36 2: {cmd:.}}short dash (almost a dot){p_end}
{p2col 17 34 36 2: {cmd:#}}small amount of blank space{p_end}
{p2line}
{p2colreset}{...}

{pin}
For a palette displaying each of the above named line styles, type

	    {cmd:.} {bf:{stata palette linepalette}} {...}
[{cmd:,} {cmdab:sch:eme:(}{it:schemename}{cmd:)}]

{pin}
Other {it:linepatternstyles} may be available; type

{phang3}
{cmd:. {bf:{stata graph query linepatternstyle}}}

{pin}
to obtain the complete list of {it:linepatternstyles} installed on your
computer.


{title:Description}

{pstd}
A line's look is determined by its pattern, thickness, and color; see 
{help lines}.  {it:linepatternstyle} specifies the pattern.

{pstd}
{it:linepatternstyle} is specified via options named

{phang2}
	<{it:object}><{cmd:l} or {cmd:li} or {cmd:line}>{cmd:pattern()}

{pstd}
or

	<{cmd:l} or {cmd:li} or {cmd:line}>{cmd:pattern()}

{pstd}
For instance, for connecting lines (the lines used to connect
points in a plot) used by {cmd:graph} {cmd:twoway} {cmd:function}, the option
is named {cmd:lpattern()}:

{phang2}
	{cmd:. twoway function} ...{cmd:, lpattern(}{it:linepatternstyle}{cmd:)} ...

{pstd}
Sometimes you will see that a {it:linepatternstylelist} is allowed:

{phang2}
	{cmd:. twoway line} ...{cmd:, lpattern(}{it:linepatternstylelist}{cmd:)} ...

{pstd}
A {it:linepatternstylelist} is a sequence of {it:linepatterns} separated by
spaces.  Shorthands are allowed to make specifying the list easier;
see {manhelpi stylelists G}.


{title:Remarks}

{pstd}
Alhtough you may choose a prerecorded pattern (e.g., {cmd:solid} or {cmd:dash}),
you can build any pattern you wish by specifying a
line-pattern formula.  For example,

{p2colset 9 24 26 2}{...}
{p2col:formula}description{p_end}
{p2line}
{p2col:{cmd:"l"}}solid line, same as {cmd:solid}{p_end}
{p2col:{cmd:"_"}}a long dash{p_end}
{p2col:{cmd:"_-"}}a long dash followed by a short dash{p_end}
{p2col:{cmd:"_--"}}a long dash followed by two short dashes{p_end}
{p2col:{cmd:"_--_#"}}a long dash, two short dashes, a long dash, and a bit of space{p_end}
{p2col:{it:etc.}}{p_end}
{p2line}

{pstd}
When you specify a formula, you must enclose it in double quotes.


{title:Also see}

{psee}
Manual:  {bf:[G] {it:linepatternstyle}}

{psee}
Online:  {manhelp lines G:concept: lines};
{manhelpi linewidthstyle G},
{manhelpi colorstyle G},
{manhelpi linestyle G};
{manhelpi connectstyle G}
{p_end}
