{smcl}
{* *! version 1.0.5  13may2008}{...}
{cmd:help lines}
{hline}

{title:Title}

{p2colset 5 27 29 2}{...}
{p2col :{hi:[G] concept: lines} {hline 2}}Using line{p_end}
{p2colreset}{...}


{title:Syntax}

{pstd}
The following affects how a line appears:

{p2colset 9 38 40 2}{...}
{p2line}
{p2col:{it:{help linestyle}}}overall style{p_end}
{p2col:{it:{help linepatternstyle}}}whether solid, dashed, etc.{p_end}
{p2col:{it:{help linewidthstyle}}}its thickness{p_end}
{p2col:{it:{help colorstyle}}}its color{p_end}
{p2line}
{p2colreset}{...}


{title:Description}

{pstd}
Lines occur in many contexts -- in borders, axes, the ticks on axes, the
outline around symbols, the connecting of points in a plot, and more.
{it:linestyle}, {it:linepatternstyle}, {it:linewidthstyle}, and
{it:colorstyle} define the look of the line.


{title:Remarks}

{pstd}
Remarks are presented under the following headings:

         {help lines##remarks1:linestyle}
         {help lines##remarks2:linepatternstyle}
         {help lines##remarks3:linewidthstyle}
         {help lines##remarks4:colorstyle}

{pstd}
{it:linestyle}, {it:linepatternstyle}, {it:linewidthstyle}, and
{it:colorstyle} are specified inside options that control how the line
is to appear.  Regardless of the object, these options usually have the same
names:

	{cmd:lstyle(}{it:linestyle}{cmd:)}
	{cmd:lpattern(}{it:linepatternstyle}{cmd:)}
	{cmd:lwidth(}{it:linewidthstyle}{cmd:)}
	{cmd:lcolor(}{it:colorstyle}{cmd:)}

{pstd}
Though for a few objects, such as markers, the form of the names is

	<{it:object}>{cmd:lstyle(}{it:linestyle}{cmd:)}
	<{it:object}>{cmd:lpattern(}{it:linepatternstyle}{cmd:)}
	<{it:object}>{cmd:lwidth(}{it:linewidthstyle}{cmd:)}
	<{it:object}>{cmd:lcolor(}{it:colorstyle}{cmd:)}

{pstd}
For instance,

{p 8 11 2}
o{space 2}The options to specify how the lines connecting points in a plot are
to appear are specified by the options {cmd:lstyle()}, {cmd:lpattern()},
{cmd:lwidth()}, and {cmd:lcolor()}; see {manhelpi connect_options G}.

{p 8 11 2}
o{space 2}The suboptions to specify how the border around a textbox, such as a
title, are to appear are named {cmd:lstyle()}, {cmd:lpattern()},
{cmd:lwidth()}, and {cmd:lcolor()}; see {manhelpi textbox_options G}.

{p 8 11 2}
o{space 2}The options to specify how the outline around markers 
is to appear are specified by the options {cmd:mlstyle()},
{cmd:mlpattern()}, {cmd:mlwidth()}, and {cmd:mlcolor()}; see 
{manhelpi marker_options G}.

{pstd}
Wherever these options arise, they always come in a group of four, and the
four pieces have the same meaning.


{marker remarks1}{...}
{title:linestyle}

{pstd}
{it:linestyle} is specified inside the {cmd:lstyle()} option or sometimes
inside the <{it:object}>{cmd:lstyle()} option.

{pstd}
{it:linestyle} specifies the overall style of the line:  its pattern
(solid, dashed, etc.), thickness, and color.

{pstd}
You need not specify the {cmd:lstyle()} option just because
there is something you want to change about the look of the line and, in fact,
most of the time you do not.  You specify
{cmd:lstyle()} when another style exists that is exactly what you
desire or when another style would allow you to specify fewer changes to
obtain what you want.

{pstd}
See {manhelpi linestyle G} for the list of what may be specified inside
the {cmd:lstyle()} option.


{marker remarks2}{...}
{title:linepatternstyle}

{pstd}
{it:linepatternstyle} is specified inside the {cmd:lpattern()} or
<{it:object}>{cmd:lpattern()} option.

{pstd}
{it:linepatternstyle} specifies whether the line is solid, dashed, etc.

{pstd}
See {manhelpi linepatternstyle G} for the list of what may be specified
inside the {cmd:lpattern()} option.


{marker remarks3}{...}
{title:linewidthstyle}

{pstd}
{it:linewidthstyle} is specified inside the {cmd:lwidth()} or
<{it:object}>{cmd:lwidth()} option.

{pstd}
{it:linewidthstyle} specifies the thickness of the line.

{pstd}
See {manhelpi linewidthstyle G} for the list of what may be specified
inside the {cmd:lwidth()} option.


{marker remarks4}{...}
{title:colorstyle}

{pstd}
{it:colorstyle} is specified inside the {cmd:lcolor()} or
<{it:object}>{cmd:lcolor()} option.

{pstd}
{it:colorstyle} specifies the color of the line.

{pstd}
See {manhelpi colorstyle G} for the list of what may be specified inside
the {cmd:lcolor()} option.


{title:Also see}

{psee}
Manual:  {bf:[G] concept: lines}

{psee}
Online:  
{manhelpi linestyle G},
{manhelpi linepatternstyle G},
{manhelpi linewidthstyle G},
{manhelpi colorstyle G};
{manhelpi connect_options G}
{p_end}
