{smcl}
{* *! version 1.1.12  31jul2007}{...}
{cmd:help logit}{right:dialogs:  {bf:{dialog logit}}  {dialog logit, message(-svy-) name(svy_logit):svy: logit}{space 3}}
{right:also see:  {help logit postestimation}}
{hline}

{title:Title}

{p2colset 5 18 20 2}{...}
{p2col :{hi:[R] logit} {hline 2}}Logistic regression, reporting
coefficients{p_end}
{p2colreset}{...}


{title:Syntax}

{p 8 15 2}
{opt logi:t} {depvar} [{indepvars}] {ifin} {weight} [{cmd:,} {it:options}]

{synoptset 20 tabbed}{...}
{synopthdr}
{synoptline}
{syntab :Model}
{synopt :{opt nocon:stant}}suppress constant term{p_end}
{synopt :{opth off:set(varname)}}include {it:varname} in model with coefficient
constrained to 1{p_end}
{synopt :{opt asis}}retain perfect predictor variables{p_end}

{syntab :SE/Robust}
{synopt :{opth vce(vcetype)}}{it:vcetype} may be {opt oim},
        {opt r:obust}, {opt cl:uster} {it:clustvar}, {opt boot:strap}, or
        {opt jack:knife}{p_end}

{syntab :Reporting}
{synopt :{opt l:evel(#)}}set confidence level; default is {cmd:level(95)}{p_end}
{synopt :{opt or}}report odds ratios{p_end}

{syntab :Max options}
{synopt :{it:{help logit##maximize_options:maximize_options}}}control the maximization process; seldom used{p_end}

{p2coldent :+ {opt nocoe:f}}do not display coefficient table; seldom
used{p_end}
{synoptline}
{p2colreset}{...}
{p 4 6 2}{it:depvar} and {it:indepvars} may contain time-series operators; see {help tsvarlist}.{p_end}
{p 4 6 2}{cmd:bootstrap}, {cmd:by}, {cmd:jackknife}, {cmd:nestreg},
{cmd:rolling}, {cmd:statsby}, {cmd:stepwise}, {cmd:svy}, and {cmd:xi} are
allowed; see {help prefix}.{p_end}
{p 4 6 2}Weights are not allowed with the {helpb bootstrap} prefix.{p_end}
{p 4 6 2}
{opt vce()}, {opt nocoef}, and  weights are not allowed with the {helpb svy}
prefix.  {p_end}
{p 4 6 2}
+ {opt nocoef} does not appear in the dialog box.
{p_end}
{p 4 6 2}{opt fweight}s, {opt iweight}s, and {opt pweight}s are allowed; see
{help weight}.{p_end}
{p 4 6 2}
See {manhelp logit_postestimation R:logit postestimation} for features
available after estimation.  {p_end}


{title:Description}

{pstd}
{cmd:logit} fits a maximum-likelihood logit model.  {it:depvar}=0
indicates a negative outcome; {it:depvar}!=0 & {it:depvar}!=. (typically
{it:depvar}=1) indicates a positive outcome.

{pstd}
Also see {manhelp logistic R}; {cmd:logistic} displays estimates as odds ratios.
Many users prefer the {cmd:logistic} command to {cmd:logit}.  Results 
are the same regardless of which you use -- both are the
maximum-likelihood estimator.  Several auxiliary commands that can be run
after {cmd:logit}, {cmd:probit}, or {cmd:logistic} estimation are described in
{helpb logistic postestimation:[R] logistic postestimation}.  A list of
related estimation commands is given in {help logistic estimation commands}.

{pstd}
If estimating on grouped data, see {manhelp glogit R}.

{pstd}
See {browse "http://www.stata.com/support/faqs/stat/rasch.html"} if
interested in the Rasch model.


{title:Options}

{dlgtab:Model}

{phang}
{opt noconstant}, {opth offset(varname)}; see
{helpb estimation options:[R] estimation options}.

{phang}
{opt asis} forces retention of perfect predictor variables and their
associated perfectly predicted observations and may produce instabilities in
maximization; see {manhelp probit R}.

{dlgtab:SE/Robust}

INCLUDE help vce_asymptall

{dlgtab:Reporting}

{phang}
{opt level(#)}; see 
{helpb estimation options##level():[R] estimation options}.

{phang}
{opt or} reports the estimated coefficients transformed to odds ratios, i.e.,
exp(b) rather than b.  Standard errors and confidence intervals are similarly
transformed.  This option affects how results are displayed, not how they are
estimated.  {opt or} may be specified at estimation or when replaying 
previously estimated results.

{marker maximize_options}{...}
{dlgtab:Max options}

{phang}
{it:maximize_options}: {opt iter:ate(#)}, [{cmdab:no:}]{opt lo:g}, {opt tr:ace},
{opt tol:erance(#)}, {opt ltol:erance(#)}, {opt nrtol:erance(#)},
{opt nonrtol:erance}; see {manhelp maximize R}.  These
options are seldom used.

{pstd}
The following option is available with {cmd:logit} but is not shown in the
dialog box:

{phang}
{opt nocoef} specifies that the coefficient table not be displayed.  This
option is sometimes used by program writers but is of no use interactively.


{title:Examples}

    {hline}
{pstd}Setup{p_end}
{phang2}{cmd:. webuse lbw2}{p_end}

{pstd}Logistic regression{p_end}
{phang2}{cmd:. logit low age lwt race2 race3 smoke ptl ht ui}{p_end}
{phang2}{cmd:. logit, level(99)}{p_end}

    {hline}
{pstd}Setup{p_end}
{phang2}{cmd:. webuse nhanes2d}{p_end}
{phang2}{cmd:. svyset}

{pstd}Logistic regression using survey data{p_end}
{phang2}{cmd:. svy: logit highbp height weight age female}{p_end}
    {hline}


{title:Saved results}

{pstd}
{cmd:logit} saves the following in {cmd:e()}:

{synoptset 15 tabbed}{...}
{p2col 5 15 19 2: Scalars}{p_end}
{synopt:{cmd:e(N)}}number of observations{p_end}
{synopt:{cmd:e(N_cds)}}number of completely determined successes{p_end}
{synopt:{cmd:e(N_cdf)}}number of completely determined failures{p_end}
{synopt:{cmd:e(df_m)}}model degrees of freedom{p_end}
{synopt:{cmd:e(r2_p)}}pseudo-R-squared{p_end}
{synopt:{cmd:e(ll)}}log likelihood{p_end}
{synopt:{cmd:e(ll_0)}}log likelihood, contant-only model{p_end}
{synopt:{cmd:e(N_clust)}}number of clusters{p_end}
{synopt:{cmd:e(chi2)}}chi-squared{p_end}

{synoptset 15 tabbed}{...}
{p2col 5 15 19 2: Macros}{p_end}
{synopt:{cmd:e(cmd)}}{cmd:logit}{p_end}
{synopt:{cmd:e(cmdline)}}command as typed{p_end}
{synopt:{cmd:e(depvar)}}name of dependent variable{p_end}
{synopt:{cmd:e(wtype)}}weight type{p_end}
{synopt:{cmd:e(wexp)}}weight expression{p_end}
{synopt:{cmd:e(title)}}title in estimation output{p_end}
{synopt:{cmd:e(clustvar)}}name of cluster variable{p_end}
{synopt:{cmd:e(offset)}}offset{p_end}
{synopt:{cmd:e(chi2type)}}{cmd:Wald} or {cmd:LR}; type of model chi-squared test{p_end}
{synopt:{cmd:e(vce)}}{it:vcetype} specified in {cmd:vce()}{p_end}
{synopt:{cmd:e(vcetype)}}title used to label Std. Err.{p_end}
{synopt:{cmd:e(crittype)}}optimization criterion{p_end}
{synopt:{cmd:e(properties)}}{cmd:b V}{p_end}
{synopt:{cmd:e(estat_cmd)}}program used to implement {cmd:estat}{p_end}
{synopt:{cmd:e(predict)}}program used to implement {cmd:predict}{p_end}

{synoptset 15 tabbed}{...}
{p2col 5 15 19 2: Matrices}{p_end}
{synopt:{cmd:e(b)}}coefficient vector{p_end}
{synopt:{cmd:e(V)}}variance-covariance matrix of the estimators{p_end}

{synoptset 15 tabbed}{...}
{p2col 5 15 19 2: Functions}{p_end}
{synopt:{cmd:e(sample)}}marks estimation sample{p_end}
{p2colreset}{...}


{title:Also see}

{psee}
Manual:  {bf:[R] logit}

{psee}
Online:  {manhelp logit_postestimation R:logit postestimation};{break}
{manhelp brier R},
{manhelp exlogistic R},
{manhelp glogit R}, 
{manhelp logistic R}, 
{manhelp probit R},
{manhelp roc R},
{manhelp svy_estimation SVY:svy estimation},
{manhelp xtlogit XT}
{p_end}
