{smcl}
{* *! version 1.0.10  20nov2008}{...}
{cmd:help logit postestimation}{right:dialog:  {bf:{dialog logit_p:predict}}}
{right:also see:  {helpb logit}{space 2}}
{hline}

{title:Title}

{p2colset 5 33 35 2}{...}
{p2col :{hi:[R] logit postestimation} {hline 2}}Postestimation tools for
logit{p_end}
{p2colreset}{...}


{title:Description}

{pstd}
The following postestimation commands are of special interest after {cmd:logit}:

{synoptset 14}{...}
{p2coldent :command}description{p_end}
{synoptline}
{synopt :{helpb logistic postestimation##estatclas:estat clas}}{cmd:estat} {cmd:classification} reports various summary statistics, including the classification table{p_end}
{synopt :{helpb logistic postestimation##estatgof:estat gof}}Pearson or Hosmer-Lemeshow goodness-of-fit test{p_end}
{synopt :{helpb logistic postestimation##lroc:lroc}}graphs the ROC curve and calculates the area under the curve{p_end}
{synopt :{helpb logistic postestimation##lsens:lsens}}graphs sensitivity and specificity versus probability cutoff{p_end}
{synoptline}
{p2colreset}{...}
{p 4 6 2}
These commands are not appropriate after the {cmd:svy} prefix.
{p_end}

{pstd}
The following standard postestimation commands are also available:

{synoptset 14 notes}{...}
{p2coldent :command}description{p_end}
{synoptline}
INCLUDE help post_adjust3par
INCLUDE help post_estat
INCLUDE help post_svy_estat
INCLUDE help post_estimates
INCLUDE help post_lincom
{p2coldent:(2) {helpb linktest}}link test for model specification{p_end}
{p2coldent:(3) {helpb lrtest}}likelihood-ratio test{p_end}
INCLUDE help post_mfx
INCLUDE help post_nlcom
{synopt :{helpb logit postestimation##predict:predict}}predictions, residuals, influence statistics, and other diagnostic measures{p_end}
INCLUDE help post_predictnl
INCLUDE help post_suest
INCLUDE help post_test
INCLUDE help post_testnl
{synoptline}
{p2colreset}{...}
{p 4 6 2}(1) {cmd:adjust} is not appropriate with time-series operators.{p_end}
{p 4 6 2}
(2) {cmd:linktest} is not available with {cmd:svy} estimation results.
{p_end}
{p 4 6 2}
(3) {cmd:lrtest} is not appropriate with {cmd:svy} estimation results.
{p_end}


{marker predict}{...}
{title:Syntax for predict}

{p 8 16 2}
{cmd:predict} {dtype} {newvar} {ifin} 
[{cmd:,} {it:statistic} {opt nooff:set} {opt rule:s} {opt asif}]

{synoptset 14 tabbed}{...}
{synopthdr :statistic}
{synoptline}
{syntab :Main}
{synopt :{opt p:r}}probability of a positive outcome; the default{p_end}
{synopt :{cmd:xb}}xb, fitted values{p_end}
{synopt :{cmd:stdp}}standard error of the prediction{p_end}
{p2coldent :* {opt db:eta}}Pregibon Delta-Beta influence statistic{p_end}
{p2coldent :* {opt de:viance}}deviance residual{p_end}
{p2coldent :* {opt dx:2}}Hosmer and Lemeshow Delta
chi-squared influence statistic{p_end}
{p2coldent :* {opt dd:eviance}}Hosmer and Lemeshow Delta-D
influence statistic{p_end}
{p2coldent :* {opt h:at}}Pregibon leverage{p_end}
{p2coldent :* {opt n:umber}}sequential number of the covariate
pattern{p_end}
{p2coldent :* {opt r:esiduals}}Pearson residuals; adjusted for number
sharing covariate pattern{p_end}
{p2coldent :* {opt rs:tandard}}standardized Pearson residuals; adjusted
for number sharing covariate pattern{p_end}
{synopt :{opt sc:ore}}first derivative of the log likelihood with respect to xb{p_end}
{synoptline}
{p2colreset}{...}
INCLUDE help unstarred
{p 4 6 2}
{opt pr}, {opt xb}, {opt stdp}, and {opt score} are the only options allowed
with {cmd:svy} estimation results.


{title:Options for predict}

{dlgtab:Main}

{phang}
{opt pr}, the default, calculates the probability of a positive outcome.

{phang}
{opt xb} calculates the linear prediction.

{phang}
{opt stdp} calculates the standard error of the linear prediction.

{phang}
{opt dbeta} calculates the Pregibon Delta-Beta influence statistic, a
standardized measure of the difference in the coefficient vector that is due
to deletion of the observation along with all others that share the same
covariate pattern.  In Hosmer and Lemeshow jargon, this statistic is
M-asymptotic; that is, it is adjusted for the number of observations that
share the same covariate pattern.

{phang}
{opt deviance} calculates the deviance residual.  

{phang}
{opt dx2} calculates the Hosmer and Lemeshow Delta chi-squared influence
statistic, reflecting the decrease in the Pearson chi-squared that is due to
deletion of the observation and all others that share the same covariate
pattern.

{phang}
{opt ddeviance} calculates the Hosmer and Lemeshow Delta-D influence
statistic, which is the change in the deviance residual that is due to
deletion of the observation and all others that share the same covariate
pattern.

{phang}
{opt hat} calculates the Pregibon leverage or the diagonal elements of the hat
matrix adjusted for the number of observations that share the same covariate
pattern. 

{phang}
{opt number} numbers the covariate patterns -- observations with the same
covariate pattern have the same number.  Observations not used in estimation
have {opt number} set to missing.  The first covariate pattern is numbered
1, the second 2, and so on. 

{phang}
{opt residuals} calculates the Pearson residual as given by Hosmer and
Lemeshow and adjusted for the number of observations that share the same
covariate pattern.

{phang}
{opt rstandard} calculates the standardized Pearson residual as given by
Hosmer and Lemeshow and adjusted for the number of observations that share the
same covariate pattern.

{phang}
{opt score} calculates the equation-level score, the first derivative of the
log likelihood with respect to the linear prediction.


{dlgtab:Options}

{phang}
{opt nooffset} is relevant only if you specified {opth offset(varname)} for
{opt logit}.  It modifies the calculations made by {opt predict} so that
they ignore the offset variable; the linear prediction is treated as xb
rather than xb + offset.

{phang}
{opt rules} requests that Stata use any rules that were used to
identify the model when making the prediction.  By default, Stata calculates
missing for excluded observations.

{phang}
{opt asif} requests that Stata ignore the rules and the exclusion criteria
and calculate predictions for all observations possible using the estimated
parameter from the model.


{title:Examples}

{phang}{cmd:. webuse lbw2}{p_end}
{phang}{cmd:. logit low age lwt race2 race3 smoke ptl ht ui}{p_end}
{phang}{cmd:. predict p}{p_end}
{phang}{cmd:. estat clas}{p_end}
{phang}{cmd:. estat gof}


{title:Also see}

{psee}
Manual:  {bf:[R] logit postestimation}

{psee}
Online:  {manhelp logit R};
{manhelp logistic_postestimation R:logistic postestimation}
{p_end}
