{smcl}
{* *! version 1.0.5  13may2008}{...}
{cmd:help marker_options}
{hline}
{* index markers}{...}
{* index symbols, see markers}{...}
{* index mstyle() tt option}{...}
{* index msymbol() tt option}{...}
{* index mcolor() tt option}{...}
{* index msize() tt option}{...}
{* index mfcolor() tt option}{...}
{* index mlstyle() tt option}{...}
{* index mlwidth() tt option}{...}
{* index mlcolor() tt option}{...}

{title:Title}

{p2colset 5 27 29 2}{...}
{p2col :{hi:[G] {it:marker_options}} {hline 2}}Options for specifying markers{p_end}
{p2colreset}{...}


{title:Syntax}

{p2colset 9 34 38 2}{...}
{p2col:{it:marker_options}}
	description{p_end}
{p2line}
{p2col:{cmdab:m:symbol:(}{it:{help symbolstyle}}{cmd:)}}
	shape of marker{p_end}
{p2col:{cmdab:mc:olor:(}{it:{help colorstyle}}{cmd:)}}
	color of marker, inside and out{p_end}
{p2col:{cmdab:msiz:e:(}{it:{help markersizestyle}}{cmd:)}}
	size of marker{p_end}

{p2col:{cmdab:mfc:olor:(}{it:{help colorstyle}}{cmd:)}}
	inside or "fill" color{p_end}

{p2col:{cmdab:mlc:olor:(}{it:{help colorstyle}}{cmd:)}}
	outline color{p_end}
{p2col:{cmdab:mlw:idth:(}{it:{help linewidthstyle}}{cmd:)}}
	outline thickness{p_end}
{p2col:{cmdab:mlsty:le:(}{it:{help linestyle}}{cmd:)}}
	thickness and color, overall style of outline{p_end}

{p2col:{cmdab:msty:le:(}{it:{help markerstyle}}{cmd:)}}
	overall style of marker; all settings above{p_end}
{p2col:{cmdab:psty:le:(}{it:{help pstyle}}{cmd:)}}
	overall plot style, including markerstyle{p_end}

{p2col:{help advanced_options:{bf:recast(}{it:newplottype}{bf:)}}}
	advanced; treat plot as {it:newplottype}{p_end}
{p2line}
{p2colreset}{...}
{pin}
All options are {it:rightmost}; see {help repeated options}.

{pstd}
One example of each of the above is{cmd}

	    msymbol(O)       mfcolor(red)    mlcolor(olive)       mstyle(p1)
	    mcolor(green)                    mlwidth(thick)       mlstyle(p1)
	    msize(medium)                                    {txt}

{pstd}
Sometimes you may specify a list of elements, with the first element
applying to the first variable, the second to the second, and
so on.  See, for instance, {manhelp scatter G:graph twoway scatter}.  One
example would be

	    {cmd:msymbol(O o p)}
	    {cmd:mcolor(green blue black)}
	    {cmd:msize(medium medium small)}

	    {cmd:mfcolor(red red none)}

	    {cmd:mlcolor(olive olive green)}
	    {cmd:mlwidth(thick thin thick)}

	    {cmd:mstyle(p1 p2 p3)}
	    {cmd:mlstyle(p1 p2 p3)}

{pstd}
For information about specifying lists, see {manhelpi stylelists G}.


{title:Description}

{pstd}
Markers are the ink used to mark where points are on a plot.
The important options are

	{cmd:msymbol(}{it:{help symbolstyle}}{cmd:)}                (choice of symbol)
	{cmd:mcolor(}{it:{help colorstyle}}{cmd:)}                  (choice of color)
	{cmd:msize(}{it:{help markersizestyle}}{cmd:)}              (choice of size)


{title:Options}

{phang}
{cmd:msymbol(}{it:symbolstyle}{cmd:)} specifies the shape of the marker
    and is one of the more commonly specified options.
    See {manhelpi symbolstyle G} for more information on this important
    option.

{phang}
{cmd:mcolor(}{it:colorstyle}{cmd:)} specifies the color of the marker.
    This option sets both the color of the line used to outline the
    markers shape and the color of the inside of the marker.  Also
    see options {cmd:mfcolor()} and {cmd:mlcolor()} below.
    See {manhelpi colorstyle G} for a list of color choices.

{phang}
{cmd:msize(}{it:markersizestyle}{cmd:)} specifies the size of the
    marker.
    See {manhelpi markersizestyle G} for a list of size choices.

{phang}
{cmd:mfcolor(}{it:colorstyle}{cmd:)}
    specifies the color of the inside of the marker.
    See {manhelpi colorstyle G} for a list of color choices.

{phang}
{cmd:mlcolor(}{it:colorstyle}{cmd:)},
{cmd:mlwidth(}{it:linewidthstyle}{cmd:)}, and
{cmd:mlstyle(}{it:linestyle}{cmd:)}
    specify the look of the line used to outline the shape of the
    marker.  See {help lines}, but you cannot change the line
    pattern of a marker.

{phang}
{cmd:mstyle(}{it:markerstyle}{cmd:)}
    specifies the overall look of markers, such as their shape and
    their color.  The other options allow you to change each attribute of
    the marker, but {cmd:mstyle()} is a starting point.

{pmore}
    You need not specify {cmd:mstyle()} just because there is something
    you want to change about the look of the marker and, in fact,
    most people seldom specify the {cmd:mstyle()} option.  You specify
    {cmd:mstyle()} when another style exists that is exactly what you
    desire or when another style would allow you to specify
    fewer changes to obtain what you want.

{pmore}
    See {manhelpi markerstyle G} for a list of available marker styles.

{phang}
{cmd:pstyle(}{it:pstyle}{cmd:)}
    specifies the overall style of the plot, including not only the
    markerstyle but also the {it:{help markerlabelstyle}} and all other settings
    for the look of the plot.  Only the {it:{help markerstyle}} and 
    {it:{help markerlabelstyle}} affect the look of markers.
    See {manhelpi pstyle G} for a list of available plot styles.

{phang}
{cmd:recast(}{it:newplottype}{cmd:)}
        is an advanced option allowing the plot to be recast from one type to
        another, for example, from a {help twoway scatter:scatterplot} to
        a {help twoway line:line plot}; see 
        {manhelpi advanced_options G}.  Most, but not all, plots allow
        {cmd:recast()}.


{title:Remarks}

{pstd}
You will never need to specify all nine marker options, and seldom will you
even need to specify more than one or two of them.  Many people think
that there is just one important marker option,

	{cmd:msymbol(}{it:symbolstyle}{cmd:)}

{pstd}
{cmd:msymbol()} specifies the shape of the symbol; see
{manhelpi symbolstyle G} for choice of symbol.
A few people would add to the important list a second option,

	{cmd:mcolor(}{it:colorstyle}{cmd:)}

{pstd}
{cmd:mcolor()} specifies the marker's color;
see {manhelpi colorstyle G} for choice of color.
Finally, a few would add

	{cmd:msize(}{it:markersizestyle}{cmd:)}

{pstd}
{cmd:msize()} specifies the marker's size; see {manhelpi markersizestyle G}
for choice of sizes.

{pstd}
After that, we are really into the details.  One of the remaining options,
however, is of interest:

	{cmd:mstyle(}{it:markerstyle}{cmd:)}

{pstd}
A marker has a set of characteristics:

	{c -(}shape, color, size, inside details, outside details{c )-}

{pstd}
Each of the options other than {cmd:mstyle()} modifies something in that set.
{cmd:mstyle()} sets the values of the entire set.  It is from there that the
changes you specify are made.  See {manhelpi markerstyle G}.


{title:Also see}

{psee}
Manual:  {bf:[G] {it:marker_options}}

{psee}
Online:  
{manhelpi symbolstyle G},
{manhelpi colorstyle G},
{manhelpi markersizestyle G},
{manhelpi linewidthstyle G},
{manhelpi linestyle G};
{manhelpi markerstyle G}
{p_end}
