{smcl}
{* *! version 1.0.4  28may2009}{...}
{cmd:help matrix svd} {right:dialog:  {bf:{dialog matrix_svd:matrix svd}}}
{hline}

{title:Title}

{p2colset 5 23 25 2}{...}
{p2col :{hi:[P] matrix svd} {hline 2}}Singular value decomposition{p_end}
{p2colreset}{...}


{title:Syntax}

{p 8 15 2}{cmdab:mat:rix} {cmd:svd} {it:U} {it:W} {it:V} {cmd:=} {it:A}

{pstd}
where {it:U}, {it:W}, and {it:V} are matrix names (the matrices may exist
or not) and {it:A} is the name of an existing m x n, m {ul:>} n matrix.


{title:Description}

{pstd}
{cmd:matrix svd} produces the singular value decomposition (SVD) of {it:A}.

{pstd}
The singular value decomposition of m x n matrix {it:A}, m {ul:>} n, is defined
as

	{it:A} = {it:U} diag({it:W}) {it:V}'

{pstd}
where {it:U} is column orthogonal, the elements of {it:W} are
positive or zero, and {it:V}'{it:V}=I.

{pstd}
Also see {bf:{help mf_svd:[M-5] svd()}} for alternative routines for obtaining
the singular value decomposition.


{title:Examples}

    {cmd:. matrix A = (1,2,9\2,7,5\2,4,18)}
    {cmd:. matrix svd U w V = A}
    {cmd:. matrix list U}
    {cmd:. matrix list w}
    {cmd:. matrix list V}
    {cmd:. matrix newA = U*diag(w)*V'}
    {cmd:. matrix list newA}


{title:Also see}

{psee}
Manual:  {bf:[P] matrix svd}

{psee}
Online:  {manhelp matrix P}
