{smcl}
{* *! version 1.0.5  09may2008}{...}
{cmd:help meta}
{hline}
{* index meta-analysis}{...}

{title:Title}

{p2colset 5 17 19 2}{...}
{p2col:{hi:[R] meta} {hline 2}}Meta-analysis{p_end}
{p2colreset}{...}


{title:Remarks}

{pstd}
Stata does not have a meta-analysis command.  Stata users, however, have
developed an excellent suite of commands for performing meta-analysis, many of
which have been published in the {it:Stata Journal} (SJ) or the 
{it:Stata Technical Bulletin} (STB).

{pstd}
For information about meta-analysis, in addition to the articles that have
appeared in the {it:Stata Journal} and the {it:Stata Technical Bulletin},
see Abramson and Abramson (2001, chap. F); Dohoo, Martin, and Stryhn (2003,
chap. 24); Edgger, Smith, and Altman (2001); and Sutton et al. (2000).

{pstd}
Also see the meta-analysis frequently asked question on the Stata web site at

                 {browse "http://www.stata.com/support/faqs/stat/meta.html"}


    Issue   insert   author(s)        command     description
    {hline}
    STB-38  sbe16    S. Sharp,        {cmd:meta}        meta-analysis for an outcome
                       J. Sterne                    of 2 exposures or 2
		       			            treatment regimens

    STB-42  sbe16.1  S. Sharp,        {cmd:meta}        update of sbe16
                       J. Sterne

    STB-43  sbe16.2  S. Sharp,        {cmd:meta}        update; {it:install this version}
                       J. Sterne                    {...}
{view "http://www.stata.com/stb/stb43/sbe16_2/meta.hlp":help file for meta command} 

    STB-41  sbe19    T. J. Steichen   {cmd:metabias}    performs the Begg and
                                                    Mazumdar (1994) adjusted
						    rank correlation test for
					            publication bias and the
						    Egger et al. (1997)
						    regression asymmetry test
						    for publication bias

    STB-44  sbe19.1  T. J. Steichen,  {cmd:metabias}    update of sbe19
                       M. Egger,
                       J. Sterne

    STB-57  sbe19.2  T. J. Steichen   {cmd:metabias}    update of sbe19

    STB-58  sbe19.3  T. J. Steichen   {cmd:metabias}    update of sbe19

    STB-61  sbe19.4  T. J. Steichen   {cmd:metabias}    update of sbe19

    SJ-3-4  sbe19.4  T. J. Steichen   {cmd:metabias}    update; {it:install this version}

    STB-41  sbe20    A. Tobias        {cmd:galbr}       performs the Galbraith
                                                    plot (1988), which is
						    useful for investigating
					   	    heterogeneity in
						    meta-analysis

    STB-56  sbe20.1  A. Tobias        {cmd:galbr}       update; {it:install this version}

    STB-42  sbe22    J. Sterne        {cmd:metacum}     performs cumulative
                                                    meta-analysis, using
						    fixed- or random-effects
						    models, and graphs the
						    result

    STB-42  sbe23    S. Sharp         {cmd:metareg}     extends a random-effects
                                                    meta-analysis to estimate
						    the extent to which one or
						    more covariates, with
						    values defined for each
						    study in the analysis,
					    	    explains heterogeneity in
						    the treatment effects

    STB-44  sbe24    M. J. Bradburn,  {cmd:metan},      meta-analysis of studies
                       J. J. Deeks,                 with two groups
                       D. G. Altman   {cmd:funnel},     funnel plot of precision
		                                    versus treatment effect
		                      {cmd:labbe}       L'Abb{c e'} plot

    STB-45  sbe24.1  M. J. Bradburn,  {cmd:funnel}      update
                       J. J. Deeks,                 
                       D. G. Altman

    SJ-8-1  sbe24_2  R. J. Harris,    {cmd:metan}      update; {it:install this version}
                       M. J. Bradburn,              
                       J. J. Deeks,                 
                       R. M. Harbord,               
                       D. G. Altman,
                       J. A. C. Sterne

    STB-47  sbe26    A. Tobias        {cmd:metainf},    graphical technique to look
                                      {cmd:meta}          for influential studies in
				                    the meta-analysis estimate

    STB-56  sbe26.1  A. Tobias        {cmd:metainf}     update; {it:install this version}

    STB-49  sbe28    A. Tobias        {cmd:metap}       combines p-values by using
                                                    either Fisher's method or
						    Edgington's method

    STB-56  sbe28.1  A. Tobias        {cmd:metap}       update; {it:install this version}

    STB-57  sbe39    T. J. Steichen   {cmd:metatrim}    performs the Duval and
                                                    Tweedie (2000)
						    nonparametric "trim and
						    fill" method of accounting
						    for publication bias in
						    meta-analysis

    STB-58  sbe39.1  T. J. Steichen   {cmd:metatrim}    update of sbe39

    STB-61  sbe39.2  T. J. Steichen   {cmd:metatrim}    update; {it:install this version}

    SJ-4-2  st0061   J. Sterne,       {cmd:metafunnel}  funnel plots
                       R. Harbord

    SJ-4-2  pr0012   T. J. Steichen               submenu and dialogs for
                                                    meta-analysis commands

    SJ-6-1  st0096   N. Orsini,       {cmd:glst}        GLS for trend estimation of
                       R. Bellocco,                 summarized dose-response
		       S. Greenland                 data
    {hline}
{pstd}More commands may be available; enter Stata and type {cmd:search}
{cmd:meta} {cmd:analysis}.

{pstd}
To download and install from the Internet the Sharp and Stern {cmd:meta}
command, for instance, in Stata you could do the following:

{phang2}
1.  Select {bf:Help > SJ and User-written Programs}.

{phang2}
2.  Click on {hi:STB}.

{phang2}
3.  Click on {hi:stb43}.

{phang2}
4.  Click on {hi:sbe16_2}.

{phang2}
5.  Click on {hi:click here to install}.

{pstd}
Or you could do the following:

{phang2}
1.  Navigate to the appropriate STB issue:
 
                a.  Type {cmd:net from http://www.stata.com}
                    Type {cmd:net cd stb}
                    Type {cmd:net cd stb43}

{pmore2}or

                b.  Type {cmd:net from http://www.stata.com/stb/stb43}

{phang2}
2.  Type {cmd:net describe sbe16_2}

{phang2}
3.  Type {cmd:net install sbe16_2}


{title:References}

{phang}
Abramson, J. H., and Z. H. Abramson. 2001.
{it:Making Sense of Data: A Self-Instruction Manual on the Interpretation}
{it:of Epidemiological Data}. 3rd ed.
New York: Oxford University Press.

{phang}
Begg, C. B., and M. Mazumdar. 1994. 
Operating characteristics of a rank correlation test for publication bias. 
{it:Biometrics} 50: 1088-1101.

{phang}
Bradburn, M. J., J. J. Deeks, and D. G. Altman. 1998a.
sbe24: metan{hline 2}an alternative meta-analysis command.
{browse "http://www.stata.com/products/stb/journals/stb44.pdf":{it:Stata Technical Bulletin} 44}: 4-15.
Reprinted in {it:Stata Technical Bulletin Reprints}, vol. 8, 
pp. 86-100.

{phang}
{hline 6}. 1998b.
sbe24.1: Correction to funnel plot.
{browse "http://www.stata.com/products/stb/journals/stb45.pdf":{it:Stata Technical Bulletin} 45}: 21.
Reprinted in {it:Stata Technical Bulletin Reprints}, vol. 8, p. 100.

{phang}
Dohoo, I., W. Martin, and H. Stryhn. 2003.
{it:Veterinary Epidemiologic Research}.
Charlottetown, Prince Edward Island: AVC.

{phang}
Egger, M., G. D. Smith, and D. G. Altman, ed. 2001.  
{it:Systematic Reviews in Health Care: Meta-analysis in Context}. 
London: BMJ Books.

{phang}
Egger, M., G. D. Smith, M. Schneider, and C. Minder. 1997.  
Bias in meta-analysis detected by a simple, graphical test. 
{it:British Medical Journal} 315: 629-634. 

{phang}
Galbraith, R. F. 1988. 
A note on graphical display of estimated odds ratios from several clinical 
trials. 
{it:Statistics in Medicine} 7: 889-894.

{phang}
L'Abb{c e'}, K. A., A. S. Detsky, and K. O'Rourke. 1987.
Meta-analysis in clinical research.
{it:Annals of Internal Medicine} 107: 224-233.

{phang}
Sharp, S. 1998.
sbe23: Meta-analysis regression.
{browse "http://www.stata.com/products/stb/journals/stb42.pdf":{it:Stata Technical Bulletin} 42}: 16-22.
Reprinted in {it:Stata Technical Bulletin Reprints}, vol. 7, 
pp. 148-155.

{phang}
Sharp, S., and J. Sterne. 1997.
sbe16: Meta-analysis.
{browse "http://www.stata.com/products/stb/journals/stb38.pdf":{it:Stata Technical Bulletin} 38}: 9-14.
Reprinted in {it:Stata Technical Bulletin Reprints}, vol. 7, 
pp. 100-106.

{phang}
{hline 6}. 1998a.
sbe16.1: New syntax and output for the meta-analysis command.
{browse "http://www.stata.com/products/stb/journals/stb42.pdf":{it:Stata Technical Bulletin} 42}: 6-8.
Reprinted in {it:Stata Technical Bulletin Reprints}, vol. 7, 
pp. 106-108.

{phang}
{hline 6}. 1998b.
sbe16.2: Corrections to the meta-analysis command.
{browse "http://www.stata.com/products/stb/journals/stb43.pdf":{it:Stata Technical Bulletin} 43}: 15.
Reprinted in {it:Stata Technical Bulletin Reprints}, vol. 8, 
p. 84.

{phang}
Steichen, T. J. 1998.
sbe19: Tests for publication bias in meta-analysis.
{browse "http://www.stata.com/products/stb/journals/stb41.pdf":{it:Stata Technical Bulletin} 41}: 9-15.
Reprinted in {it:Stata Technical Bulletin Reprints}, vol. 7,
pp. 125-133.

{phang}
{hline 6}. 2000a.
sbe19.2: Update of tests for publication bias in meta-analysis.
{browse "http://www.stata.com/products/stb/journals/stb57.pdf":{it:Stata Technical Bulletin} 57}: 4.
Reprinted in {it:Stata Technical Bulletin Reprints}, vol. 10,
p. 70.

{phang}
{hline 6}. 2000b.
sbe39: Nonparametric trim and fill analysis of publication bias in
meta-analysis. 
{browse "http://www.stata.com/products/stb/journals/stb57.pdf":{it:Stata Technical Bulletin} 57}: 8-14.
Reprinted in {it:Stata Technical Bulletin Reprints}, vol. 10,
pp. 108-117.

{phang}
{hline 6}. 2000c.
sbe19.3: Tests for publication bias in meta-analysis: Erratum.
{browse "http://www.stata.com/products/stb/journals/stb58.pdf":{it:Stata Technical Bulletin} 58}: 8.
Reprinted in {it:Stata Technical Bulletin Reprints}, vol. 10,
p. 71.

{phang}
{hline 6}. 2000d.
sbe39.1: Nonparametric trim and fill analysis of publication bias in
meta-analysis: Erratum.  
{browse "http://www.stata.com/products/stb/journals/stb58.pdf":{it:Stata Technical Bulletin} 58}: 8-9.
Reprinted in {it:Stata Technical Bulletin Reprints}, vol. 10,
pp. 117-118.

{phang}
{hline 6}. 2001a.
sbe19.4: Update to metabias to work under version 7.
{browse "http://www.stata.com/products/stb/journals/stb61.pdf":{it:Stata Technical Bulletin} 61}: 11.
Reprinted in {it:Stata Technical Bulletin Reprints}, vol. 10,
pp. 71-72.

{phang}
{hline 6}. 2001b.
sbe39.2: Update of metatrim to work under version 7.
{browse "http://www.stata.com/products/stb/journals/stb61.pdf":{it:Stata Technical Bulletin} 61}: 11.
Reprinted in {it:Stata Technical Bulletin Reprints}, vol. 10,
p. 118.

{phang}
{hline 6}. 2004.
Submenu and dialogs for meta-analysis commands.
{browse "http://www.stata-journal.com/article.html?article=pr0012":{it:Stata Journal} 4: 124-126}.

{phang}
Steichen, T. J., M. Egger, and J. Sterne. 1998.
sbe19.1: Tests for publication bias in meta-analysis.
{browse "http://www.stata.com/products/stb/journals/stb44.pdf":{it:Stata Technical Bulletin} 44}: 3-4.
Reprinted in {it:Stata Technical Bulletin Reprints}, vol. 8, 
pp. 84-85.

{phang}
Sterne, J. 1998.
sbe22: Cumulative meta-analysis. 
{browse "http://www.stata.com/products/stb/journals/stb42.pdf":{it:Stata Technical Bulletin} 42}: 13-16.
Reprinted in {it:Stata Technical Bulletin Reprints}, vol. 7, 
pp. 143-147.

{phang}
Sterne, J. A. C., and R. M. Harbord. 2004.
Funnel plots in meta-analysis.
{browse "http://www.stata-journal.com/article.html?article=st0061":{it:Stata Journal} 4: 127-141}.

{phang}
Sterne, J. A. C., R. Harris, and R. M. Harbord. 2007.
FAQ: What meta-analysis features are available in Stata?
http://www.stata.com/support/faqs/stat/meta.html.

{phang}
Sutton, A. J., K. R. Abrams, D. R. Jones, T. A. Sheldon, and F. Song. 2000.  
{it:Methods for Meta-Analysis in Medical Research}. 
New York: Wiley.

{phang}
Tobias, A. 1998.
sbe20: Assessing heterogeneity in meta-analysis: The Galbraith plot.
{browse "http://www.stata.com/products/stb/journals/stb41.pdf":{it:Stata Technical Bulletin} 41}: 15-17.
Reprinted in {it:Stata Technical Bulletin Reprints}, vol. 7, 
pp. 133-136.

{phang}
{hline 6}. 1999a.
sbe26: Assessing the influence of a single study in the meta-analysis estimate.
{browse "http://www.stata.com/products/stb/journals/stb47.pdf":{it:Stata Technical Bulletin} 47}: 15-17.
Reprinted in {it:Stata Technical Bulletin Reprints}, vol. 8, 
p. 108-110.

{phang}
{hline 6}. 1999b.
sbe28: Meta-analysis of p-values.
{browse "http://www.stata.com/products/stb/journals/stb49.pdf":{it:Stata Technical Bulletin} 49}: 15-17.
Reprinted in {it:Stata Technical Bulletin Reprints}, vol. 9, 
pp. 138-140.

{phang}
{hline 6}. 2000a.
sbe20.1: Update of galbr.
{it:Stata Technical Bulletin} 56: 14.
{browse "http://www.stata.com/products/stb/journals/stb56.pdf":{it:Stata Technical Bulletin} 56}: 14.
Reprinted in {it:Stata Technical Bulletin Reprints}, vol. 10, p. 72.

{phang}
{hline 6}. 2000b.
sbe26.1: Update of metainf.
{browse "http://www.stata.com/products/stb/journals/stb56.pdf":{it:Stata Technical Bulletin} 56}: 15.
Reprinted in {it:Stata Technical Bulletin Reprints}, vol. 10, p. 72.

{phang}
{hline 6}. 2000c.
sbe28.1: Update of metap.
{browse "http://www.stata.com/products/stb/journals/stb56.pdf":{it:Stata Technical Bulletin} 56}: 15.
Reprinted in {it:Stata Technical Bulletin Reprints}, vol. 10, p. 73.
{p_end}
