{smcl}
{* *! version 1.0.2  29may2008}{...}
{cmd:help mata Dmatrix()}{right:also see:  {help forthcoming}}
{hline}
{* index duplication matrix}{...}
{* index Dmatrix()}{...}
{* index vec}{...}
{* index vech}{...}

{title:Title}

{p 4 4 2}
{bf:[M-5] Dmatrix() -- Duplication matrix}


{title:Syntax}

{p 8 12 2}
{it:real matrix}
{cmd:Dmatrix(}{it:real scalar n}{cmd:)}


{title:Description}

{p 4 4 2}
{cmd:Dmatrix(}{it:n}{cmd:)} 
returns the {it:n}^2 {it:x} {it:n}*({it:n}+1)/2 duplication
matrix {cmd:D} for which {cmd:D}*{cmd:vech(}{it:X}{cmd:)} {cmd:=}
{cmd:vec(}{it:X}{cmd:)}, where {it:X} is an arbitrary {it:n x n} symmetric
matrix.


{title:Remarks}

{p 4 4 2}
Duplication matrices are frequently used in computing derivatives of
functions of symmetric matrices.  Section 9.5 of
L{c u:}tkepohl (1996) lists many
useful properties of duplication matrices.


{title:Conformability}

    {cmd:Dmatrix(}{it:n}{cmd:)}:
		{it:n}:    1 {it:x} 1
	   {it:result}:  {it:n}^2 {it:x n}*({it:n} + 1)/2


{title:Diagnostics}

{p 4 4 2}
{cmd:Dmatrix(}{it:n}{cmd:)} aborts with error if {it:n} is less than 0 or is
missing.  {it:n} is interpreted as {cmd:trunc(}{it:n}{cmd:)}.


{title:References}

{p 4 4 2}
L{c u:}tkepohl, H. 1996.  {it:Handbook of Matrices}. New York: Wiley.


{title:Source code}

{p 4 4 2}
{view dmatrix.mata, adopath asis:dmatrix.mata}


{title:Also see}

{p 4 13 2}
Manual:  {hi:[M-5] Dmatrix()} ({help forthcoming)}

{p 4 13 2}
Online:   
{bf:{help mf_kmatrix:[M-5] Kmatrix}}, 
{bf:{help mf_lmatrix:[M-5] Lmatrix}}, 
{bf:{help mf_vec:[M-5] vec}}, 
{bf:{help mf_vech:[M-5] vech}}; 
{bf:{help m4_standard:[M-4] standard}}
{p_end}
