{smcl}
{* *! version 1.0.3  19jun2008}{...}
{cmd:help mata kmatrix()}{right:also see:  {help forthcoming}}
{hline}
{* index commutation matrix}{...}
{* index kmatrix()}{...}
{* index vec}{...}

{title:Title}

{p 4 4 2}
{bf:[M-5] kmatrix() -- Commutation matrix}


{title:Syntax}

{p 8 12 2}
{it:real matrix}
{cmd:kmatrix(}{it:real scalar m}{cmd:,} {it:real scalar n}{cmd:)}


{title:Description}

{p 4 4 2}
{cmd:kmatrix(}{it:m}{cmd:,} {it:n}{cmd:)} 
returns the {it:mn} {it:x} {it:mn} commutation matrix {cmd:K}
for which {cmd:K}*{cmd:vec(}{it:X}{cmd:)} {cmd:=} {cmd:vec(}{it:X}{cmd:')},
where {it:X} is an {it:m x n} matrix.


{title:Remarks}

{p 4 4 2}
Commutation matrices are frequently used in computing derivatives of
functions of matrices.  Section 9.2 of L{c u:}tkepohl (1996) lists many
useful properties of commutation matrices.


{title:Conformability}

    {cmd:kmatrix(}{it:m}{cmd:,} {it:n}{cmd:)}:
		{it:m}:   1 {it:x} 1
		{it:n}:   1 {it:x} 1
	   {it:result}:  {it:mn} {it:x mn}


{title:Diagnostics}

{p 4 4 2}
{cmd:kmatrix(}{it:m}{cmd:,} {it:n}{cmd:)} aborts with error if either 
{it:m} or {it:n} is less than 0 or is missing.  {it:m} and {it:n} are
interpreted as {cmd:trunc(}{it:m}{cmd:)} and {cmd:trunc(}{it:n}{cmd:)}.


{title:References}

{p 4 4 2}
L{c u:}tkepohl, H. 1996.  {it:Handbook of Matrices}. New York: Wiley.


{title:Source code}

{p 4 4 2}
{view kmatrix.mata, adopath asis:kmatrix.mata}


{title:Also see}

{p 4 13 2}
Manual:  {hi:[M-5] kmatrix()} ({help forthcoming})

{p 4 13 2}
Online:   
{bf:{help mf_dmatrix:[M-5] Dmatrix}}, 
{bf:{help mf_lmatrix:[M-5] Lmatrix}}, 
{bf:{help mf_vec:[M-5] vec}}; 
{bf:{help m4_standard:[M-4] standard}}
{p_end}
