{smcl}
{* *! version 1.0.2  29may2008}{...}
{cmd:help mata Lmatrix()}{right:also see:  {help forthcoming}}
{hline}
{* index elimination matrix}{...}
{* index Lmatrix()}{...}
{* index vec}{...}
{* index vech}{...}

{title:Title}

{p 4 4 2}
{bf:[M-5] Lmatrix() -- Elimination matrix}


{title:Syntax}

{p 8 12 2}
{it:real matrix}
{cmd:Lmatrix(}{it:real scalar n}{cmd:)}


{title:Description}

{p 4 4 2}
{cmd:Lmatrix(}{it:n}{cmd:)} returns the 
{it:n}({it:n}+1)/2 {it:x} {it:n}^2 elimination matrix {cmd:L}
for which {cmd:L}*{cmd:vec(}{it:X}{cmd:)} {cmd:=} {cmd:vech(}{it:X}{cmd:)},
where {it:X} is an {it:n x n} symmetric matrix.


{title:Remarks}

{p 4 4 2}
Elimination matrices are frequently used in computing derivatives of
functions of symmetric matrices.  Section 9.6 of
L{c u:}tkepohl (1996) lists many
useful properties of elimination matrices.


{title:Conformability}

    {cmd:Lmatrix(}{it:n}{cmd:)}:
		{it:n}:         1 {it:x} 1
	   {it:result}:  {it:n}({it:n}+1)/2 {it:x n}^2


{title:Diagnostics}

{p 4 4 2}
{cmd:Lmatrix(}{it:n}{cmd:)} aborts with error if 
{it:n} is less than 0 or is missing.  {it:n} is
interpreted as {cmd:trunc(}{it:n}{cmd:)}.


{title:References}

{p 4 4 2}
L{c u:}tkepohl, H. 1996.  {it:Handbook of Matrices}. New York: Wiley.


{title:Source code}

{p 4 4 2}
{view lmatrix.mata, adopath asis:lmatrix.mata}


{title:Also see}

{p 4 13 2}
Manual:  {hi:[M-5] Lmatrix()} ({help forthcoming})

{p 4 13 2}
Online:   
{bf:{help mf_dmatrix:[M-5] Dmatrix}}, 
{bf:{help mf_kmatrix:[M-5] Kmatrix}}, 
{bf:{help mf_vec:[M-5] vec}}, 
{bf:{help mf_vech:[M-5] vech}}; 
{bf:{help m4_standard:[M-4] standard}}
{p_end}
