{smcl}
{* *! version 1.0.3  11apr2008}{...}
{cmd:help mata mindouble()}
{hline}
{* index mindouble()}{...}
{* index maxdouble()}{...}
{* index smallestdouble()}{...}

{title:Title}

{p 4 8 2}
{bf:[M-5] mindouble() -- Minimum and maximum nonmissing value}


{title:Syntax}

{p 8 8 2}
{it:real scalar}
{cmd:mindouble()}

{p 8 8 2}
{it:real scalar}
{cmd:maxdouble()}

{p 8 8 2}
{it:real scalar}
{cmd:smallestdouble()}


{title:Description}

{p 4 4 2}
{cmd:mindouble()} returns the largest negative, nonmissing value.

{p 4 4 2}
{cmd:maxdouble()} returns the largest positive, nonmissing value.

{p 4 4 2}
{cmd:smallestdouble()} returns the smallest full-precision value of {it:e},
{it:e}>0.  The largest full-precision value of {it:e}, {it:e}<0 is
{cmd:-smallestdouble()}.  


{title:Remarks}

{p 4 4 2}
All nonmissing values {it:x} fulfill 

	{cmd:mindouble()} <= {it:x} <= {cmd:maxdouble()}.

{p 4 4 2}
All missing values {it:m} fulfill

	{it:m} > {cmd:maxdouble()}

{p 4 4 2}
Missing values also fulfill 

	{it:m} >= {cmd:.}

{p 4 4 2}
On all computers on which Stata and Mata are currently implemented -- 
which are computers following IEEE standards -- 

                                 exact                  approximate
	function             hexadecimal value         decimal value
	{hline 60}
	{cmd:mindouble()}        -1.fffffffffffffX+3ff        -1.7977e+308
	{cmd:smallestdouble()}   +1.0000000000000X-3fe         2.2251e-308
	{cmd:epsilon(1)}         +1.0000000000000X-034         2.2205e-016
	{cmd:maxdouble()}        +1.fffffffffffffX+3fe         8.9885e+307
	{hline 60}

{p 4 4 2}
The smallest missing value ({cmd:.} < {cmd:.a} < ... < {cmd:.z})
is +1.0000000000000X+3ff.

{p 4 4 2}
Do not confuse {cmd:smallestdouble()} with the more interesting value 
{cmd:epsilon(1)}.  {cmd:smallestdouble()} is the smallest full-precision value of {it:e},
{it:e}>0.  {cmd:epsilon(1)} is the smallest value of {it:e}, {it:e}+1>1;
see {bf:{help mf_epsilon:[M-5] epsilon()}}.


{title:Conformability}

    {cmd:mindouble()}, {cmd:maxdouble()}, {cmd:smallestdouble()}:
	   {it:result}:  1 {it:x} 1


{title:Diagnostics}

{p 4 4 2}
None.


{title:Source code}

{p 4 4 2}
Functions are built in.


{title:Also see}

{p 4 13 2}
Manual:  {hi:[M-5] mindouble()}

{p 4 13 2}
Online:   
{bf:{help mf_epsilon:[M-5] epsilon()}};
{bf:{help m4_utility:[M-4] utility}}
{p_end}
