{smcl}
{* *! version 1.1.12  31jul2007}{...}
{cmd:help mlogit}{right:dialogs:  {bf:{dialog mlogit}}  {dialog mlogit, message(-svy-) name(svy_mlogit):svy: mlogit}{space 2}}
{right:also see:  {help mlogit postestimation}}
{hline}

{title:Title}

{p2colset 5 19 21 2}{...}
{p2col :{hi:[R] mlogit} {hline 2}}Multinomial (polytomous) logistic
regression{p_end}
{p2colreset}{...}


{title:Syntax}

{p 8 15 2}
{cmdab:mlog:it}
{depvar}
[{indepvars}]
{ifin}
{weight}
[{cmd:,} {it:options}]

{synoptset 22 tabbed}{...}
{synopthdr}
{synoptline}
{syntab :Main}
{synopt :{opt noc:onstant}}suppress constant term{p_end}
{synopt :{opt b:aseoutcome(#)}}value of {depvar} that will be the base outcome{p_end}
{synopt :{cmdab:c:onstraints(}{it:{help mlogit##clist:clist}}{cmd:)}}apply specified linear constraints{p_end}
{synopt:{opt col:linear}}keep collinear variables{p_end}

{syntab :SE/Robust}
{synopt :{opth vce(vcetype)}}{it:vcetype} may be {opt oim},
   {opt r:obust}, {opt cl:uster} {it:clustvar}, {opt boot:strap}, or
   {opt jack:knife}{p_end}

{syntab :Reporting}
{synopt :{opt l:evel(#)}}set confidence level; default is
{cmd:level(95)}{p_end}
{synopt :{opt rr:r}}report relative-risk ratios{p_end}

{syntab :Max options}
{synopt :{it:{help mlogit##maximize_options:maximize_options}}}control the
maximization process; seldom used{p_end}
{synoptline}
{p2colreset}{...}
{p 4 6 2}{marker clist}
where {it:clist} has the form
{it:#}[{cmd:-}{it:#}][{cmd:,}{it:#}[{cmd:-}{it:#}] {it:...} ]{p_end}
{p 4 6 2}
{opt bootstrap}, {opt by}, {opt jackknife}, {opt rolling}, {opt statsby},
{opt svy}, and {cmd:xi} are allowed; see {help prefix}.{p_end}
{p 4 6 2}Weights are not allowed with the {helpb bootstrap} prefix.{p_end}
{p 4 6 2}
{opt vce()} and weights are not allowed with the {helpb svy} prefix.
{p_end}
{p 4 6 2}
{opt fweight}s, {opt iweight}s, and {opt pweight}s are allowed;
see {help weight}.{p_end}
{p 4 6 2}
See {manhelp mlogit_postestimation R:mlogit postestimation} for features
available after estimation.{p_end}


{title:Description}

{pstd}
{opt mlogit} fits maximum-likelihood multinomial logit models, also
known as polytomous logistic regression.  You can define constraints to
perform constrained estimation.  Some people refer to conditional logistic
regression as multinomial logit.  If you are one of them, see
{manhelp clogit R}.

{pstd}
See {help logistic estimation commands} for a list of related estimation
commands.

{pstd}
The model can have a maximum of 50 outcomes with Stata/MP, Stata/SE, or
Stata/IC and 20 outcomes with Small Stata.


{title:Options}

{dlgtab:Model}

{phang}
{opt noconstant}; see
{helpb estimation options##noconstant:[R] estimation options}.

{phang}
{opt baseoutcome(#)} specifies the value of {depvar}
to be treated as the base outcome.  The default is to choose the most
frequent outcome.

{phang}
{cmd:constraints(}{it:{help mlogit##clist:clist}}{cmd:)},
{opt collinear}; see
{helpb estimation options:[R] estimation options}.

{dlgtab:SE/Robust}

INCLUDE help vce_asymptall

{pmore}
If specifying {cmd:vce(bootstrap)} or {cmd:vce(jackknife)}, you must also
specify {cmd:baseoutcome()}.

{dlgtab:Reporting}

{phang}
{opt level(#)}; see
{helpb estimation options##level():[R] estimation options}.

{phang}
{opt rrr} reports the estimated coefficients transformed to relative-risk
ratios, i.e., exp(b) rather than b.  Standard errors and confidence intervals
are similarly transformed.  This option affects how results are displayed, not
how they are estimated.  {opt rrr} may be specified at estimation or when
replaying previously estimated results.

{marker maximize_options}{...}
{dlgtab:Max options}

{phang}
{it:maximize_options}:
{opt iter:ate(#)},
[{cmdab:no:}]{opt lo:g},
{opt tr:ace},
{opt tol:erance(#)},
{opt ltol:erance(#)}, 
{opt nrtol:erance(#)},
{opt nonrtol:erance};
see {manhelp maximize R}.  These options are seldom used.


{title:Examples}

{pstd}Setup{p_end}
{phang2}{cmd:. webuse sysdsn3}{p_end}

{pstd}Fit multinomial logistic regression model{p_end}
{phang2}{cmd:. mlogit insure age male nonwhite site2 site3}{p_end}

{pstd}Same as above, but use 2 as the base outcome{p_end}
{phang2}{cmd:. mlogit insure age male nonwhite site2 site3, base(2)}{p_end}

{pstd}Replay, reporting relative-risk ratios{p_end}
{phang2}{cmd:. mlogit, rrr}{p_end}

{pstd}Setup{p_end}
{phang2}{cmd:. constraint 1 [Uninsure]}{p_end}
{phang2}{cmd:. constraint 2 [Prepaid]: site2 site3}{p_end}

{pstd}Fit multinomial logistic regression model with constraints{p_end}
{phang2}{cmd:. mlogit insure age male nonwhite site2 site3, constraint(1)}{p_end}
{phang2}{cmd:. mlogit insure age male nonwhite site2 site3, constraint(2)}{p_end}
{phang2}{cmd:. mlogit insure age male nonwhite site2 site3, constraint(1-2)}


{title:Saved results}

{pstd}
{cmd:mlogit} saves the following in {cmd:e()}:

{synoptset 20 tabbed}{...}
{p2col 5 20 24 2: Scalars}{p_end}
{synopt:{cmd:e(N)}}number of observations{p_end}
{synopt:{cmd:e(k_out)}}number of outcomes{p_end}
{synopt:{cmd:e(k_eq_model)}}number of equations in model Wald test{p_end}
{synopt:{cmd:e(df_m)}}model degrees of freedom{p_end}
{synopt:{cmd:e(r2_p)}}pseudo-R-squared{p_end}
{synopt:{cmd:e(ll)}}log likelihood{p_end}
{synopt:{cmd:e(ll_0)}}log likelihood, constant-only model{p_end}
{synopt:{cmd:e(N_clust)}}number of clusters{p_end}
{synopt:{cmd:e(chi2)}}chi-squared{p_end}
{synopt:{cmd:e(ibaseout)}}base outcome number{p_end}
{synopt:{cmd:e(baseout)}}the value of {it:depvar} to be treated as the base
	outcome{p_end}

{synoptset 20 tabbed}{...}
{p2col 5 20 24 2: Macros}{p_end}
{synopt:{cmd:e(cmd)}}{cmd:mlogit}{p_end}
{synopt:{cmd:e(cmdline)}}command as typed{p_end}
{synopt:{cmd:e(depvar)}}name of dependent variable{p_end}
{synopt:{cmd:e(wtype)}}weight type{p_end}
{synopt:{cmd:e(wexp)}}weight expression{p_end}
{synopt:{cmd:e(title)}}title in estimation output{p_end}
{synopt:{cmd:e(clustvar)}}name of cluster variable{p_end}
{synopt:{cmd:e(baselab)}}value label corresponding to base outcome{p_end}
{synopt:{cmd:e(eqnames)}}names of equations{p_end}
{synopt:{cmd:e(chi2type)}}{cmd:Wald} or {cmd:LR}; type of model chi-squared
	test{p_end}
{synopt:{cmd:e(vce)}}{it:vcetype} specified in {cmd:vce()}{p_end}
{synopt:{cmd:e(vcetype)}}title used to label Std. Err.{p_end}
{synopt:{cmd:e(crittype)}}optimization criterion{p_end}
{synopt:{cmd:e(properties)}}{cmd:b V}{p_end}
{synopt:{cmd:e(footnote)}}program used to implement the footnote display{p_end}
{synopt:{cmd:e(predict)}}program used to implement {cmd:predict}{p_end}

{synoptset 20 tabbed}{...}
{p2col 5 20 24 2: Matrices}{p_end}
{synopt:{cmd:e(b)}}coefficient vector{p_end}
{synopt:{cmd:e(out)}}outcome values{p_end}
{synopt:{cmd:e(V)}}variance-covariance matrix of the estimators{p_end}

{synoptset 20 tabbed}{...}
{p2col 5 20 24 2: Functions}{p_end}
{synopt:{cmd:e(sample)}}marks estimation sample{p_end}
{p2colreset}{...}


{title:Also see}

{psee}
Manual:  {bf:[R] mlogit}

{psee}
Online:  {manhelp mlogit_postestimation R:mlogit postestimation};{break}
{manhelp clogit R},
{manhelp logistic R},
{manhelp logit R},
{manhelp mprobit R},
{manhelp nlogit R},
{manhelp ologit R},
{manhelp rologit R},
{manhelp slogit R}
{manhelp svy_estimation SVY:svy estimation}
{p_end}
