{smcl}
{* *! version 1.0.9  20nov2008}{...}
{cmd:help nbreg postestimation}{...}
{right:dialogs:  {dialog nbreg_p:nbreg predict} }
{right:{dialog gnbreg_p:gnbreg predict}}
{right:also see:  {helpb nbreg}         }
{hline}

{title:Title}

{p2colset 5 33 35 2}{...}
{p2col :{hi:[R] nbreg postestimation} {hline 2}}Postestimation tools for nbreg and gnbreg{p_end}
{p2colreset}{...}


{title:Description}

{pstd}
The following postestimation commands are available for {cmd:nbreg} and
{cmd:gnbreg}:

{synoptset 13 notes}{...}
{p2coldent :command}description{p_end}
{synoptline}
INCLUDE help post_adjust2par
INCLUDE help post_estat
INCLUDE help post_svy_estat
INCLUDE help post_estimates
INCLUDE help post_lincom
{p2coldent:(2) {helpb linktest}}link test for model specification{p_end}
{p2coldent:(3) {helpb lrtest}}likelihood-ratio test{p_end}
INCLUDE help post_mfx
INCLUDE help post_nlcom
{synopt :{helpb nbreg postestimation##predict:predict}}predictions, residuals, influence statistics, and other diagnostic measures{p_end}
INCLUDE help post_predictnl
INCLUDE help post_suest
INCLUDE help post_test
INCLUDE help post_testnl
{synoptline}
{p2colreset}{...}
{p 4 6 2}(1) {cmd:adjust} is not appropriate with time-series operators.{p_end}
{p 4 6 2}
(2) {cmd:linktest} is not available with {cmd:svy} estimation results.
{p_end}
{p 4 6 2}
(3) {cmd:lrtest} is not appropriate with {cmd:svy} estimation results.
{p_end}


{marker predict}{...}
{title:Syntax for predict}

{p 8 16 2}
{cmd:predict} {dtype} {newvar} {ifin} [{cmd:,} {it:statistic} 
{opt nooff:set}]

{p 8 16 2}
{cmd:predict} {dtype} {c -(}{it:stub*}{c |}{it:newvar_reg}
 {it:newvar_disp}{c )-}
 {ifin} {cmd:,} {opt sc:ores}

{synoptset 11 tabbed}{...}
{synopthdr :statistic}
{synoptline}
{syntab :Main}
{synopt :{cmd:n}}number of events; the default{p_end}
{synopt :{cmd:ir}}incidence rate (equivalent to {cmd:predict} ..., {cmd:n nooffset}){p_end}
{synopt :{cmd:xb}}linear prediction{p_end}
{synopt :{cmd:stdp}}standard error of the linear prediction{p_end}
{synoptline}
{p2colreset}{...}

{pstd}
In addition, relevant only after {cmd:gnbreg} are

{synoptset 11 tabbed}{...}
{synopthdr :statistic}
{synoptline}
{syntab :Main}
{synopt :{opt a:lpha}}predicted values of alpha{p_end}
{synopt :{opt lna:lpha}}predicted values of ln(alpha){p_end}
{synopt :{opt stdpl:na}}standard error of predicted ln(alpha){p_end}
{synoptline}
{p2colreset}{...}

INCLUDE help esample


{title:Options for predict}

{dlgtab:Main}

{phang}
{opt n}, the default, calculates the predicted number of events, which
is exp(xb) if neither {opth offset:(varname:varname_o)}
nor {opt exposure(varname_e)}
was specified when the model was fitted; exp(xb + offset) if
{opt offset()} was specified; or exp(xb)*exposure if {opt exposure()} was
specified.

{phang}
{opt ir} calculates the incidence rate exp(xb), the predicted number
of events when exposure is 1.  This is equivalent to specifying both
{opt n} and {opt nooffset} options.

{phang}
{opt xb} calculates the linear prediction.

{phang}
{opt stdp} calculates the standard error of the linear prediction.

{phang}
{opt alpha}, {opt lnalpha}, and {opt stdplna} are relevant after {cmd:gnbreg}
estimation only; they produce the predicted values of alpha or ln(alpha) and
the standard error of the predicted ln(alpha), respectively.

{phang}
{opt nooffset} is relevant only if you specified {opt offset()} or
{opt exposure()} when you fitted the model.  It modifies the
calculations made by {cmd:predict} so that they ignore the
offset or exposure variable; the linear prediction is treated as xb rather
than as xb + offset or xb + ln(exposure_j).  Specifying {cmd:predict}
...{cmd:,} {opt nooffset} is equivalent to specifying {cmd:predict} ...{cmd:,}
{opt ir}.

{phang}
{opt scores} calculates equation-level score variables.

{pmore}
The first new variable will contain the derivative of the log likelihood with
respect to the regression equation.

{pmore}
The second new variable will contain the derivative of the log likelihood with
respect to the dispersion equation.


{title:Examples}

{pstd}Setup{p_end}
{phang2}{cmd:. webuse rod93}{p_end}
{phang2}{cmd:. tab cohort, gen(coh)}{p_end}
{phang2}{cmd:. nbreg deaths coh2 coh3, exposure(exp)}{p_end}

{pstd}Test that coefficients of {cmd:coh2} and {cmd:coh3} are 0{p_end}
{phang2}{cmd:. test coh2 coh3}{p_end}

{pstd}Predict number of events{p_end}
{phang2}{cmd:. predict count}{p_end}

{pstd}Predict incidence rate{p_end}
{phang2}{cmd:. predict rate, ir}


{title:Also see}

{psee}
Manual:  {bf:[R] nbreg postestimation}

{psee}
Online:  {manhelp nbreg R}
{p_end}
