{smcl}
{* *! version 1.0.6  14jan2009}{...}
{cmd:help nlsur postestimation}{right:dialog:  {bf:{dialog nlsur_p:predict}}}
{right:also see:  {helpb nlsur} {space 1}}
{hline}

{title:Title}

{p2colset 5 33 35 2}{...}
{p2col :{hi:[R] nlsur postestimation} {hline 2}}Postestimation tools for nlsur{p_end}
{p2colreset}{...}


{title:Description}

{pstd}
The following postestimation commands are available for {cmd:nlsur}:

{synoptset 11}{...}
{p2coldent :command}description{p_end}
{synoptline}
{synopt :{helpb estat}}AIC*, BIC*, VCE, and estimation sample summary{p_end}
INCLUDE help post_estimates
INCLUDE help post_lincom
{synopt :{helpb lrtest}*}likelihood-ratio test{p_end}
INCLUDE help post_mfx
INCLUDE help post_nlcom
{synopt :{helpb nlsur postestimation##predict:predict}}predictions and residuals{p_end}
INCLUDE help post_predictnl
INCLUDE help post_test
INCLUDE help post_testnl
{synoptline}
{p2colreset}{...}
{p 4 6 2}
* The AIC, BIC, and likelihood-ratio tests are available only if {opt ifgnls} was used with {cmd:nlsur}.


{marker predict}{...}
{title:Syntax for predict}

{p 8 16 2}
{cmd:predict} 
{dtype} 
{newvar} 
{ifin}
[{cmd:,} {opt eq:uation}{cmd:(#}{it:eqno}{cmd:)}
{opt y:hat} {opt r:esiduals}]

INCLUDE help esample


{title:Options for predict}

{dlgtab:Main}

{phang}
{cmd:equation(#}{it:eqno}{cmd:)} specifies to which equation you 
are referring.  {cmd:equation(#1)} would mean the calculation is to be 
made for the first equation, {cmd:equation(#2)} would mean the second, 
and so on.  If you do not specify {opt equation()}, results are the same 
as if you specified {cmd:equation(#1)}.

{phang}
{opt yhat}, the default, calculates the fitted values for the specified
equation.

{phang}
{opt residuals} calculates the residuals for the specified equation.


{title:Examples}

{pstd}Setup{p_end}
{phang2}{cmd:. sysuse auto}{p_end}
{phang2}{cmd:. nlsur (mpg = {b0} + {b1} / turn) (gear_ratio = {c0} + {c1}*length)}{p_end}

{pstd}Calculate fitted values for the first equation{p_end}
{phang2}{cmd:. predict mpghat, equation(#1)}{p_end}

{pstd}Calculate residuals for the second equation{p_end}
{phang2}{cmd:. predict gearerr, residuals equation(#2)}{p_end}


{title:Also see}

{psee}
Manual:  {bf:[R] nlsur postestimation}

{psee}
Online:  {manhelp nlsur R}
{p_end}
