*! version 2.0.1  01feb2008
program notes
	version 10

	if (`"`0'"' == "") {
		notelist 
		exit
	}

	gettoken one rest : 0, parse(" :")
	if (`"`one'"' == substr("list", 1, max(1,strlen(`"`one'"')))) {
		notelist `rest'
		exit
	}
	if (`"`one'"' == "drop") { 
		notedrop `rest'
		exit
	}

	if (`"`one'"'==":") {
		noteadd _dta: `rest'
		exit
	}
	gettoken two rest : rest, parse(" :")
	if (`"`two'"' == ":") {
		noteadd `one' : `rest'
		exit
	}
	notelist `0'
end

program noteadd /* <name> : ... */
	gettoken name 0 : 0, parse(" :")
	if (`"`name'"' != "_dta") { 
		getvarname name : `name'
	}

	gettoken colon 0 : 0, parse(" :")
	if (`"`colon'"' != ":") { 
		error 198
	}
	mata: trimmacro("0")
	if (`"`0'"' == "") { 
		di as txt "  (no note added)"
		exit
	}
	local n : char `name'[note0]
	cap confirm integer number `n'
	if _rc { 
		local n 1
	}
	else {
		local ++n
		if (`n'>9999) { 
			di as err "too many notes"
			exit 103
		}
	}

	local ts = substr("$S_DATE $S_TIME", 1, 17)
	local text : subinstr local 0 "TS" "`ts'", all word

	nobreak { 
		char `name'[note0] `n'
		char `name'[note`n'] `"`text'"'
	}
end

program notelist /* [evarlist] [in ...] */
	parsenotesyntax haslist hasin list in1 in2 : `"`0'"'
	foreach name of local list {
		notelist_u `name' `in1' `in2'
	}
end


program notedrop
	parsenotesyntax haslist hasin list in1 in2 : `"`0'"'
/*
	di as txt `"haslist `haslist'"'
	di as txt `"hasin   `hasin'"'
	di as txt `"list   |`list'|"'
	di as txt `"in1     `in1'"'
	di as txt `"in2     `in2'"'
*/

	if (`haslist'==0) { 
		error 198
	}

	local N 0
	foreach name of local list {
		notedrop_u n : `name' `in1' `in2'
		local N = `N' + `n'
	}
	local note = cond(`n'==1, "note", "notes")
	di as txt "  (`n' `note' dropped)"
end


program parsenotesyntax
	args haslist hasin list in1 in2 colon rest

	mata: splitstring("rawlist", "rawin", "rest")
	if "`rawlist'" == "" { 
		c_local `haslist' 0
		local 0 _all
		syntax varlist 
		c_local `list' _dta `varlist'
	}
	else {
		c_local `haslist' 1
		local 0 `rawlist'
		nobreak {
			cap gen byte _dta_ = 1 
			cap noi syntax varlist
			local rc = _rc 
			cap drop _dta_
		}
		if (`rc') { 
			exit `rc'
		}
		c_local `list' `varlist'
	}

	if (`"`rawin'"'=="") {
		c_local `hasin' 0
		c_local `in1' 1
		c_local `in2' 9999
		exit
	}

	c_local `hasin' 1 
	gettoken el rest : rawin, parse(" /")
	isvalidel r1 : `"`el'"'
	gettoken el rest : rest, parse(" /") 
	if (`"`el'"'=="") { 
		c_local `in1' `r1'
		c_local `in2' `r1'
		exit
	}
	if (`"`el'"'=="/") { 
		gettoken el rest : rest, parse(" /")
		isvalidel r2 : `"`el'"'
		if (`r1'<=`r2') {
			gettoken el rest : rest, parse(" /")
			if "`el'"=="" { 
				c_local `in1' `r1'
				c_local `in2' `r2'
				exit
			}
		}
	}
	di as err `"in `rawin':  invalid"'
	exit 198
end



program getvarname
	gettoken dest 0  : 0, parse(" :")
	gettoken colon 0 : 0, parse(" :")
	if (`"`colon'"' != ":") { 
		error 198
	}
	syntax varname
	c_local `dest' `varlist'
end


program notedrop_u
	args n colon name in1 in2
	if ("`name'"=="_dta_") { 
		local name "_dta"
	}
	/* di as txt "name=|`name'| in1=`in1' in2=`in2'" */
	firstlastnote i1 i2 : `name' `in1' `in2'
	/* di as txt "name=|`name'| i1=`i1' i2=`i2'" */

	if (`i1' < 0) {
		c_local n 0 
		exit
	}


	local dropped 0
	forvalues i=`i1'/`i2' { 
		local thenote : char `name'[note`i']
		if (`"`thenote'"' != "") {
			char `name'[note`i']
			local ++dropped
		}
	}
	c_local `n' `dropped'

	actuallastnote N : `name'
	if (`N') {
		char `name'[note0] `N'
	}
	else { 
		char `name'[note0]
	}
end



program isvalidel
	args res colon el 
	if (`"`el'"' == "f" | `"`el'"'=="F") { 
		c_local `res' 1
		exit
	}
	if (`"`el'"' == "l" | `"`el'"'=="L") { 
		c_local `res' 10000
		exit
	}
	cap confirm integer number `el'
	if _rc==0 { 
		if (`el'>=1 & `el'<=9999) { 
			c_local `res' `el'
			exit
		}
	}
	di as err `"`el':  invalid range element"'
	exit 198
end

program notelist_u
	args name i1 i2

	if ("`name'" == "_dta_") {
		local name "_dta"
	}

	local n : char `name'[note0]
	cap confirm number `n'
	if _rc { 
		exit
	}

	local n = min(`n', `i2')
	if (`i1'>`n') { 
		exit
	}

	local j -1
	forvalues i=`i1'/`n' { 
		local thenote : char `name'[note`i']
		if (`"`thenote'"' != "") {
			local j `i'
			continue, break
		}
	}
	if (`j'==-1) { 
		exit
	}

	di as txt
	di as res "`name':"
	forvalues i=`j'/`n' {
		local thenote : char `name'[note`i']
		if (`"`thenote'"' != "") {
			local k = strlen("`i'")
			local p0 = max(3-`k', 0)
			local p1 = cond(`k'>3, 7, 6)
			di as txt "{p `p0' `p1'}"
			di as txt "`i'."
			di as txt `"`thenote'"'
			di as txt "{p_end}"
		}
	}
end


program firstlastnote 
	args first last colon name i1 i2

	local n : char `name'[note0]
	if ("`n'"=="") { 
		c_local `first' -1
		c_local `last'   0
		exit
	}

	local n = min(`i2', `n')
	c_local `last' `n'
	if (`i1'==10000) {
		local i1 `n'
	}

	local j -1
	forvalues i=`i1'/`n' {
		local thenote : char `name'[note`i']
		if (`"`thenote'"' != "") {
			local j `i'
			continue, break 
		}
	}
	c_local `first' `j'
end

program actuallastnote
	args last colon name

	local n : char `name'[note0]
	if "`n'"=="" {
		c_local `last' 0
		exit 
	}
	local j 0
	forvalues i = `n'(-1)1 { 
		local thenote : char `name'[note`i']
		if (`"`thenote'"' != "") {
			local j `i'
			continue, break
		}
	}
	c_local `last' `j'
end


version 10
local SS	string scalar
local RS	real scalar
mata:

void splitstring(`SS' lname, `SS' rname, `SS' strname)
{
	`SS' 	str
	`RS'	p

	str = " " + strtrim(st_local(strname)) + " "
	if (p   = strpos(str, " in ")) { 
		st_local(lname, strtrim(substr(str, 1, p-1)))
		st_local(rname, strtrim(substr(str, p+4, .)))
	}
	else {
		st_local(lname, strtrim(str))
		st_local(rname, "")
	}
}

void trimmacro(`SS' mname)
{
	st_local(mname, strtrim(st_local(mname)))
}
end
