{smcl}
{* *! version 1.0.9  22nov2008}{...}
{cmd:help ologit postestimation}{right:dialog:  {bf:{dialog ologit_p:predict}}}
{right:also see:  {helpb ologit}{space 1}}
{hline}

{title:Title}

{p2colset 5 34 36 2}{...}
{p2col :{hi:[R] ologit postestimation} {hline 2}}Postestimation tools for
ologit{p_end}
{p2colreset}{...}


{title:Description}

{pstd}
The following postestimation commands are available for {opt ologit}:

{synoptset 13 notes}{...}
{p2coldent :command}description{p_end}
{synoptline}
INCLUDE help post_adjust2
INCLUDE help post_estat
INCLUDE help post_svy_estat
INCLUDE help post_estimates
INCLUDE help post_lincom
{p2coldent:(1) {helpb linktest}}link test for model specification{p_end}
{p2coldent:(2) {helpb lrtest}}likelihood-ratio test{p_end}
INCLUDE help post_mfx
INCLUDE help post_nlcom
{synopt :{helpb ologit postestimation##predict:predict}}predictions, residuals, influence statistics, and other diagnostic measures{p_end}
INCLUDE help post_predictnl
INCLUDE help post_suest
INCLUDE help post_test
INCLUDE help post_testnl
{synoptline}
{p2colreset}{...}
{p 4 6 2}
(1) {cmd:linktest} is not available with {cmd:svy} estimation results.
{p_end}
{p 4 6 2}
(2) {cmd:lrtest} is not appropriate with {cmd:svy} estimation results.
{p_end}


{marker predict}{...}
{title:Syntax for predict}

{p 8 16 2}
{cmd:predict}
{dtype}
{it:{help newvar:newvars}}
{ifin}
[{cmd:,} {it:statistic}
{opt o:utcome(outcome)} {opt nooff:set}]

{p 8 16 2}
{cmd:predict}
{dtype}
{c -(}{it:stub*}{c |}{it:newvar_reg}
{it:newvar_k1}
... {it:newvar_kk-1}{c )-}
{ifin}
{cmd:,}
{opt sc:ores}

{pstd}
where k is the number of outcomes in the model.

{synoptset 11 tabbed}{...}
{synopthdr :statistic}
{synoptline}
{syntab :Main}
{synopt :{opt p:r}}predicted probabilities; the default{p_end}
{synopt :{opt xb}}linear prediction{p_end}
{synopt :{opt stdp}}standard error of the linear prediction{p_end}
{synoptline}
{p2colreset}{...}
{p 4 6 2}
With the {opt pr} option, you specify  one or k new variables
depending on whether the {opt outcome()} option is also specified.
With {opt xb} and {opt stdp}, one new variable is specified.
{p_end}
INCLUDE help esample


{title:Options for predict}

{dlgtab:Main}

{phang}
{opt pr}, the default, calculates the predicted probabilities.
If you do not also specify the {opt outcome()} option, you must specify
k new variables, where k is the number of categories of the
dependent variable.  Say that you fitted a model by typing
{cmd:ologit result x1 x2}, and {opt result} takes on three values.
Then you could type {cmd:predict p1 p2 p3} to obtain all three predicted
probabilities.  If you specify the {opt outcome()} option, you must specify
one new variable.  Say that {opt result} takes on the values 1, 2, and 3.
Typing {cmd:predict p1, outcome(1)} would produce the same {opt p1}.

{phang}
{opt xb} calculates the linear prediction.  You specify one new
variable, for example, {cmd:predict linear, xb}.  The linear prediction is
defined, ignoring the contribution of the estimated cutpoints.

{phang}
{opt stdp} calculates the standard error of the linear prediction.  You
specify one new variable, for example, {cmd:predict se, stdp}.

{phang}
{opt outcome(outcome)} specifies for which outcome the predicted probabilities
are to be calculated.  {opt outcome()} should contain either one value of
the dependent variable or one of {opt #1}, {opt #2}, {it:...}, with {opt #1}
meaning the first category of the dependent variable, {opt #2} the second
category, etc.

{phang}
{opt nooffset} is relevant only if you specified {opth offset(varname)} for
{opt ologit}.  It modifies the calculations made by {opt predict} so that they
ignore the offset variable; the linear prediction is treated as xb rather than
as xb + offset.

{phang}
{opt scores} calculates equation-level score variables.  The number of score
variables created will equal the number of outcomes in the model.  If the
number of outcomes in the model were k, then

{pmore}
The first new variable will contain the derivative of the log likelihood with
respect to the regression equation.

{pmore}
The other new variables will contain the derivative of the log likelihood with
respect to the cutpoints.


{title:Examples}

{pstd}Setup{p_end}
{phang2}{cmd:. webuse fullauto}{p_end}
{phang2}{cmd:. ologit rep77 foreign length mpg}{p_end}

{pstd}Predicted probabilities{p_end}
{phang2}{cmd:. predict poor fair avg good exc}{p_end}


{title:Also see}

{psee}
Manual:  {bf:[R] ologit postestimation}

{psee}
Online:  {manhelp ologit R}
{p_end}
