{smcl}
{* *! version 1.0.7  13may2008}{...}
{cmd:help pict_options}
{hline}
{* index exporting graphs}{...}
{* index PICT format}{...}
{* index Macintosh PICT format}{...}

{title:Title}

{p2colset 5 25 27 2}{...}
{p2col :{hi:[G] {it:pict_options}} {hline 2}}Options for exporting or printing to Macintosh PICT{p_end}
{p2colreset}{...}


{title:Syntax}

{p2colset 9 30 32 2}{...}
{p2col:{it:pict_options}}
	description{p_end}
{p2line}
{p2col:{cmd:mag(}{it:#}{cmd:)}}
        magnification/shrinkage factor; default is 100{p_end}
{p2col:{cmdab:font:face:(}{it:fontname}{cmd:)}}
	font to use{p_end}
{p2line}
{p2colreset}{...}

{pstd}
Current default values may be listed by typing

	{bf:. {stata graph set pict}}

{pstd}
and default values may be set by typing

{p 8 16 2}
{cmd:.} {helpb graph set}
{cmd:pict}
{it:name}
{it:value}

{pstd}
where {it:name} is the name of a {it:pict_option}, omitting the
parentheses.


{title:Description}

{pstd}
These {it:pict_options} are used with {cmd:graph} {cmd:export}
when creating a PICT file; see {manhelp graph_export G:graph export}.


{title:Options}

{phang}
{cmd:mag(}{it:#}{cmd:)}
    specifies that the graph be drawn smaller or larger than the default.
    {cmd:mag(100)} is the default, meaning ordinary size.
    {cmd:mag(110)} would make the graph 10% larger than usual, and
    {cmd:mag(90)} would make the graph 10% smaller than usual.
    {it:#} must be an integer.

{phang}
{cmd:fontface(}{it:fontname}{cmd:)}
    specifies the name of the PostScript font to be used to render text.
    If {it:fontname} contains blanks, {it:fontname} must be enclosed in
    double quotes.


{title:Remarks}

{pstd}
Remarks are presented under the following headings:

	{help pict_options##remarks1:Using the pict_options}
	{help pict_options##remarks2:Setting defaults}


{marker remarks1}{...}
{title:Using the pict_options}

{pstd}
You have drawn a graph and wish to create a PICT file.  You wish,
however, to change the text from Helvetica to Roman, which is "Times" in
PICT jargon:

	{cmd:. graph} ...{col 50}(draw a graph)

	{cmd:. graph export myfile.pict, fontface(Times)}


{marker remarks2}{...}
{title:Setting defaults}

{pstd}
If you always wanted {cmd:graph} {cmd:export} to use Times when exporting
to PICT files, you could type

	{cmd:. graph set pict fontface Times }

{pstd}
Later you could type

	{cmd:. graph set pict fontface Helvetica}

{pstd}
to set it back.  You can list the {it:pict_option} settings
for PICT by typing

	{cmd:. graph set pict}


{title:Also see}

{psee}
Manual:  {bf:[G] {it:pict_options}}

{psee}
Online:  
{manhelp graph_export G:graph export},
{manhelp graph_set G:graph set}
{p_end}
