{smcl}
{* *! version 1.0.5  13may2008}{...}
{cmd:help pr_options}
{hline}
{* index printing graphs}{...}
{* index graph print tt}{...}
{* index graph set tt}{...}

{title:Title}

{p2colset 5 23 25 2}{...}
{p2col :{hi:[G] {it:pr_options}} {hline 2}}Options for use with graph print{p_end}
{p2colreset}{...}


{title:Syntax}

{p2colset 9 40 42 2}{...}
{p2col:{it:pr_options}}
	description{p_end}
{p2line}
{p2col:{cmdab:tm:argin:(}{it:#}{cmd:)}}
	top margin, in inches, 0 <= {it:#} <= 20{p_end}
{p2col:{cmdab:lm:argin:(}{it:#}{cmd:)}}
	left margin, in inches, 0 <= {it:#} <= 20{p_end}
{p2col:{cmd:logo(on}|{cmd:off)}}
	whether to display Stata logo{p_end}
{p2line}
{p2colreset}{...}

{pstd}
Current default values may be listed by typing

	{bf:. {stata graph set print}}

{pstd}
The defaults may be changed by typing

{p 8 16 2}
{cmd:.} {helpb graph set}
{cmd:print}
{it:name}
{it:value}

{pstd}
where {it:name} is the name of a {it:pr_option}, omitting the parentheses.


{title:Description}

{pstd}
The {it:pr_options} are used with {cmd:graph} {cmd:print}; see
{manhelp graph_print G:graph print}.


{title:Options}

{phang}
{cmd:tmargin(}{it:#}{cmd:)} and
{cmd:lmargin(}{it:#}{cmd:)}
    set the top and left page margins -- the distance from the edge of
    the page to the start of the graph.  {it:#} is specified in inches, must
    be between 0 and 20, and may be fractional.

{phang}
{cmd:logo(on)} and {cmd:logo(off)}
    specify whether the Stata logo should be included at the bottom of the
    graph.


{title:Remarks}

{pstd}
Remarks are presented under the following headings:

	{help pr_options##remarks1:Using the pr_options}
	{help pr_options##remarks2:Setting defaults}
	{help pr_options##remarks3:Note for Unix users}


{marker remarks1}{...}
{title:Using the pr_options}

{pstd}
You have drawn a graph and wish to print it.  You wish, however,
to suppress the Stata logo (although we cannot imagine why you would want
to do that):

	{cmd:. graph} ...{col 50}(draw a graph)

	{cmd:. graph print, logo(off)}


{marker remarks2}{...}
{title:Setting defaults}

{pstd}
If you always wanted {cmd:graph} {cmd:print} to suppress the Stata logo,
you could type

	{cmd:. graph set print logo off}

{pstd}
At a future date, you could type

	{cmd:. graph set print logo on}

{pstd}
to set it back.  You can determine your default {it:pr_options} settings
by typing

	{cmd:. graph set print}


{marker remarks3}{...}
{title:Note for Unix users}

{pstd}
In addition to the options documented above, there are other options you
may specify.  Under Stata for Unix, the {it:pr_options} are in fact
{it:ps_options}; see {manhelpi ps_options G}.


{title:Also see}

{psee}
Manual:  {bf:[G] {it:pr_options}}

{psee}
Online:  {manhelp graph_print G:graph print}
{p_end}
