{smcl}
{* *! version 1.1.19  22aug2007}{...}
{cmd:help probit}, {cmd:help dprobit} {right:dialogs:  {bf:{dialog probit}}  {bf:{dialog dprobit}}{space 6}}
{right:{dialog probit, message(-svy-) name(svy_probit):svy: probit}{space 10}}
{right:also see:  {help probit postestimation}}
{hline}

{title:Title}

{p2colset 5 19 21 2}{...}
{p2col :{hi:[R] probit} {hline 2}}Probit regression{p_end}
{p2colreset}{...}


{title:Syntax}

{phang}
Probit regression

{p 8 15 2}
{opt prob:it} {depvar} [{indepvars}] {ifin} {weight} 
[{cmd:,} {it:{help probit##probit_options:probit_options}}]


{phang}
Probit regression, reporting marginal effects

{p 8 16 2}
{opt dprobit} [{depvar} {indepvars} {ifin} {weight}] 
[{cmd:,} {it:{help probit##dprobit_options:dprobit_options}}] 


{synoptset 20 tabbed}{...}
{marker probit_options}{...}
{synopthdr :probit_options}
{synoptline}
{syntab :Model}
{synopt :{opt nocon:stant}}suppress constant term{p_end}
{synopt :{opth off:set(varname)}}include {it:varname} in model with coefficient
constrained to 1{p_end}
{synopt :{opt asis}}retain perfect predictor variables{p_end}

{syntab :SE/Robust}
{synopt :{opth vce(vcetype)}}{it:vcetype} may be {opt oim},
   {opt r:obust}, {opt cl:uster} {it:clustvar}, {opt boot:strap}, or 
   {opt jack:knife}{p_end}

{syntab :Reporting}
{synopt :{opt l:evel(#)}}set confidence level; default is
{cmd:level(95)}{p_end}

{syntab :Max options}
{synopt :{it:{help probit##probit_maximize:maximize_options}}}control the maximization process; seldom
used{p_end}

{p2coldent :+ {opt nocoe:f}}do not display the coefficient table; seldom
used{p_end}
{synoptline}
{p2colreset}{...}

{synoptset 23 tabbed}{...}
{marker dprobit_options}{...}
{synopthdr :dprobit_options}
{synoptline}
{syntab :Model}
{synopt :{opth off:set(varname)}}include {it:varname} in model with coefficient
constrained to 1{p_end}
{synopt :{opt at(matname)}}point at which marginal effects are evaluated{p_end}
{synopt :{opt asis}}retain perfect predictor variables{p_end}
{synopt :{opt cl:assic}}calculate mean effects for dummies like those for
continuous variables{p_end}

{syntab :SE/Robust}
{synopt :{opth vce(vcetype)}}{it:vcetype} may be {opt oim}, {opt r:obust}, or
        {opt cl:uster} {it:clustvar}{p_end}

{syntab :Reporting}
{synopt :{opt l:evel(#)}}set confidence level; default is
{cmd:level(95)}{p_end}

{syntab :Max options}
{synopt :{it:{help probit##dprobit_maximize:maximize_options}}}control the maximization process; seldom
used{p_end}

{p2coldent :+ {opt nocoe:f}}do not display the coefficient table; seldom
used{p_end}
{synoptline}
{p2colreset}{...}

{p 4 6 2}{it:depvar} and {it:indepvars} for {cmd:probit} may
contain time-series operators; see {help tsvarlist}.{p_end}
{p 4 6 2}{cmd:bootstrap}, {cmd:by}, {cmd:jackknife}, {cmd:nestreg},
{cmd:rolling}, {cmd:statsby}, {cmd:stepwise}, {cmd:svy}, and {cmd:xi}
are allowed with {cmd:probit}, and {cmd:by}, {cmd:rolling}, {cmd:statsby},
and {cmd:xi} are allowed with {cmd:dprobit}; see {help prefix}.{p_end}
{p 4 6 2}Weights are not allowed with the {helpb bootstrap} prefix.{p_end}
{p 4 6 2}{cmd:aweights} are not allowed with the {helpb jackknife} prefix.
{p_end}
{p 4 6 2}{opt vce()}, {opt nocoef}, and weights are not allowed with the
{helpb svy} prefix.
{p_end}
{p 4 6 2}+ {opt nocoef} does not appear in the dialog box.
{p_end}
{p 4 6 2}{opt fweight}s, {opt iweight}s, and {opt pweight}s
are allowed with {cmd:probit}, and {cmd:fweight}s and {cmd:pweight}s are
allowed with {cmd:dprobit}; see {help weight}.{p_end}
{p 4 6 2}
See {manhelp probit_postestimation R:probit postestimation} for features
available after estimation.  {p_end}


{title:Description}

{pstd}
{cmd:probit} fits a maximum-likelihood probit model.

{pstd}
{cmd:dprobit} fits maximum-likelihood probit models and is an alternative to
{cmd:probit}.  Rather than reporting the coefficients, {cmd:dprobit} reports
the marginal effect, that is, the change in the probability for an
infinitesimal change in each independent, continuous variable and, by default,
reports the discrete change in the probability for dummy variables.
{cmd:probit} may be typed without arguments after {cmd:dprobit} estimation to
see the model in coefficient form.

{pstd}
If estimating on grouped data, see {helpb bprobit}.

{pstd}
Several auxiliary command may be run after {cmd:probit}, {cmd:logit}, or
{cmd:logistic}; see
{manhelp logistic_postestimation R:logistic postestimation} for a description
of these commands.

{pstd}
See {help logistic estimation commands} for a list of related estimation
commands.


{title:Options for probit}

{dlgtab:Model}

{phang}
{opt noconstant}, {opth offset(varname)}; see
{helpb estimation options:[R] estimation options}.

{phang}
{marker asis}
{opt asis} specifies that all specified variables and observations be retained
in the maximization process.  This option is typically not specified and may
introduce numerical instability.  Normally {cmd:probit} drops variables that
perfectly predict success or failure in the dependent variable along with
their associated observations.  In those cases, the effective coefficient on
the dropped variables is infinity (negative infinity) for variables that
completely determine a success (failure).  Dropping the variable and perfectly
predicted observations has no effect on the likelihood or estimates of the
remaining coefficients and increases the numerical stability of the
optimization process.  Specifying this option forces retention of perfect
predictor variables and their associated observations.

{dlgtab:SE/Robust}

INCLUDE help vce_asymptall

{dlgtab:Reporting}

{phang}
{opt level(#)}; see 
{helpb estimation options##level():[R] estimation options}.

{marker probit_maximize}{...}
{dlgtab:Max options}

{phang}
{it:maximize_options}: {opt iter:ate(#)}, [{cmdab:no:}]{opt lo:g}, 
{opt tr:ace}, {opt tol:erance(#)}, {opt ltol:erance(#)},
{opt nrtol:erance(#)}, {opt nonrtol:erance}; see
{manhelp maximize R}.  These options are seldom used.

{pstd}
The following option is available with {opt probit} but is not shown in the
dialog box:

{phang}
{opt nocoef} specifies that the coefficient table not be displayed.  This
option is sometimes used by programmers but is of no use interactively. 


{title:Options for dprobit}

{dlgtab:Model}

{phang}
{opth offset(varname)}; see
{helpb estimation options##offset():[R] estimation options}.

{phang}
{opt at(matname)} specifies the point at which marginal effects are evaluated.
The default is to evaluate at the mean of the independent variables.  If there
are k independent variables, {it:matname} may be 1 x k or {bind:1 x (k + 1)};
that is, it may optionally include final element 1 reflecting the constant. 
{opt at()} may be specified when the model is fitted or when results are
redisplayed.

{phang}
{opt asis}; see {help probit##asis:Options for probit} above.

{phang}
{opt classic} requests that the mean effects always be calculated using the
formula f(xb)*b_i.  If {opt classic} is not specified, f(xb)*b_i
is used for continuous variables, but the mean effects for dummy variables are
calculated as F(x_1*b) - F(x_0*b).  Here x_1=x but with element i set to 1, and
x_0=x  but with element i set to 0, and x is the mean of the independent
variables or the vector specified by {opt at()}.  {opt classic} may be
specified at estimation time or when results are redisplayed.  Results
calculated without {opt classic} may be redisplayed with {opt classic} and
vice versa.

{dlgtab:SE/Robust}

{phang}
{opt vce(vcetype)} specifies the type of standard error reported, which
includes types that are derived from asymptotic theory, that are robust to
some kinds of misspecification, and that allow for intragroup correlation; see
{helpb vce_option:[R] {it:vce_option}}.

{dlgtab:Reporting}

{phang}
{opt level(#)}; see
{helpb estimation options##level():[R] estimation options}.

{marker dprobit_maximize}{...}
{dlgtab:Max options}

{phang}
{it:maximize_options}: {opt iter:ate(#)}, [{cmdab:no:}]{opt lo:g}, 
{opt tr:ace}, {opt tol:erance(#)}, {opt ltol:erance(#)}; see
{manhelp maximize R}.  These options are seldom used.

{phang}
The following option is available with {cmd:dprobit} but is not shown in the
dialog box:

{phang}
{opt nocoef} specifies that the coefficient table not be displayed.  This
option is sometimes used by programmers but is of no use interactively.


{title:Examples}

    {hline}
    Setup
{phang2}{cmd:. sysuse auto}{p_end}

{pstd}Probit regression{p_end}
{phang2}{cmd:. probit foreign weight mpg}{p_end}

{phang}Same as above, but with robust standard errors{p_end}
{phang2}{cmd:. probit foreign weight mpg, vce(robust)}{p_end}

    {hline}
    Setup
{phang2}{cmd:. webuse union}{p_end}

{pstd}Probit regression{p_end}
{phang2}{cmd:. probit union age grade not_smsa south southXt}{p_end}

{phang}Same as above, but adjust standard errors for clusters in {cmd:id}{p_end}
{phang2}{cmd:. probit union age grade not_smsa south southXt, vce(cluster id)}
{p_end}

    {hline}
    Setup
{phang2}{cmd:. sysuse auto}{p_end}
{phang2}{cmd:. generate goodplus = rep78 >= 4 if rep78 < .}{p_end}

{pstd}Probit regression, reporting marginal effects{p_end}
{phang2}{cmd:. dprobit foreign mpg goodplus}{p_end}

    {hline}
{pstd}Setup{p_end}
{phang2}{cmd:. webuse nhanes2d, clear}{p_end}
{phang2}{cmd:. svyset}

{pstd}Probit regression using survey data{p_end}
{phang2}{cmd:. svy: probit highbp height weight age female}{p_end}
    {hline}


{title:Saved Results}

{pstd}
{cmd:probit} saves the following in {cmd:e()}:

{synoptset 15 tabbed}{...}
{p2col 5 15 19 2: Scalars}{p_end}
{synopt:{cmd:e(N)}}number of observations{p_end}
{synopt:{cmd:e(N_cds)}}number of completely determined successes{p_end}
{synopt:{cmd:e(N_cdf)}}number of completely determined failures{p_end}
{synopt:{cmd:e(df_m)}}model degrees of freedom{p_end}
{synopt:{cmd:e(r2_p)}}pseudo-R-squared{p_end}
{synopt:{cmd:e(ll)}}log likelihood{p_end}
{synopt:{cmd:e(ll_0)}}log likelihood, constant-only model{p_end}
{synopt:{cmd:e(N_clust)}}number of clusters{p_end}
{synopt:{cmd:e(chi2)}}chi-squared{p_end}

{synoptset 15 tabbed}{...}
{p2col 5 15 19 2: Macros}{p_end}
{synopt:{cmd:e(cmd)}}{cmd:probit}{p_end}
{synopt:{cmd:e(cmdline)}}command as typed{p_end}
{synopt:{cmd:e(depvar)}}name of dependent variable{p_end}
{synopt:{cmd:e(wtype)}}weight type{p_end}
{synopt:{cmd:e(wexp)}}weight expression{p_end}
{synopt:{cmd:e(title)}}title in estimation output{p_end}
{synopt:{cmd:e(clustvar)}}name of cluster variable{p_end}
{synopt:{cmd:e(chi2type)}}{cmd:Wald} or {cmd:LR}; type of model chi-squared
	test{p_end}
{synopt:{cmd:e(vce)}}{it:vcetype} specified in {cmd:vce()}{p_end}
{synopt:{cmd:e(vcetype)}}title used to label Std. Err.{p_end}
{synopt:{cmd:e(crittype)}}optimization criterion{p_end}
{synopt:{cmd:e(properties)}}{cmd:b V}{p_end}
{synopt:{cmd:e(estat_cmd)}}program used to implement {cmd:estat}{p_end}
{synopt:{cmd:e(predict)}}program used to implement {cmd:predict}{p_end}

{synoptset 15 tabbed}{...}
{p2col 5 15 19 2: Matrices}{p_end}
{synopt:{cmd:e(b)}}coefficient vector{p_end}
{synopt:{cmd:e(V)}}variance-covariance matrix of the estimators{p_end}

{synoptset 15 tabbed}{...}
{p2col 5 15 19 2: Functions}{p_end}
{synopt:{cmd:e(sample)}}marks estimation sample{p_end}

{pstd}
{cmd:dprobit} saves the following in {cmd:e()}:

{synoptset 15 tabbed}{...}
{p2col 5 15 19 2: Scalars}{p_end}
{synopt:{cmd:e(N)}}number of observations{p_end}
{synopt:{cmd:e(N_cds)}}number of completely determined successes{p_end}
{synopt:{cmd:e(N_cdf)}}number of completely determined failures{p_end}
{synopt:{cmd:e(df_m)}}model degrees of freedom{p_end}
{synopt:{cmd:e(r2_p)}}pseudo-R-squared{p_end}
{synopt:{cmd:e(ll)}}log likelihood{p_end}
{synopt:{cmd:e(ll_0)}}log likelihood, constant-only model{p_end}
{synopt:{cmd:e(N_clust)}}number of clusters{p_end}
{synopt:{cmd:e(chi2)}}chi-squared{p_end}
{synopt:{cmd:e(pbar)}}fraction of successes observed in data{p_end}
{synopt:{cmd:e(xbar)}}average probit score{p_end}
{synopt:{cmd:e(offbar)}}average offset{p_end}

{synoptset 15 tabbed}{...}
{p2col 5 15 19 2: Macros}{p_end}
{synopt:{cmd:e(cmd)}}{cmd:dprobit}{p_end}
{synopt:{cmd:e(cmdline)}}command as typed{p_end}
{synopt:{cmd:e(depvar)}}name of dependent variable{p_end}
{synopt:{cmd:e(wtype)}}weight type{p_end}
{synopt:{cmd:e(wexp)}}weight expression{p_end}
{synopt:{cmd:e(title)}}title in estimation output{p_end}
{synopt:{cmd:e(clustvar)}}name of cluster variable{p_end}
{synopt:{cmd:e(at)}}predicted probability (at x){p_end}
{synopt:{cmd:e(chi2type)}}{cmd:Wald} or {cmd:LR}; type of model chi-squared
	test{p_end}
{synopt:{cmd:e(vce)}}{it:vcetype} specified in {cmd:vce()}{p_end}
{synopt:{cmd:e(vcetype)}}title used to label Std. Err.{p_end}
{synopt:{cmd:e(dummy)}}string of blank-separated 0s and 1s; 0 means that the
corresponding independent variable is not a dummy; 1 means that it is{p_end}
{synopt:{cmd:e(crittype)}}optimization criterion{p_end}
{synopt:{cmd:e(properties)}}{cmd:b V}{p_end}
{synopt:{cmd:e(estat_cmd)}}program used to implement {cmd:estat}{p_end}
{synopt:{cmd:e(predict)}}program used to implement {cmd:predict}{p_end}

{synoptset 15 tabbed}{...}
{p2col 5 15 19 2: Matrices}{p_end}
{synopt:{cmd:e(b)}}coefficient vector{p_end}
{synopt:{cmd:e(V)}}variance-covariance matrix of the estimators{p_end}
{synopt:{cmd:e(dfdx)}}marginal effects{p_end}
{synopt:{cmd:e(se_dfdx)}}standard errors of the marginal effects{p_end}

{synoptset 15 tabbed}{...}
{p2col 5 15 19 2: Functions}{p_end}
{synopt:{cmd:e(sample)}}marks estimation sample{p_end}


{title:Also see}

{psee}
Manual:  {bf:[R] probit}

{psee}
Online:  {manhelp probit_postestimation R: probit postestimation};{break}
{manhelp asmprobit R},
{manhelp biprobit R},
{manhelp brier R},
{manhelp glm R},
{manhelp hetprob R},
{manhelp ivprobit R},
{manhelp logistic R},
{manhelp logit R},
{manhelp mprobit R},
{manhelp roc R},
{manhelp scobit R},
{manhelp svy_estimation SVY:svy estimation},
{manhelp xtprobit XT}
{p_end}
