{smcl}
{* *! version 1.0.6  13may2008}{...}
{cmd:help ps_options}
{hline}
{* index exporting graphs}{...}
{* index PostScript}{...}

{title:Title}

{p2colset 5 23 25 2}{...}
{p2col :{hi:[G] {it:ps_options}} {hline 2}}Options for exporting or printing to PostScript{p_end}
{p2colreset}{...}


{title:Syntax}

{p2colset 9 34 37 2}{...}
{p2col:{it:ps_options}}
	description{p_end}
{p2line}
{p2col:{cmdab:tm:argin:(}{it:#}{cmd:)}}
	top margin in inches{p_end}
{p2col:{cmdab:lm:argin:(}{it:#}{cmd:)}}
	left margin in inches{p_end}
{p2col:{cmd:logo(on}|{cmd:off)}}
	whether to include Stata logo{p_end}
{p2col:{cmd:cmyk(on}|{cmd:off)}}
	whether to use CMYK rather than RGB colors{p_end}
{p2col:{cmd:mag(}{it:#}{cmd:)}}
            magnification/shrinkage factor; default is 100{p_end}
{p2col:{cmdab:font:face:(}{it:fontname}{cmd:)}}
	font to use{p_end}
{p2col:{cmdab:or:ientation:(portrait}|}{p_end}
{p2col 22 34 37 2:{cmd:landscape)}}
	whether vertical or horizontal{p_end}
{p2col:{cmdab:pages:ize:(letter}|{cmd:legal}|}{p_end}
{p2col 13 34 37 2:{cmd:executive}|{cmd:A4}|{cmd:custom)}}
	size of page{p_end}
{p2col:{cmdab:pageh:eight:(}{it:#}{cmd:)}}
	inches; relevant only if {cmd:pagesize(custom)}{p_end}
{p2col:{cmdab:pagew:idth:(}{it:#}{cmd:)}}
	inches; relevant only if {cmd:pagesize(custom)}{p_end}
{p2line}
{p2colreset}{...}

{pstd}
Current default values may be listed by typing

	{bf:. {stata graph set ps}}

{pstd}
and default values may be set by typing

{p 8 16 2}
{cmd:.} {helpb graph set}
{cmd:ps}
{it:name}
{it:value}

{pstd}
where {it:name} is the name of a {it:ps_option}, omitting the
parentheses.


{title:Description}

{pstd}
These {it:ps_options} are used with {cmd:graph} {cmd:export}
when creating a PostScript file; see {manhelp graph_export G:graph export}.

{pstd}
Also, under Stata for Unix, these options are used with {cmd:graph}
{cmd:print}; see {manhelp graph_print G:graph print}.


{title:Options}

{phang}
{cmd:tmargin(}{it:#}{cmd:)} and
{cmd:lmargin(}{it:#}{cmd:)}
    set the top and left page margins -- the distance from the edge of
    the page to the start of the graph.  {it:#} is specified in inches, must
    be between 0 and 20, and may be fractional.

{phang}
{cmd:logo(on)} and {cmd:logo(off)}
    specify whether the Stata logo should be included at the bottom of the
    graph.

{phang}
{cmd:cmyk(on)} and {cmd:cmyk(off)}
    specify whether colors in the output file should be specified as CMYK
    values rather than RGB values.

{phang}
{cmd:mag(}{it:#}{cmd:)}
    specifies that the graph be drawn smaller or larger than the default.
    {cmd:mag(100)} is the default, meaning ordinary size.
    {cmd:mag(110)} would make the graph 10% larger than usual and
    {cmd:mag(90)} would make the graph 10% smaller than usual.
    {it:#} must be an integer.

{phang}
{cmd:fontface(}{it:fontname}{cmd:)}
    specifies the name of the PostScript font to be used to render text.
    If {it:fontname} contains blanks, {it:fontname} must be enclosed in
    double quotes.

{phang}
{cmd:orientation(portrait)}
and
{cmd:orientation(landscape)}
    specify whether the graph is to be presented vertically or horizontally.

{phang}
{cmd:pagesize()}
    specifies the size of the page.  {cmd:pagesize(letter)},
    {cmd:pagesize(legal)}, {cmd:pagesize(executive)}, and {cmd:pagesize(A4)}
    are prerecorded sizes.  {cmd:pagesize(custom)} specifies that you wish to
    explicitly specify the size of the page by using the {cmd:pageheight()}
    and {cmd:pagewidth()} options.

{phang}
{cmd:pageheight(}{it:#}{cmd:#}{cmd:)}
and
{cmd:pagewidth(}{it:#}{cmd:#}{cmd:)}
    are relevant only if {cmd:pagesize(custom)} is specified.  They specify
    the height and width of the page in inches.  {it:#} is specified in inches,
    must be between 0 and 20, and may be fractional.


{title:Remarks}

{pstd}
Remarks are presented under the following headings:

	{help ps_options##remarks1:Using the ps_options}
	{help ps_options##remarks2:Setting defaults}
	{help ps_options##remarks3:Note for Unix users}


{marker remarks1}{...}
{title:Using the ps_options}

{pstd}
You have drawn a graph and wish to create a PostScript file.  You wish,
however, to change the text from Helvetica to Roman, which is "Times" in
PostScript jargon:

	{cmd:. graph} ...{col 50}(draw a graph)

	{cmd:. graph export myfile.ps, fontface(Times)}


{marker remarks2}{...}
{title:Setting defaults}

{pstd}
If you always wanted {cmd:graph} {cmd:export} to use Times when exporting
to PostScript files, you could type

	{cmd:. graph set ps fontface Times }

{pstd}
At a future date, you could type

	{cmd:. graph set ps fontface Helvetica}

{pstd}
to set it back.  You can list the current {it:ps_option} settings
for PostScript by typing

	{cmd:. graph set ps}


{marker remarks3}{...}
{title:Note for Unix users}

{pstd}
The PostScript settings are used not only by {cmd:graph} {cmd:export}
when creating a PostScript file but also by {cmd:graph} {cmd:print}.
In {manhelpi pr_options G}, you are told that you may list and set
defaults by typing

	{cmd:. graph set print} ...

{pstd}
That is true, but under Unix, {cmd:print} is a synonym for {cmd:ps}, so
whether you type {cmd:graph} {cmd:set} {cmd:print} or {cmd:graph} {cmd:set}
{cmd:ps} makes no difference.


{title:Also see}

{psee}
Manual:  {bf:[G] {it:ps_options}}

{psee}
Online:   
{manhelp graph_export G:graph export},
{manhelp graph_set G:graph set}
{p_end}
