{smcl}
{* *! version 1.0.6  13may2008}{...}
{cmd:help rcap_options}
{hline}
{* index twoway rcap}{...}

{title:Title}

{p2colset 5 25 27 2}{...}
{p2col:{hi:[G] {it:rcap_options}} {hline 2}}Options for determining the look of range plots with capped spikes{p_end}
{p2colreset}{...}


{title:Syntax}

{p2colset 9 38 40 2}{...}
{p2col:{it:rcap_options}}
	description{p_end}
{p2line}
{p2col:{it:{help line_options}}}
	change look of spike and cap lines{p_end}
{p2col:{cmdab:msiz:e:(}{it:{help markersizestyle}}{cmd:)}}
	width of cap{p_end}

{p2col:{help advanced_options:{bf:recast(}{it:newplottype}{bf:)}}}
	advanced; treat plot as {it:newplottype}{p_end}
{p2line}
{p2colreset}{...}
{pin}
All options are {it:rightmost}; see {help repeated options}.


{title:Description}

{pstd}
The {it:rcap_options} determine the look of spikes (lines connecting two
points vertically or horizontally) and their endcaps.


{title:Options}

{phang}
{it:line_options} 
    specify the look of the lines used to draw the spikes and their caps,
    including pattern, width, and color; see {manhelpi line_options G}.{p_end}

{phang}
{cmd:msize(}{it:markersizestyle}{cmd:)}
    specifies the width of the cap.  Option {cmd:msize()} is in fact
    {cmd:twoway} {cmd:scatter}'s {it:marker_option} that sets the size of the
    marker symbol, but here {cmd:msymbol()} is borrowed to set the cap width.
    See {manhelpi markersizestyle G} for a list of size choices.

{phang}
{cmd:recast(}{it:newplottype}{cmd:)}
        is an advanced option allowing the plot to be recast from one type to
        another, for example, from a {help twoway rcap:range-capped plot} to 
	an {help twoway area:area plot}; see 
        {manhelpi advanced_options G}.  Most, but not all, plots allow
        {cmd:recast()}.


{title:Remarks}

{pstd}
Range-capped plots are used in many contexts.  They are sometimes the default
for confidence intervals.  For instance, the {cmd:lcolor()} suboption of
{cmd:ciopts()} in

{phang2}
	{cmd:. tabodds died age, ciplot ciopts(lcolor(green))}

{pstd}
causes the color of the horizontal lines representing the confidence intervals
in the graph to be drawn in green.


{title:Also see}

{psee}
Manual:  {bf:[G]} {it:rcap_options}

{psee}
Online:  
{manhelp lines G:concept: lines}
{p_end}
