{smcl}
{* *! version 1.0.7  13may2008}{...}
{cmd:help region options}
{hline}
{* index size of graph}{...}
{* index axes, setting offset between and plot region}{...}
{* index plot region, suppressing border around}{...}
{* index borders, suppressing around plot region}{...}
{* index colors, setting background and fill}{...}
{* index available area}{...}
{* index plot region}{...}
{* index graph region}{...}
{* index ysize() tt option}{...}
{* index xsize() tt option}{...}
{* index graphregion() tt option}{...}
{* index plotregion() tt option}{...}

{title:Title}

{p2colset 5 27 29 2}{...}
{p2col :{hi:[G] {it:region_options}} {hline 2}}Options for shading and outlining regions and controlling graph size{p_end}
{p2colreset}{...}


{title:Syntax}

{p2colset 9 40 42 2}{...}
{p2col:{it:region_options}}
	description{p_end}
{p2line}
{p2col:{cmdab:ysiz:e:(}{it:#}{cmd:)}}
	height of {it:available area} (in inches){p_end}
{p2col:{cmdab:xsiz:e:(}{it:#}{cmd:)}}
	width of {it:available area} (in inches){p_end}
{p2col:{cmdab:graphr:egion:(}{it:suboptions}{cmd:)}}
	attributes of {it:graph region}{p_end}
{p2col:{cmdab:plotr:egion:(}{it:suboptions}{cmd:)}}
	attributes of {it:plot region}{p_end}
{p2line}
{pin}
Options {cmd:ysize()} and {cmd:xsize()} are {it:unique};
options {cmd:graphregion()} and {cmd:plotregion()} are
{it:merged-implicit}; see {help repeated options}.


{p2col:{it:suboptions}}
	description{p_end}
{p2line}
{p2col:{cmdab:sty:le:(}{it:{help areastyle}}{cmd:)}}
	overall style of outer region{p_end}
{p2col:{cmdab:c:olor:(}{it:{help colorstyle}}{cmd:)}}
	line and fill color of outer region{p_end}
{p2col:{cmdab:fc:olor:(}{it:{help colorstyle}}{cmd:)}}
	fill color of outer region{p_end}
{p2col:{cmdab:ls:tyle:(}{it:{help linestyle}}{cmd:)}}
	overall style of outline{p_end}
{p2col:{cmdab:lc:olor:(}{it:{help colorstyle}}{cmd:)}}
	color of outline{p_end}
{p2col:{cmdab:lw:idth:(}{it:{help linewidthstyle}}{cmd:)}}
	thickness of outline{p_end}
{p2col:{cmdab:lp:attern:(}{it:{help linepatternstyle}}{cmd:)}}
	outline pattern (solid, dashed, etc.){p_end}

{p2col:{cmdab:isty:le:(}{it:{help areastyle}}{cmd:)}}
	overall style of inner region{p_end}
{p2col:{cmdab:ic:olor:(}{it:{help colorstyle}}{cmd:)}}
	line and fill color of inner region{p_end}
{p2col:{cmdab:ifc:olor:(}{it:{help colorstyle}}{cmd:)}}
	fill color of inner region{p_end}
{p2col:{cmdab:ils:tyle:(}{it:{help linestyle}}{cmd:)}}
	overall style of outline{p_end}
{p2col:{cmdab:ilc:olor:(}{it:{help colorstyle}}{cmd:)}}
	color of outline{p_end}
{p2col:{cmdab:ilw:idth:(}{it:{help linewidthstyle}}{cmd:)}}
	thickness of outline{p_end}
{p2col:{cmdab:ilp:attern:(}{it:{help linepatternstyle}}{cmd:)}}
	outline pattern (solid, dashed, etc.){p_end}

{p2col:{cmdab:m:argin:(}{it:{help marginstyle}}{cmd:)}}
	margin between inner and outer regions{p_end}
{p2line}
{p2colreset}{...}


{pstd}
The {it:available area}, {it:graph region}, and {it:plot region} are defined

	{c TLC}{hline 41}{c TRC}
	{c |}{it:(outer graph region)}             {it:margin}  {c |}
	{c |} {c TLC}{hline 37}{c TRC} {c |}
	{c |} {c |}{it:(inner graph region)}                 {c |} {c |}    {it:titles appear outside}
	{c |} {c |}                                     {c |} {c |}      {it:the borders of outer}
	{c |} {c |}   {c TLC}{hline 28}{c TRC}    {c |} {c |}      {it:plot region}
	{c |} {c |}   {c |}{it:(outer plot region)}  {it:margin} {c |}    {c |} {c |}
	{c |} {c |}   {c |} {c TLC}{hline 24}{c TRC} {c |}    {c |} {c |}{...}
{col 56}{it:axes appear on the}
	{c |} {c |}   {c |} {c |}                        {c |} {c |}    {c |} {c |}      {it:borders of the outer}
	{c |}m{c |}   {c |}m{c |}                        {c |}m{c |}    {c |}m{c |}      {it:plot region}
	{c |}a{c |}   {c |}a{c |}                        {c |}a{c |}    {c |}a{c |}
	{c |}r{c |}   {c |}r{c |}    {it:(inner plot}         {c |}r{c |}    {c |}r{c |}{...}
{col 56}{it:plot appears in inner}
	{c |}g{c |}   {c |}g{c |}             {it:region)}    {c |}g{c |}    {c |}g{c |}      {it:plot region}
	{c |}i{c |}   {c |}i{c |}                        {c |}i{c |}    {c |}i{c |}
	{c |}n{c |}   {c |}n{c |}                        {c |}n{c |}    {c |}n{c |}
	{c |} {c |}   {c |} {c |}                        {c |} {c |}    {c |} {c |}
	{c |} {c |}   {c |} {c BLC}{hline 24}{c BRC} {c |}    {c |} {c |}{...}
{col 56}{it:Note: what are called}
	{c |} {c |}   {c |}            {it:margin}          {c |}    {c |} {c |}{...}
{col 58}{it:the "graph region" and}
	{c |} {c |}   {c BLC}{hline 28}{c BRC}    {c |} {c |}{...}
{col 58}{it:the "plot region" are}
	{c |} {c |}                                     {c |} {c |}{...}
{col 58}{it:sometimes the inner}
	{c |} {c |}                                     {c |} {c |}{...}
{col 58}{it:and sometimes the}
	{c |} {c BLC}{hline 37}{c BRC} {c |}{...}
{col 58}{it:outer regions.}
	{c |}                  {it:margin}                 {c |}{...}
{col 58}
	{c BLC}{hline 41}{c BRC}{txt}{...}
{col 58}

	{it:The available area and outer graph region}
	{it:are almost coincident; they differ only by}
	{it:the width of the border.}

	{it:The borders of the outer plot or graph}
	{it:region are sometimes called the outer}
	{it:borders of the plot or graph region.}


{title:Description}

{pstd}
The {it:region_options} set the size, margins, and color of the area in which
the graph appears.


{title:Options}

{phang}
{cmd:ysize(}{it:#}{cmd:)} and {cmd:xsize(}{it:#}{cmd:)}
    specify in inches the height and width of the {it:available area}.  The
    defaults are usually {cmd:ysize(4)} and {cmd:xsize(5)}, but this, of
    course, is controlled by the scheme; see {manhelp schemes G:schemes intro}.
    These two
    options can be used to control the overall aspect ratio of a graph.  See
    {hi:Controlling the aspect ratio} below.

{phang}
{cmd:graphregion(}{it:suboptions}{cmd:)} and
{cmd:plotregion(}{it:suboptions}{cmd:)}
    specify attributes for the {it:graph region} and {it:plot region}.


{title:Suboptions}

{phang}
{cmd:style(}{it:areastyle}{cmd:)} and
{cmd:istyle(}{it:areastyle}{cmd:)}
    specify the overall style of the outer and inner regions.
    The other suboptions allow you to change the region's attributes
    individually, but {cmd:style()} and {cmd:istyle()} provide the
    starting points.
    See {manhelpi areastyle G} for a list of choices.

{phang}
{cmd:color(}{it:colorstyle}{cmd:)} and
{cmd:icolor(}{it:colorstyle}{cmd:)}
    specify the color of the line used to outline the outer and inner regions;
    see {manhelpi colorstyle G} for a list of choices.

{phang}
{cmd:fcolor(}{it:colorstyle}{cmd:)} and
{cmd:ifcolor(}{it:colorstyle}{cmd:)}
    specify the fill color for the outer and inner regions;
    see {manhelpi colorstyle G} for a list of choices.

{phang}
{cmd:lstyle(}{it:linestyle}{cmd:)} and
{cmd:ilstyle(}{it:linestyle}{cmd:)}
    specify the overall style of the line used to outline the outer and inner
    regions, which includes its pattern (solid, dashed, etc.), thickness,
    and color.  The other suboptions listed below allow you to change the
    line's attributes individually, but {cmd:lstyle()} and {cmd:ilstyle()} are
    the starting points.  See {manhelpi linestyle G} for a list of choices.

{phang}
{cmd:lcolor(}{it:colorstyle}{cmd:)} and
{cmd:ilcolor(}{it:colorstyle}{cmd:)}
    specify the color of the line used to outline the outer and inner regions;
    see {manhelpi colorstyle G} for a list of choices.

{phang}
{cmd:lwidth(}{it:linewidthstyle}{cmd:)} and
{cmd:ilwidth(}{it:linewidthstyle}{cmd:)}
    specify the thickness of the line used to outline the outer and inner
    regions; see {manhelpi linewidthstyle G} for a list of choices.

{phang}
{cmd:lpattern(}{it:linepatternstyle}{cmd:)} and
{cmd:ilpattern(}{it:linepatternstyle}{cmd:)}
    specify whether the line used to outline the outer and inner regions is
    solid, dashed, etc.; see {manhelpi linepatternstyle G} for a list of
    choices.

{phang}
{cmd:margin(}{it:marginstyle}{cmd:)}
    specifies the margin between the outer and inner regions.


{title:Remarks}

{pstd}
Remarks are presented under the following headings:

	{help region_options##remarks1:Setting the offset between the axes and the plot region}
	{help region_options##remarks2:Controlling the aspect ratio}
	{help region_options##remarks3:Suppressing the border around the plot region}
	{help region_options##remarks4:Setting background and fill colors}
	{help region_options##remarks5:How graphs are constructed}


{marker remarks1}{...}
{title:Setting the offset between the axes and the plot region}

{* index offset between axes and data, setting}{...}
{pstd}
By default, most schemes (see {manhelp schemes G:schemes intro}) offset the
axes from the region in which the data are plotted.  This offset is specified
{cmd:plotregion(margin(}{it:marginstyle}{cmd:))}; see
{manhelpi marginstyle G}.

{pstd}
If you do not want the axes offset from the contents of the plot,
specify {cmd:plotregion(margin(zero))}.  Compare

	{cmd:. sysuse auto}

	{cmd:. scatter price mpg}
	  {it:({stata "gr_example auto: scatter price mpg":click to run})}
{* graph regopts1}{...}

{pstd}
with

	{cmd:. scatter price mpg, plotr(m(zero))}
	  {it:({stata "gr_example auto: scatter price mpg, plotr(m(zero))":click to run})}
{* graph regopts2}{...}


{marker remarks2}{...}
{title:Controlling the aspect ratio}

{* index aspect ratio, controlling}{...}
{pstd}
Here we discuss controlling the overall aspect ratio of a graph.  To control
the aspect ratio of a plot region for {helpb twoway}, {helpb graph bar}, 
{helpb graph box}, or {helpb graph dot}, see {manhelpi aspect_option G}.

{pstd}
The way to control the aspect ratio of the overall graph is by specifying
the {cmd:xsize()} or {cmd:ysize()} options.  For instance, you draw a graph
and find that the graph is too wide given its height.  To address the problem,
either increase {cmd:ysize()} or decrease {cmd:xsize()}.  The usual defaults
(which of course are determined by the scheme; see
{manhelp schemes G:schemes intro}) are
{cmd:ysize(4)} and {cmd:xsize(5.5)}, so you might try

	{cmd:. graph} ...{cmd:,} ... {cmd:ysize(5)}

{pstd}
or

	{cmd:. graph} ...{cmd:,} ... {cmd:xsize(4.5)}

{pstd}
For instance, compare

	{cmd:. scatter mpg weight}
	  {it:({stata "gr_example auto: scatter mpg weight":click to run})}
{* graph mpgweight}{...}

{pstd}
with

	{cmd:. scatter mpg weight, ysize(5)}
	  {it:({stata "gr_example auto: scatter mpg weight, ysize(4.5)":click to run})}
{* graph regopts3}{...}

{pstd}
Another way to control the aspect ratio is to add to the outer margin
of the {it:graph area}.  This will keep the overall size of the graph
the same while using less of the {it:available area}.  For instance,

	{cmd:. scatter mpg weight, graphregion(margin(l+10 r+10))}
	  {it:({stata "gr_example auto: scatter mpg weight, graphregion(margin(l+10 r+10))":click to run})}
{* graph regopts4}{...}

{pstd}
This method is especially useful when using {cmd:graph,} {cmd:by()}, but
remember to specify the {cmd:graphregion(margin())} option inside the
{cmd:by()} so that it affects the entire graph:

	{cmd:. scatter mpg weight, by(foreign, total graphr(m(l+10 r+10)))}
	  {it:({stata "gr_example auto: scatter mpg weight, by(foreign, total graphr(m(l+10 r+10)))":click to run})}
{* graph regopts5}{...}

{pstd}
Compare the above with

	{cmd:. scatter mpg weight, by(foreign, total)}
	  {it:({stata "gr_example auto: scatter mpg weight, by(foreign, total)":click to run})}
{* graph regopts6}{...}

{pstd}
A similar, and often preferable, effect can be obtained by constraining the
aspect ratio of the plot region itself; see {manhelpi aspect_option G}.

{pstd}
You do not have to get the aspect ratio or size right the first time you
draw a graph; using {cmd:graph} {cmd:display}, you can change the aspect
ratio of an already drawn graph -- even a graph saved in a {cmd:.gph} file.
See {hi:Changing the size and aspect ratio} in
{manhelp graph_display G:graph display}.


{marker remarks3}{...}
{title:Suppressing the border around the plot region}

{* index border around plot region, suppressing}{...}
{pstd}
To eliminate the border around the plot region, specify
{cmd:plotregion(style(none))}:

	{cmd:. sysuse auto, clear}

	{cmd:. scatter mpg weight, plotregion(style(none))}
	  {it:({stata "gr_example auto: scatter mpg weight, plotregion(style(none))":click to run})}
{* graph regopts7}{...}


{marker remarks4}{...}
{title:Setting background and fill colors}

{* index background color, setting}{* index fill color, setting}{...}
{pstd}
The background color of a graph is determined by default by the scheme you
choose -- see {manhelp schemes G:schemes intro} -- and is usually black or
white, perhaps with a tint.  Option
{cmd:graphregion(fcolor(}{it:colorstyle}{cmd:))} allows you to override the
scheme's selection.  When doing this, choose a light background color for
schemes that are naturally white and a dark background color for schemes that
are naturally black, or you will have to type many options to make
your graph look good.

{pstd}
Below we draw a graph, using a light gray background:

	{cmd:. sysuse auto, clear}

	{cmd:. scatter mpg weight, graphregion(fcolor(gs13))}
	  {it:({stata `"gr_example auto: scatter mpg weight, graphregion(fcolor(gs13))"':click to run})}
{* graph regopts8}{...}

{pstd}
See {manhelpi colorstyle G} for information on what you may specify
inside the {cmd:graphregion(fcolor())} option.

{pstd}
In addition to {cmd:graphregion(fcolor())}, there are three other fill-color
options:

	{cmd:graphregion(ifcolor())}{col 34}{...}
fills {it:inner graph region}   <-- {it:of little use}
{...}
	{cmd:plotregion(fcolor())}{col 34}{...}
fills {it:outer plot region}    <-- {it:useful}
{...}
	{cmd:plotregion(ifcolor())}{col 34}{...}
fills {it:inner plot region}    <-- {it:could be useful}

{pstd}
{cmd:plotregion(fcolor())} is worth remembering.  Below we make
the plot region a light gray:

	{cmd:. scatter mpg weight, plotr(fcolor(gs13))}
	  {it:({stata `"gr_example auto: scatter mpg weight, plotr(fc(gs13))"':click to run})}
{* graph regopts9}{...}

{pstd}
The other two options -- {cmd:graphregion(ifcolor())}
and
{cmd:plotregion(ifcolor())} -- fill the {it:inner graph region} and
{it:inner plot region}.
Filling the {it:inner graph region} serves little purpose.
Filling the {it:inner plot region} -- which is the same as the
{it:outer plot region} except that it omits the margin between
the {it:inner plot region} and the axes -- generally makes graphs appear
too busy.


{marker remarks5}{...}
{title:How graphs are constructed}

{pstd}
{cmd:graph} works from the outside in, with the result that the dimensions of
the {it:plot region} are what are left over.

{pstd}
{cmd:graph} begins with the {it:available area}, the size of which is
determined by the {cmd:xsize()} and {cmd:ysize()} options.
{cmd:graph} indents on all four sides by
{cmd:graphregion(margin())}, so it defines the outer border of the
{it:graph region}, the interior of which is the
{it:inner graph region}.

{pstd}
Overall titles (if any) are now placed on the graph, and on each of the four
sides, those titles are allocated whatever space they require.  Next are
placed any axis titles and labels, and they too are allocated whatever space
necessary.  That then determines the outer border of the {it:plot region}
(or, more properly, the border of the {it:outer plot region}).

{pstd}
The axis (if any) is placed right on top of that border.  {cmd:graph} now
indents on all four sides by {cmd:plotregion(margin())}, and that determines the
inner border of the plot region, meaning the border of the
({it:inner}) {it:plot region}.  It is inside this that the data are plotted.

{pstd}
An implication of the above is that, if {cmd:plotregion(margin(zero))},
the axes are not offset from the region in which the data are plotted.

{pstd}
Now consider the lines used to outline the regions and the fill colors
used to shade their interiors.

{pstd}
Starting once again with the {it:available area}, {cmd:graph} outlines its
borders by using {cmd:graphregion(lstyle())} -- which is usually
{cmd:graphregion(lstyle(none))} -- and fills the area
with the {cmd:graphregion(fcolor())}.

{pstd}
{cmd:graph} now moves to the inner border of the {it:graph region}, outlines
it using {cmd:graphregion(ilstyle())}, and fills the {it:graph region} with
{cmd:graphregion(ifcolor())}.

{pstd}
{cmd:graph} moves to the outer border of the {it:plot region}, outlines it
using {cmd:plotregion(lstyle())}, and fills the {it:outer plot region}
with {cmd:plotregion(fcolor())}.

{pstd}
Finally, {cmd:graph} moves to the inner border of the {it:plot region},
outlines it using {cmd:plotregion(ilstyle())}, and fills the ({it:inner})
{it:plot region} with {cmd:plotregion(ifcolor())}.


{title:Also see}

{psee}
Manual:  {bf:[G] {it:region_options}}

{psee}
Online:  
{manhelpi areastyle G},
{manhelpi colorstyle G},
{manhelpi linestyle G},
{manhelpi linewidthstyle G},
{manhelpi linepatternstyle G},
{manhelpi marginstyle G}
{p_end}
