{smcl}
{* *! version 1.0.4  13may2008}{...}
{cmd:help relativesize}
{hline}

{title:Title}

{p2colset 5 25 27 2}{...}
{p2col :{hi:[G] {it:relativesize}} {hline 2}}Choices for sizes of objects{p_end}
{p2colreset}{...}


{title:Syntax}

{p2colset 9 32 34 2}{...}
{p2col:{it:relativesize}}
	description{p_end}
{p2line}
{p2col:{it:#}}
	specify size;
	size 100 = minimum of width and height of graph;
	{it:#} must be >= 0, depending on context{p_end}

{p2col:{cmd:*}{it:#}}
	specify size change via multiplication;
	{cmd:*1} means no change, {cmd:*2} twice as large, {cmd:*.5} half;
	{it:#} must be >= 0, depending on context{p_end}
{p2line}
{pin}
Negative sizes are allowed in certain contexts, such as for gaps;
in other cases, such as the size of symbol, the size must be nonnegative, and
negative sizes, if specified, are ignored.

{phang}
Examples:{break}

{p2col:{it:example}}
	description{p_end}
{p2line}
{p2col:{cmd:msize(2)}}
	make marker diameter 2% of {it:g}{p_end}
{p2col:{cmd:msize(1.5)}}
	make marker diameter 1.5% of {it:g}{p_end}
{p2col:{cmd:msize(.5)}}
	make marker diameter .5% of {it:g}{p_end}
{p2col:{cmd:msize(*2)}}
	make marker size twice as large as default{p_end}
{p2col:{cmd:msize(*1.5)}}
	make marker size 1.5 times as large as default{p_end}
{p2col:{cmd:msize(*.5)}}
	make marker size half as large as default{p_end}

{p2col:{cmd:xsca(titlegap(2))}}
	make gap 2% of {it:g}{p_end}
{p2col:{cmd:xsca(titlegap(.5))}}
	make gap .5% of {it:g}{p_end}
{p2col:{cmd:xsca(titlegap(-2))}}
	make gap -2% of {it:g}{p_end}
{p2col:{cmd:xsca(titlegap(-.5))}}
	make gap -.5% of {it:g}{p_end}
{p2col:{cmd:xsca(titlegap(*2))}}
	make gap twice as large as default{p_end}
{p2col:{cmd:xsca(titlegap(*.5))}}
	make gap half as large as default{p_end}
{p2col:{cmd:xsca(titlegap(*-2))}}
	make gap -2 times as large as default{p_end}
{p2col:{cmd:xsca(titlegap(*-.5))}}
	make gap -.5 times as large as default{p_end}
{p2line}
{p2colreset}{...}
{pin}
where {it:g} = min(width of graph, height of graph)


{title:Description}

{pstd}
A {it:relativesize} specifies a size relative to the graph (or subgraph) being
drawn.  Thus as the size of the graph changes, so does the size of the
object.


{title:Remarks}

{pstd}
{it:relativesize} is allowed, for instance, as a {it:textsizestyle} or
a {it:markersizestyle} -- see {manhelpi textsizestyle G} and
{manhelpi markersizestyle G} -- and as the size of many other things, as
well.

{pstd}
Relative sizes are not restricted to being integers; relative
sizes of .5, 1.25, 15.1, etc., are allowed.


{title:Also see}

{psee}
Manual:  {bf:[G] {it:relativesize}}

{psee}
Online:  
{manhelpi markersizestyle G},
{manhelpi textsizestyle G}
{p_end}
