{smcl}
{* *! version 1.0.7  13may2008}{...}
{cmd:help rspike_options}
{hline}
{* index twoway rspike}{...}

{title:Title}

{p2colset 5 27 29 2}{...}
{p2col:{hi:[G] {it:rspike_options}} {hline 2}}Options for determining the look of range spikes{p_end}
{p2colreset}{...}


{title:Syntax}

{p2colset 9 38 40 2}{...}
{p2col:{it:rspike_options}}
	description{p_end}
{p2line}
{p2col:{cmdab:lp:attern:(}{it:{help linepatternstyle}}{cmd:)}}
	whether spike line is solid, dashed, etc.{p_end}
{p2col:{cmdab:lw:idth:(}{it:{help linewidthstyle}}{cmd:)}}
	thickness of spike line{p_end}
{p2col:{cmdab:lc:olor:(}{it:{help colorstyle}}{cmd:)}}
	color of spike line{p_end}

{p2col:{cmdab:lsty:le:(}{it:{help linestyle}}{cmd:)}}
	overall style of spike line{p_end}
{p2col:{cmdab:psty:le:(}{it:{help pstyle}}{cmd:)}}
	overall plot style, including line style{p_end}

{p2col:{help advanced_options:{bf:recast(}{it:newplottype}{bf:)}}}
	advanced; treat plot as {it:newplottype}{p_end}
{p2line}
{p2colreset}{...}
{pin}
All options are {it:rightmost}; see {help repeated options}.


{title:Description}

{pstd}
The {it:rspike_options} determine the look of spikes (lines connecting two
points vertically or horizontally) in most contexts.


{title:Options}

{phang}
{cmd:lpattern(}{it:linepatternstyle}{cmd:)}
    specifies whether the line for the spike is solid, dashed, etc.
    See {manhelpi linepatternstyle G} for a list of available patterns.

{phang}
{cmd:lwidth(}{it:linewidthstyle}{cmd:)}
    specifies the thickness of the line for the spike.
    See {manhelpi linewidthstyle G} for a list of available thicknesses.

{phang}
{cmd:lcolor(}{it:colorstyle}{cmd:)}
    specifies the color of the line for the spike.  See {manhelpi colorstyle G}
    for a list of available colors.

{phang}
{cmd:lstyle(}{it:linestyle}{cmd:)}
    specifies the overall style of the line for the spike:  its pattern,
    thickness, and color.

{pmore}
    You need not specify {cmd:lstyle()} just because there is something
    you want to change about the look of the spike.  The other
    {it:rspike_options} will allow you to make changes.  You specify
    {cmd:lstyle()} when another style exists that is exactly what you want 
    or when another style would allow you to specify fewer changes.

{pmore}
    See {manhelpi linestyle G} for a list of available line styles.

{phang}
{cmd:pstyle(}{it:pstyle}{cmd:)}
    specifies the overall style of the plot, including not only the line style
    but also all other settings for the look of the plot.  Only the 
    {it:{help linestyle}} affects the look of spikes.  See 
    {manhelpi pstyle G} for a list of available plot styles.

{phang}
{cmd:recast(}{it:newplottype}{cmd:)}
        is an advanced option allowing the plot to be recast from one type to
        another, for example, from a {help twoway rspike:range spike plot} to 
	a {help twoway rarea:range area plot}; see 
        {manhelpi advanced_options G}.  Most, but not all, plots allow
        {cmd:recast()}.


{title:Remarks}

{pstd}
Range spikes are used in many contexts.  They are sometimes the default for
confidence intervals.  For instance, the {cmd:lcolor()} suboption of
{cmd:ciopts()} in

{phang2}
	{cmd:. ltable age, graph ciopts(lcolor(red))}

{pstd}
causes the color of the horizontal lines representing the confidence intervals
in the life-table graph to be drawn in red.


{title:Also see}

{psee}
Manual:  {bf:[G]} {it:rspike_options}

{psee}
Online:  
{manhelp lines G:concept: lines}
{p_end}
