{smcl}
{* *! version 1.0.6  13may2008}{...}
{cmd:help saving_option}
{hline}
{* index saving() tt option}{...}

{title:Title}

{p2colset 5 26 28 2}{...}
{p2col :{hi:[G] {it:saving_option}} {hline 2}}Option for saving graph to disk{p_end}
{p2colreset}{...}


{title:Syntax}

{p2colset 9 42 45 2}{...}
{p2col:{it:saving_option}}
	description{p_end}
{p2line}
{p2col:{cmd:saving(}{it:filename} [{cmd:,} {it:suboptions}]{cmd:)}}
	save graph to disk{p_end}
{p2line}
	{cmd:saving()} is {it:unique}; see {help repeated options}.


{p2col:{it:suboptions}}
	description{p_end}
{p2line}
{p2col:{cmd:asis}}
	freeze graph and save as is{p_end}
{p2col:{cmd:replace}}
	okay to replace existing {it:filename}{p_end}
{p2line}
{p2colreset}{...}


{title:Description}

{pstd}
Option {cmd:saving()} saves the graph to disk.


{title:Option}

{phang}
{cmd:saving(}{it:filename} [{cmd:,} {it:suboptions}]{cmd:)}
    specifies the name of the diskfile to be created or replaced.
    If {it:filename} is specified without an extension, {cmd:.gph}
    will be assumed.


{title:Suboptions}

{phang}
{cmd:asis} specifies that the graph be frozen and saved just as it is.
    The alternative -- and the default if {cmd:asis} is not
    specified -- is known as live format.  In live format, the graph can
    continue to be edited in future sessions, and the overall
    look of the graph continues to be controlled by the chosen scheme (see
    {manhelp schemes G:schemes intro}).

{pmore}Say that you type

	    {cmd:. scatter yvar xvar,} ... {cmd:saving(mygraph)}

{pmore}
    That will create file {cmd:mygraph.gph}.  Now pretend you send that file
    to a colleague.  The way the graph appears on your colleague's computer
    might be different from how it appears on yours.  Perhaps you display titles
    on the top and your colleague has set his scheme to display titles on the
    bottom.  Or perhaps your colleague prefers the {it:y} axis on the right
    rather than the left.  It will still be the same graph,
    but it might have a different look.

{pmore}
    Or perhaps you just file away {cmd:mygraph.gph} for use later.  If you
    store it in the default live format, you can come back to it later and
    change the way it looks by specifying a different scheme or can edit it.

{pmore}
    If, on the other hand, you specify {cmd:asis}, the graph will look forever
    just as it looked the instant it was saved.  You cannot edit it; you
    cannot change the scheme.  If you send the as-is graph to colleagues,
    they will see it in exactly the form you see it.

{pmore}
    Whether a graph is saved as-is or live makes no difference for 
    printing.  As-is graphs usually require fewer bytes to store, and they
    generally display more quickly, but that is all.

{pstd}
{cmd:replace} specifies that the file may be replaced if it already exists.


{title:Remarks}

{pstd}
To save a graph permanently, you add {cmd:saving()} to the end of the
{cmd:graph} command (or any place among the options):


	{cmd:. graph} ... {cmd:,} ... {cmd:saving(myfile)} ...
	(file myfile.gph saved)

{pstd}
You can also achieve the same result in two steps:

	{cmd:. graph} ... {cmd:,} ...

	{cmd:. graph save myfile}
	(file myfile.gph saved)

{pstd}
The advantage of the two-part construction is that you can edit the graph
between the time you first draw it and save it.
The advantage of the one-part construction is that you will not forget to
save it.


{title:Also see}

{psee}
Manual:  {bf:[G] {it:saving_option}}

{psee}
Online:  
{manhelp graph_save G:graph save},
{manhelp graph_export G:graph export};
{manhelp gph_files G:concept: gph files},
{manhelp graph_manipulation G:graph manipulation}
{p_end}
