{smcl}
{* *! version 1.0.4  13may2008}{...}
{cmd:help scale_option}
{hline}
{* index scale() tt option}{...}

{title:Title}

{p2colset 5 25 27 2}{...}
{p2col :{hi:[G] {it:scale_option}} {hline 2}}Option for resizing text, markers, and line widths{p_end}
{p2colreset}{...}


{title:Syntax}

{p2colset 9 40 42 2}{...}
{p2col:{it:scale_option}}description{p_end}
{p2line}
{p2col:{cmd:scale(}{it:#}{cmd:)}}specify scale; default is {cmd:scale(1)}{p_end}
{p2line}
{p2colreset}{...}
	{cmd:scale()} is {it:unique}; see {help repeated options}.


{title:Description}

{pstd}
Option {cmd:scale()} makes all the text, markers, and line widths on a graph
larger or smaller.


{title:Option}

{phang}
{cmd:scale(}{it:#}{cmd:)}
    specifies a multiplier that affects the size of all text, markers, and
    line widths on a graph.  {cmd:scale(1)} is the default.

{pmore}
    To increase the size of all text, markers, and line widths on a graph by
    20%, specify {cmd:scale(1.2)}.  To reduce the size of all text, markers,
    and line widths on a graph by 20%, specify {cmd:scale(.8)}.


{title:Remarks}

{pstd}
Under {hi:Advanced use} in {manhelpi marker_label_options G}, we showed
the following graph,

	{cmd}. twoway (scatter lexp gnppc, mlabel(country) mlablv(pos))
		 (line hat gnppc, sort)
		 , xsca(log) xlabel(.5 5 10 15 20 25 30, grid)
		   legend(off)
		   title("Life expectancy vs. GNP per capita")
		   subtitle("North, Central, and South America")
		   note("Data source:  World bank, 1998")
		   ytitle("Life expectancy at birth (years)"){txt}
	  {it:({stata "gr_example2 markerlabel3":click to run})}{txt}
{* graph markerlabel3}{...}

{pstd}
Here is the same graph with the size of all text, markers, and line widths
increased by 10%:

	{cmd}. twoway (scatter lexp gnppc, mlabel(country) mlablv(pos))
		 (line hat gnppc, sort)
		 , xsca(log) xlabel(.5 5 10 15 20 25 30, grid)
		   legend(off)
		   title("Life expectancy vs. GNP per capita")
		   subtitle("North, Central, and South America")
		   note("Data source:  World bank, 1998")
		   ytitle("Life expectancy at birth (years)")
		   scale(1.1){txt}{right:<-- {it:new}  }
	  {it:({stata "gr_example2 markerlabel4":click to run})}{txt}
{* graph markerlabel4}{...}

{pstd}
All we did was add the option {cmd:scale(1.1)} to the original command.


{title:Also see}

{psee}
Manual:  {bf:[G] {it:scale_option}}

{psee}
Online:  {manhelp graph G}
{p_end}
