{smcl}
{* *! version 1.0.8  02may2007}{...}
{cmd:help signrank}, {cmd:help signtest} {right:dialogs:  {bf:{dialog signrank}}  {bf:{dialog signtest}}}
{hline}

{title:Title}

{p2colset 5 21 23 2}{...}
{p2col :{hi:[R] signrank} {hline 2}}Equality tests on matched data{p_end}
{p2colreset}{...}


{title:Syntax}

{phang}
Wilcoxon matched-pairs signed-ranks test

{p 8 20 2} 
{cmd:signrank} {varname} {cmd:=} {it:{help exp}} {ifin} 


{phang}
Sign test of matched pairs

{p 8 20 2}
{cmd:signtest} {varname} {cmd:=} {it:{help exp}} {ifin} 


{phang}
{cmd:by} is allowed with {cmd:signrank} and {cmd:signtest}; see
{manhelp by D}. 


{title:Description}

{pstd}
{cmd:signrank} tests the equality of matched pairs of observations by using the
Wilcoxon matched-pairs signed-ranks test (Wilcoxon 1945).  The null hypothesis
is that both distributions are the same.

{pstd}
{cmd:signtest} also tests the equality of matched pairs of observations
(Arbuthnott 1712, but better explained by Snedecor and Cochran 1989) by
calculating the difference between {it:varname} and the expression.  The null
hypothesis is that the median of the differences is zero; no further
assumptions are made about the distributions.  This, in turn, is equivalent to
the hypothesis that the true proportion of positive (negative) signs is
one-half.

{pstd}
For equality tests on unmatched data, see {manhelp ranksum R}.


{title:Examples}

{phang}{cmd:. webuse fuel}{p_end}
{phang}{cmd:. signrank mpg1 = mpg2}{p_end}
{phang}{cmd:. signtest mpg1 = mpg2}{p_end}


{title:Saved results}

{pstd}
{cmd:signrank} saves the following in {cmd:r()}:

{synoptset 15 tabbed}{...}
{p2col 5 15 19 2: Scalars}{p_end}
{synopt:{cmd:r(N_neg)}}number of negative comparisons{p_end}
{synopt:{cmd:r(N_pos)}}number of positive comparisons{p_end}
{synopt:{cmd:r(N_tie)}}number of tied comparisons{p_end}
{synopt:{cmd:r(sum_pos)}}sum of the positive ranks{p_end}
{synopt:{cmd:r(sum_neg)}}sum of the negative ranks{p_end}
{synopt:{cmd:r(z)}}z statistic{p_end}
{synopt:{cmd:r(Var_a)}}adjusted variance{p_end}

{pstd}
{cmd:signtest} saves the following in {cmd:r()}:

{synoptset 15 tabbed}{...}
{p2col 5 15 19 2: Scalars}{p_end}
{synopt:{cmd:r(N_neg)}}number of negative comparisons{p_end}
{synopt:{cmd:r(N_pos)}}number of positive comparisons{p_end}
{synopt:{cmd:r(N_tie)}}number of tied comparisons{p_end}
{synopt:{cmd:r(p_2)}}two-sided probability{p_end}
{synopt:{cmd:r(p_neg)}}one-sided probability of negative comparison{p_end}
{synopt:{cmd:r(p_pos)}}one-sided probability of positive comparison{p_end}
{p2colreset}{...}


{title:References}

{phang}
Arbuthnott, J. 1712. An argument for divine providence, taken from the
constant regularity observed in the births of both sexes.
{it:Philosophical Transactions} 27: 186-190.

{phang}
Snedecor, G. W., and W. G. Cochran. 1989. {it:Statistical Methods}. 8th ed.
Ames, IA: Iowa State University Press.

{phang}
Wilcoxon, F. 1945. Individual comparisons by ranking methods.
{it:Biometrics} 1: 80-83.


{title:Also see}

{psee}Manual:  {hi:[R] signrank}{p_end}

{psee}Online:  {manhelp ranksum R}, {manhelp ttest R}{p_end}
