{smcl}
{* *! version 1.0.5  19dec2007}{...}
{cmd:help sj}
{hline}

{title:Title}

{p2colset 5 15 17 2}{...}
{p2col:{hi:[R] sj} {hline 2}}Stata Journal installation instructions{p_end}
{p2colreset}{...}


{title:Description}

{pstd}
The {bf:Stata Journal} (SJ) is a quarterly journal containing articles about
statistics, data analysis, teaching methods, and effective use of Stata's
language.  The SJ publishes reviewed papers together with shorter notes
and comments, regular columns, book reviews, and other material of interest to
researchers applying statistics in a variety of disciplines.  You can read all
about the Stata Journal at {browse "http://www.stata-journal.com"}.

{pstd}
The Stata Journal is a printed and electronic journal with corresponding
software.  If you want the journal you must subscribe, but the software is
available for free from our web site {browse "http://www.stata-journal.com"}.

{pstd}
As an example, the table of contents for the Stata Journal, Volume 6, 
{bind:Number 1}, is

{center:{hline 71}}
{center:{bf:Articles and Columns} {space 48} 1}

{center:Estimating variance components in Stata. . . . . . .  Y. Marchenko    1}
{center:Automatic generation of documents. . . . . R. Gini and J. Pasquini   22}
{center:Generalized least squares for trend estimation of summarized{space 10}} 
{center:{space 5}dose-response data. . N. Orsini, R. Bellocco, and S. Greenland   40}
{center:Generalized ordered logit/partial proportional odds models for{space 9}}
{center:{space 5}ordinal dependent variables . . . . . . . . . . . R. Williams   58}
{center:Explained variation for survival models. . . . . . . .  P. Royston   83}
{center:Goodness-of-fit test for a logistic regression model fitted using{space 5}}
{center:{space 5}survey sample data . . . . . . .  K. J. Archer and S. Lemeshow   97}
{center:Decomposing inequality and obtaining marginal effects. . . . . . . {space 3}}
{center:{space 5} . . . . . . . . . . . . . . . . . . . . . . A. L{c o'}pez-Feldman  106 }
{center:Mata Matters:  Creating new variables{hline 2}sounds boring, isn't. . . . {space 3}}
{center:{space 5} . . . . . . . . . . . . . . . . . . . . . . . . . . W. Gould  112}
{center:Speaking Stata: Time of day. . . . . . . . . . . . . . .  N.J. Cox  124}
{center:Review of Multilevel and Longitudinal Modeling Using Stata by{space 10}}
{center:{space 5}Rabe-Hesketh and Skrondal. . . . . . . . . . . . . .  R. Wolfe  138}

{center:{bf:Notes and Comments} {space 48} 144}

{center:Stata tip 28: Precise control of dataset sort order. . . P. Schumm  144}
{center:Stata tip 29: For all times and all places. . . . . C. H. Franklin  147}
{center:Stata tip 30: May the source be with you . . . . . . . . N. J. Cox  149}

{center:{bf:Software Updates} {space 50} 151}
{center:{hline 71}}

{pstd}
The Stata Journal, Volume 1, Issue 1, began publication in the fourth quarter
of 2001.  The predecessor to the Stata Journal was the Stata Technical Bulletin
(STB); see {help stb}.  The STB began publication in May 1991 and was the
first publication of its kind for statistical software users.

{pstd}
To see the table of contents for the latest SJ (or any SJ), see
{browse "http://www.stata-journal.com/archives.html"}.


{title:Obtaining user-written additions from the SJ}

{pstd}
The SJ user-written additions are easily obtained.
You can {net "from http://www.stata-journal.com/software":click here}

{p 4 15 2}Or {space 4} 1) Select {bf:Help > SJ and User-written Programs}{p_end}
{p 12 15 2}2) Click on Stata Journal{p_end}

{pstd}
Or use the command line and type

	    {inp:. net from http://www.stata-journal.com/software}

{pstd}
See {manhelp net R}.  What to do next will be obvious.


{title:Subscribing to the SJ}

{pstd}
Subscriptions to and back issues of the Stata Journal are available from
StataCorp.

	    StataCorp
	    4905 Lakeway Drive
	    College Station, Texas 77845

	    {browse "http://www.stata.com"}
	    {browse "mailto:stata@stata.com":stata@stata.com}

	    800-782-8272  (800-STATAPC, USA)
	    800-248-8272  (Canada)
	    979-696-4600  (Worldwide)
	    979-696-4601  (Fax)


{title:Also see}

{psee}
Manual:  {bf:[R] sj}

{psee}
Online:  {manhelp net R}, {manhelp net_search R:net search},
{manhelp statalist U:3.4 The Stata listserver},
{manhelp search R}, {help stb}, {manhelp update R}, {help whatsnew}
{p_end}
