{smcl}
{* *! version 1.0.8  27mar2008}{...}
{cmd:help sktest} {right:dialog:  {bf:{dialog sktest}}}
{hline}

{title:Title}

{p2colset 5 19 21 2}{...}
{p2col:{hi:[R] sktest} {hline 2}}Skewness and kurtosis test for
normality{p_end}
{p2colreset}{...}


{title:Syntax}

{p 8 15 2}
{cmd:sktest}
{varlist}
{ifin}
{weight}
[{cmd:,} {opt noa:djust}]

{p 4 6 2}
{opt aweight}s and {opt fweight}s are allowed; see {help weight}.


{title:Description}

{pstd}
For each variable in {varlist}, {opt sktest} presents a test for
normality based on skewness and another based on kurtosis and then combines
the two tests into an overall test statistic.  {opt sktest} requires a minimum
of 8 observations to make its calculations.


{title:Option}

{dlgtab:Main}

{phang}
{opt noadjust} suppresses the empirical adjustment made by Royston (1991)
to the overall chi-squared and its significance level and presents the
unaltered test as described by D'Agostino, Balanger, and D'Agostino Jr. (1990).


{title:Example}

{phang}{cmd:. sysuse auto}{p_end}
{phang}{cmd:. sktest mpg trunk}


{title:Saved results}

{pstd}
{cmd:sktest} saves the following in {cmd:r()}:

{synoptset 15 tabbed}{...}
{p2col 5 15 19 2: Scalars}{p_end}
{synopt:{cmd:r(chi2)}}chi-squared{p_end}
{synopt:{cmd:r(P_skew)}}Pr(skewness){p_end}
{synopt:{cmd:r(P_kurt)}}Pr(kurtosis){p_end}
{synopt:{cmd:r(P_chi2)}}Prob > chi2{p_end}
{p2colreset}{...}

{synoptset 15 tabbed}{...}
{p2col 5 15 19 2: Matrices}{p_end}
{synopt:{cmd:r(Utest)}}matrix of test results, one row per variable{p_end}
{p2colreset}{...}


{title:References}

{phang}
D'Agostino, R. B., A. Balanger, and R. B. D'Agostino, Jr. 1990.
A suggestion for using powerful and informative tests of normality.
{it:American Statistician} 44: 316-321.

{phang}
Royston, P. 1991. sg3.5: Comment on sg3.4 and an improved D'Agostino test.
{browse "http://www.stata.com/products/stb/journals/stb3.pdf":{it:Stata Technical Bulletin} 3}: 19.
Reprinted in {it:Stata Technical Bulletin Reprints}, vol. 1, pp. 110-112.


{title:Also see}

{psee}
Manual:  {bf:[R] sktest}

{psee}
Online:  {manhelp diagnostic_plots R:diagnostic plots},
{manhelp ladder R}, {manhelp lv R}, {manhelp swilk R}
{p_end}
