{smcl}
{* *! version 1.1.0  04dec2008}{...}
{cmd:help stcox}{right:dialogs:  {bf:{dialog stcox}}  {dialog stcox, message(-svy-) name(svy_stcox):svy: stcox}{space 3}}
{right:also see:  {help stcox postestimation}}
{hline}

{title:Title}

{p2colset 5 19 21 2}{...}
{p2col :{hi:[ST] stcox} {hline 2}}Fit Cox proportional hazards model{p_end}
{p2colreset}{...}


{title:Syntax}

{p 8 17 2}
{cmd:stcox} [{varlist}] {ifin} [{cmd:,}
{it:options}] 

{synoptset 21 tabbed}{...}
{synopthdr}
{synoptline}
{syntab:Model}
{synopt :{opt esti:mate}}fit model without covariates{p_end}
{synopt :{opth st:rata(varlist:varnames)}}strata ID variables{p_end}
{synopt :{opth sh:ared(varname)}}shared-frailty ID variable{p_end}
{synopt :{opth off:set(varname)}}include {it:varname} in model with coefficient constrained to 1{p_end}
{synopt :{opt bre:slow}}use Breslow method to handle tied failures; the default{p_end}
{synopt :{opt efr:on}}use Efron method to handle tied failures{p_end}
{synopt :{opt exactm}}use exact marginal-likelihood method to handle tied failures{p_end}
{synopt :{opt exactp}}use exact partial-likelihood method to handle tied failures{p_end}

{syntab:Time varying}
{synopt :{opth tvc(varlist)}}time-varying covariates{p_end}
{synopt :{opth texp(exp)}}multiplier for time-varying covariates; default is {cmd:texp(_t)}{p_end}

{syntab:SE/Robust}
{synopt :{opt vce(vcetype)}}{it:vcetype} may be {opt oim},
  {opt r:obust}, {opt cl:uster} {it:clustvar}, {opt boot:strap}, or
  {opt jack:knife}{p_end}
{synopt :{opt noadj:ust}}do not use standard degree-of-freedom adjustment{p_end}

{syntab:Reporting}
{synopt :{opt l:evel(#)}}set confidence level; default is {cmd:level(95)}{p_end}
{synopt :{opt nohr}}report coefficients, not hazard ratios{p_end}
{synopt :{opt nosh:ow}}do not show st setting information{p_end}

{syntab:Reporting 2}
{synopt :{opth mg:ale(newvar)}}create {it:newvar} containing partial martingale residuals{p_end}
{synopt :{opth basec:hazard(newvar)}}create {it:newvar} containing cumulative baseline hazard{p_end}
{synopt :{opth basehc(newvar)}}create {it:newvar} containing baseline hazard contributions{p_end}
{synopt :{opth bases:urv(newvar)}}create {it:newvar} containing baseline survivor function{p_end}
{synopt :{opth eff:ects(newvar)}}create {it:newvar} containing estimated log-frailties{p_end}
{synopt :{opth "esr(newvar:newvars)"}}create {it:newvar} containing partial efficient score residuals{p_end}
{synopt :{opth sch:oenfeld(newvar:newvars)}}create {it:newvar} containing Schoenfeld residuals{p_end}
{synopt :{opth sca:ledsch(newvar:newvars)}}create {it:newvar} containing scaled Schoenfeld residuals{p_end}

{syntab:Max options}
{synopt :{it:{help stcox##maximize_options:maximize_options}}}control the maximization process; seldom used{p_end}
{synoptline}
{p2colreset}{...}
{p 4 6 2}
You must {cmd:stset} your data before using {cmd:stcox}; see
{manhelp stset ST}.{p_end}
{p 4 6 2}
{cmd:bootstrap}, {cmd:by}, {cmd:jackknife}, {cmd:nestreg},
{cmd:statsby}, {cmd:stepwise}, {cmd:svy}, and {cmd:xi} are allowed; see
{help prefix}.{p_end}
{p 4 6 2}
{opt estimate},
{opt shared()},
{opt efron},
{opt exactm},
{opt exactp},
{opt tvc()},
{opt texp()},
{opt vce()},
{opt noadjust}, 
{opt mgale()},
{opt schoenfeld()}, 
and 
{opt scaledsch()}
are not allowed with the {helpb svy} prefix.
{p_end}
{p 4 6 2}
{cmd:fweight}s, {cmd:iweight}s, and {cmd:pweight}s may be specified using 
{cmd:stset}; see {manhelp stset ST}. However, weights may not be specified if
you are using the {cmd:bootstrap} prefix with the {cmd:stcox} command.{p_end}
{p 4 6 2}
See {manhelp stcox_postestimation ST:stcox postestimation} for features
available after estimation.{p_end}


{title:Description}

{pstd}
{cmd:stcox} fits, via maximum likelihood, proportional hazards models on 
{help st} data.  {cmd:stcox} can be used with single- or multiple-record or 
single- or multiple-failure st data.


{title:Options for stcox}

{dlgtab:Model}

{phang}
{opt estimate} forces the fitting of the null model.  All Stata estimation
commands redisplay results when the command name is typed without arguments.
So does {cmd:stcox}.  What if you wish to fit a Cox model on xb, where xb is 
defined as 0?  Logic says that you would type {cmd:stcox}.  There are no 
explanatory variables, so there is nothing to type after the command.
Unfortunately, {cmd:stcox} looks the same as {cmd:stcox} typed without 
arguments, which is a request to redisplay results.

{pmore}
To fit the null model, type {cmd:stcox, estimate}.

{phang}
{opth strata:(varlist:varnames)} specifies up to five strata variables.
Observations with equal values of the strata variables are assumed to be in 
the same stratum. Stratified estimates (equal coefficients across strata but 
with baseline hazard unique to each stratum) are then obtained.

{phang}
{opth shared(varname)} specifies that a Cox model with shared frailty be 
fitted.  Observations with equal value of {it:varname} are assumed to have
shared (the same) frailty.  Across groups, the frailties are assumed to be
gamma-distributed latent random effects that affect the hazard multiplicatively,
or, equivalently, the logarithm of the frailty enters the linear predictor as 
a random offset.  Think of a shared-frailty model as a Cox model for panel data.
{it:varname} is a variable in the data that identifies the groups.

{pmore}
See {hi:[ST] stcox} for more information on the {cmd:shared()} option.

{phang}
{opth offset(varname)}; see {helpb st estimation options##offset():[ST] estimation options}.

{phang}
{opt breslow}, {opt efron}, {opt exactm}, and {opt exactp} specify the
 method for handling tied failures in the calculation of the log partial 
likelihood (and residuals). {opt breslow} is the default.  
{opt efron} and the exact methods require substantially more computer time than
the default {opt breslow} option. {opt exactm} and {opt exactp} may not be 
specified with {opt tvc()}, {cmd:vce(robust)}, or {cmd:vce(cluster}
{it:clustvar}{cmd:)}.

{dlgtab: Time varying}

{phang}
{opth tvc(varlist)} specifies those variables that vary continuously with 
respect to time, i.e., time-varying covariates.  This is a convenience option 
used to speed up calculations and to avoid having to {cmd:stsplit} the data 
over many failure times.

{pmore}
{opt tvc(varlist)} may not be specified with any of the following options:
{opt basechazard()},
{opt basehc()},
{opt basesurv()},
{opt effects()},
{opt esr()},
{opt mgale()},
{opt scaledsch()},
{opt schoenfeld()}.
These options require that the data be {cmd:stsplit} in order to generate the
requested information.

{phang}
{opth texp(exp)} is used in conjunction with {opth tvc(varlist)} to specify 
the function of analysis time should be multiplied by the time-varying 
covariates. For example, specifying {cmd:texp(ln(_t))} would cause the 
time-varying covariates to be multiplied by the logarithm of analysis time. If 
{opt tvc(varlist)} is used without {opt texp(exp)}, Stata understands 
that you mean {cmd:texp(_t)}, and thus multiplies the time-varying covariates 
by the analysis time.

{pmore}
See {hi:[ST] stcox} for more information on the {cmd:tvc()} and
{cmd:texp()} options.

{dlgtab: SE/Robust}

INCLUDE help vce_asymptall

{phang}
{opt noadjust} is for use with {cmd:vce(robust)} or {cmd:vce(cluster}
{it:clustvar}{cmd:)}. {opt noadjust} prevents the estimated variance matrix
from being multiplied by N/(N-1) or g/(g-1), where g is the number of
clusters.  The default adjustment is somewhat arbitrary because it is not
always clear how to count observations or clusters.  In such cases, however,
the adjustment is likely to be biased toward 1, so we would still recommend
making it.

{dlgtab: Reporting}

{phang}
{opt level(#)}; see {helpb st estimation options##level():[ST] estimation options}.

{phang}
{opt nohr} specifies that coefficients be displayed rather than exponentiated
coefficients or hazard ratios.  This option affects only how results are
displayed and not how they are estimated.  {opt nohr} may be specified at
estimation time or when redisplaying previously estimated results (which you
do by typing {cmd:stcox} without a variable list).

{phang}
{opt noshow} prevents {cmd:stcox} from showing the key st variables.  This 
option is seldom used since most people type {cmd:stset, show} or 
{cmd:stset, noshow} to set whether they want to see these variables mentioned
at the top of the output of every st command; see {manhelp stset ST}.

{dlgtab: Reporting 2}

{phang}
{opth mgale(newvar)} adds {it:newvar} containing the partial
martingale residuals.  If each observation in your data represents a different
subject (single-record-per-subject data), the partial martingale residuals are
the martingale residuals. 

{pmore}
If you have data with multiple records per subject, the value that
{opt mgale()} stores in each observation is the observation's contribution to
the martingale residual, and these partial residuals can be summed within
{opt id()} to obtain the subject's martingale residual.  Say that you specify
{cmd:mgale(pmr)} and that you have previously {cmd:stset, id(patid)}.  Then
{cmd:egen mr = total(pmr), by(patid)} would create the martingale residuals.

{phang}
{opth basechazard(newvar)} adds {it:newvar} to the data containing the 
estimated cumulative baseline hazard. If {opt strata()} is also specified, 
cumulative baseline estimates for each stratum are provided.

{phang}
{opth basehc(newvar)} adds {it:newvar} to the data containing the estimated 
baseline hazard contributions.  These are used to construct the product-limit 
type estimator for the baseline survivor function generated by 
{opt basesurv()}.  If {opt strata()} is also specified, baseline estimates for 
each stratum are provided.

{phang}
{opth basesurv(newvar)} adds {it:newvar} to the data containing the estimated 
baseline survivor function.  In the null model, this is equivalent 
to the Kaplan-Meier product-limit estimate.  If {opt strata()} is also 
specified, baseline estimates for each stratum are provided.

{phang}
{opth effects(newvar)} is for use with {opt shared()} and creates {it:newvar} 
containing estimates of the log-frailty for each group. The log-frailties
are random group-specific offsets to the linear predictor that measure the 
group effect on the log-relative hazard.

{phang}
{opth esr:(newvar:newvars)} adds {it:newvars} containing the partial
efficient score residuals; see {hi:[ST] stcox}. If each observation in your data
represents a different subject (single-record-per-subject data), the partial
efficient score residuals are the efficient score residuals.

{pmore}
If you have data with multiple records per subject, the values {cmd:esr()} 
stores are each observation's contribution to the score residuals, and these
partial residuals can be summed within {opt id()} to form the subject's 
efficient score residuals.  This could be accomplished as noted under 
{opt mgale()} above.

{pmore}
One efficient score residual variable is created for each regressor in the 
model; the first new variable corresponds to the first regressor, the second
to the second, and so on. 

{phang}
{opth schoenfeld:(newvar:newvars)} adds {it:newvars} containing the Schoenfeld 
residuals. This option may not be used with the {opt exactm} and {opt exactp} 
options.  Schoenfeld residuals are calculated and reported only at failure 
times.

{pmore}
One Schoenfeld residual variable is created for each regressor in the model; the
first new variable corresponds to the first regressor, the second to the second,
and so on.

{phang}
{opth scaledsch:(newvar:newvars)} adds {it:newvars} containing the scaled 
Schoenfeld residuals.  This option may not be used with the {opt exactm} and 
{opt exactp} options.  Scaled Schoenfeld residuals are calculated and 
reported only at failure times.

{pmore}
One scaled Schoenfeld residual variable is created for each regressor in the 
model; the first new variable corresponds to the first regressor, the second 
to the second, and so on.

{phang}
{hi:Note:} the easiest way to specify the preceding three options is, for 
example, {opt esr(stub*)}, where {it:stub} is a short name of your choosing.  
Stata then creates variables {it:stub}{cmd:1}, {it:stub}{cmd:2}, etc. 
You may also specify each variable name explicitly, in which case 
there must be as many (and no more) variables specified in {cmd:esr()} as 
regressors in the model.

{pmore}
However, be aware that {cmd:stcox} will drop variables from the model because
of collinearity.  This is a desirable feature.  A side effect is that the
score residual variable, the Schoenfeld residual variable, and the scaled
Schoenfeld residual variable may not align with the regressors in the way you
expect.  Say that you fit a model by typing

{pmore2}
{cmd:. stcox x1 x2 x3, esr(r1 r2 r3)}

{pmore}
Usually, {opt r1} will contain the residual associated with {opt x1}, {opt r2}
the residual associated with {opt x2}, etc.

{pmore}
Now assume that {opt x2} is dropped because of collinearity.  Then 
{opt r1} will correspond to {opt x1}, {opt r2} to {opt x3}, and {opt r3} will
contain 0.  This happens because, after the collinear variables are omitted,
there are only two variables in the model: {opt x1} and {opt x3}.

{marker maximize_options}{...}
{dlgtab:Max options}
 
{phang}
{it:maximize_options}; {opt iter:ate(#)}, [{cmdab:no:}]{opt lo:g}, {opt tr:ace},
{opt tol:erance(#)}, {opt ltol:erance(#)}, {opt nrtol:erance(#)},
{opt nonrtol:erance}; see {manhelp maximize R}.  These
options are seldom used.
 
 
{title:Example of Cox regression with uncensored data}
 
{pstd}Setup{p_end}
{phang2}{cmd:. webuse kva}{p_end}

{pstd}List the data{p_end}
{phang2}{cmd:. list}

{pstd}Declare data to be survival-time data{p_end}
{phang2}{cmd:. stset failtime}{p_end}

{pstd}Fit Cox proportional hazards model{p_end}
{phang2}{cmd:. stcox load bearings}{p_end}

{pstd}Replay results, but show coefficients rather than hazard ratios{p_end}
{phang2}{cmd:. stcox, nohr}{p_end}


{title:Example of Cox regression with censored data}

{pstd}Setup{p_end}
{phang2}{cmd:. webuse drugtr}{p_end}

{pstd}Show st settings{p_end}
{phang2}{cmd:. stset}

{pstd}Fit Cox proportional hazards model{p_end}
{phang2}{cmd:. stcox drug age}


{title:Example of Cox regression with discrete time-varying covariates}

{pstd}Setup{p_end}
{phang2}{cmd:. webuse stan3}{p_end}
{phang2}{cmd:. stset}

{pstd}Fit Cox model{p_end}
{phang2}{cmd:. stcox age posttran surg year}

{pstd}Obtain robust estimate of variance{p_end}
{phang2}{cmd:. stcox age posttran surg year, vce(robust)}


{title:Example of Cox regression with continuous time-varying covariates}

{pstd}Setup{p_end}
{phang2}{cmd:. webuse drugtr2}

{pstd}List some of the data{p_end}
{phang2}{cmd:. list in 1/12, sep(0)}

{pstd}Declare data to be survival-time data{p_end}
{phang2}{cmd:. stset time, failure(cured)}

{pstd}Fit Cox model{p_end}
{phang2}{cmd:. stcox age drug1 drug2}

{pstd}Refit model taking into account that the actual level of the drug
remaining in the body diminishes exponentially with time{p_end}
{phang2}{cmd:. stcox age, tvc(drug1 drug2) texp(exp(-0.35*_t))}


{title:Example of Cox regression with multiple-failure data}

{pstd}Setup{p_end}
{phang2}{cmd:. webuse mfail}

{pstd}Fit model with robust estimate of variance{p_end}
{phang2}{cmd:. stcox x1 x2, vce(robust)}


{title:Example of stratified estimation}

{pstd}Setup{p_end}
{phang2}{cmd:. webuse stan3}

{pstd}Modify data to reflect changes in treatment 1970 and 1973{p_end}
{phang2}{cmd:. generate pgroup = year}{p_end}
{phang2}{cmd:. recode pgroup min/69=1 70/72=2 73/max=3}

{pstd}Fit Cox model{p_end}
{phang2}{cmd:. stcox age posttran surg year, strata(pgroup)}


{title:Example of Cox regression with shared frailty}

{pstd}Setup{p_end}
{phang2}{cmd:. webuse catheter, clear}

{pstd}List some of the data{p_end}
{phang2}{cmd:. list in 1/10}

{pstd}Declare data to be survival-time data{p_end}
{phang2}{cmd:. stset time, fail(infect)}

{pstd}Fit Cox model{p_end}
{phang2}{cmd:. stcox age female, shared(patient)}


{title:Example of Cox regression with survey data}

{pstd}Setup{p_end}
{phang2}{cmd:. webuse nhefs}

{pstd}Declare survey design for data{p_end}
{phang2}{cmd:. svyset psu2 [pw=swgt2], strata(strata2)}

{pstd}Declare data to be survival-time data{p_end}
{phang2}{cmd:. stset age_lung_cancer if age_lung_cancer < . [pw=swgt2],}
                   {cmd:fail(lung_cancer)}

{pstd}Fit Cox model taking into account data are survey data{p_end}
{phang2}{cmd:. svy: stcox former_smoker smoker male urban1 rural}{p_end}


{title:Saved results}

{pstd}
{cmd:stcox} saves the following in {cmd:e()}:

{synoptset 15 tabbed}{...}
{p2col 5 15 19 2: Scalars}{p_end}
{synopt:{cmd:e(N)}}number of observations{p_end}
{synopt:{cmd:e(N_sub)}}number of subjects{p_end}
{synopt:{cmd:e(N_fail)}}number of failures{p_end}
{synopt:{cmd:e(risk)}}total time at risk{p_end}
{synopt:{cmd:e(N_clust)}}number of clusters{p_end}
{synopt:{cmd:e(df_m)}}model degrees of freedom{p_end}
{synopt:{cmd:e(r2_p)}}pseudo-R-squared{p_end}
{synopt:{cmd:e(theta)}}frailty parameter{p_end}
{synopt:{cmd:e(chi2_c)}}chi-squared, comparison model{p_end}
{synopt:{cmd:e(p_c)}}significance, comparison model{p_end}
{synopt:{cmd:e(N_g)}}number of groups{p_end}
{synopt:{cmd:e(g_max)}}largest group size{p_end}
{synopt:{cmd:e(g_min)}}smallest group size{p_end}
{synopt:{cmd:e(g_avg)}}average group size{p_end}
{synopt:{cmd:e(ll)}}log likelihood{p_end}
{synopt:{cmd:e(ll_0)}}log likelihood, constant-only model{p_end}
{synopt:{cmd:e(chi2)}}chi-squared{p_end}
{synopt:{cmd:e(se_theta)}}standard error of theta{p_end}
{synopt:{cmd:e(ll_c)}}log likelihood, comparison model{p_end}

{synoptset 15 tabbed}{...}
{p2col 5 15 19 2: Macros}{p_end}
{synopt:{cmd:e(cmd)}}{cmd:cox} or {cmd:stcox_fr}{p_end}
{synopt:{cmd:e(cmd2)}}{cmd:stcox}{p_end}
{synopt:{cmd:e(cmdline)}}command as typed{p_end}
{synopt:{cmd:e(depvar)}}{cmd:_t}{p_end}
{synopt:{cmd:e(t0)}}{cmd:_t0}{p_end}
{synopt:{cmd:e(texp)}}function used for time-varying covariates{p_end}
{synopt:{cmd:e(ties)}}method used for handling ties{p_end}
{synopt:{cmd:e(shared)}}frailty grouping variable{p_end}
{synopt:{cmd:e(offset)}}offset{p_end}
{synopt:{cmd:e(clustvar)}}name of cluster variable{p_end}
{synopt:{cmd:e(re_var)}}variable containing estimated random effects{p_end}
{synopt:{cmd:e(bases)}}variable containing baseline survivor function{p_end}
{synopt:{cmd:e(basec)}}variable containing baseline cumulative hazard
	function{p_end}
{synopt:{cmd:e(basehc)}}variable containing baseline hazard contributions{p_end}
{synopt:{cmd:e(mgale)}}variable containing partial martingale residuals{p_end}
{synopt:{cmd:e(vl_esr)}}variables containing partial efficient score
	residuals{p_end}
{synopt:{cmd:e(vl_sch)}}variables containing Schoenfeld residuals{p_end}
{synopt:{cmd:e(vl_ssc)}}variables containing scaled Schoenfeld residuals{p_end}
{synopt:{cmd:e(chi2type)}}{cmd:Wald} or {cmd:LR}; type of model chi-squared
	test{p_end}
{synopt:{cmd:e(vce)}}{it:vcetype} specified in {cmd:vce()}{p_end}
{synopt:{cmd:e(vcetype)}}title used to label Std. Err.{p_end}
{synopt:{cmd:e(method)}}requested estimation method{p_end}
{synopt:{cmd:e(crittype)}}optimization criterion{p_end}
{synopt:{cmd:e(properties)}}{cmd:b V}{p_end}
{synopt:{cmd:e(estat_cmd)}}program used to implement {cmd:estat}{p_end}
{synopt:{cmd:e(footnote)}}program used to implement the footnote display{p_end}
{synopt:{cmd:e(predict)}}program used to implement {cmd:predict}{p_end}

{synoptset 15 tabbed}{...}
{p2col 5 15 19 2: Matrices}{p_end}
{synopt:{cmd:e(b)}}coefficient vector{p_end}
{synopt:{cmd:e(V)}}variance-covariance matrix of the estimators{p_end}

{synoptset 15 tabbed}{...}
{p2col 5 15 19 2: Functions}{p_end}
{synopt:{cmd:e(sample)}}marks estimation sample{p_end}
{p2colreset}{...}

 
{title:Also see}
 
{psee}
Manual:  {bf:[ST] stcox}
 
{psee}
Online:  {manhelp stcox_postestimation ST:stcox postestimation};
{manhelp stcurve ST};{break}
{manhelp stcox_diagnostics ST:stcox diagnostics}, 
{manhelp sts ST},
{manhelp stset ST},
{manhelp streg ST}
{p_end}
