{smcl}
{* *! version 1.0.9  25feb2008}{...}
{cmd:help stphplot}, {cmd:help stcoxkm} {right:dialogs:  {bf:{dialog stphplot}}  {bf:{dialog stcoxkm}}}
{hline}

{title:Title}

{p2colset 5 31 33 2}{...}
{p2col :{hi:[ST] stcox diagnostics} {hline 2}}stcox diagnostic plots{p_end}


{title:Syntax}

{phang}
Check proportional-hazards assumption:

{p 6 8 2}
Log-log plot of survival

{p 8 17 2}
{cmd:stphplot} [{it:if}] {cmd:,} {c -(}{opth by(varname)} | 
{opt str:ata(varname)}{c )-} [{it:{help stcox_diagnostics##stphplot_options:stphplot_options}}]


{p 6 8 2}
Kaplan-Meier and predicted survival plot

{p 8 17 2}
{cmd:stcoxkm} [{it:if}] {cmd:,} {opth by(varname)} [{it:{help stcox diagnostics##stcoxkm_options:stcoxkm_options}}]


{synoptset 33 tabbed}{...}
{marker stphplot_options}{...}
{synopthdr :stphplot_options}
{synoptline}
{syntab :Main}
{p2coldent :* {opth by(varname)}}fit separate Cox models; the default{p_end}
{p2coldent :* {opth str:ata(varname)}}fit stratified Cox model{p_end}
{synopt :{opth adj:ust(varlist)}}adjust to average values of {it:varlist}{p_end}
{synopt :{opt z:ero}}adjust to zero values of {it:varlist}; use with {opt adjust()}{p_end}

{syntab :Options}
{synopt :{opt noneg:ative}}plot ln{c -(}-ln(survival){c )-}{p_end}
{synopt :{opt nolnt:ime}}plot curves against analysis time{p_end}
{synopt :{opt nosh:ow}}do not show st setting information{p_end}

{syntab:Plot}
{synopt :{cmdab:plot:}{ul:{it:#}}{cmd:opts(}{help stcox_diagnostics##stphplot_plot_options:{it:stphplot_plot_options}}{cmd:)}}affect rendition of the {it:#}th connected line and {it:#}th plotted points{p_end}

{syntab:Add plots}
{synopt :{opth "addplot(addplot_option:plot)"}}add other plots to the generated graph{p_end}

{syntab:Y axis, X axis, Titles, Legend, Overall}
{synopt :{it:{help twoway_options}}}any options other than {opt by()} documented in {bind:{bf:[G] {it:twoway_options}}}{p_end}
{synoptline}
{p2colreset}{...}
{pstd}
* Either {opt by(varname)} or {opt strata(varname)} is required with 
{cmd:stphplot}.{p_end}


{synoptset 33}{...}
{marker stphplot_plot_options}{...}
{synopthdr:stphplot_plot_options}
{synoptline}
{synopt:{it:cline_options}}change look of lines or connecting method{p_end}
{synopt:{it:marker_options}}change look of markers (color, size, etc.){p_end}
{synoptline}
{p2colreset}{...}



{synoptset 33 tabbed}{...}
{marker stcoxkm_options}{...}
{synopthdr :stcoxkm_options}
{synoptline}
{syntab :Main}
{p2coldent :* {opth by(varname)}}report the nominal or ordinal covariate{p_end}
{synopt :{cmdab:tie:s(}{cmdab:bre:slow)}}use Breslow method to handle tied failures{p_end}
{synopt :{cmdab:tie:s(}{cmdab:efr:on)}}use Efron method to handle tied failures{p_end}
{synopt :{cmdab:tie:s(exactm)}}use exact marginal-likelihood method to handle tied failures{p_end}
{synopt :{cmdab:tie:s(exactp)}}use exact partial-likelihood method to handle tied failures{p_end}
{synopt :{opt sep:arate}}draw separate plot for predicted and observed curves{p_end}
{synopt :{opt nosh:ow}}do not show st setting information{p_end}

{syntab:Observed plot}
{synopt :{opth obsop:ts(stcox_diagnostics##stcoxkm_plot_options:stcoxkm_plot_options)}}affect rendition of the observed curve{p_end}
{synopt :{cmdab:obs:}{ul:{it:#}}{cmd:opts(}{help stcox_diagnostics##stcoxkm_plot_options:{it:stcoxkm_plot_options}}{cmd:)}}affect rendition of the {it:#}th observed curve; not allowed with {opt separate}{p_end}

{syntab:Predicted plot}
{synopt :{opth predop:ts(stcox_diagnostics##stcoxkm_plot_options:stcoxkm_plot_options)}}affect rendition of the predicted
curve{p_end}
{synopt :{cmdab:pred:}{ul:{it:#}}{cmd:opts(}{help stcox_diagnostics##stcoxkm_plot_options:{it:stcoxkm_plot_options}}{cmd:)}}affect rendition of the {it:#}th predicted curve; not allowed with {opt separate}{p_end}

{syntab:Add plots}
{synopt :{opth "addplot(addplot_option:plot)"}}add other plots to the generated graph{p_end}

{syntab:Y axis, X axis, Titles, Legend, Overall}
{synopt :{it:{help twoway_options}}}any options other than {opt by()} documented in {bind:{bf:[G] {it:twoway_options}}}{p_end}
{synopt :{opth byop:ts(by_option:byopts)}}how subgraphs are combined, labeled,
etc.{p_end}
{synoptline}
{p2colreset}{...}
{p 4 6 2}
* {opt by(varname)} is required with {cmd:stcoxkm}.{p_end}


{synoptset 33}{...}
{marker stcoxkm_plot_options}{...}
{synopthdr:stcoxkm_plot_options}
{synoptline}
{synopt:{it:connect_options}}change look of connecting method{p_end}
{synopt:{it:marker_options}}change look of markers (color, size, etc.){p_end}
{synoptline}
{p2colreset}{...}


{p 4 6 2}
You must {cmd:stset} your data before using {cmd:stphplot} and {cmd:stcoxkm};
see {manhelp stset ST}.{p_end}
{p 4 6 2}
{opt fweight}s, {opt iweight}s, and {opt pweight}s may be specified
using {cmd:stset}; see {manhelp stset ST}.


{title:Description}

{pstd}
{cmd:stphplot} plots -ln{c -(}-ln(survival){c )-} curves for each category of a
nominal or ordinal covariate versus ln(analysis time). These are often
referred to as "log-log" plots.  Optionally, these estimates can be adjusted
for covariates.  The proportional-hazards assumption is not violated when the
curves are parallel.

{pstd}
{cmd:stcoxkm} plots Kaplan-Meier observed survival curves and compares them
with the Cox predicted curves for the same variable.  The closer the observed
values are to the predicted, the less likely it is that the proportional-hazards
assumption has been violated.  Do not run {cmd:stcox} before running this
command; {cmd:stcoxkm} will execute {cmd:stcox} itself to fit the model and
obtain predicted values.


{title:Options for stphplot}

{dlgtab:Main}

{phang}
{opth by(varname)} specifies the nominal or ordinal covariate.  Either
{opt by()} or {opt strata()} is required with {cmd:stphplot}.

{phang}
{opth strata(varname)} is an alternative to {opt by()}.  Rather than fitting
separate Cox models for each value {it:varname}, {opt strata()} fits 
one stratified Cox model.  You must also specify {opth adjust(varlist)} 
with the {opt strata(varname)} option; see {manhelp sts_graph ST:sts graph}.

{phang}
{opth adjust(varlist)} adjusts the estimates to that for the average values of 
the {it:varlist} specified.  The estimates can also be
adjusted to zero values of {it:varlist} by specifying the {opt zero} option.
{opt adjust(varlist)} can be specified with {opt by()}; it is required with
{opt strata(varname)}.

{phang}
{opt zero} is used with {opt adjust()} to specify that the estimates be 
adjusted to the 0 values of the {it:varlist} rather than to the average 
values.

{dlgtab:Options}

{phang}
{opt nonegative} specifies that ln{c -(}-ln(survival){c )-} be plotted instead
of -ln{c -(}-ln(survival){c )-}.

{phang}
{opt nolntime} specifies that curves be plotted against analysis time instead
of against ln(analysis time).

{phang}
{opt noshow} prevents {cmd:stphplot} from showing the key st variables.  This
option is seldom used since most people type {cmd:stset, show} or 
{cmd:stset, noshow} to set whether they want to see these variables mentioned 
at the top of the output of every st command; see {manhelp stset ST}.

{dlgtab:Plot}

{phang}
{cmd:plot}{it:#}{cmd:opts(}{it:stphplot_plot_options}{cmd:)} affects
the rendition of the {it:#}th connected line; see
{manhelpi cline_options G} and
{manhelpi marker_options G}.

{dlgtab:Add plots}

{phang}
{opt addplot(plot)} provides a way to add other plots to the generated
graph; see {manhelpi addplot_option G}.

{dlgtab:Y axis, X axis, Titles, Legend, Overall}

{phang}
{it:twoway_options} are any of the options documented in 
{manhelpi twoway_options G}, excluding {opt by()}.  These include options for 
titling the graph (see {manhelpi title_options G}) and for saving the 
graph to disk (see {manhelpi saving_option G}).


{title:Options for stcoxkm}

{dlgtab:Main}

{phang}
{opth by(varname)} specifies the nominal or ordinal covariate.
{opt by()} is required.

{phang}
{cmd:ties(breslow} | {opt efron} | {opt exactm} | {opt exactp)} specifies
one of the methods available to {cmd:stcox} for handling tied failures.  If 
none is specified, {cmd:ties(breslow)} is assumed; see {manhelp stcox ST}.

{phang}
{opt separate} produces separate plots of predicted and observed values for 
each value of the variable specified with {opt by()}.

{phang}
{opt noshow} prevents {cmd:stcoxkm} from showing the key st variables.  This
option is seldom used since most people type {cmd:stset, show} or 
{cmd:stset, noshow} to set whether they want to see these variables mentioned 
at the top of the output of every st command; see {manhelp stset ST}.

{dlgtab:Observed plot}

{phang}
{opt obsopts(stcoxkm_plot_options)} affects the rendition of the observed curve;
 see {manhelpi connect_options G} and {manhelpi marker_options G}.

{phang}
{cmd:obs}{it:#}{cmd:opts(}{it:stcoxkm_plot_options}{cmd:)} affects the
rendition of the {it:#}th observed curve; see
{manhelpi connect_options G} and {manhelpi marker_options G}.
This option is not allowed with {cmd:separate}. 

{dlgtab:Predicted plot}

{phang}
{opt predopts(stcoxkm_plot_options)} affects the rendition of the predicted
curve; see {manhelpi connect_options G} and {manhelpi marker_options G}.

{phang}
{cmd:pred}{it:#}{cmd:opts(}{it:stcoxkm_plot_options}{cmd:)} affects the
rendition of the {it:#}th predicted curve; see
{manhelpi connect_options G} and {manhelpi marker_options G}.
This option is not allowed with {opt separate}.

{dlgtab:Add plots}

{phang}
{opt addplot(plot)} provides a way to add other plots to the generated
graph; see {manhelpi addplot_option G}.

{dlgtab:Y axis, X axis, Titles, Legend, Overall}

{phang}
{it:twoway_options} are any of the options documented in 
{manhelpi twoway_options G}, excluding {opt by()}.  These include options for 
titling the graph (see {manhelpi title_options G}) and for saving the 
graph to disk (see {manhelpi saving_option G}).

{phang}
{opt byopts(byopts)} affects the appearance of the combined graph when
{cmd:by()} and {cmd:separate} are specified, including the overall graph title
and the organization of subgraphs.  See {manhelpi by_option G}.


{title:Examples}

{pstd}Setup{p_end}
{phang2}{cmd:. webuse leukemia}{p_end}
{phang2}{cmd:. stset weeks, failure(relapse) noshow}

{pstd}Check proportional-hazards assumption for {cmd:treatment1} using
{cmd:stphplot}{p_end}
{phang2}{cmd:. stphplot, by(treatment1)}

{pstd}Same as above, but adjust for white-blood-cell count{p_end}
{phang2}{cmd:. stphplot, by(treatment1) adj(wbc2 wbc3)}

{pstd}Check proportional-hazards assumption for {cmd:treatment1} using
{cmd:stcoxkm}{p_end}
{phang2}{cmd:. stcoxkm, by(treatment1)}

{pstd}Check proportional-hazards assumption for {cmd:treatment2} using
{cmd:stphplot}{p_end}
{phang2}{cmd:. stphplot, by(treatment2)}

{pstd}Check proportional-hazards assumption for {cmd:treatment2} using
{cmd:stcoxkm}{p_end}
{phang2}{cmd:. stcoxkm, by(treatment2) separate}


{title:Also see}

{psee}
Manual:  {bf:[ST] stcox diagnostics}

{psee}
Online:  {manhelp stcox ST}, {manhelp sts ST}, {manhelp stset ST}
{p_end}
