{smcl}
{* *! version 1.1.0  04dec2008}{...}
{cmd:help streg postestimation} {right:dialog:  {bf:{dialog streghet1_p:predict}}}
{right:also see:  {helpb streg}{space 2}}
{hline}

{title:Title}

{p2colset 5 34 36 2}{...}
{p2col :{hi:[ST] streg postestimation} {hline 2}}Postestimation tools for streg{p_end}
{p2colreset}{...}


{title:Description}

{pstd}
The following postestimation command is of special interest after {cmd:streg}:

{synoptset 13}{...}
{p2coldent :command}description{p_end}
{synoptline}
{synopt :{helpb stcurve}}plot the survivor, hazard, and cumulative hazard functions{p_end}
{synoptline}
{p2colreset}{...}

{pstd}
The following standard postestimation commands are also available:

{synoptset 13 notes}{...}
{p2coldent :command}description{p_end}
{synoptline}
INCLUDE help post_adjust2
INCLUDE help post_estat
INCLUDE help post_svy_estat
INCLUDE help post_estimates
INCLUDE help post_lincom
{p2coldent:(1) {helpb linktest}}link test for model specification{p_end}
{p2coldent:(2) {helpb lrtest}}likelihood-ratio test{p_end}
INCLUDE help post_mfx
INCLUDE help post_nlcom
{p2col :{helpb streg postestimation##predict:predict}}predictions, residuals, influence statistics, and other diagnostic measures{p_end}
INCLUDE help post_predictnl
INCLUDE help post_suest
INCLUDE help post_test
INCLUDE help post_testnl
{synoptline}
{p2colreset}{...}
{p 4 6 2}
(1) {cmd:linktest} is not available with {cmd:svy} estimation results.
{p_end}
{p 4 6 2}
(2) {cmd:lrtest} is not appropriate with {cmd:svy} estimation results.
{p_end}


{title:Special-interest postestimation command}

{pstd}
{cmd:stcurve} is used after {cmd:streg} (or {cmd:stcox}) to plot the
cumulative hazard, survivor, and hazard functions at the mean value of the
covariates or at the values specified by the {opt at()} options.


{marker predict}{...}
{title:Syntax for predict}

{p 8 16 2}
{cmd:predict} {dtype} {newvar} {ifin} [{cmd:,} {it:statistic} {opt oos}
              {opt alpha:1} {opt uncond:itional}]

{p 8 16 2}
{cmd:predict} {dtype} {c -(}{it:stub}{cmd:*}|{it:newvarlist}{c )-}
{ifin}{cmd:,} {opt sc:ores}

{synoptset 17 tabbed}{...}
{synopthdr :statistic}
{synoptline}
{syntab:Main}
{synopt :{opt med:ian} {opt time}}median survival time; the default{p_end}
{synopt :{opt med:ian} {opt lnt:ime}}median ln(survival time){p_end}
{synopt :{opt mean time}}mean survival time{p_end}
{synopt :{opt mean} {opt lnt:ime}}mean ln(survival time){p_end}
{synopt :{opt hazard}}hazard{p_end}
{synopt :{opt hr}}hazard ratio, also known as the relative hazard{p_end}
{synopt :{opt xb}}linear prediction xb{p_end}
{synopt :{opt stdp}}standard error of the linear prediction; SE(xb){p_end}
{synopt :{opt s:urv}}S(t|t_0){p_end}
{synopt :{opt csn:ell}}(partial) Cox-Snell residuals{p_end}
{synopt :{opt mg:ale}}(partial) martingale-like residuals{p_end}
{p2coldent :* {opt dev:iance}}deviance residuals{p_end}
{p2coldent :* {opt cs:urv}}S(t|earliest t_0 for subject){p_end}
{p2coldent :* {opt ccs:nell}}cumulative Cox-Snell residuals{p_end}
{p2coldent :* {opt cmg:ale}}cumulative martingale-like residuals{p_end}
{synoptline}
{p2colreset}{...}
{p 4 6 2} 
Unstarred statistics are available both in and out of sample; type
{cmd:predict} {it:...} {cmd:if e(sample)} {it:...} if wanted only for the
estimation sample. Starred statistics are calculated for the estimation sample
by default, but the {opt oos} option makes them available both in and out of
sample.{p_end}
{p 4 6 2} 
When no option is specified, the predicted median survival time is calculated
for all models.  The predicted hazard ratio option {opt hr} is available only
for the exponential, Weibull, and Gompertz models.  The {opt mean time} and
{opt mean lntime} options are not available for the Gompertz model.
Unconditional estimates of {opt mean time} and {opt mean lntime} are not
available when {opt frailty()} is specified.{p_end}
{p 4 6 2}
{opt csnell}, {opt mgale}, {opt deviance}, {opt ccsnell}, and {opt cmgale}
are not allowed with {cmd:svy} estimation results.{p_end}


{title:Options for predict}

{dlgtab:Main}

{phang}
{opt median time} calculates the predicted median survival time in
analysis time units.  This is the prediction from time 0 conditional
on constant covariates.  When no options are specified with {cmd:predict}, the
predicted median survival time is calculated for all models.

{phang}
{opt median lntime} calculates the natural logarithm of what {opt median time}
produces.

{phang}
{opt mean time} calculates the predicted mean survival time in analysis
time units.  This is the prediction from time 0 conditional on
constant covariates.  This option is not available for Gompertz regressions
and is available only for frailty models if {opt alpha1} is specified, in
which case what you obtain is an estimate of the mean survival time
conditional on a frailty effect of one.

{phang}
{opt mean lntime} predicts the mean of the natural logarithm of {opt time}.
This option is not available for Gompertz regression and is available only for
frailty models if {opt alpha1} is specified, in which case what you obtain is
an estimate of the mean log-survival time conditional on a frailty effect of
one.

{phang}
{opt hazard} calculates the predicted hazard.

{phang}
{opt hr} calculates the hazard ratio.  This option is valid only for models
having a proportional-hazards parameterization.

{phang}
{opt xb} calculates the linear prediction from the fitted model. That is,
you fit the model by estimating a set of parameters b0, b1, b2, ..., bk,
and the linear prediction is y = xb.

{pmore}
The x used in the calculation is obtained from the data
currently in memory and need not correspond to the data on the independent
variables used in estimating b.

{phang}
{opt stdp} calculates the standard error of the prediction, that is,
the standard error of y.

{phang}
{opt surv} calculates each observation's predicted survivor probability
S(t|t0), where t_0 is _t0, the analysis time at which each record became at
risk.  For multiple-record data, see the {opt csurv} option below.

{phang}
{opt csnell} calculates the (partial) Cox-Snell residual.  If you have 
1 observation per subject, {opt csnell} calculates the usual Cox-Snell
residual.  Otherwise, {opt csnell} calculates the additive contribution of
this observation to the subject's overall Cox-Snell residual.

{phang}
{opt mgale} calculates the (partial) martingale-like residual.  The
issues are the same as with {opt csnell} above.

{phang}
{opt deviance} calculates the deviance residual.  For 
multiple-record data, only one value per subject is calculated, and it is
placed on the last record for the subject.

{phang}
{opt csurv} calculates the predicted S(t|earliest t0) for each subject in
multiple-record data by calculating the conditional survivor values S(t|t0)
(see option {opt surv} above) and then multiplying them together.

{pmore}
What you obtain from {cmd:surv} will differ from what you obtain from
{cmd:csurv} only if you have multiple records for that subject and delayed
entry, gaps, or time-varying covariates.

{phang}
{opt ccsnell} calculates the (cumulative) Cox-Snell residual in
multiple-record data by calculating the partial Cox-Snell residuals (see
option {opt csnell} above) and then summing them.  Only one value per subject
is recorded -- the overall sum -- and it is placed on the last
record for the subject.

{phang}
{opt cmgale} calculates the (cumulative) martingale-like residual in
multiple-record data.  This is based on calculating the partial
martingale-like residuals (see option {opt mgale} above) and then summing
them.  Only one value per subject is recorded -- the overall 
sum -- and it is placed on the last record for the subject.

{phang}
{opt oos} make {opt deviance}, {opt csurv}, {opt ccsnell}, and {opt cmgale}
available both in and out of sample.

{phang}
{opt alpha1}, when used after fitting a frailty model, specifies that
{it:statistic} be predicted conditional on a frailty value equal to one.
This is the default for shared-frailty models.

{phang}
{opt unconditional}, when used after fitting a frailty model, specifies that
{it:statistic} be predicted unconditional on the frailty.  That is, the
prediction is averaged over the frailty distribution.  This is the default for
unshared-frailty models.

{phang}
{opt scores} calculates equation-level score variables.  The number of score
variables created depends upon the chosen distribution.

{pmore}
The first new variable will always contain the partial derivative of the log
likelihood with respect to the linear prediction (regression equation)
from the fitted model.

{pmore}
The subsequent new variables will contain the partial derivative of the log
likelihood with respect to the ancillary parameters.  For example, in the
generalized gamma model, the second new variable will contain
the partial derivative of the log likelihood with respect to the linear
prediction (sigma equation), and the third new variable will contain
the partial derivative of the log likelihood with respect to the linear
prediction (kappa equation).


{title:Examples}

    {hline}
{pstd}Setup{p_end}
{phang2}{cmd:. webuse kva}

{pstd}Fit Weibull survival model{p_end}
{phang2}{cmd:. streg load bearings, d(weibull)}

{pstd}Predict median survival time{p_end}
{phang2}{cmd:. predict time, time}

{pstd}Predict log-median survival time{p_end}
{phang2}{cmd:. predict lntime, lntime}

    {hline}
{pstd}Setup{p_end}
{phang2}{cmd:. webuse cancer, clear}

{pstd}Map value for {cmd:drug} into 0 for placebo and 1 for nonplacebo{p_end}
{phang2}{cmd:. replace drug = drug == 2 | drug == 3}

{pstd}Declare data to be survival-time data{p_end}
{phang2}{cmd:. stset studytime, failure(died)}

{pstd}Fit exponential survival model{p_end}
{phang2}{cmd:. streg age drug, d(exp)}

{pstd}Predict Cox-Snell residuals{p_end}
{phang2}{cmd:. predict double cs, csnell}

{pstd}{cmd:stset} the data again with {cmd:cs} as failure-time variable{p_end}
{phang2}{cmd:. stset cs, failure(died)}

{pstd}Create {cmd:km} containing Kaplan-Meier survival estimates{p_end}
{phang2}{cmd:. sts generate km = s}

{pstd}Create {cmd:H}, the cumulative hazard{p_end}
{phang2}{cmd:. generate double H = ln(km)}

{pstd}Plot {cmd:H} against {cmd:cs}, specifying {cmd:cs} twice to obtain
reference line{p_end}
{phang2}{cmd:. line H cs cs, sort}

{pstd}Fit lognormal survival model{p_end}
{phang2}{cmd:. streg age drug, d(lnormal)}

{pstd}Predict deviance residuals{p_end}
{phang2}{cmd:. predict dev, deviance}

{pstd}Plot deviance residuals{p_end}
{phang2}{cmd:. scatter dev studytime, yline(0) m(o)}{p_end}
    {hline}


{title:Also see}

{psee}
Manual:  {bf:[ST] streg postestimation}

{psee}
Online:  {manhelp streg ST}; {manhelp stcurve ST}
{p_end}
