{smcl}
{* *! version 1.0.5  13may2008}{...}
{cmd:help textboxstyle}
{hline}
{* index textboxstyle it}{...}

{title:Title}

{p2colset 5 25 27 2}{...}
{p2col :{hi:[G] {it:textboxstyle}} {hline 2}}Choices for the overall look of text including border{p_end}
{p2colreset}{...}


{title:Syntax}

{p2colset 9 38 40 2}{...}
{p2col:{it:textboxstyle}}description{p_end}
{p2line}
{p2col:{cmd:heading}}large text suitable for headings{p_end}
{p2col:{cmd:subheading}}medium text suitable for subheadings{p_end}
{p2col:{cmd:body}}medium text{p_end}
{p2col:{cmd:smbody}}small text{p_end}
{* p1-p15 intentionally not documented}{...}
{p2line}
{p2colreset}{...}

{pin}
Other {it:textboxstyles} may be available; type

	    {cmd:.} {bf:{stata graph query textboxstyle}}

{pin}
to obtain the complete list of {it:textboxstyles} installed on your computer.


{title:Description}

{pstd}
A textbox contains one or more lines of text.  {it:textboxstyle} specifies the
overall style of the textbox.

{pstd}
{it:textboxstyle} is specified in the {cmd:style()} option nested within
another option, such as {cmd:title()}:

{phang2}
	{cmd:. graph} ...{cmd:, title("My title", style(}{it:textboxstyle}{cmd:))} ...

{pstd}
See {manhelpi textbox_options G} for more information on textboxes.

{pstd}
Sometimes you will see that a {it:textboxstylelist} is allowed.  A
{it:textboxstylelist} is a sequence of {it:textboxstyles} separated by spaces.
Shorthands are allowed to make specifying the list easier; see
{manhelpi stylelists G}.


{title:Remarks}

{pstd}
Remarks are presented under the following headings:

	{help textboxstyle##remarks1:What is a textbox?}
	{help textboxstyle##remarks2:What is a textboxstyle?}
	{help textboxstyle##remarks3:You do not need to specify a textboxstyle}


{marker remarks1}{...}
{title:What is a textbox?}

{pstd}
A textbox is one or more lines of text that may or may not have a border
around it.


{marker remarks2}{...}
{title:What is a textboxstyle?}

{pstd}
Textboxes are defined by 11 attributes:

{phang2}
    1.  Whether the textbox is vertical or horizontal;
	see {manhelpi orientationstyle G}

{phang2}
    2.  The size of the text;
	see {manhelpi textsizestyle G}

{phang2}
    3.  The color of the text;
	see {manhelpi colorstyle G}

{phang2}
    4.  Whether the text is left-justified, centered, or right-justified;
	see {manhelpi justificationstyle G}

{phang2}
    5.  How the text aligns with the baseline;
	see {manhelpi alignmentstyle G}

{phang2}
    6.  The margin from the text to the border;
	see {manhelpi marginstyle G}

{phang2}
    7.  The gap between lines;
	see {manhelpi relativesize G}

{phang2}
    8.  Whether a border is drawn around the box, and if so

{phang3}
	a.  The color of the background;
	    see {manhelpi colorstyle G}

{phang3}
	b.  The overall style of the line used to draw the border,
	    which includes its color, width, and whether solid or dashed,
	    etc.; see {manhelpi linestyle G}

{phang2}
    9.  The margin from the border outward;
	see {manhelpi marginstyle G}

{p 7 12 2}
   10.  Whether the box is to expand to fill the box in which it is placed

{p 7 12 2}
   11.  Whether the box is to be shifted when placed on the graph;
	see {manhelpi compassdirstyle G}

{pstd}
The {it:textboxstyle} specifies all 11 of these attributes.


{marker remarks3}{...}
{title:You do not need to specify a textboxstyle}

{pstd}
The {it:textboxstyle} is specified in option

	{cmd:tstyle(}{it:textboxstyle}{cmd:)}

{pstd}
Correspondingly, you will find other options are available for setting
each attribute above; see {manhelpi textbox_options G}.

{pstd}
You specify the {it:textboxstyle} when a style exists that is exactly what
you desire or when another style would allow you to specify fewer
changes to obtain what you want.


{title:Also see}

{psee}
Manual:  {bf:[G] {it:textboxstyle}}

{psee}
Online:  
{manhelpi textbox_options G};
{manhelpi textstyle G}
{p_end}
