{smcl}
{* *! version 1.0.10  13may2008}{...}
{cmd:help tif_options}
{hline}
{* index exporting graphs}{...}
{* index TIFF}{...}
{* index bitmap}{...}

{title:Title}

{p2colset 5 24 28 2}{...}
{p2col :{hi:[G] {it:tif_options}} {hline 2}}Options for exporting to tagged
image file format (TIFF){p_end}
{p2colreset}{...}


{title:Syntax}

{p2colset 9 40 42 2}{...}
{p2col:{it:tif_options}}description{p_end}
{p2line}
{p2col:{cmdab:wid:th:(}{it:#}{cmd:)}}width of graph in pixels{p_end}
{p2col:{cmdab:hei:ght:(}{it:#}{cmd:)}}height of graph in pixels{p_end}
{p2line}
{p2colreset}{...}


{title:Description}

{pstd}
The {it:tif_options} are used with {cmd:graph} {cmd:export} when creating
TIFF graphs; see {manhelp graph_export G:graph export}.


{title:Options}

{phang}
{cmd:width(}{it:#}{cmd:)}
    specifies the width of the graph in pixels.  {cmd:width()} must
    contain an integer between 8 and 16,000.

{phang}
{cmd:height(}{it:#}{cmd:)}
    specifies the height of the graph in pixels.  {cmd:height()} must
    contain an integer between 8 and 16,000.


{title:Remarks}

{pstd}
Remarks are presented under the following headings:

	{help tif_options##remarks1:Using tif_options}
	{help tif_options##remarks2:Specifying the width or height}


{marker remarks1}{...}
{title:Using tif_options}

{pstd}
You have drawn a graph and wish to create a TIFF file to include in a
document.  You wish, however, to set the width of the graph to 800 pixels and
the height to 600 pixels:

	{cmd:. graph} ...{col 50}(draw a graph)

{phang2}
	{cmd:. graph export myfile.tif, width(800) height(600)}


{marker remarks2}{...}
{title:Specifying the width or height}

{pstd}
If the width is specified but not the height, Stata determines the appropriate
height from the graph's aspect ratio.  If the height is specified but
not the width, Stata determines the appropriate width from the graph's aspect
ratio.  If neither the width nor the height is specified, Stata
will export the graph on the basis of the current size of the Graph window.


{title:Also see}

{psee}
Manual:  {bf:[G] {it:tif_options}}

{psee}
Online:  
{manhelp graph_export G:graph export}
{p_end}
