{smcl}
{* *! version 1.0.7  14may2008}{...}
{cmd:help twoway qfit}{right:dialog:  {bf:{dialog twoway}}}
{hline}
{* index fits, adding}{...}

{title:Title}

{p2colset 5 30 32 2}{...}
{p2col :{hi:[G] graph twoway qfit} {hline 2}}Twoway quadratic prediction plots{p_end}
{p2colreset}{...}


{title:Syntax}

{p 8 60 2}
{cmdab:tw:oway}
{cmd:qfit}
{it:yvar} {it:xvar}
{ifin}
{weight}
[{cmd:,}
{it:options}]

{p2colset 9 38 42 2}{...}
{p2col:{it:options}}description{p_end}
{p2line}
{p2col:{cmdab:r:ange:(}{it:#} {it:#}{cmd:)}}range over which predictions
       calculated{p_end}
{p2col:{cmd:n(}{it:#}{cmd:)}}number of prediction points{p_end}
{p2col:{cmd:atobs}}calculate predictions at {it:xvar}{p_end}
{p2col:{cmdab:est:opts:(}{it:regress_options}{cmd:)}}options for
       {cmd:regress}{p_end}
{p2col:{cmdab:pred:opts:(}{it:predict_options}{cmd:)}}options for
       {cmd:predict}{p_end}

{p2col:{it:{help cline_options}}}change look of predicted line{p_end}

INCLUDE help gr_axlnk

INCLUDE help gr_twopt
{p2line}
{p2colreset}{...}
{pin}
All options are {it:rightmost}; see {help repeated options}.

{phang}
{cmd:aweight}s,
{cmd:fweight}s, and
{cmd:pweight}s are allowed.  Weights, if specified, affect estimation but
not how the weighted results are plotted.  See {help weight}.


{title:Description}

{pstd}
{cmd:twoway} {cmd:qfit} calculates the prediction for {it:yvar} from a
linear regression of {it:yvar} on {it:xvar} and {it:xvar}^2 and plots the
resulting curve.


{title:Options}

{phang}
{cmd:range(}{it:#} {it:#}{cmd:)}
    specifies the {it:x} range over which predictions are calculated.
    The default is {cmd:range(. .)}, meaning the minimum and maximum
    values of {it:xvar}.  {cmd:range(0 10)} would make the range 0
    to 10, {cmd:range(. 10)} would make the range the minimum to 10, and
    {cmd:range(0 .)} would make the range 0 to the maximum.

{phang}
{cmd:n(}{it:#}{cmd:)}
    specifies the number of points at which predictions over
    {cmd:range()} are to be calculated.  The default is {cmd:n(100)}.

{phang}
{cmd:atobs}
    is an alternative to {cmd:n()}.  It specifies that the predictions be
    calculated at the {it:xvar} values.  {cmd:atobs} is the default
    if {cmd:predopts()} is specified and any statistic other than
    {cmd:xb} is requested.

{phang}
{cmd:estopts(}{it:regress_options}{cmd:)}
    specifies options to be passed along to {cmd:regress} to
    estimate the linear regression from which the curve will be predicted;
    see {manhelp regress R}.  If this option is specified, commonly specified
    is {cmd:estopts(nocons)}.

{phang}
{cmd:predopts(}{it:predict_options}{cmd:)}
    specifies options to be passed along to {cmd:predict} to
    obtain the predictions after estimation by {cmd:regress}.

{phang}
{it:cline_options}
     specify how the prediction line is rendered;
     see {manhelpi cline_options G}.

INCLUDE help gr_axlnkf

INCLUDE help gr_twoptf


{title:Remarks}

{pstd}
Remarks are presented under the following headings:

	{help twoway qfit##remarks1:Typical use}
	{help twoway qfit##remarks2:Cautions}
	{help twoway qfit##remarks3:Use with by()}


{marker remarks1}{...}
{title:Typical use}

{pstd}
{cmd:twoway} {cmd:qfit} is nearly always used in conjunction with
other {cmd:twoway} plottypes, such as

	{cmd:. sysuse auto}

	{cmd:. scatter mpg weight || qfit mpg weight}
	  {it:({stata "gr_example auto: scatter mpg weight || qfit mpg weight":click to run})}
{* graph gtqfit1}{...}

{pstd}
Results are visually the same as typing

	{cmd:. generate} {it:tempvar} {cmd:= weight^2}
	{cmd:. regress mpg weight} {it:tempvar}
	{cmd:. predict fitted}
	{cmd:. scatter mpg weight || line fitted weight}


{marker remarks2}{...}
{title:Cautions}

{pstd}
Do not use {cmd:twoway} {cmd:qfit} when specifying the
{it:axis_scale_options} {cmd:yscale(log)} or {cmd:xscale(log)} to create log
scales.  Typing

	{cmd:. scatter mpg weight, xscale(log) || qfit mpg weight}

{pstd}
produces something that is not a parabola because
the regression estimated for the prediction
was for {cmd:mpg} on {cmd:weight} and {cmd:weight^2}, not {cmd:mpg} on
{cmd:log(weight)} and {cmd:log(weight)^2}.


{marker remarks3}{...}
{title:Use with by()}

{pstd}
{cmd:qfit} may be used with {cmd:by()} (as can all the {cmd:twoway} plot
commands):

{phang2}
	{cmd:. scatter mpg weight || qfit mpg weight ||, by(foreign, total row(1))}
{p_end}
	  {it:({stata "gr_example auto: scatter mpg weight || qfit mpg weight ||, by(foreign, total row(1))":click to run})}
{* graph gtqfit2}{...}


{title:Also see}

{psee}
Manual:  {bf:[G] graph twoway qfit}

{psee}
Online:  
{manhelp line G:graph twoway line},
{manhelp twoway_lfit G:graph twoway lfit},
{manhelp twoway_fpfit G:graph twoway fpfit},
{manhelp twoway_mband G:graph twoway mband},
{manhelp twoway_mspline G:graph twoway mspline};
{manhelp twoway_qfitci G:graph twoway qfitci};
{manhelp regress R}
{p_end}
