{smcl}
{* *! version 1.0.5  12may2008}{...}
{cmd:help twoway rline}{right:dialog:  {bf:{dialog twoway}}}
{hline}

{title:Title}

{p2colset 5 31 33 2}{...}
{p2col :{hi:[G] graph twoway rline} {hline 2}}Range plot with lines{p_end}
{p2colreset}{...}


{title:Syntax}

{p 8 60 2}
{cmdab:tw:oway}
{cmdab:rl:ine}
{it:y1var} {it:y2var} {it:xvar}
{ifin}
[{cmd:,}
{it:options}]

{p2colset 9 32 34 2}{...}
{p2col: {it:options}}description{p_end}
{p2line}
{p2col: {cmdab:vert:ical}}vertical plot; the default{p_end}
{p2col: {cmdab:hor:izontal}}horizontal plot{p_end}

{p2col:{it:{help connect_options}}}change rendition of lines connecting points{p_end}

INCLUDE help gr_axlnk

INCLUDE help gr_twopt
{p2line}
{p2colreset}{...}
{pin}
All explicit options are {it:rightmost}, except {cmd:vertical}
and {cmd:horizontal}, which are {it:unique}; see {help repeated options}.


{title:Description}

{pstd}
A range plot has two {it:y} variables, such as high and low daily stock prices
or upper and lower 95% confidence limits.

{pstd}
{cmd:twoway} {cmd:rline} plots the upper and lower ranges
by using lines.


{title:Options}

{phang}
{cmd:vertical}
and
{cmd:horizontal}
    specify whether the high and low {it:y} values are to be presented
    vertically (the default) or horizontally.

{pmore}
    In the default {cmd:vertical} case, {it:y1var} and {it:y2var} record the
    minimum and maximum (or maximum and minimum) {it:y} values to be
    graphed against each {it:xvar} value.

{pmore}
    If {cmd:horizontal} is specified, the values recorded in {it:y1var} and
    {it:y2var} are plotted in the {it:x} direction and {it:xvar} is treated
    as the {it:y} value.

{phang}
{it:connect_options}
    change the rendition of the lines connecting the points, including
    sorting, handling missing observations, and the look of the line --  
    line thickness, pattern, and color.  For details, see 
    {manhelpi connect_options G}.

INCLUDE help gr_axlnkf

INCLUDE help gr_twoptf


{title:Remarks}

{pstd}
Visually, there is no difference between

{phang2}
	{cmd:. twoway rline} {it:y1var} {it:y2var} {it:xvar}

{pstd}
and

{phang2}
	{cmd:. twoway line} {it:y1var} {it:xvar} {cmd:||}
		{cmd:line} {it:y2var} {it:xvar}{cmd:, pstyle(p1)}

{pstd}
The two lines are presented in the same overall style, meaning
color, thickness, and pattern.


{title:Also see}

{psee}
Manual:  {bf:[G] graph twoway rline}

{psee}
Online:  
{manhelp twoway_rarea G:graph twoway rarea},
{manhelp twoway_rbar G:graph twoway rbar},
{manhelp twoway_rspike G:graph twoway rspike},
{manhelp twoway_rcap G:graph twoway rcap},
{manhelp twoway_rcapsym G:graph twoway rcapsym},
{manhelp twoway_rconnected G:graph twoway rconnected},
{manhelp twoway_rscatter G:graph twoway rscatter}
{p_end}
