{smcl}
{* *! version 1.0.6  12may2008}{...}
{cmd:help twoway rscatter}{right:dialog:  {bf:{dialog twoway}}}
{hline}

{title:Title}

{p2colset 5 34 36 2}{...}
{p2col :{hi:[G] graph twoway rscatter} {hline 2}}Range plot with markers{p_end}
{p2colreset}{...}


{title:Syntax}

{p 8 24 2}
{cmdab:tw:oway}
{cmdab:rsc:atter}
{it:y1var} {it:y2var} {it:xvar}
{ifin}
[{cmd:,}
{it:options}]

{p2colset 9 34 36 2}{...}
{p2col: {it:options}}description{p_end}
{p2line}
{p2col: {cmdab:vert:ical}}vertical plot; the default{p_end}
{p2col: {cmdab:hor:izontal}}horizontal plot{p_end}

INCLUDE help gr_markopt

INCLUDE help gr_axlnk

INCLUDE help gr_twopt
{p2line}
{p2colreset}{...}
{pin}
All explicit options are {it:rightmost}; see {help repeated options}.


{title:Description}

{pstd}
A range plot has two {it:y} variables, such as high and low daily stock prices
or upper and lower 95% confidence limits.

{pstd}
{cmd:twoway} {cmd:rscatter} plots the upper and lower ranges as scatters.


{title:Options}

{phang}
{cmd:vertical}
and
{cmd:horizontal}
    specify whether the high and low {it:y} values are to be presented
    vertically (the default) or horizontally.

{pmore}
    In the default {cmd:vertical} case, {it:y1var} and {it:y2var} record the
    minimum and maximum (or maximum and minimum) {it:y} values to be
    graphed against each {it:xvar} value.

{pmore}
    If {cmd:horizontal} is specified, the values recorded in {it:y1var} and
    {it:y2var} are plotted in the {it:x} direction and {it:xvar} is treated
    as the {it:y} value.

{phang}
{it:marker_options}
    specify how the markers look, including
    shape, size, color, and outline;
    see {manhelpi marker_options G}.  The same marker is used for both points.

{phang}
{it:marker_label_options}
    specify if and how the markers are to be labeled.  Because
    the same marker label would be used to label both points,
    these options are of limited use in this case.
    See {manhelpi marker_label_options G}.

INCLUDE help gr_axlnkf

INCLUDE help gr_twoptf


{title:Remarks}

{pstd}
Visually, there is no difference between

	{cmd:. twoway rscatter} {it:y1var} {it:y2var} {it:xvar}

{pstd}
and

	{cmd:. twoway scatter} {it:y1var} {it:xvar} {cmd:||} {...}
{cmd:scatter} {it:y2var} {it:xvar}{cmd:, pstyle(p1)}

{pstd}
The two scatters are presented in the same overall style,
meaning that the markers (symbol shape and color)
are the same.


{title:Also see}

{psee}
Manual:  {bf:[G] graph twoway rscatter}

{psee}
Online:  
{manhelp twoway_rarea G:graph twoway rarea},
{manhelp twoway_rbar G:graph twoway rbar},
{manhelp twoway_rspike G:graph twoway rspike},
{manhelp twoway_rcap G:graph twoway rcap},
{manhelp twoway_rcapsym G:graph twoway rcapsym},
{manhelp twoway_rline G:graph twoway rline},
{manhelp twoway_rconnected G:graph twoway rconnected}
{p_end}
