{smcl}
{* *! version 1.0.9  13feb2008}{...}
{cmd:help update}{right:dialog:  {bf:{update:update}}}
{hline}

{title:Title}

{p2colset 5 19 21 2}{...}
{p2col:{hi:[R] update} {hline 2}}Update Stata{p_end}
{p2colreset}{...}


{title:Syntax}

{pstd}
Report on update level of currently installed Stata

{p 8 26 2}{cmd:update}


{pstd}
Set update source

{p 8 26 2}{cmd:update from} {it:location}


{pstd}
Compare update level of currently installed Stata with that of source

{p 8 26 2}{cmd:update} {opt q:uery} [{cmd:,} {opt from(location)}]


{pstd}
Update ado-files from source if necessary

{p 8 26 2}{cmd:update ado} [{cmd:,} {opt from(location)} {opt into(dirname)}]


{pstd}
Update executable from source if necessary

{p 8 26 2}{cmd:update executable} [{cmd:,} {opt from(location)} {opt into(dirname)} {opt force}]


{pstd}
Update utilities from source if necessary (Windows only)

{p 8 26 2}{cmd:update utilities} [{cmd:,} {opt from(location)} {opt into(dirname)} {opt force}]


{pstd}
Perform update ado, update executable, and update utilities if necessary

{p 8 26 2}{cmd:update all} [{cmd:,} {opt from(location)}]


{pstd}
Complete installation of newly updated executable

{p 8 26 2}{cmd:update swap} [{cmd:, clear}]


{pstd}
Set automatic updates (Windows and Macintosh only)

{p 8 26 2}{opt se:t} {cmd:update_query}{space 3}{c -(}{cmd:on}|{cmd:off}{c )-}{p_end}
{p 8 26 2}{opt se:t} {cmd:update_interval} {it:#} {p_end}
{p 8 26 2}{opt se:t} {cmd:update_prompt}{space 2}{c -(}{cmd:on}|{cmd:off}{c )-}


{title:Description}

{pstd}
The {opt update} command reports on the current update level and installs
official updates to Stata.  Official updates are updates to Stata as it was
originally shipped from StataCorp, not the additions to Stata published in,
for instance, the {bf:Stata Journal} (SJ) or {bf:Stata Technical Bulletin}
(STB).  Those additions are installed using the {opt net} command and updated
using the {cmd:adoupdate} command; see {manhelp net R} and
{manhelp adoupdate R}.

{phang}
{opt update} without arguments reports on the update level of the currently
installed Stata.

{phang}
{opt update from} sets an update source, where {it:location} is a directory
name or URL.  If you are on the Internet, type {cmd:update from http://www.stata.com}.

{phang}
{opt update query} compares the update level of the currently installed
Stata with that available from the update source and displays a report.

{phang}
{opt update ado} compares the update level of the official ado-files of the
currently installed Stata with those available from the update source.  If the
currently installed ado-files need updating, {opt update ado} copies and
installs those files from the update source that are necessary to bring the
ado-files up to date. {cmd:update ado} is seldom used by itself.  Instead, it
is called automatically by {cmd:update all}.

{phang}
{opt update executable} compares the update level of the currently
installed Stata executable with that available from the update source.  If the
currently installed Stata needs updating, {opt update executable} copies the
new executable from the update source, but the last step of the
installation -- erasing the old executable and renaming the new
executable -- must be performed by the {cmd:update swap} command. 
{opt update executable} displays instructions on how to do this.
{cmd:update executable} is seldom used by itself, it is called automatically
by {cmd:update all}.

{phang}
{opt update utilities} compares the update level of the currently
installed Stata utilities with that available from the update source.  If the
currently installed Stata utilities need updating, {opt update utilities} 
copies and installs the new utilities from the update source.
{cmd:update utilities} is seldom used by itself; it is called automatically
by {cmd:update all}.  {opt update utilities} is available only on Windows 
platforms.

{phang}
{opt update all} does the same as {opt update ado} followed by
{opt update executable} and {opt update utilities}.  This is what you
should type to check for and install updates.  {opt update utilities}
is available only on Windows platforms.

{phang}
{opt update swap} completes the installation of a newly updated executable by
automatically swapping the newly downloaded executable with the currently
running executable.  During this process, Stata will shut down to perform the
swap before automatically launching the new executable.  This command is
necessary after either the {opt update executable} or the {opt update all}
command when a new executable is downloaded.

{phang}
{opt set update_query} determines if {opt update query} is to be automatically
performed when Stata is launched.  Only Windows and Macintosh platforms can be
set for automatic updating.

{phang}
{opt set update_interval} {it:#} sets the number of days to elapse before
performing the next automatic {opt update query}.  The default {it:#} is 
7. The interval starts from the last time an {opt update query} was performed
(automatically or manually).  Only Windows and Macintosh platforms can be set
for automatic updating.

{phang}
{opt  set update_prompt} determines whether a dialog is to be displayed before
performing an automatic {opt update query}.  The dialog allows you to perform
an {opt update query} now, perform one the next time Stata is launched,
perform one after the next interval has passed, or disable automatic
{opt update query}.  Only Windows and Macintosh platforms can be set for
automatic updating.


{title:Options}

{phang}
{opt from(location)} specifies the location of the update source.  You can
   specify the {opt from()} option on the individual {opt update} commands or
   use the {opt update from} command.  Which you do makes no difference.
   You typically do not need to use this option.

{phang}
{opt into(dirname)} specifies the name of the directory into which the updates
   are to be copied.  {it:dirname} can be a directory name or a {opt sysdir}
   codeword such as {bf:UPDATES} or {bf:STATA}; see {manhelp sysdir P}.
   This option is seldom used.

{pmore}
   For {opt update ado}, the default is {cmd:into(UPDATES)}, the
   official update directory.  Network computer managers might want to specify
   {opt into()} if they want to download the updates but leave the last
   step -- copying the files into the official directory -- to do
   themselves.

{pmore}
   For {opt update executable}, the default is {cmd:into(STATA)},
   the official Stata directory.  Network computer managers might want to
   specify {opt into()} so that they can copy the update into a more
   accessible directory.  Then the last step of copying the new
   executable over the existing executable would be left for them to perform.

{phang}
{opt force} is used with {opt update executable} to force downloading a
   new executable even if, based on the date comparison, Stata does not think
   it is necessary.  There is seldom a reason to specify this option.  There is
   no such option for {opt update ado} because, if you wanted to force the
   reinstallation of all ado-file updates, you would need only to erase the
   {bf:UPDATES} directory.  You can type {cmd:sysdir} to see where the
   {bf:UPDATES} directory is on your computer; see {manhelp sysdir P}.

{phang}
{opt clear} specifies that it is okay for {cmd:update swap} to shut down this
Stata and start the new one, even if data in memory have not been saved to
disk.


{title:Examples}

    {cmd:. update}         (report on what you have installed)

    {cmd:. update query}   (compare what you have with update source)

    {cmd:. update all}     (update ado-files and executable)

    {cmd:. update swap}    (install the new executable)


{title:Saved results}

{pstd}
{cmd:update} without a subcommand, {cmd:update from}, and {cmd:update query}
save the following in {cmd:r()}:

{synoptset 15 tabbed}{...}
{p2col 5 15 19 2: Scalars}{p_end}
{synopt:{cmd:r(inst_exe)}}date of executable installed (*){p_end}
{synopt:{cmd:r(avbl_exe)}}date of executable available over web (*) (**){p_end}
{synopt:{cmd:r(inst_ado)}}date of ado-files installed (*){p_end}
{synopt:{cmd:r(avbl_ado)}}date of ado-files available over web (*) (**){p_end}

{synoptset 15 tabbed}{...}
{p2col 5 15 19 2: Macros}{p_end}
{synopt:{cmd:r(dir_exe)}}directory in which executable is stored{p_end}
{synopt:{cmd:r(dir_ado)}}directory in which ado-files are stored{p_end}
{synopt:{cmd:r(name_exe)}}name of the Stata executable{p_end}

{pstd}
Notes:

{p 5 7 2}
  * Dates are stored as integers counting the number of days since January 1,
    1960; see {helpb dates and times:[D] dates and times}.

{p 4 7 2}
 ** These dates are not saved by {cmd:update} without a subcommand since
    {cmd:update} by itself reports information solely about the local computer
    and does not check what is available on the web.
{p2colreset}{...}


{title:Also see}

{psee}
Manual:  {bf:[R] update};{break}
{hi:[GSM] 20 Updating and extending Stata -- Internet functionality},{break}
{hi:[GSU] 20 Updating and extending Stata -- Internet functionality},{break}
{hi:[GSW] 20 Updating and extending Stata -- Internet functionality}

{psee}
Online:  {manhelp adoupdate R}, {manhelp net R}, {manhelp sysdir P}
{p_end}
