{smcl}
{* *! version 1.0.3  12may2008}{...}
{cmd:help while}
{hline}

{title:Title}

{p2colset 5 18 20 2}{...}
{p2col :{hi:[P] while} {hline 2}}Looping{p_end}
{p2colreset}{...}


{title:Syntax}

	{cmd:while} {it:exp} {cmd:{c -(}}
		{it:stata_commands}
	{cmd:{c )-}}

{pstd}
Braces must be specified with {cmd:while}, and

{phang2}
1.  the open brace must appear on the same line as the {cmd:while};

{phang2}
2.  nothing may follow the open brace, except, of course, comments;
    the first command to be executed must appear on a new line;

{phang2}
3.  the close brace must appear on a line by itself.


{title:Description}

{pstd}
{cmd:while} evaluates {it:exp} and, if it is true (nonzero), executes the
{it:stata_commands} enclosed in the braces. It then repeats the process until
{it:exp} evaluates to false (zero).  {cmd:while}s may be nested within
{cmd:while}s.  If the {it:exp} refers to any variables, their values in the
first observation are used unless explicit subscripts are specified; see
{hi:[U] 13.7 Explicit subscripting}.

{pstd}
Also see {manhelp foreach P} and {manhelp forvalues P} for alternatives to 
{cmd:while}.


{title:Example 1}

	{cmd:program} {it:...}
		{it:...}
		{cmd:gettoken tok 0 : 0}
		{cmd:while "`tok'" != "" {c -(}}
			{it:...}
			{cmd:gettoken tok 0 : 0}
		{cmd:{c )-}}
		{it:...}
	{cmd:end}


{title:Example 2}

{pstd}
{cmd:while} may be used interactively.  Here we use it to generate
several uniform random variables.

	{cmd:. set obs 10}
	{cmd:. local i = 1}
	{cmd:. while `i' < 40 {c -(}}
	  {cmd:2. gen u`i' = runiform()}
	  {cmd:3. local i = `i' + 1}
	  {cmd:4. {c )-}}
	{cmd:. list u1 - u7}


{title:Also see}

{psee}
Manual:  {bf:[P] while}

{psee}
Online:  {manhelp continue P}, {manhelp foreach P},
{manhelp forvalues P}, {manhelp ifcmd P:if}
{p_end}
