{smcl}
{* *! version 1.0.5  31aug2007}{...}
{cmd:help window manage}
{hline}

{title:Title}

{p2colset 5 22 24 2}{...}
{p2col :{hi:window manage} {hline 2}}Manage window characteristics{p_end}
{p2colreset}{...}


{title:Syntax}

{phang}Minimize or restore the main Stata window

{p 8 18 2}
{opt win:dow} {opt man:age} {cmd:minimize}

{p 8 18 2}
{opt win:dow} {opt man:age} {cmd:restore}


{phang}Manage window preferences

{p 8 18 2}
{opt win:dow} {opt man:age} {opt prefs}
 {c -(}{opt load} "{it:prefname}"|{opt save} "{it:prefname}"|{opt default}{c )-}


{phang}Refresh the Variables window

{p 8 18 2}
{opt win:dow} {opt man:age} {opt update} {opt variable}


{phang}Restore file associations (Windows only)

{p 8 18 2}
{opt win:dow} {opt man:age} {opt associate}


{phang}Reset main window title (Windows and Unix only)

{p 8 18 2}
{opt win:dow} {opt man:age} {opt maintitle} {c -(}{opt reset} | "{it:title}"{c )-}


{phang}Bring windows forward

{p 8 18 2}
{opt win:dow} {opt man:age} {opt forward} {it:window-name}

{phang2}
where {it:window-name} can be {opt command}, {opt doeditor}, {opt graph}, 
{opt help}, {opt results}, {opt review}, {opt variables}, or {opt viewer}.


{phang}Commands to manage Graph windows

{p 8 18 2}
{opt win:dow} {opt man:age} {opt print} {opt graph}

{p 8 18 2}
{opt win:dow} {opt man:age} {opt forward} {opt graph}
 ["{it:graphname}"]

{p 8 18 2}
{opt win:dow} {opt man:age} {opt close} {opt graph}
 [{c -(}"{it:graphname}"|{cmd:_all}{c )-}]

{p 8 18 2}
{opt win:dow} {opt man:age} {opt rename} {opt graph}
 {it:oldgraphname} {it:newgraphname}


{phang}Commands to manage Viewer windows

{p 8 18 2}
{opt win:dow} {opt man:age} {opt print} {opt viewer}
 ["{it:viewername}"]

{p 8 18 2}
{opt win:dow} {opt man:age} {opt forward} {opt viewer}
 ["{it:viewername}"]

{p 8 18 2}
{opt win:dow} {opt man:age} {opt close} {opt viewer}
 [{c -(}"{it:viewername}"|{cmd:_all}{c )-}]


{title:Description} 

{pstd}
{cmd:window manage} allows Stata programs to invoke features from
Stata's main menu.


{title:Remarks}

{pstd}
{cmd:window} {cmd:manage} accesses various parts of Stata's windowed interface
that would otherwise be available only interactively.  For instance, say that a
programmer wanted to ensure that the Graph window was brought to the front.
An interactive user would do that by selecting {hi:Graph} from the 
{hi:Window} menu.  A Stata program could be made to do the same thing by
coding '{cmd:window} {cmd:manage} {cmd:forward} {cmd:graph}'.

{pstd}
Remarks are presented under the following headings:

       {hi:{help window manage##minimizing:Minimizing or restoring the main window (Windows and Macintosh only)}}
       {hi:{help window manage##preferences:Windowing preferences}}
       {hi:{help window manage##refreshing:Refreshing the Variables window}}
       {hi:{help window manage##restoringfile:Restoring file associations (Windows only)}}
       {hi:{help window manage##maintitle:Resetting the main window title}}
       {hi:{help window manage##windowsforward:Bringing windows forward}}
       {hi:{help window manage##graphs:Commands to manage Graph windows}}
       {hi:{help window manage##viewer:Commands to manage Viewer windows}}


{marker minimizing}{...}
{title:Minimizing or restoring the main window (Windows and Macintosh only)}

{pstd}
{cmd:window} {cmd:manage} {cmd:minimize} minimizes (hides) the Stata window.
With Stata for Windows, this has the same effect as clicking on the minimize
button on Stata's title bar.  With Stata for Macintosh, this has the same
effect as selecting {hi:Hide Stata} from the {hi:Stata} menu.

{pstd}
For example,

       {cmd:window manage minimize}

{pstd}
minimizes the overall Stata window if you are using Stata for Windows and
hides Stata's windows if you are using Stata for Macintosh.

{pstd}
{cmd:window} {cmd:manage} {cmd:restore} restores the Stata window if
necessary.  This command is allowed only with Stata for Windows and Stata for
Macintosh.

{pstd}
With Stata for Windows, this command has the same effect as
clicking the Stata button on the taskbar.  With Stata for Macintosh, this 
command has the same effect as clicking on the Stata icon on the Dock.

{pstd}
For example,

       {cmd:window manage restore}

{pstd}
restores Stata's overall window to its normal, nonminimized state.


{marker preferences}{...}
{title:Windowing preferences}

{pstd}
{cmd:window} {cmd:manage} {cmd:prefs}
{c -(}{opt load} "{it:prefname}"|{opt save} "{it:prefname}"|{opt default}{c )-}
loads, saves, and restores windowing preferences.

{pstd}
{cmd:window manage prefs load} "{it:prefname}" is
equivalent to selecting
{bf:Edit > Preferences > Manage Preferences > Load Preferences} and loading a
named preference set.  
{cmd:window manage prefs save} "{it:prefname}" is equivalent to selecting
{bf:Edit > Preferences > Manage Preferences > Save Preferences} and naming
a new preference set.  
{cmd:window manage prefs default} is equivalent to selecting
{bf:Edit > Preferences > Manage Preferences > Load Preferences > Factory Settings}.
In Stata for Macintosh, the {bf:Preferences} menu is located in the {bf:Stata}
menu.

{pstd}
For example,

       {cmd:window manage prefs default}

{pstd}
restores Stata's windows to their "factory" appearance.


{marker refreshing}{...}
{title:Refreshing the Variables window}

{pstd}
{cmd:window} {cmd:manage} {cmd:update} {cmd:variable} forces an update of
Stata's Variables window, which is the window that displays the currently
loaded variable names and their labels.  Stata normally updates this window
between interactive commands only.  If you run a long do- or ado-file that
changes the data in a way which would affect the Variables window, the change
will not be visible until the do- or ado-file completes.

{pstd}
{cmd:window manage update variable} allows a do- or ado-file to force
an early update of the Variables window to reflect any changes.

{pstd}
For example,

       {hline 45} top of vars.do {hline 3}
       use auto
       drop make
       window manage update variable
       drop price
       window manage update variable
       drop mpg
       window manage update variable
       label variable weight "Weight of car"
       window manage update variable
       {hline 45} end of vars.do {hline 3}

{pstd}
If you were to run the above do-file and there were no 
{cmd:window manage update variable} commands in it, you would not see the
changes made to the variables until after the do-file completed.


{marker restoringfile}{...}
{title:Restoring file associations (Windows only)}

{pstd}
In Stata for Windows, {cmd:window} {cmd:manage} {cmd:associate} restores the
default actions for Stata file types.  For example, another application could
take over the {cmd:.dta} extension so that double-clicking on a Stata dataset
would no longer launch Stata.  {cmd:window} {cmd:manage} {cmd:associate}
restores the association between all Stata file extensions (such as
{cmd:.dta}) and Stata.  This is equivalent to selecting 
{bf:Edit > Preferences > Restore File Associations}.


{marker maintitle}{...} 
{title:Resetting the main window title}

{pstd}
In Stata for Windows and Stata for Unix (GUI), {cmd:window} {cmd:manage}
{cmd:maintitle} "{it:title}" changes the title of the main Stata Window.
The title may be reset to the default with {cmd:window} {cmd:manage}
{cmd:maintitle} {cmd:reset}.


{marker windowsforward}{...} 
{title:Bringing windows forward}

{pstd}
{cmd:window} {cmd:manage} {cmd:forward} {it:window-name} brings the specified
window to the top of all other Stata windows.  This command is equivalent to
selecting one of the available windows from the {hi:Window} menu.  The
following table lists the {it:window-name}s that {cmd:window manage forward}
understands:

          {it:window-name}{col 30}Stata window
          {hline 40}
          {cmd:command}{col 30}Command window
          {cmd:doeditor}{col 30}Do-file editor window
          {cmd:graph}{col 30}Graph window
          {cmd:help}{col 30}Help/search window
          {cmd:results}{col 30}Results window
          {cmd:review}{col 30}Review window
          {cmd:variables}{col 30}Variables window
          {cmd:viewer}{col 30}Viewer window

{pstd}
If a window had not been available on Stata's {hi:Window} menu (if it had
been grayed out), specifying {it:window-name} after 
{cmd: window manage forward} would do nothing.  For example, if there is no
current graph, {cmd:window manage forward graph} will do nothing; it is not an
error.

{pstd}
For example,

       {cmd:window manage forward results}

{pstd}
brings the Results window to the top of the other Stata windows.

{pstd}
Under Stata for Unix, specifying the Command, Results, Review, or Variables
windows will bring the main Stata window forward since these windows are
all contained within one window.
{p_end}


{marker graphs}{...}
{title:Commands to manage Graph windows}

{pstd}{bf:Printing}

{pstd}
{cmd:window} {cmd:manage} {cmd:print} {opt graph} invokes the action of the
{hi:File} > {hi:Print} > {hi:Graph (Graph)} menu item.  If there is no current
graph, {cmd:window} {cmd:manage} {cmd:print} does nothing; it does not return
an error.

{pstd}
For example,

       {cmd:window manage print graph}

{pstd}
displays the print dialog box just as if you pulled down
{hi:File} > {hi:Print} > {hi:Graph (Graph)}.

{pstd}{bf:Bringing forward}

{pstd}
{cmd:window} {cmd:manage} {cmd:forward} {opt graph} [{it:graphname}] brings
the Graph window named {it:graphname}, if it exists, to the top of other
windows.  If {it:graphname} is not specified and there are multiple graph 
windows open, {cmd:window} {cmd:manage} {cmd:forward} {cmd:graph} brings
the topmost Graph window to the top of other windows.

{pstd}{bf:Closing}

{pstd}
{cmd:window} {cmd:manage} {cmd:close} {opt graph} [{it:graphname}|{cmd:_all}]
closes the Graph windows named {it:graphname}, if it exists.  If {cmd:_all}
is specified, all Graph windows are closed.  If {it:graphname} is not 
specified and an unnamed Graph window exists, the unnamed Graph window will
be closed.

{pstd}{bf:Renaming}

{pstd}
{cmd:window} {cmd:manage} {cmd:rename} {it:oldgraphname} {it:newgraphname}
renames the Graph window named {it:oldgraphname}, if it exists, to 
{it:newgraphname}.  Note that this is not intended for an end user to use;
it is a utility to be used by {cmd:graph rename}.  End users should use
{cmd:graph rename} to rename graphs.


{marker viewer}{...}
{title:Commands to manage Viewer windows}

{pstd}{bf:Printing}

{pstd}
{cmd:window} {cmd:manage} {cmd:print} {opt viewer} [{it:viewername}] prints 
the Viewer window named {it:viewername}, if it exists.  If {it:viewername} is
not specified and there are multiple Viewer windows open, {cmd:window}
{cmd:manage} prints the topmost Viewer window.  If there is no current Viewer
window, {cmd:window} {cmd:manage} {cmd:print} does nothing; it does not return
an error.

{pstd}{bf:Bringing forward}

{pstd}
{cmd:window} {cmd:manage} {cmd:forward} {opt viewer} [{it:viewername}] brings
the Viewer window named {it:viewername}, if it exists, to the top of other
windows.  If {it:viewername} is not specified and there are multiple Viewer 
windows open, {cmd:window} {cmd:manage} brings the topmost Viewer window
to the top of other windows.

{pstd}{bf:Closing}

{pstd}
{cmd:window} {cmd:manage} {cmd:close} {opt viewer} [{it:viewername}|{cmd:_all}]
closes the Viewer window named {it:viewername}, if it exists.  If {cmd:_all}
is specified, all Viewer windows are closed.  If {it:viewername} is not 
specified and an unnamed Viewer window exists, the unnamed Viewer window will
be closed.


{title:Also see}

{psee}
Online:  {manhelp window_programming P:window programming}
{p_end}
