{smcl}
{* *! version 1.0.9  12may2008}{...}
{cmd:help wntestb}{right:dialog:  {bf:{dialog wntestb}}}
{hline}

{title:Title}

{p2colset 5 21 23 2}{...}
{p2col :{hi:[TS] wntestb} {hline 2}}Bartlett's periodogram-based test for white
noise{p_end}
{p2colreset}{...}


{title:Syntax}

{p 8 17 2}{cmd:wntestb} {varname} {ifin} 
[{cmd:,} {it:options}]

{synoptset 25 tabbed}{...}
{synopthdr}
{synoptline}
{syntab:Main}
{synopt :{opt ta:ble}}display a table instead of graphical output{p_end}
{synopt :{opt l:evel(#)}}set confidence level; default is
  {cmd:level(95)}{p_end}

{syntab:Plot}
{synopt :{it:{help marker_options}}}change look of markers (color, 
	size, etc.){p_end}
{synopt :{it:{help marker_label_options}}}add marker labels; 
	change look or position{p_end}
{synopt :{it:{help cline_options}}}add connecting lines; change look{p_end}

{syntab:Add plots}
{synopt :{opth "addplot(addplot_option:plot)"}}add other plots to the generated graph{p_end}

{syntab:Y axis, X axis, Titles, Legend, Overall}
{synopt :{it:{help twoway_options}}}any options other than {cmd:by()} documented in {bind:{bf:[G]} {it:twoway_options}}{p_end}
{synoptline}
{p2colreset}{...}
{p 4 6 2} You must {cmd:tsset} your data before using {cmd:wntestb}; see
{helpb tsset:[TS] tsset}.  In addition, the time series must be dense
(nonmissing and no gaps in the time variable) in the specified sample.{p_end}
{p 4 6 2}{it:varname} may contain time-series operators; see {help tsvarlist}.
{p_end}


{title:Description}

{pstd}
{cmd:wntestb} performs Bartlett's periodogram-based test for white noise.
The result is presented graphically by default but optionally may be 
presented as text in a table.


{title:Options}

{dlgtab:Main}

{phang}
{opt table} displays the test results as a table instead of as the
default graph.

{phang}
{opt level(#)} specifies the confidence level, as a percentage, for the
confidence bands included on the graph.  The default is {cmd:level(95)} or as
set by {helpb set level}.

{dlgtab:Plot}

{phang}
{it:marker_options}
    specify the look of markers.  This
    look includes the marker symbol, the marker size, and its color and
    outline; see {manhelpi marker_options G}.

{phang}
{it:marker_label_options}
    specify if and how the markers are to be labeled; 
    see {manhelpi marker_label_options G}.

{phang}
{it:cline_options} 
    specify if the points are to be connected with lines and the rendition of
    those lines; see {manhelpi line_options G}.

{dlgtab:Add plots}

{phang}
{opt addplot(plot)} adds specified plots to the generated graph; see 
{manhelpi addplot_option G}.

{dlgtab:Y axis, X axis, Titles, Legend, Overall}

{phang}
{it:twoway_options} are any of the options documented in 
{manhelpi twoway_options G}, excluding {opt by()}.  These include options for
titling the graph (see {manhelpi title_options G}) and saving the graph to disk
(see {manhelpi saving_option G}).


{title:Examples}
 
{pstd}Setup{p_end}
{phang2}{cmd:. drop _all}{p_end}
{phang2}{cmd:. set obs 100}{p_end}
{phang2}{cmd:. generate x1 = rnormal()}{p_end}
{phang2}{cmd:. generate time = _n}{p_end}
{phang2}{cmd:. tsset time}{p_end}

{pstd}Perform Bartlett's periodogram-based test for white noise on series
{cmd:x1}{p_end}
{phang2}{cmd:. wntestb x1}{p_end}

{pstd}Same as above, but present results as a table instead of a graph{p_end}
{phang2}{cmd:. wntestb x1, table}{p_end}


{title:Saved results}

{pstd}
{cmd:wntestb} saves the following in {cmd:r()}:

{synoptset 15 tabbed}{...}
{p2col 5 15 19 2: Scalars}{p_end}
{synopt:{cmd:r(stat)}}Bartlett's statistic{p_end}
{synopt:{cmd:r(p)}}probability value{p_end}
{p2colreset}{...}


{title:Also see}

{psee}
Manual:  {bf:[TS] wntestb}{p_end}

{psee}
Online:  {manhelp corrgram TS}, {manhelp cumsp TS}, {manhelp pergram TS},
{manhelp tsset TS}, {manhelp wntestq TS}
{p_end}
