{smcl}
{* *! version 1.0.11  24mar2008}{...}
{cmd:help xtlogit postestimation}{...}
{right:predict dialogs:  {bf:{dialog xtlogit_re_p:re}}  {bf:{dialog xtlogit_fe_p:fe}}  {bf:{dialog xtlogit_pa_p:pa}}}
{right:also see:  {helpb xtlogit} {space 2}}
{hline}

{title:Title}

{p2colset 5 36 38 2}{...}
{p2col :{hi:[XT] xtlogit postestimation} {hline 2}}Postestimation tools for xtlogit{p_end}
{p2colreset}{...}


{title:Description}

{pstd}
The following postestimation commands are available for {cmd:xtlogit}:

{synoptset 13 notes}{...}
{p2coldent :command}description{p_end}
{synoptline}
INCLUDE help post_adjust3par
{p2coldent :(2) {helpb estat}}AIC, BIC, VCE, and estimation sample summary{p_end}
INCLUDE help post_estimates
INCLUDE help post_hausman
INCLUDE help post_lincom
INCLUDE help post_lrtest
INCLUDE help post_mfx
INCLUDE help post_nlcom
{synopt :{helpb xtlogit postestimation##predict:predict}}predictions, residuals, influence statistics, and other diagnostic measures{p_end}
INCLUDE help post_predictnl
INCLUDE help post_test
INCLUDE help post_testnl
{synoptline}
{p2colreset}{...}
{p 4 6 2}
(1) {cmd:adjust} is not appropriate with time-series operators.
{p_end}
{p 4 6 2}
(2) {cmd: estat ic} is not appropriate with {cmd: xtlogit, pa}.
{p_end}


{marker predict}{...}
{title:Syntax for predict}

{phang}
Random-effects model

{p 8 16 2}
{cmd:predict} {dtype} {newvar} {ifin} [{cmd:,} 
{it:{help xtlogit_postestimation##randomeffects:RE_statistic}} {opt nooff:set}]

{phang}
Fixed-effects model

{p 8 16 2}
{cmd:predict} {dtype} {newvar} {ifin} [{cmd:,} 
{it:{help xtlogit_postestimation##fixedeffects:FE_statistic}} {opt nooff:set}]

{phang}
Population-averaged model

{p 8 16 2}
{cmd:predict} {dtype} {newvar} {ifin} [{cmd:,} 
{it:{help xtlogit_postestimation##popaverage:PA_statistic}} {opt nooff:set}]

{marker randomeffects}{...}
{synoptset 13 tabbed}{...}
{synopthdr :RE_statistic}
{synoptline}
{syntab:Main}
{synopt :{opt xb}}linear prediction; the default{p_end}
{synopt :{opt pu0}}probability of a positive outcome assuming the random effect is zero{p_end}
{synopt :{opt stdp}}standard error of the linear prediction{p_end}
{synoptline}
{p2colreset}{...}

{marker fixedeffects}{...}
{synoptset 13 tabbed}{...}
{synopthdr :FE_statistic}
{synoptline}
{syntab:Main}
{synopt :{opt p:c1}}probability of a positive outcome conditional on one positive outcome within group; the default{p_end}
{synopt :{opt pu0}}probability of a positive outcome assuming the fixed effect is zero{p_end}
{synopt :{opt xb}}linear prediction{p_end}
{synopt :{opt stdp}}standard error of the linear prediction{p_end}
{synoptline}
{p2colreset}{...}

{marker popaverage}{...}
{synoptset 13 tabbed}{...}
{synopthdr :PA_statistic}
{synoptline}
{syntab:Main}
{synopt :{opt mu}}probability of {depvar}; considers the {opt offset()}{p_end}
{synopt :{opt rate}}probability of {depvar}{p_end}
{synopt :{opt xb}}linear prediction{p_end}
{synopt :{opt stdp}}standard error of the linear prediction{p_end}
{synopt :{opt score}}first derivative of the log likelihood with respect to xb{p_end}
{synoptline}
{p2colreset}{...}

INCLUDE help esample
{p 4 6 2}
The predicted probability for the fixed-effects model is conditional
on there being only one outcome per group.  See {bf:[R] clogit} for details.


{title:Options for predict}

{dlgtab:Main}

{phang}
{opt xb} calculates the linear prediction.  This is the default for the
random-effects model.

{phang}
{opt pc1} calculates the predicted probability of a positive outcome conditional
on one positive outcome within group.  This is the default for the
fixed-effects model.

{phang}
{opt mu} and {opt rate} both calculate the predicted probability of {depvar}.
{opt mu} takes into account the {opt offset()}, and {opt rate} ignores those
adjustments.  {opt mu} and {cmd:rate} are equivalent if you did not specify
{opt offset()}.  {opt mu} is the default for the population-averaged model.

{phang}
{opt pu0} calculates the probability of a positive outcome, assuming that the
fixed or random effect for that observation's panel is zero.  This
may not be similar to the proportion of observed outcomes in the group.

{phang}
{opt stdp} calculates the standard error of the linear prediction.

{phang}
{opt score} calculates the equation-level score.

{phang}
{opt nooffset} is relevant only if you specified {opth offset(varname)} for
{cmd:xtlogit}.  This option modifies the calculations made by {cmd:predict} so
that they ignore the offset variable; the linear prediction is treated as xb
rather than xb + offset.


{title:Examples}

{pstd}Setup{p_end}
{phang2}{cmd:. webuse union}{p_end}

{pstd}Fit random-effects model{p_end}
{phang2}{cmd:. xtlogit union age grade south, i(idcode)}{p_end}

{pstd}Compute probability of positive outcome, assuming random effect is zero
{p_end}
{phang2}{cmd:. predict prob, pu0}

{pstd}Fit population-averaged model{p_end}
{phang2}{cmd:. xtlogit union age grade south, i(idcode) pa}{p_end}

{pstd}Compute predicted probability of {cmd:union}{p_end}
{phang2}{cmd:. predict unionpr, mu}{p_end}

{pstd}Compute marginal effect of {cmd:age} on probability of
{cmd:union}{p_end}
{phang2}{cmd:. mfx, varlist(age)}{p_end}


{title:Also see}

{psee}
Manual:  {bf:[XT] xtlogit postestimation}

{psee}
Online:  {manhelp xtlogit XT}{break}
{p_end}
