{smcl}
{* *! version 1.2.5  06sep2007}{...}
{cmd:help xtmelogit postestimation}{right:dialogs:  {bf:{dialog xtmelogit_p:predict}}  {bf:{dialog xtmelogit_estat:estat}}}
{right:also see:  {helpb xtmelogit}     }
{hline}

{title:Title}

{p2colset 5 38 40 2}{...}
{p2col :{hi:[XT] xtmelogit postestimation} {hline 2}}Postestimation tools for
xtmelogit{p_end}
{p2colreset}{...}


{title:Description}

{pstd}
The following postestimation commands are of special interest after
{cmd:xtmelogit}:

{synoptset 14 tabbed}{...}
{p2coldent :command}description{p_end}
{synoptline}
{synopt :{helpb xtmelogit postestimation##estatgroup:estat group}}summarizes
the composition of the nested groups{p_end}
{synopt :{helpb xtmelogit postestimation##estatcov:estat recov}}{cmd:estat} 
{cmd:recovariance} displays the estimated random-effects covariance matrix{p_end}
{synoptline}
{p2colreset}{...}

{pstd}
The following standard postestimation commands are also available:

{synoptset 14 notes}{...}
{p2coldent :command}description{p_end}
{synoptline}
{p2coldent:(1) {helpb adjust}}adjusted predictions of xb or probabilities{p_end}
INCLUDE help post_estat
INCLUDE help post_estimates
INCLUDE help post_lincom
INCLUDE help post_lrtest
INCLUDE help post_mfx
INCLUDE help post_nlcom
{synopt :{helpb xtmelogit postestimation##predict:predict}}predictions, residuals, influence statistics, and other diagnostic measures{p_end}
INCLUDE help post_predictnl
INCLUDE help post_test
INCLUDE help post_testnl
{synoptline}
{p2colreset}{...}
{p 4 6 2}
(1) {cmd:adjust} is not appropriate with time-series operators.


{title:Special-interest postestimation commands}

{pstd}
{cmd:estat group} reports number of groups and minimum, average, and maximum
group sizes for each level of the model.  Model levels are identified by 
the corresponding group variable in the data.  Since groups are treated
as nested, the information in this summary may differ from what you would
get had you {cmd:tabulate}d each group variable yourself.

{pstd}
{cmd:estat recovariance} displays the estimated variance-covariance matrix 
of the random effects for each level.  Random effects can be either
random intercepts, in which case the corresponding rows and columns 
of the matrix are labeled as _cons, or random coefficients, in which case
the label is the name of the associated variable in the data.


{marker predict}{...}
{title:Syntax for predict}

{p 4 4 2}
Syntax for obtaining estimated random effects or their standard errors

{p 8 16 2}
{cmd:predict} {dtype} {{it:stub*}{c |}{it:newvarlist}} {ifin}
{cmd:,} { {opt ref:fects} | {opt rese:s} } [{opt l:evel(levelvar)}]

{p 4 4 2}
Syntax for obtaining other predictions

{p 8 16 2}
{cmd:predict} {dtype} {newvar} {ifin} 
[{cmd:,} {it:statistic} {opt fixed:only} {opt nooff:set}]


{synoptset 13 tabbed}{...}
{synopthdr :statistic}
{synoptline}
{syntab :Main}
{synopt :{opt m:u}}the predicted mean; the default{p_end}
{synopt :{cmd:xb}}xb, linear predictor for the {it:fixed} portion of the 
model{p_end}
{synopt :{cmd:stdp}}standard error of the fixed-portion linear 
prediction xb{p_end}
{synopt :{opt p:earson}}Pearson residuals{p_end}
{synopt :{opt d:eviance}}Deviance residuals{p_end}
{synopt :{opt a:nscombe}}Anscombe residuals{p_end}
{synoptline}
{p2colreset}{...}
INCLUDE help esample


{title:Options for predict}

{dlgtab:Main}

{phang}
{opt reffects} calculates posterior modal estimates of the 
random effects.  By default, estimates for all random effects in the model 
are calculated. However, if option {opt level(levelvar)} is specified, then 
estimates for only level {it:levelvar} in the model are calculated.  For
example, if {cmd:class}es are nested within {cmd:school}s, then

{p 12 16 2}{cmd:. predict b*, reffects level(school)}{p_end}

{pmore}
would yield random-effects estimates at the {cmd:school} level.  You must
specify {it:q} new variables, where {it:q} is the number of random-effects
terms in the model (or level).  However, it is much easier to just specify
{it:stub}{cmd:*} and let Stata name the variables
{it:stub}{cmd:1}, {it:stub}{cmd:2}, ..., {it:stubq} for you.

{phang}
{opt reses} calculates standard errors for the random-effects
estimates obtained by using option {opt reffects}.
By default, standard errors for all random effects in the model 
are calculated. However, if option {opt level(levelvar)} is specified, then 
standard errors for only level {it:levelvar} in the model are calculated.  For
example, if {cmd:class}es are nested within {cmd:school}s, then

{p 12 16 2}{cmd:. predict se*, reses level(school)}{p_end}

{pmore}
would yield standard errors at the {cmd:school} level.  You must
specify {it:q} new variables, where {it:q} is the number of random-effects
terms in the model (or level).  However, it is much easier to just specify
{it:stub}{cmd:*} and let Stata name the variables
{it:stub}{cmd:1}, {it:stub}{cmd:2}, ..., {it:stubq} for you.

{pmore}
Options {cmd:reffects} and {cmd:reses} often generate multiple new 
variables at once.  When this occurs, the random effects (or standard 
errors) contained in the
generated variables correspond to the order in which the variance components
are listed in the output of {cmd:xtmelogit}.  Still, examining the variable
labels of the generated variables (using {help describe}, for instance) can
be useful in deciphering which variables correspond to which terms in the
model.

{phang}
{opt level(levelvar)} specifies the level in the model at which
predictions for random effects and their standard errors are
to be obtained.  {it:levelvar} is the name of the model level and is either
the name of the variable describing the grouping at that level or {cmd:_all},
a special designation for a group comprising all the estimation data.

{phang} 
{opt mu}, the default, calculates the predicted mean.
By default, this is based on a linear predictor that
includes {it:both} the fixed effects and the random effects, and the predicted
mean is conditional on the values of the estimated random effects.  Use option
{opt fixedonly} if you want predictions that include only the fixed portion of
the model, i.e., if you want random effects set to zero.

{phang}
{opt xb} calculates the linear prediction for the fixed portion of the
model. 

{phang}
{opt stdp} calculates the standard error of the fixed-portion linear prediction.

{phang}
{opt pearson} calculates Pearson residuals.  Pearson residuals large in
absolute value may indicate a lack of fit.  By default, residuals include both
the fixed portion and the random portion of the model.  Option {opt fixedonly}
modifies the calculation to include the fixed portion only.

{phang}
{opt deviance} calculates deviance residuals.  Deviance residuals are
recommended by McCullagh and Nelder (1989) as having the best properties for
examining the goodness of fit of a GLM.  They are approximately normally
distributed if the model is correctly specified.  They may be plotted against
the fitted values or against a covariate to inspect the model's fit.  By
default, residuals include both the fixed portion and the random portion of the
model.  Option {opt fixedonly} modifies the calculation to include the fixed
portion only.

{phang}
{opt anscombe} calculates Anscombe residuals, residuals that are designed to
closely follow a normal distribution.  By default, residuals include both the
fixed portion and the random portion of the model.  Option {opt fixedonly}
modifies the calculation to include the fixed portion only.

{phang}
{opt fixedonly} modifies predictions to include only the fixed portion 
of the model, equivalent to setting all random effects equal to 
zero;  see above.

{phang}
{opt nooffset} is relevant only if you specified {opth offset(varname)} 
for {cmd:xtmelogit}.  It modifies the calculations made by {cmd:predict} so 
that they ignore the offset variable; the linear prediction is treated
as xb (+ Zu) rather than xb (+ Zu) + offset.


{marker estatgroup}{...}
{title:Syntax for estat group}

{p 8 14 2}
{cmd:estat} {opt gr:oup} 


{marker estatcov}{...}
{title:Syntax for estat recovariance}

{p 8 14 2}
{cmd:estat} {opt recov:ariance} [{cmd:,} {it:recov_options}]

{synoptset 18}{...}
{synopthdr :recov_options}
{synoptline}
{synopt :{opt l:evel(levelvar)}}display
the random-effects covariance/correlation matrix for level {it:levelvar}
{p_end}
{synopt :{opt corr:elation}}display matrix as a correlation matrix{p_end}
{synopt :{it:matlist_options}}style options for displaying the 
matrix; see {helpb matlist:[P] matlist}{p_end}
{synoptline}
{p2colreset}{...}


{title:Options for estat recovariance}

{phang}
{opt level(levelvar)} specifies the level in the model for which the
random-effects covariance matrix is to be displayed.  By default, the
covariance matrices for all levels in the model are displayed.  {it:levelvar}
is the name of the model level and is either the name of variable describing
the grouping at that level or {cmd:_all}, a special designation for a group
comprising all the estimation data.

{phang}
{opt correlation} displays the covariance matrix as a correlation matrix.

{phang}
{it:matlist_options} control how the matrix (or matrices) are displayed.  See
{helpb matlist:[P] matlist} for details.


{title:Examples}

    {hline}
{pstd}Setup{p_end}
{phang2}{cmd:. webuse bangladesh}{p_end}
{phang2}{cmd:. xtmelogit c_use urban age child* || district: urban, covariance(unstructured)}{p_end}

{pstd}Random-effects covariance matrix for level {cmd:district}{p_end}
{phang2}{cmd:. estat recovariance}{p_end}

{pstd}Random-effects correlation matrix for level {cmd:district}{p_end}
{phang2}{cmd:. estat recovariance, correlation}{p_end}

{pstd}Predictions of random effects{p_end}
{phang2}{cmd:. predict re_urban re_cons, reffects}{p_end}

    {hline}
{pstd}Setup{p_end}
{phang2}{cmd:. webuse towerlondon, clear}{p_end}
{phang2}{cmd:. xi: xtmelogit dtlm difficulty i.group || family: || subject:}
{p_end}

{pstd}Summarize composition of nested groups{p_end}
{phang2}{cmd:. estat group}{p_end}

{pstd}Predicted probabilities, incorporating random effects{p_end}
{phang2}{cmd:. predict p}{p_end}

{pstd}Predicted probabilities, ignoring subject and family effects{p_end}
{phang2}{cmd:. predict p_fixed, fixedonly}{p_end}
    {hline}


{title:Saved results}

{pstd}
{cmd:estat recovariance} saves the last-displayed random-effects covariance
matrix in {cmd:r(cov)} or in {cmd:r(corr)} if it is displayed as a correlation
matrix.


{title:Reference}

{phang}
McCullagh, P., and J. A. Nelder. 1989.
{it:Generalized Linear Models}. 2nd ed.
London: Chapman & Hall/CRC.


{title:Also see}

{psee}
Manual:  {bf:[XT] xtmelogit postestimation}

{psee}
Online:  {manhelp xtmelogit XT}
{p_end}
