*! version 2.0.4  13may2009
program xtmixed, eclass byable(onecall) prop(xt)
	global XTM_ver = _caller() 
	version 9
	
	if _by() {
		local by "by `_byvars'`_byrc0':"
	}
	if replay() {
		if "`e(cmd)'" != "xtmixed" {
			error 301
		}
		if _by() {
			error 190
		}
		Display `0'
		exit
	}

	capture noisily `by' Estimate `0'
	local rc = _rc
	ereturn local cmdline `"xtmixed `0'"'
	capture mata: _xtm_cleanup()
	capture mac drop XTM_ver
	exit `rc'
end

program Estimate, sortpreserve eclass byable(recall)
	local globopts `"Level(cilevel) PPARSEPOST"'
	local globopts `"`globopts' REML MLe VARiance EMITERate(integer 20)"'
	local globopts `"`globopts' EMTOLerance(real 1e-10) EMLOG EMDOTs"'
	local globopts `"`globopts' noGRoup noHEADer ESTMetric"'
	local globopts `"`globopts' noSTDerr noLRtest noLOg EMONLY NOEMSHOW"'
	local globopts `"`globopts' noFETable noRETable"'

	// undocumented, for use by predict and estat

	local globopts `"`globopts' grouponly getblups(string)"'

	// mlopts

	local mlopts `"NONRTOLerance NRTOLerance(string)"'
	local mlopts `"`mlopts' TRace GRADient HESSian showstep"'
	local mlopts `"`mlopts' technique(string) SHOWNRtolerance"'
	local mlopts `"`mlopts' ITERate(string) TOLerance(string)"'
	local mlopts `"`mlopts' LTOLerance(string) GTOLerance(string)"'
	local mlopts `"`mlopts' DIFficult"'

	local globallow `"`globopts' `mlopts'"'

	// parse

	_parse expand cmd glob : 0 , common(`globallow')

	forvalues k = 1/`cmd_n' {			// Parse global if/in
                local cmds `"`cmds' `"`cmd_`k''"'"'
        }
        _mixed_parseifin `=`cmd_n'+1' `cmds' "`glob_if' `glob_in'"

	forvalues k=0/`=`cmd_n'-1' {			// Parse subcmds
		_mixed_parsecmd `k' `cmd_`=`k'+1''
		local allnms `allnms' `levnm_`k'' `varnames_`k''
	}
	if "`depname'" == "" {
		di as err "dependent variable not specified"
		exit 198
	}
	local allnms `allnms' `depname'

	local 0 `"`glob_if' `glob_in'"'			// set estimation sample
	syntax [if] [in]
	marksample touse
	local allnms : subinstr local allnms "_all" "" , word all
	markout `touse' `allnms' , strok

	tempvar one					// processing macs
	qui gen byte `one' = 1 if `touse'
	local lev_beg 0
	local last_levnm "______"
	tempname lev_nvars sublevels
	if (`cmd_n' > 1)  matrix `sublevels' = J(1,`=`cmd_n'-1', 0)

	forvalues k=0/`=`cmd_n'-1' {			// reconcile levels
		local k1 = `k' - 1			// and sublevels

		if "`levnm_`k''" != "`last_levnm'" {

			if `k' > 0 {			// level var repeated
				if 0`:list levnm_`k' in levnms' {	
					if `"`levnm_`k''"' != `""' {
						RepeatedLevelError `levnm_`k''
						exit 198
					}
				}
				local levnms `levnms' `levnm_`k''

				_mixed_fixupconstant `lev_beg' `k1' /// 
						     `last_const'
				_mixed_setsublevels  `lev_beg' `k1' `sublevels'
				_mixed_rmcollevel `lev_beg' `k1' `depname'  ///
					   "`lev_constant'" "`lev_isfctrs'" ///
					   "`collin_`k1''" `touse'	    ///
					   `lev_varnames'
			}

			local lev_varnames `""`varnames_`k''""'
			if "`constant_`k''" != "" {
				local lev_constant 0
			}
			else {
				local lev_constant 1
			}
			local last_const   = cond("`constant_`k''"=="", `k', -1)
			local lev_isfctrs  `isfctr_`k''
			local lev_beg      `k'
		}
		else {
			local lev_varnames `"`lev_varnames' "`varnames_`k''""'
			local lev_isfctrs `lev_isfctrs' `isfctr_`k''

			if "`constant_`k''" != "" {
				local lev_constant `lev_constant' 0
			}
			else {
				local lev_constant `lev_constant' 1
			}
			if "`constant_`k''" == "" {
				local last_const = `k'
			}
		}

		local last_levnm `levnm_`k''
		local kh `k'
	}

	_mixed_fixupconstant `lev_beg' `kh' `last_const'
	_mixed_setsublevels  `lev_beg' `kh' `sublevels'
	_mixed_rmcollevel `lev_beg' `kh' `depname' "`lev_constant'"	///
		   "`lev_isfctrs'" "`collin_`kh''" `touse' `lev_varnames'

	tempname fctrlevs

	forvalues k=0/`=`cmd_n'-1' {
		if `isfctr_`k'' {			// create factors
			tempvar ifctr
			qui egen long `ifctr' = group(`varnames_`k'') if `touse'
			label variable `ifctr'				///
			      `"R.`:subinstr local varlist_`k' " " " R."'"'
			local varlist_`k' `ifctr'

			sum `ifctr' , meanonly
			matrix `fctrlevs' = (nullmat(`fctrlevs'), r(max))
		}
		else {					// handle ts ops
			tsrevar `varnames_`k'' if `touse'
			local varlist_`k' `r(varlist)'
		}

		if "`constant_`k''" == "" {		// handle constants
			local varlist_`k' `varlist_`k'' `one'
			local varnames_`k' `varnames_`k'' _cons
		}

		if `k' > 0 & !`isfctr_`k'' {
			foreach var of local varlist_`k' {
				matrix `fctrlevs' = (nullmat(`fctrlevs'), 1)
			}
							// Fixup covariance
			if (`:list sizeof varlist_`k'' + 		///
			    ("`constant_`k''"=="")) == 1 {
				local cov_`k' = "identity"
			}

		}

	}
	tsrevar `depname' if `touse'			// handle ts depvar
	local depvar `r(varlist)'

	foreach nm of local levnms {			// encode levels
		tempvar level 
		if ("`nm'" == "_all")  local nm `one'
		local nms `nms' `nm'
		qui egen long `level' = group(`nms') if `touse'
		local levelvars `levelvars' `level'
	}

	forvalues k=1/`=`cmd_n'-1' {		// check for empty levels
		if "`varlist_`k''" == "" {
			if !`k' { 
				local lab fixed effects
			}
			else {
				local lab group `levnm_`k'':
			}
			di as error "`lab' equation empty"
			exit 102
		}
	}

	// global options are in glob_op  -- your parsing goes here
	local 0 `", `glob_op'"'
	syntax [ , `globopts' *]

	mlopts mlopts, `options'
	local coll `s(collinear)'
	local 0 `", `mlopts'"'
	syntax [, technique(string) COLlinear *]
	if `:list posof "bhhh" in technique' {
		di as err "option technique(bhhh) not allowed"
		exit 198
	}
	local mlopts `"technique(`technique') `options'"'

// error checking options goes here

	if "`mle'" != "" {
		local ml ml
	}
	if "`ml'" != "" {
		if "`reml'" != "" {
			di as err "ml and reml may not be specified at " _c
			di as err "the same time"
			exit 198
		}
		local reml 0
		local method ML
	}
	else {
		local reml 1
		local method REML
	}
	if "`emonly'" != "" & "`emdots'" == "" & "`noemshow'" == "" {   
		local emlog emlog
	}
	if "`emlog'" != "" & "`emdots'" != "" {
		di as err "emlog and emdots may not be specified together"
		exit 198
	}
	if "`variance'" != "" & "`estmetric'" != "" {
		di as err "variance and estmetric may not be specified together"
		exit 198
	}

	if "`pparsepost'" != "" {
		ereturn clear
		foreach mac in depvar depname cmd_n {
			ereturn local `mac' ``mac''
		}
		forvalues l = 0/`=`cmd_n'-1' {
			foreach mac in levnm isfctr cov	k sublevels	///
				       constant varlist varnames {
				ereturn local `mac'_`l' ``mac'_`l''
			}
		}
		exit
	}
							// set up _xtm_model
	tempvar nn
	qui gen long `nn' = _n if `touse'
	gsort -`touse' `levelvars' `nn'

	tempname obs re_n
	qui count if `touse'
	scalar `obs' = r(N)
	scalar `re_n' = `cmd_n' - 1
	
	mata: _xtm_setup()

	// obtain blups if specified and exit
	if `"`getblups'"' != "" {
		CheckBlups `getblups'
		SetBlupMats `touse'
		GetBlups `getblups'
		exit	
	}
		
	if `reml' {
		local crittype log restricted-likelihood
	}
	else {
		local crittype log likelihood
	}
	if "`log'" != "" {
		local q qui
	}

	tempname delta deltaf theta thetaf gamma s h err beta Vbeta V

// fit reference regression model
	
	if `cmd_n' == 1 | "`lrtest'" == "" {
		MyReg `depvar' `varlist_0' if `touse', reml(`reml')
		local ll_0 `r(ll0)'
		local gam `r(lnsig)'
	}

	if `cmd_n' == 1 { 	// model is linear regression 
		local ll_2 `ll_0'
		mat `beta' = e(b)    // from regress
		mat `Vbeta' = e(V)  
		local c = colsof(`Vbeta')
		if !`reml' & `c'{         // ml uses different sigma^2
			mat `Vbeta' = `Vbeta' * e(df_r)/e(N)
		}
		mat `gamma' = `gam'
		mat colnames `gamma' = lnsig_e:_cons
		mat `V' = 0
		if "`stderr'" == "" {
			mat `V' = 1/(2*e(N))
		}
		local lrtest nolrtest
		local emconv 1
	}
	else {
// starting values

		mata: _xtm_start("`delta'",0.375)   

// EM iterations
		if `emiterate' {
		   `q' IterateEM `delta', crit(`crittype') iter(`emiterate') ///
			tol(`emtolerance') `emlog' `emdots' 
		    local emconv = r(converged)
		}
		mat `deltaf' = `delta'

// Transform to NR parameterization
		mata: _xtm_delta_to_theta("`theta'","`delta'","`err'")
		if scalar(`err') {
			di as err "initial values/EM solution not feasible"
			exit 430 
		}
		mat `thetaf' = `theta'
		mata: _xtm_ml_eqlist("eqlist")

		local df_c : word count `eqlist'
		mat `h' = J(1,`df_c',1)
	
		if "`emonly'" == "" {
			`q' di
			`q' di as txt "Performing gradient-based optimization: " 
			cap noi `q' ml model d0 mixed_ll `eqlist', ///
				max init(`theta', copy) ///
				search(off) crittype(`crittype') dzeros(`h') ///
				collinear missing nopreserve `mlopts' 
			if _rc | "`e(converged)'" == "0" {	
				if _rc == 1 {
					exit 1
				}
				local noconv noconv
				mat `delta' = `deltaf'
				mat `theta' = `thetaf'
			}
			else {
				mat `theta' = e(b)
				mata: _xtm_theta_to_delta("`delta'","`theta'","`err'")	
				local opt `e(opt)'	
				local ml_method `e(ml_method)'
				local technique `e(technique)'
			}
		}
		scalar `s' = -1 
		mata: _xtm_mixed_ll("`delta'","`s'",0)
		local ll_1 = r(ll)
		scalar `s' = r(mse)
		local ll_2 = `ll_1'

// Reparameterize
		mata: _xtm_theta_to_gamma("`gamma'","`theta'","`s'")
		if "`noconv'" == "" & "`emonly'" == "" & "`stderr'" == "" {
			mat `h' = e(ml_d0_s), 1
			local c = colsof(`theta')
			forvalues i = 1/`c' {
			    mat `h'[1,`i'] = `h'[1,`i'] * ///
				abs(`gamma'[1,`i']/`theta'[1,`i'])
			}
			`q' di 
			`q' di as txt "Computing standard errors:" 
			cap ml model d0 mixed_ll_reparm ///
			    `eqlist' /lnsig_e, ///
			    max init(`gamma',copy) search(off) iter(0) ///
			    dzeros(`h') collinear missing nopreserve `mlopts'
			if _rc {
				if _rc == 1 {
					exit 1
				}
				local nostd nostd
				local ll_2 = `ll_1'
			}
			else {
				local ll_2 = e(ll)
				if reldif(`ll_1',`ll_2') > 1e-10 {
					local nostd nostd
				}
			}
			if "`nostd'" != "" {
				di as err "standard error calculation failed"
			}
		}

// Get final beta
        	mata: _xtm_mixed_ll("`delta'","`s'",1) 
		mata: _xtm_beta("`beta'","`Vbeta'","`s'")
		if "`noconv'"=="" & "`emonly'"=="" & ///
			"`nostd'" == "" & "`stderr'"=="" {
			mat `gamma' = e(b)
			mat `V' = e(V)	
		}
		else {
			local eqnames : subinstr local eqlist "/" "", all
			mat coleq `gamma' = `eqnames' lnsig_e
			mat colnames `gamma' = _cons
			local c = colsof(`gamma')
			mat `V' = J(`c',`c',0)
		}
	}

// Post Parameters

	if `"`varnames_0'"' == "" {
		PostParms `depname', re(`gamma') vre(`V') touse(`touse')
	}
	else {
		PostParms `depname' `varnames_0', beta(`beta') ///
			vbeta(`Vbeta') re(`gamma') vre(`V') touse(`touse')
	}

// Out of the variance estimates, count how many sigmas and rhos 

	mat `gamma' = e(b)
	local eqs : coleq `gamma'
	local k_rs 0
	forval i = `=e(k_f)+1'/`e(k)' {
		local eq : word `i' of `eqs'
		if substr("`eq'",1,3) == "lns" {
			local ++k_rs
		}
	}
	ereturn scalar k_rs = `k_rs'
	ereturn scalar k_rc = e(k_r) - e(k_rs)

	if "`emonly'" != "" {
		ereturn local emonly emonly
		ereturn scalar converged = `emconv'
	}
	else {
		ereturn scalar converged = ("`noconv'"=="")
	}
	ereturn local depvar `depname'
	ereturn scalar ll = `ll_2'

// Comparison test
	
	if `cmd_n' > 1 & "`lrtest'" == "" {
		ereturn scalar ll_c = `ll_0'
		ereturn scalar df_c = `df_c'
		ereturn scalar chi2_c = 2*(e(ll) - e(ll_c))
		if e(chi2_c) < 0 {
			ereturn scalar chi2_c = 0
		}
		ereturn scalar p_c = chi2tail(e(df_c),e(chi2_c))
		if e(df_c) == 1 & e(chi2_c) > 1e-5 {
			ereturn scalar p_c = 0.5*e(p_c)
		}
	}

//  data resorted in what follows

	SaveGroupInfo `"`levelvars'"' 

	ereturn local crittype `crittype'
	ereturn local method `method'
	ereturn local opt `opt'
	ereturn local ml_method `ml_method'
	ereturn local technique `technique'
	ereturn local title Mixed-effects `e(method)' regression

	forvalues k=1/`=`cmd_n'-1' {
		if `isfctr_`k'' {
			local varnames_`k'				///
			      `"R.`:subinstr local varnames_`k' " " " R."'"'
		}
		local zvars     `"`zvars' `varnames_`k''"'
		local vartypes  `"`vartypes' `=proper("`cov_`k''")'"'
		local lvnms     `"`lvnms' `levnm_`k''"'
		local dimz	`"`dimz' `:list sizeof varnames_`k''"'
	}
	ereturn local revars `zvars'
	ereturn local vartypes `vartypes'
	ereturn local ivars `lvnms'
	ereturn local redim `dimz'
	ereturn local cmd xtmixed
	ereturn local predict xtmixed_p
	ereturn local estat_cmd xtmixed_estat

	if "`varnames_0'" == "_cons"  | "`varnames_0'" == "" {
		ereturn scalar chi2 = .
		ereturn scalar p = .
		ereturn scalar df_m = 0
	}
	else {
		qui test [#1]
		if `r(drop)' {
			ereturn scalar chi2 = .
			ereturn scalar p = .
		}
		else {
			ereturn scalar chi2 = r(chi2)
			ereturn scalar p = r(p)
		}
		ereturn scalar df_m = r(df)
	}
	ereturn local chi2type Wald
	ereturn scalar rc = cond(`e(converged)',0,430)

	Display, level(`level') `lrtest' ///
		`variance' `group' `header' `estmetric' ///
		`grouponly' `fetable' `retable'
end

program ConstantNote
	args lev_k

	di as text							///
"{p 0 6}Note: level `lev_k' already has a constant, {cmd:noconstant} assumed for all other entries for the level{p_end}"

end

program RepeatedLevelError
    di as error 							///
    "{p 0 4}`0' level variable, specified at more than one level{p_end}"
end

program PostParms, eclass
	syntax [anything] [, beta(string) vbeta(string) re(string) ///
			    vre(string) touse(string) ]
	tempname bc vc 

	local r2 = colsof(`re')
	if "`beta'" != "" {	
		local r1 = colsof(`beta')
	}
	else {
		local names: colfullnames `re'
		mat colnames `vre' = `names'
		mat rownames `vre' = `names'
		eret post `re' `vre', depname(`depvar') esample(`touse') 
		eret scalar k_f = 0
		eret scalar k_r = `r2'
		eret scalar k = `r2'
		exit
	}
	gettoken depvar xvars : anything

	if strpos("`depvar'",".") {
		gettoken ts rest : depvar, parse(".")
		gettoken dot depvar : rest, parse(".")
	}

	foreach v of local xvars {
		local col `col' `depvar':`v'
	}	
	mat colnames `beta' = `col'
	mat `bc' = `beta', `re'	
	mat `vc' = (`vbeta' , J(`r1',`r2',0) \ J(`r2',`r1',0), `vre')
	local names: colfullnames `bc'
	mat colnames `vc' = `names'
	mat rownames `vc' = `names'
	eret post `bc' `vc', depname(`depvar') esample(`touse') 
	eret scalar k_f = `r1'
	eret scalar k_r = `r2'
	eret scalar k = `r1' + `r2'
end

program Display
	syntax [, level(cilevel) VARiance noLRtest ///
		  noGRoup noHEADer noFETable noRETable ESTMetric grouponly]

	local k = ("`fetable'"!="") + ("`retable'"!="") + ("`variance'"!="")
	if `k' {
		if "`estmetric'" != "" {
di as err "{p 0 4 4}option estmetric not allowed with options nofetable, noretable, and variance{p_end}"
			exit 198
		}
	}
	if "`header'" == "" {
		DiHeader, `group' `grouponly'
		if "`grouponly'" != "" {
			exit
		}
	}
	if "`estmetric'" != "" {
		di
		eret di, level(`level')
		exit
	}
	if "`fetable'" == "" & e(k_f) > 0 {
		DiEstTable, level(`level')
	}
	if "`retable'" == "" {
		DiVarComp, level(`level') `variance' `lrtest'
		local note `r(note)'
	}
	if !`e(converged)' {
		if "`note'" == "" {
			di
		}
		if "`e(emonly)'" != "" {
di as txt "{p 0 6 4}Note: EM algorithm failed to converge{p_end}"
		}
		else {
di as txt "{p 0 9 4}Warning: " ///
"convergence not achieved; estimates are based on iterated EM{p_end}" 
		}
	}
end	

program DiHeader
	syntax [, noGRoup grouponly]
	if "`grouponly'" != "" {
		if "`e(ivars)'" == "" {
			di as err "{p 0 4 2}model is linear regression; "
			di as err "no group information avaiable{p_end}"
			exit 459
		}
		DiGroupTable, table
		exit
	}
	di
	local crtype = upper(substr(`"`e(crittype)'"',1,1)) + /*
                */ substr(`"`e(crittype)'"',2,.)
	
	di as txt "`e(title)'" _c
	di _col(49) as txt "Number of obs" _col(68) "=" _col(70) as res ///
		%9.0g e(N)

	if "`group'" == "" {
 		DiGroupTable
		di
	}
        di _col(49) as txt "`e(chi2type)' chi2(" as res e(df_m) as txt ")" ///
                _col(68) "=" _col(70) as res %9.2f e(chi2)
	di as txt "`crtype'" " = " as res %10.0g e(ll) /*
                */ _col(49) as txt "Prob > chi2" _col(68) "=" _col(73) /*
                */ as res %6.4f chiprob(e(df_m), e(chi2))
end

program DiGroupTable
	syntax [, table]
	local ivars `e(ivars)'
	local levels : list uniq ivars
	tempname Ng min avg max
	mat `Ng' = e(N_g)
	mat `min' = e(g_min)
	mat `avg' = e(g_avg)
	mat `max' = e(g_max)
	local w : word count `levels'
	if `w' == 0 {
		exit
	}
	if `w' == 1 & "`table'" == "" {
		di as txt "Group variable: " as res abbrev("`levels'",14) ///
		     _col(49) as txt "Number of groups" _col(68) "=" ///
		     _col(70) as res %9.0g `Ng'[1,1] _n
		di as txt _col(49) "Obs per group: min" _col(68) "=" ///
		     _col(70) as res %9.0g `min'[1,1]
		di as txt _col(64) "avg" _col(68) "=" ///
		     _col(70) as res %9.1f `avg'[1,1]
		di as txt _col(64) "max" _col(68) "=" ///
		     _col(70) as res %9.0g `max'[1,1] _n
	}
	//         1         2         3         4         5         6
	//123456789012345678901234567890123456789012345678901234567890
	//                    No. of       Observations per Group
	// Group Variable |   Groups    Minimum    Average    Maximum
	//        level1  | ########  #########  #########  #########
	else {
		di
		di as txt "{hline 16}{c TT}{hline 42}
		di as txt _col(17) "{c |}" _col(21) "No. of" ///
	          _col(34) "Observations per Group"
		di as txt _col(2) "Group Variable" _col(17) "{c |}" ///
		  _col(21) "Groups" _col(31) "Minimum" ///
		  _col(42) "Average" _col(53) "Maximum" 
		di as txt "{hline 16}{c +}{hline 42}"
		local i 1
		foreach k of local levels {
			local lev = abbrev("`k'",12)
			local p = 16 - length("`lev'")
			di as res _col(`p') "`lev'" /// 
			  as txt _col(17) "{c |}" ///
			  as res _col(19) %8.0g `Ng'[1,`i'] ///
                          _col(29) %9.0g `min'[1,`i'] ///
                          _col(40) %9.1f `avg'[1,`i'] ///
                          _col(51) %9.0g `max'[1,`i'] 
			local ++i	
		}
		di as txt "{hline 16}{c BT}{hline 42}" 
	}
end

program DiEstTable
	syntax [, level(cilevel)]

	di
	_coef_table, first level(`level') ignorerc 
end

program DiLRTest, rclass

	// We have already established that e(chi2_c) exists
	if ((e(chi2_c) > 0.005) & (e(chi2_c)<1e5)) | (e(chi2_c)==0) {
  		local fmt "%8.2f"
        }
        else    local fmt "%8.2e"

	di as txt "LR test vs. linear regression:" _c
	if `e(df_c)' == 1 {    		// chibar2(01)
		di as txt _col(32) "{help j_chibar##|_new:chibar2(01) =}" ///
                   _col(46) as res `fmt' e(chi2_c) ///
		   _col(55) as txt "Prob >= chibar2 = " ///
		   _col(73) as res %6.4f e(p_c)
	}		
	else {
		local k = length("`e(df_c)'")
		di as txt _col(`=39-`k'') "chi2(" as res e(df_c) ///
		   as txt ") =" _col(48) as res `fmt' e(chi2_c) ///
		   _col(59) as txt "Prob > chi2 =" ///
		   _col(73) as res %6.4f e(p_c)
		return local conserve conserve
	}
end

program DiVarComp, rclass
	syntax [, level(cilevel) VARiance noLRtest]

	local depvar `e(depvar)'
	if strpos("`depvar'",".") {
		gettoken ts rest : depvar, parse(".")
		gettoken dot depvar : rest, parse(".")
	}
	
	local dimx `e(k_f)'

	// display header 

	di
	di as txt "{hline 29}{c TT}{hline 48}
	if "`e(vcetype)'" == "Bootstrap" || ///
	   "`e(vcetype)'" == "Bstrap *" {
		local obs "Observed"
		local citype "Normal-based"
	}
	if `"`e(vcetype)'"' == "Bootstrap" || ///
	   `"`e(vcetype)'"' == "Bstrap *"  || ///
	   `"`e(vcetype)'"' == "Jackknife" || ///
	   `"`e(vcetype)'"' == "Jknife *" {
		local vcetype `e(vcetype)'
		if `"`e(mse)'"' != "" {
			capture which `e(vce)'_`e(mse)'.sthlp
			local mycrc = c(rc)
			if `mycrc' {
				capture which `e(vce)'_`e(mse)'.hlp
				local mycrc = c(rc)
			}
			if !`mycrc' {
				local vcetype ///
				"{help `e(vce)'_`e(mse)'##|_new:`vcetype'}"
                        }
		}
		di as txt _col(30) "{c |}" _col(34) `"`obs'"' ///
			  _col(45) `"`vcetype'"' ///
			  _col(63) `"`citype'"'
	}
	local k = length("`level'")
	di as txt _col(3) "Random-effects Parameters" _col(30) "{c |}" ///
		_col(34) "Estimate" _col(45) "Std. Err." _col(`=61-`k'') ///
		`"[`=strsubdp("`level'")'% Conf. Interval]"'
	di as txt "{hline 29}{c +}{hline 48}

	local zvars `e(revars)'
	local dimz `e(redim)'

	// loop over levels

	local foot = 1
	local pos `dimx'
	local levs : word count `e(ivars)'
	forvalues k = 1/`levs' {
		local lev : word `k' of `e(ivars)'
		local vartype : word `k' of `e(vartypes)'
		di as res abbrev("`lev'",12) as txt ": `vartype'" ///
			_col (30)"{c |}"

		GetNames "`vartype'" "`zvars'" "`dimz'" `foot'
		local zvars `s(zvars)'     // collapsed lists
		local dimz `s(dimz)'
		local names `"`s(names)'"'
		if `"`s(footnote)'"' != "" {
			local footnotes `"`footnotes' `s(footnote)'"'
			local ++foot
		}

		local nbeta : word count `names'
	
		DiParms `pos' `nbeta' `"`names'"' `level' `variance'

		local pos = `pos' + `nbeta'
		di as txt "{hline 29}{c +}{hline 48}
	}

	// Residual Variance 

	if "`variance'" == "" {
		local parm exp
		local label sd
		local p 17
	}
	else {
		local parm f(exp(2*@)) d(2*exp(2*@))
		local label var
		local p 16
	}
	qui _diparm lnsig_e, `parm' level(`level') notab
	di as txt _col(`p') "`label'(Residual)" _col(30) "{c |}" ///
	   as res _col(33) %9.0g r(est) ///
	   as res _col(44) %9.0g r(se)  ///
	   as res _col(58) %9.0g cond(missing(r(se)),.,r(lb))  ///
	   as res _col(70) %9.0g cond(missing(r(se)),.,r(ub))
	di as txt "{hline 29}{c BT}{hline 48}
	
	// Footnotes
	if "`e(chi2_c)'" != "" & "`lrtest'" == "" {
		DiLRTest
		local conserve `r(conserve)'
	}
	
	forvalues k = 1/`=`foot'-1' {
		local note: word `k' of `footnotes'
		local indent = 3 + length("`k'")
		di as txt `"{p 0 `indent' 4} `note'{p_end}"'
	}
	if "`conserve'" != "" {
		di as txt _n "{p 0 6 4}Note: {help j_xtmixedlr##|_new:LR test is conservative} and provided only for reference.{p_end}"
		return local note note
	}
end

program DiParms
	args pos nb names cilev var

	local stripes : coleq e(b), quoted
	forvalues k = 1/`nb' {
		local label : word `k' of `names'	
		local eq : word `=`pos'+`k'' of `stripes'
		GetParmEqType `eq' `var'
		local parm `s(parm)'
		local label `"`s(type)'`label'"'	
		local diparmeq `"`s(diparmeq)'"'

		local p = 29 - length("`label'")
		qui _diparm `diparmeq', `parm' level(`cilev') notab
		di as txt _col(`p') "`label'" _col(30) "{c |}" ///
		   as res _col(33) %9.0g r(est) ///
		   as res _col(44) %9.0g r(se)  ///
		   as res _col(58) %9.0g cond(missing(r(se)),.,r(lb))  ///
		   as res _col(70) %9.0g cond(missing(r(se)),.,r(ub))
	}
end

program GetNames, sclass
	args type zvars dimz foot

	gettoken dim dimz : dimz
	forvalues k = 1/`dim' {
		gettoken tok1 zvars : zvars
		local fullvarnames `fullvarnames' `tok1'
		local len = length("`tok1'")
		if substr("`tok1'",1,2) == "R." {
			local w = substr("`tok1'",3,`len') 
			local tok1 = "R." + abbrev("`w'",8)
		}
		else {
			local tok1 = abbrev("`tok1'",8)
		}
		local varnames `varnames' `tok1'
	}
	if ("`type'" == "Unstructured") {
		forvalues j = 1/`dim' {
			local w : word `j' of `varnames'
			local names `"`names' "(`w')""'
		}
		forvalues j = 1/`dim' {
			forvalues k = `=`j'+1'/`dim' {
				local w1 : word `j' of `varnames'
				local w2 : word `k' of `varnames'
				local names `"`names' "(`w1',`w2')""'	
			}
		}
	}
	else if ("`type'" == "Independent") {    
		forvalues j = 1/`dim' {
			local w : word `j' of `varnames'
			local names `"`names' "(`w')""'
		}
	}
	else {    // Identity or Exchangeable
		local ex = ("`type'" == "Exchangeable")
		if (`dim' == 1) {		// check for factor variable
			local w `varnames'
			local names `""(`w')""'
			if `ex' {
				local names `"`names' "(`w')""'
			}
		}
		else if (`dim' == 2) {
			local w1 : word 1 of `varnames'
			local w2 : word 2 of `varnames'
			local names `""(`w1' `w2')""'
			if `ex' {
local names `"`names' "(`w1',`w2')""'
			}
		}
		else {
			local k : length local varnames
			if `k' > 20 {		// too long
				local w1 : word 1 of `varnames'	
				local w2 : word `dim' of `varnames'
				local names `""(`w1'..`w2')(`foot')""'
				if `ex' {
local names `"`names' "(`w1'..`w2')(`foot')""'
				}
				local footnote `""(`foot') `fullvarnames'""'
			}
			else {
				local names `""(`varnames')""'
				if `ex' {
local names `"`names' "(`varnames')""'
				}
			}
		}
	}

	sreturn local zvars "`zvars'"
	sreturn local dimz "`dimz'"
	sreturn local names `"`names'"'
	sreturn local footnote `"`footnote'"'
end

program GetParmEqType, sclass
	args eq var
	
	if substr("`eq'",1,1) == "l" {	  // log standard deviation
		if "`var'" == "" {	  // se/corr metric
			local parm exp
			local type sd
		}			
		else {			  // var/cov metric
			local parm f(exp(2*@)) d(2*exp(2*@))
			local type var
		}
		local deq `eq'
	}
	else { // substr("`eq'",1,1) == "a"  atanh correlation
		if "`var'" == "" {        // se/corr metric
			local parm tanh
			local type corr
			local deq `eq'
		}
		else {			  // var/cov metric
			ParseEq `eq'
			local eq2 lns`r(n1)'_`r(n2)'_`r(n3)'
			local eq3 lns`r(n1)'_`r(n2)'_`r(n4)'
			local deq `eq' `eq2' `eq3'	
			local parm f(tanh(@1)*exp(@2+@3))
			local parm `parm' d((1-(tanh(@1)^2))*exp(@2+@3)
			local parm `parm' tanh(@1)*exp(@2+@3)
			local parm `parm' tanh(@1)*exp(@2+@3)) 
			local type cov
		}
	}

	sreturn local parm `"`parm'"'
	sreturn local type `"`type'"'
	sreturn local diparmeq `"`deq'"'
end

program ParseEq, rclass
	args eq

	// I've got "eq" == "atr#_#_#_#", and I need the four #'s
	// returned as r(n1), r(n2), r(n3), and r(n4)

	local len = length("`eq'")
	local eq = substr("`eq'",4,`len')
	forvalues k = 1/4 {
		gettoken n`k' eq : eq, parse(" _")
		return local n`k' `n`k''
		gettoken unscore eq : eq, parse(" _")
	}
end

program SaveGroupInfo, eclass
	args levnames

	qui count if e(sample)
	ereturn scalar N = `r(N)'
	local levels : list uniq levnames
	local k : word count `levels'
	if `k' == 0 {
		exit
	}
		
	tempname gmin gmax gavg Ng
	mat `Ng' = J(1,`k',0)
	mat `gmin' = J(1,`k',0)
	mat `gavg' = J(1,`k',0)
	mat `gmax' = J(1,`k',0)

	forvalues i = 1/`k' {
		GroupStats `:word `i' of `levels'' if e(sample)	
		mat `Ng'[1,`i'] = r(ng)
		mat `gmin'[1,`i'] = r(min)
		mat `gavg'[1,`i'] = r(avg)
		mat `gmax'[1,`i'] = r(max)
		local ++i
	}
	ereturn matrix N_g `Ng'
	ereturn matrix g_min `gmin'
	ereturn matrix g_avg `gavg'
	ereturn matrix g_max `gmax'
end

program GroupStats, rclass
	syntax name [if]
	marksample touse

	if "`namelist'" == "_all" {
		tempvar one
		qui gen byte `one' = 1 if `touse'
		local namelist `one'
	}
	tempname T
	qui {
		bysort `touse' `namelist': /// 
			gen long `T' = cond(_n==_N,_N,.) if `touse'
		sum `T' if `touse'
	}
	return scalar ng = r(N)
	return scalar min = r(min)
	return scalar max = r(max)
	return scalar avg = r(mean)
end

program IterateEM, rclass
	syntax name(name=theta) [, iter(integer 1) tol(real 1.0) ///
			crit(string) emlog emdots ]

	tempname thetaold s lold lnew delta err
	mat `thetaold' = `theta'

	if "`emlog'" == "" {
		local st *
	}
	di as txt _n "Performing EM optimization: " _c
	if "`emdots'" != "" {
		local didot `"di as txt "." _c"'
	}
	else {
		di
		`st' di
	}
	scalar `lold' = -1
	scalar `lnew' = 1
	
	local i 0	
	while `i' <= `iter'-1 & ///
	   reldif(scalar(`lold'),scalar(`lnew')) > `tol' {
		mata: _xtm_em_iter("`thetaold'","`theta'","`s'")
		if missing(r(ll)) {
			if "`emdots'" != "" {
				di _n
			}
			di as err "likelihood evaluates to missing"
			exit 430
		}
`st'di as txt "Iteration `i':" _col(16) "`crit' = " as res %10.0g `r(ll)'
		`didot'
		mat `thetaold' = `theta'
		scalar `lold' = scalar(`lnew')
		scalar `lnew' = r(ll)
		local ++i
	}
	scalar `s' = -1
	mata: _xtm_mixed_ll("`theta'","`s'",0)
`st'di as txt "Iteration `i':" _col(16) "`crit' = " as res %10.0g `r(ll)'
	if "`emdots'" != "" {
		di 
	}
	return scalar converged = (`i'<`iter')
end

program MyReg, rclass
	syntax anything(name=model) [if] [, reml(integer 0)]
	
	gettoken depvar xvars : model

	// strip _cons off the end of xvars
	local k: word count `xvars'
	if `k' {
		if "`:word `k' of `xvars''" == "_cons" {
			local xvars : subinstr local xvars "_cons" ""
		}
		else {
			local nocons nocons
		}
	}
	else {
		local nocons nocons
	}
	qui regress `depvar' `xvars' `if', `nocons'
	tempname lnsig ll0 logdet fact
	if `reml' {	
		mata: _xtm_logdetr00("`logdet'")
		scalar `lnsig' = log(e(rmse))
		scalar `ll0' = -e(df_r)/2*(log(2*_pi) + 1 + 2*`lnsig') ///
			       -`logdet'
	}
	else {		
		scalar `lnsig' = log(e(rss)/e(N))/2
		scalar `ll0' = e(ll)
		
	}
	return scalar lnsig = `lnsig'
	return scalar ll0 = `ll0'
end

program SetBlupMats 
	args touse
	tempname gamma theta delta err s2

	if `"`e(cmd)'"' != "xtmixed" {
di as err "BLUP calculations require a previously fitted {cmd:xtmixed} model"
		exit 301
	}

	qui count if `touse'
	if r(N) != e(N) {
	    di as err "BLUP calculation failed; estimation data have changed"
	    exit 459
	}

	mat `gamma' = e(b)
	local p = colsof(`gamma')
	scalar `s2' = exp(2*`gamma'[1,`p'])
	mat `gamma' = `gamma'[1,`=e(k_f)+1'...]

	local k 0
	capture {
		 mata: _xtm_gamma_to_theta("`theta'","`gamma'","`err'")
		 local k = scalar(`err')
		 mata: _xtm_theta_to_delta("`delta'","`theta'","`err'")
		 local k = `k' + scalar(`err')
	}
	if `k' | _rc {
		di as err "BLUP calculation failed; e(b) unsuitable"
		exit 459
	}
	local ll 0
	capture {
		mata: _xtm_mixed_ll("`delta'","`s2'",2)
		local ll = r(ll)
	}
	if _rc | reldif(`ll',e(ll)) > 1e-12 {
	    di as err "BLUP calculation failed; estimation data have changed"
	    exit 459
	}
end

program CheckBlups
	local k : word count `0'
	if mod(`k',2) {
		di as err "getblups() incorrectly specified"
		exit 198
	}
	forvalues i = 1/`=`k'/2' {
		gettoken level 0 : 0
		gettoken stub 0 : 0
		if `:list stub in stublist' {
			di as err "stubs must be unique"
			exit 198
		}
		local stublist `stublist' `stub'
		if `"`level'"' != "_all" {
			unab level : `level'
		}
		local ivars `e(ivars)'
		local p : list posof "`level'" in ivars
		if !`p' {
			di as err `"`level' is not a group variable"'
			exit 198
		}
		local m 0
		forvalues j = `p'/`:word count `ivars'' {
			if `"`:word `j' of `ivars''"' != "`level'" {
				continue, break
			}
			local np : word `j' of `e(redim)'	
			forvalues k = 1/`np' {
				confirm new variable `stub'`=`m'+`k''
			}
			local m = `m' + `np'
		}
	}
end

program GetBlups
	mata: _xtm_fillBmat() 

	local k : word count `0'
	forvalues i = 1/`=`k'/2' {
		gettoken level 0 : 0
		gettoken stub 0 : 0
		if `"`level'"' != "_all" {
			unab level : `level'
		}
		GetBlupsLevel `level' `stub'		
	}
end

program GetBlupsLevel
	args lvar stub

	local ivars `e(ivars)'
	local zvars `e(revars)'

	// get z variables
	local w : word count `ivars'
	forvalues i = 1/`w' {
		local lev : word `i' of `ivars'
		local dim : word `i' of `e(redim)'
		if "`lev'" != "`lvar'" {
			local dont *
		}
		forvalues j = 1/`dim' {
			gettoken z zvars : zvars 
			`dont'local zs `zs' `z'
		}
		local dont
	}

	local uivars : list uniq ivars
	local p : list posof "`lvar'" in uivars 	// p is the true level
	local nz : word count `zs'

	forvalues i = 1/`nz' {
		qui gen double `stub'`i' = . 
		label var `stub'`i' `"BLUP r.e. for `lvar': `:word `i' of `zs''"'
	}
	mata: _xtm_blup_save("`stub'",`p')
end

exit
