{smcl}
{* *! version 1.1.16  09oct2008}{...}
{cmd:help xttobit} {right:dialog:  {bf:{dialog xttobit}}{space 15}}
{right:also see:  {help xttobit postestimation}}
{hline}

{title:Title}

{p2colset 5 21 23 2}{...}
{p2col :{hi:[XT] xttobit} {hline 2}}Random-effects tobit models{p_end}
{p2colreset}{...}


{title:Syntax}

{p 8 16 2}
{cmd:xttobit} {depvar} [{indepvars}] {ifin} {weight} [{cmd:,} {it:options}]

{synoptset 27 tabbed}{...}
{synopthdr}
{synoptline}
{syntab :Model}
{synopt :{opt nocon:stant}}suppress constant term{p_end}
{synopt :{opt ll(varname|#)}}left-censoring variable/limit{p_end}
{synopt :{opt ul(varname|#)}}right-censoring variable/limit{p_end}
{synopt :{opth off:set(varname)}}include {it:varname} in model with coefficient constrained to 1{p_end}
{synopt :{opth const:raints(xt estimation options##constraints():constraints)}}apply specified linear constraints{p_end}
{synopt:{opt col:linear}}keep collinear variables{p_end}

{syntab :SE}
{synopt :{opth vce(vcetype)}}{it:vcetype} may be {opt oim},
       {opt boot:strap}, or {opt jack:knife}{p_end}

{syntab :Reporting}
{synopt :{opt l:evel(#)}}set confidence level; default is {cmd:level(95)}{p_end}
{synopt :{opt tobit}}perform likelihood-ratio test comparing against pooled tobit model{p_end}
{synopt :{opt noskip}}perform likelihood-ratio test{p_end}

INCLUDE help intpts1

{syntab :Max options}
{synopt :{it:{help xttobit##maximize_options:maximize_options}}}control the maximization process; seldom used{p_end}
{synoptline}
{p2colreset}{...}
{p 4 6 2}
A panel variable must be specified; use {helpb xtset}.{p_end}
{p 4 6 2}
{it:depvar} and {it:indepvars} may contain time-series operators; see {help tsvarlist}.{p_end}
{p 4 6 2}
{opt by}, {opt statsby}, and {cmd:xi} are allowed; see {help prefix}.{p_end}
{p 4 6 2}
{opt iweight}s are allowed; see {help weight}.  Weights must be constant
within panel.{p_end}
{p 4 6 2}
See {manhelp xttobit_postestimation XT:xttobit postestimation} for features
available after estimation.{p_end}


{title:Description}

{pstd}
{cmd:xttobit} fits a random-effects tobit models.  There is no command for a
conditional fixed-effects model, as there does not exist a sufficient
statistic allowing the fixed effects to be conditioned out of the likelihood.
Honore has developed a semiparametric estimator
for fixed-effect tobit models.  Unconditional fixed-effects tobit models may
be fitted with {cmd:tobit} command with indicator variables for the panels.
The appropriate indicator variables can be generated using {cmd:tabulate} or
{cmd:xi}.  However, unconditional fixed-effects estimates are biased.


{title:Options}

{dlgtab:Model}

{phang}
{opt noconstant}; see 
{helpb xt estimation options##noconstant:[XT] estimation options}.

{phang}
{opt ll(varname|#)} and {opt ul(varname|#)} indicate the censoring points.
You may specify one or both.  {opt ll()} indicates the lower limit for
left-censoring.  Observations with depvar{ul:<}{opt ll()} are left-censored,
observations with depvar{ul:>}{opt ul()} are right-censored, and remaining
observations are not censored.  See {manhelp tobit R}.

{phang}
{opth offset(varname)}, {opt constraints(constraints)}, {opt collinear}; see 
{helpb xt estimation options##offset():[XT] estimation options}.

{dlgtab:SE}

INCLUDE help xt_vce_asymptbj

{dlgtab:Reporting}

{phang}
{opt level(#)}; see
{helpb xt estimation options##level():[XT] estimation options}. 

{phang}
{opt tobit} specifies that a likelihood-ratio test comparing the random effects model with the pooled (tobit) model be included in the output.

{phang}
{opt noskip}; see
{helpb xt estimation options##noskip:[XT] estimation options}. 

INCLUDE help intpts4

{dlgtab:Max options}

{phang}
{marker maximize_options}
{it:maximize_options}: {opt dif:ficult}, {opt tech:nique(algorithm_spec)}, 
{opt iter:ate(#)}, [{opt no:}]{opt lo:g}, {opt tr:ace}, {opt grad:ient}, 
{opt showstep}, {opt hess:ian}, {opt shownr:tolerance}, {opt tol:erance(#)}, 
{opt ltol:erance(#)}, {opt gtol:erance(#)}, {opt nrtol:erance(#)}, 
{opt nonrtol:erance}, {opt from(init_specs)}; see {manhelp maximize R}.  Some
of these options are not available if {cmd:intmethod(ghermite)} is specified.
These options are seldom used.


{title:Technical note}

{pstd}
The random-effects model is calculated using quadrature, which is an
approximation whose accuracy depends partially on the number of integration
points used.  We can use the {cmd:quadchk} command to see if changing the
number of integration points affects the results.  If the results change, the
quadrature approximation is not accurate given the number of integration
points.  Try increasing the number of integration points using the
{cmd:intpoints()} option and again run {cmd:quadchk}.  Do not attempt to
interpret the results of estimates when the coefficients reported by
{cmd:quadchk} differ substantially.  See {manhelp quadchk XT} for details and
{bf:[XT] xtprobit} for an example.

{pstd}
Because the {cmd:xttobit} likelihood function is calculated by Gauss
Hermite quadrature, on large problems, the computations can be slow.
Computation time is roughly proportional to the number of points used for the
quadrature.


{title:Example}

{pstd}Setup{p_end}
{phang2}{cmd:. webuse nlswork3}{p_end}
{phang2}{cmd:. xtset idcode}{p_end}

{pstd}Fit random-effects (RE) tobit model{p_end}
{phang2}{cmd:. xttobit ln_wage union age grade not_smsa south southXt, ul(1.9)}

{pstd}Same as above, but increase the number of integration points from 12 to
25{p_end}
{phang2}{cmd:. xttobit ln_wage union age grade not_smsa south southXt, ul(1.9)}
            {cmd:intpoints(25)}

{pstd}Same as above, but report likelihood-ratio test comparing RE model with
the pooled model{p_end}
{phang2}{cmd:. xttobit ln_wage union age grade not_smsa south southXt, ul(1.9)}
            {cmd:intpoints(25) tobit}


{title:Saved results}

{pstd}
{cmd:xttobit} saves the following in {cmd:e()}:

{synoptset 15 tabbed}{...}
{p2col 5 15 19 2: Scalars}{p_end}
{synopt:{cmd:e(N)}}number of observations{p_end}
{synopt:{cmd:e(N_g)}}number of groups{p_end}
{synopt:{cmd:e(N_unc)}}number of uncensored observations{p_end}
{synopt:{cmd:e(N_lc)}}number of left-censored observations{p_end}
{synopt:{cmd:e(N_rc)}}number of right-censored observations{p_end}
{synopt:{cmd:e(N_int)}}number of interval observations{p_end}
{synopt:{cmd:e(N_cd)}}number of completely determined observations{p_end}
{synopt:{cmd:e(df_m)}}model degrees of freedom{p_end}
{synopt:{cmd:e(ll)}}log likelihood{p_end}
{synopt:{cmd:e(ll_0)}}log likelihood, constant-only model{p_end}
{synopt:{cmd:e(g_max)}}largest group size{p_end}
{synopt:{cmd:e(g_min)}}smallest group size{p_end}
{synopt:{cmd:e(g_avg)}}average group size{p_end}
{synopt:{cmd:e(chi2)}}chi-squared{p_end}
{synopt:{cmd:e(chi2_c)}}chi-squared for comparison test{p_end}
{synopt:{cmd:e(rho)}}rho{p_end}
{synopt:{cmd:e(sigma_u)}}panel-level standard deviation{p_end}
{synopt:{cmd:e(sigma_e)}}standard deviation of epsilon_it{p_end}
{synopt:{cmd:e(n_quad)}}number of quadrature points{p_end}
{synopt:{cmd:e(k)}}number of parameters{p_end}
{synopt:{cmd:e(k_eq)}}number of equations{p_end}
{synopt:{cmd:e(k_eq_model)}}number of equations in model Wald test{p_end}
{synopt:{cmd:e(k_dv)}}number of dependent variables{p_end}
{synopt:{cmd:e(p)}}significance{p_end}
{synopt:{cmd:e(rank)}}rank of {cmd:e(V)}{p_end}
{synopt:{cmd:e(rank0)}}rank of {cmd:e(V)} for constant-only model{p_end}
{synopt:{cmd:e(ic)}}number of iterations{p_end}
{synopt:{cmd:e(rc)}}return code{p_end}
{synopt:{cmd:e(converged)}}{cmd:1} if converged, {cmd:0} otherwise{p_end}

{synoptset 15 tabbed}{...}
{p2col 5 15 19 2: Macros}{p_end}
{synopt:{cmd:e(cmd)}}{cmd:xttobit}{p_end}
{synopt:{cmd:e(cmdline)}}command as typed{p_end}
{synopt:{cmd:e(depvar)}}name of dependent variable{p_end}
{synopt:{cmd:e(ivar)}}variable denoting groups{p_end}
{synopt:{cmd:e(wtype)}}weight type{p_end}
{synopt:{cmd:e(wexp)}}weight expression{p_end}
{synopt:{cmd:e(title)}}title in estimation output{p_end}
{synopt:{cmd:e(llopt)}}contents of {cmd:ll()}, if specified{p_end}
{synopt:{cmd:e(ulopt)}}contents of {cmd:ul()}, if specified{p_end}
{synopt:{cmd:e(offset1)}}offset{p_end}
{synopt:{cmd:e(chi2type)}}{cmd:Wald} or {cmd:LR}; type of model chi-squared
	test{p_end}
{synopt:{cmd:e(chi2_ct)}}{cmd:Wald} or {cmd:LR}; type of model chi-squared
	test corresponding to {cmd:e(chi2_c}{p_end}
{synopt:{cmd:e(distrib)}}{cmd:Gaussian}; the distribution of the random
	effect{p_end}
{synopt:{cmd:e(intmethod)}}integration method{p_end}
{synopt:{cmd:e(vce)}}{it:vcetype} specified in {cmd:vce()}{p_end}
{synopt:{cmd:e(vcetype)}}title used to label Std. Err.{p_end}
{synopt:{cmd:e(opt)}}type of optimization{p_end}
{synopt:{cmd:e(ml_method)}}type of {cmd:ml} method{p_end}
{synopt:{cmd:e(user)}}name of likelihood-evaluator program{p_end}
{synopt:{cmd:e(technique)}}maximization technique{p_end}
{synopt:{cmd:e(crittype)}}optimization criterion{p_end}
{synopt:{cmd:e(properties)}}{cmd:b V}{p_end}
{synopt:{cmd:e(predict)}}program used to implement {cmd:predict}{p_end}

{synoptset 15 tabbed}{...}
{p2col 5 15 19 2: Matrices}{p_end}
{synopt:{cmd:e(b)}}coefficient vector{p_end}
{synopt:{cmd:e(V)}}variance-covariance matrix of the estimators{p_end}
{synopt:{cmd:e(ilog)}}iteration log{p_end}
{synopt:{cmd:e(gradient)}}gradient vector{p_end}

{synoptset 15 tabbed}{...}
{p2col 5 15 19 2: Functions}{p_end}
{synopt:{cmd:e(sample)}}marks estimation sample{p_end}
{p2colreset}{...}


{title:Also see}

{psee}
Manual:  {bf:[XT] xttobit}

{psee}
Online:  {manhelp xttobit_postestimation XT:xttobit postestimation};{break}
{manhelp quadchk XT}, {manhelp xtintreg XT}, {manhelp xtreg XT},
{manhelp constraint R}, {manhelp tobit R}
{p_end}
